#include <AccessManager/xacml/impl/BCMResource.h>

namespace daq
{

namespace am
{

// the resource category is "bcm"
#define VALUE_RESOURCE_CATEGORY		"BCM"

// the resource id is "bcm"
#define VALUE_RESOURCE_ID			"bcm"

// the BCM possible actions: configure and update
const BCMAction BCMResource::ACTION_CONFIGURE(BCMAction::getValueForActionCONFIGURE());
const BCMAction BCMResource::ACTION_UPDATE(BCMAction::getValueForActionUPDATE());

BCMResource::BCMResource(const BCMAction& action):
	Resource(){

	//TYPES INITIALIZATION

	//VALUES INITIALIZATION
	initValues();

	//ACTIONS INITIALIZATION
	//initialize the actions for the resource id
	addAction(getResourceId(), &action);

	// set the description attribute
	this->description = "BCM Resource";
}

/*
 * Populate the list and maps from parent class with known values;
 */
void BCMResource::initValues(){
	// set the BCM resource category value
	addValue(getResourceCategory(), VALUE_RESOURCE_CATEGORY);
	// set the BCM resource id value
	addValue(getResourceId(), VALUE_RESOURCE_ID);
}

BCMResource::~BCMResource(){

}

std::unique_ptr<const BCMResource> BCMResource::getInstanceForActionCONFIGURE() {
	return std::unique_ptr<const BCMResource>(new BCMResource(BCMResource::ACTION_CONFIGURE));
}

std::unique_ptr<const BCMResource> BCMResource::getInstanceForActionUPDATE(){
	return std::unique_ptr<const BCMResource>(new BCMResource(BCMResource::ACTION_UPDATE));
}


}

}
