#ifndef AutoPrescaler_rulechecker_DataModel_h
#define AutoPrescaler_rulechecker_DataModel_h
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
#include <AutoPrescaler/rulechecker/Subscriber.h>
#include <AutoPrescaler/rulechecker/OnlineData.h>
#include <AutoPrescaler/rulechecker/DataAbstraction.h>
//------------------------------------------------------------------------------


//------------------------------------------------------------------------------
namespace L1CT {
//------------------------------------------------------------------------------


//------------------------------------------------------------------------------
class DataModel : public Subscriber {

public:
    virtual ~DataModel() {}
    DataModel() : m_dataAbstraction(m_onlineData) {
        // Subscribe to updates of the DataAbstraction
	ERS_LOG("Constructing DataModel");
        m_dataAbstraction.add(*this);
	ERS_LOG("Added DataModel to the DataAbstraction callbacks");

        // Subscribe the online data to IS
	ERS_LOG("Subscribing the onlineData");
        m_onlineData.subscribe();
    }

    inline const OnlineData &online() const { return m_onlineData; }
    inline const DataAbstraction &abstraction() const { return m_dataAbstraction; }
    // Non-const version for the moment: sloppy, to be fixed later
    inline DataAbstraction &abstraction() { return m_dataAbstraction; }

public: 
    virtual void callback(ISCallbackInfo * isc) final { 
        // Just debug. Print and call the parent.
      ERS_DEBUG(3, "DataModel::callback(" << std::hex << isc << std::dec << ") -- entered");
        Subscriber::callback(isc);
    }

protected:
    OnlineData      m_onlineData; 
    DataAbstraction m_dataAbstraction;

};
//------------------------------------------------------------------------------



//------------------------------------------------------------------------------
}
//------------------------------------------------------------------------------


//------------------------------------------------------------------------------
#endif

