//------------------------------------------------------------------------------
#include <AutoPrescaler/ipc/PrescaleWriterIpcCommander.h>
//------------------------------------------------------------------------------


//------------------------------------------------------------------------------
using namespace L1CT;
//------------------------------------------------------------------------------




//------------------------------------------------------------------------------
int PrescaleWriterIpcCommander::createPrescale(const unsigned long psk, const PrescaleBuffer &prescales) {
    
    L1CTIPC::PrescaleRequest request;
    request.psk = psk;
    request.values.length(prescales.size());
    
    size_t i = 0;
    for(const auto &it : prescales) {
        L1CTIPC::PrescaleValue value;
        
        value.item      = it.triggerName.c_str();
        value.prescale  = it.prescale;

        //request.values.push_back(value);
        request.values[i] = value;
        ++i;
    }


    L1CTIPC::PrescaleReturn myResult;
    try{
      myResult = prescaler()->requestPrescale(request);
    } catch(...) {
      return -1;
    }    

    std::cout << "No exceptions" << std::endl;
    std::cout << "Success?" << myResult.success << std::endl;
    std::cout << "PSK:" << myResult.psk << std::endl;
    // We will catch things better later on...
    
    if(!myResult.success)
      return -1;
    
    return int(myResult.psk);

}
//------------------------------------------------------------------------------

