#include <AutoPrescaler/rulechecker/MenuDraft.h>
#include <AutoPrescaler/rulechecker/RuleChecker.h>

//------------------------------------------------------------------------------
using namespace L1CT;
//------------------------------------------------------------------------------


MenuDraft::Draft_t MenuDraft::check()
{
  if(m_currentDraft.size() ==0)
    return m_currentDraft;
  
  ERS_DEBUG(3,"Checking Menu Draft");
  
  MenuDraft::Draft_t filteredDraft;

  // Compare the PS to what is currently implemented
  for(auto item : m_currentDraft)
    {
      // Are we book-keeping this item?  If not, forget about it for now: misconfiguration
      if(!rulechecker().dataModel().abstraction().checkItem(item.first))
	continue;
      ERS_DEBUG(3,"Request for: " << item.first);
      ERS_DEBUG(3,"Current PS is: " << rulechecker().dataModel().abstraction().getL1Prescale(item.first));
      ERS_DEBUG(3,"Requested PS is: " << item.second);
      
      if(item.second != rulechecker().dataModel().abstraction().getL1Prescale(item.first))
	{
	  filteredDraft[item.first] = item.second;
	  ERS_LOG("Adding menu request for: " << item.first << " prescaled at: " << item.second); 
	}
    }
  return filteredDraft;
}
