/*
 *  NullStream.java
 *  
 *  Created by Claire Biau on 02.06.08
 *  Copyright 2008 CERN. All rights reserved.
 *
 */

/** \file  NullStream.java This file defines NullStream ERS stream
 * \author Claire Biau
 *	This stream class implements a null stream, i.e a stream where no issue can be read from
 * and it also silently discards sent issues.
 */

package ers.streams ;

import java.util.Map;

import ers.AbstractOutputStream;
import org.mangosdk.spi.ProviderFor ;

@ProviderFor(ers.StreamRegistrator.class)
public class NullStream extends AbstractOutputStream {

	public String getStreamName()
		{
		return "null" ;
		}

	/**
	 * Does essentially nothing
	 */
	public void write (final Exception issue, final ers.Severity sev) 
		{}
	
	/**
	 * This function returns true because a NullStream is always considered as null
	 */
	public boolean isNull()
		{
		return true;
		}

	public void cleanUp() {} ;

	public void configure(Map<String, String> config) {
		// TODO Auto-generated method stub
		
	}
}


//ERS_REGISTER_OUTPUT_STREAM( ers::NullStream, "null", ) TODO
