/*
 *  ThrottleStream.java
 *  
 *  Created by Andrei Kazarov
 *  Copyright 2011 CERN. All rights reserved.
 *
 */

/** \file  ThrottleStream.java. This file defines ERS throttle stream. It extends ers.OutputStream.
    Present dummy implementation works in pass-through mode.
 * \author Andrei Kazarov
 *	
 */

package ers.streams ;

import java.util.Map;

import org.mangosdk.spi.ProviderFor ;

@ProviderFor(ers.StreamRegistrator.class)
public class ThrottleStream extends ers.AbstractOutputStream {
	
	public String getStreamName()
		{
		return "throttle" ;
		}

	public void cleanUp() {} ;

	/**
	 * configure the stream
	 * @param config
	 */
	public void configure ( Map<String,String> config) {} ;

	public ThrottleStream( String format ) {} ;

	public ThrottleStream( ) {} ;

	public void write(final Exception issue, final ers.Severity sev) {
		chained().write( issue, sev ) ;	 
	}

}
