#ifndef MIG_HISTOGRAMTAGCONTBASE_H
#define MIG_HISTOGRAMTAGCONTBASE_H

//-----------------
// C/C++ Headers --
//-----------------
#include <memory>
#include <string>

//-------------------------------
// Collaborating Class Headers --
//-------------------------------
#include "oh/core/Histogram.h"
#include "oh/core/ObjectBase.h"

//------------------------------------
// Collaborating Class Declarations --
//------------------------------------
namespace MIG {
class TimingCollector;
}

namespace MIG {

/**
 * Interface for per-tag container classes.
 */
class HistogramTagContBase {
public:

    using Histogram = oh::ObjectBase<oh::Histogram>;

    virtual ~HistogramTagContBase() {}

    /**
     *  Receive new contribution from provider.
     *
     *  @param histo Histogram object, never nullptr.
     *  @param providerName Name of the provider for this contribution.
     *  @param timingColl Profiling data collector.
     *  @return true if this caused publication.
     */
    virtual bool tagOperate(std::unique_ptr<Histogram> histo,
                            const std::string& providerName,
                            TimingCollector& timingColl) = 0;

};

} // namespace MIG

#endif // MIG_HISTOGRAMTAGCONTBASE_H
