"""
Module containing class Olc2HltInvalidator anbd related methods.
"""

from __future__ import absolute_import, print_function, division

#--------------------------------
#  Imports of standard modules --
#--------------------------------
import logging
import subprocess

#-----------------------------
# Imports for other modules --
#-----------------------------

#----------------------------------
# Local non-exported definitions --
#----------------------------------

_LOG = logging.getLogger("Olc2HltInvalidator")

#------------------------
# Exported definitions --
#------------------------

#---------------------
#  Class definition --
#---------------------


class Olc2HltInvalidator(object):
    """
    Class implementing invalidation of OLC2HLT conditions.

    Parameters
    ----------
    config_id : str
        ID of the configuration object.
    """

    process_exec = subprocess.check_call  # can be changed for testing

    def __init__(self, config_id):
        self._config_id = config_id

    def run(self):
        """
        Do invalidation, throws in case of errors.
        """
        args = ['olc2hlt-invalidate', '-n', self._config_id]
        _LOG.info('executing: {}'.format(args))
        self.process_exec(args)
        _LOG.info('invalidation finished successfully')
