#!/usr/bin/env tdaq_python

"""Unit test for Olc2HltInvalidator class.
"""

from __future__ import absolute_import, print_function, division

import unittest

from pyolc2hlt import Olc2HltInvalidator


class MockExec(object):

    def __init__(self):
        self.args = None

    def __call__(self, args):
        self.args = args


class TestCase(unittest.TestCase):

    def setUp(self):

        self.mockExec = MockExec()
        Olc2HltInvalidator.process_exec = self.mockExec

    def test01(self):

        uid = "olc2hlt-sor-invalidate"
        inval = Olc2HltInvalidator(uid)
        inval.run()
        self.assertEqual(self.mockExec.args, ['olc2hlt-invalidate', '-n', uid])


if __name__ == "__main__":
    unittest.main()
