#!/usr/bin/env tdaq_python

"""Unit test for StableBeamsFlag class.
"""

from __future__ import absolute_import, print_function, division

import unittest

from pyolc2hlt import StableBeamsFlag
from _mocks import MockISObjectStableBeams


class TestCase(unittest.TestCase):

    def setUp(self):

        StableBeamsFlag.ISObjectClass = MockISObjectStableBeams

    def test01(self):

        # this will cause exception which returns False
        sbeams = StableBeamsFlag("initial", "LHC.StableBeamsFlag")
        MockISObjectStableBeams.stableBeams = None
        self.assertFalse(sbeams())

        # no exceptions, plain False
        MockISObjectStableBeams.stableBeams = False
        self.assertFalse(sbeams())

        # Stable now
        MockISObjectStableBeams.stableBeams = True
        self.assertTrue(sbeams())


if __name__ == "__main__":
    unittest.main()
