# -- CUT FROM THIS POINT UPWARDS --
# This dump was automatically generated by myopt
# User haimo (Haimo Zobernig) at Wed Oct 16 18:21:54 2013

# All options should be inside the 'option' dictionary
# The keys being the long name of the options and the
# values, the new default to be attributed.
option = {}

# ================================
# 'Data Quality Monitoring' options 
# ================================

# If set, should be the (relative) path to a DQM segment for the HLT. This segment should contain a single segment that will be linked in through the highest segment at this trigger level.
option['hlt-dqm'] = ''

# ================================
# 'Dataflow' options 
# ================================

# If set, should be a list of network masks for the NetworkInterfaces to be used for the communication.
option['data-networks'] = []

# Maximum number of events to run the L2SV for (0 means forever
option['max-events'] = 0

# List of data files to preload or the size of the dummy ROBs (for partitions with ROSs/ROSEs) or the dummy event (for partitions with an SFI emulator)
option['data'] = 100

# List of directories where to place (SFI/O) output files. If you are using an SFO, the first entry in this list will be also used to place the index files.
option['write-dir'] = []

# ================================
# 'Farm size' options 
# ================================

# Number of HLTPU's per node. 
option['hltpus-per-node'] = 1

# ================================
# 'HLT' options 
# ================================

# pudummy algorithm configuration
option['hlt-implementation'] = {'implementation': 'pudummy'}

# ================================
# 'Machine allocation' options 
# ================================

# This parameter defines the name of a python module that contains a dictionary named "hlt_farm". This dictionary should contain the python farm description of the HLT farm as described at the documentation of the function "gen_ebef_segment" at the submodule pm.multinode. If the module contains another variable called "includes", it will be used as the OKS hardware database and will be included in the final generated database
#
# uncomment the next line to generate a multirack farm
#option['hlt-farm'] = 'hltfarm'

# This parameter defines the name of a python module that contains a dictionary named "ros_farm". This dictionary should contain the python farm description of the ROS farm as described at the documentation of the function "gen_ros_segment" at the submodule pm.multinode. If the module contains another variable called "includes", it will be used as the OKS hardware database and will be included in the final generated database
option['ros-farm'] = 'pm.partition.default_farm'

# ================================
# 'Partition making' options 
# ================================

# If this flag is set, the output will not contain any applications, but just the control tree (useful for controller-only tests)
option['control-only'] = False

# If you set this option it has to point to python module that contains a function named "modify" that will take the object generated (segment or partition) and post process it using such a function. This function should just modify the required objects and attributes and return the outcome. PartitionMaker will persistify that result. The specification of the module path follows the python standard, separating paths with dots. Any valid python module in PYTHONPATH or sys.path will work. Multiples of this option may be given at the command line in which case the filters are applied sequentially.
option['post-processor'] = []

# Which standard template file to include in your partition. This file contains the RC and RDB templates to be used at your segment or partition.
option['template-file'] = 'daq/sw/common-templates.data.xml'

# Add a RepositoryRoot to the partition
option['repository-root'] = ''

# The name of the OKS partition
#option['partition-name'] = 'part_lh_pudummy'

# Which setup file to include in your partition
option['setup-file'] = 'daq/segments/setup.data.xml'

# Extra OKS includes to your output
option['extra-includes'] = []

