# -- CUT FROM THIS POINT UPWARDS --
# This dump was automatically generated by myopt
# User haimo (Haimo Zobernig) at Wed Oct 16 18:21:54 2013

# All options should be inside the 'option' dictionary
# The keys being the long name of the options and the
# values, the new default to be attributed.
option = {}

# ================================
# 'Data Quality Monitoring' options 
# ================================

# If set, should be the (relative) path to a DQM segment for the HLT. This segment should contain a single segment that will be linked in through the highest segment at this trigger level.
option['hlt-dqm'] = ''

# ================================
# 'Dataflow' options 
# ================================

# If set, should be a list of network masks for the NetworkInterfaces to be used for the communication.
option['data-networks'] = []

# Maximum number of events to run the L2SV for (0 means forever
option['max-events'] = 0

# List of data files to preload or the size of the dummy ROBs (for partitions with ROSs/ROSEs) or the dummy event (for partitions with an SFI emulator)
option['data'] = 100

# List of directories where to place (SFI/O) output files. If you are using an SFO, the first entry in this list will be also used to place the index files.
option['write-dir'] = []

# ================================
# 'Farm size' options 
# ================================

# Number of HLTPU's per node. 
option['hltpus-per-node'] = 1

# ================================
# 'HLT' options 
# ================================

# algorithm configuration, examples (value of 'implementation' is case-insensitive)
# option['hlt-implementation'] = {'implementation': 'pudummy'}
# option['hlt-implementation'] = {'implementation': 'JobOptions', ... }
# option['hlt-implementation'] = {'implementation': 'DB', ... }
# option['hlt-implementation'] = {'implementation': 'DBPython', ... }

# Defines the HLT Implementation to use. It has to be either a python dictionary (like the default argument), a dictionary that configures an HLTImplementation, or a string, that determines the path to the jobOptions to use. This parameter can also be set to dal.HLTImplementation object that will be used blindly to configure the HLT system at your partition.

import os

cmtconfig = os.environ['CMTCONFIG']
install_suffix = 'InstallArea/share/data'

workarea_root = '/pcuwtr-srv1/data/wiedenat/hlt/Pesa/18.X.Y/new_ROBDataProviderSvc'
workarea = workarea_root + '/' + install_suffix + ':' + workarea_root + '/InstallArea/' + cmtconfig + '/data' 

patcharea = '/afs/cern.ch/atlas/software/releases/17.1.1/AtlasP1HLT/17.1.1.3' + '/' + install_suffix \
    + ':' + '/afs/cern.ch/atlas/software/releases/17.1.1/AtlasP1HLT/17.1.1.3/InstallArea/' + cmtconfig + '/data'

release = '/afs/cern.ch/atlas/software/releases/18.1.0/AtlasHLT/18.1.0/' + install_suffix + ':' \
    + '/afs/cern.ch/atlas/software/releases/18.1.0/AtlasHLT/18.1.0/InstallArea/' + cmtconfig + '/data'

option['hlt-implementation'] = {'implementation': 'JobOptions', 
                                'jobOptionsPath': '/pcatr-srv1/data2/wiedenat/hlt/Pesa/17.X.0/T45_ROB_prefetching_in_ROBDataProviderSvc/run/TestMTCalibPebOptions.py',
                                'workarea': workarea,
                                #'patcharea': patcharea,
                                'release': release}

# Defines a set of extra paths that should contain valid installation areas where you have patches for the HLT/Offline software. The order you set is preserved. These areas are attached both to L2 and EF HLT nodes.

option['hlt-extra-path'] = ['/pcatr-srv1/data2/wiedenat/hlt/Pesa/17.X.0/T45_ROB_prefetching_in_ROBDataProviderSvc']

# If you set this option, we will populate the generated segment or partition with coral proxies where they fit. If you do not set this option, the default action is not to place any proxies.
option['proxy'] = False

# ================================
# 'Machine allocation' options 
# ================================

# This parameter defines the name of a python module that contains a dictionary named "hlt_farm". This dictionary should contain the python farm description of the HLT farm as described at the documentation of the function "gen_ebef_segment" at the submodule pm.multinode. If the module contains another variable called "includes", it will be used as the OKS hardware database and will be included in the final generated database
#option['hlt-farm'] = 'hltfarm'


# ================================
# 'Partition making' options 
# ================================

# If this flag is set, the output will not contain any applications, but just the control tree (useful for controller-only tests)
option['control-only'] = False

# If you set this option it has to point to python module that contains a function named "modify" that will take the object generated (segment or partition) and post process it using such a function. This function should just modify the required objects and attributes and return the outcome. PartitionMaker will persistify that result. The specification of the module path follows the python standard, separating paths with dots. Any valid python module in PYTHONPATH or sys.path will work. Multiples of this option may be given at the command line in which case the filters are applied sequentially.
option['post-processor'] = []

# Which standard template file to include in your partition. This file contains the RC and RDB templates to be used at your segment or partition.
option['template-file'] = 'daq/sw/common-templates.data.xml'

# Extra OKS includes to your output
option['extra-includes'] = []

