{
  TFile myFile("/tmp/eff_combined.root", "READ");
  TCanvas* c1 = new TCanvas("c1","daq running time",50,50,800,600);
  TH2F* ht = (TH2F*) myFile.Get("ht0");
  TGraph* runEffGraph = (TGraph*) myFile.Get("RunEffGraph");
  TGraph* runEffReadyGraph = (TGraph*) myFile.Get("RunEffReadyGraph");
  runEffGraph->SetFillColor(kGreen);
  runEffGraph->SetLineWidth(1);
  runEffReadyGraph->SetFillColor(kGray);
  runEffReadyGraph->SetLineWidth(1);

  gROOT->LoadMacro("AtlasStyle.C");
  SetAtlasStyle();

  TDatime T1(2011,03,13,00,00,00);
  int X1 = T1.Convert();
//  ht->GetXaxis()->SetNdivisions(-6);
  ht->GetXaxis()->SetNdivisions(-407);
  ht->GetXaxis()->SetLabelOffset(0.015);
  ht->Draw();

  runEffGraph->GetXaxis()->SetTimeDisplay(1);
  runEffReadyGraph->GetXaxis()->SetTimeDisplay(1);

  runEffGraph->Draw("f");
  runEffGraph->Draw("l");
  runEffReadyGraph->Draw("f");
  runEffReadyGraph->Draw("l");


  leg = new TLegend(0.20,0.84,0.80,0.89);
  leg->AddEntry(runEffGraph,"Run Eff","f");
  leg->AddEntry(runEffReadyGraph,"Run Eff Physics","f");
  leg->SetShadowColor(0);
  leg->SetNColumns(3);
  leg->SetFillColor(0);
  leg->SetBorderSize(0);
  leg->Draw();

  Color_t color = 1;
  TLatex l;
  l.SetNDC();
  l.SetTextFont(72);
  l.SetTextColor(color);
  Double_t x = 0.49;
  Double_t y = 0.90;
  l.DrawLatex(x,y,"ATLAS");
  l.Draw();
  TLatex ll;
  ll.SetNDC();
  ll.SetTextColor(color);
  Double_t x1 = 0.615;
  Double_t y1 = 0.90;
  ll.DrawLatex(x1,y1,"DAQ Operations");
  ll.Draw();

  gPad->RedrawAxis();
  gPad->SetTicks(0,0);

  c1->Print("/tmp//DailyPlot.png");
  exit();
}
