{
  TFile myFile("/tmp/eff_combined.root", "READ");
  TCanvas* c1 = new TCanvas("c1","daq efficiency",50,50,900,600);
  TH2F* ht3 = (TH2F*) myFile.Get("ht3");
  TGraph* beamGraph = (TGraph*) myFile.Get("BeamGraph");
  TGraph* runEffGraph = (TGraph*) myFile.Get("RunEffGraph");
  TGraph* runEffReadyGraph = (TGraph*) myFile.Get("RunEffReadyGraph");
  TGaxis* axis3 = (TGaxis*) myFile.Get("axis3");
  beamGraph->SetFillColor(kYellow);
  beamGraph->SetLineWidth(1);
//  beamGraph->SetLineColor(kBlack);
  runEffGraph->SetFillColor(kGreen);
  runEffGraph->SetLineWidth(1);
//  runEffGraph->SetLineColor(kBlack);
  runEffReadyGraph->SetFillColor(kGray+1);
  runEffReadyGraph->SetLineWidth(1);
//  runEffReadyGraph->SetLineColor(kBlack);
  gROOT->LoadMacro("AtlasStyle.C");
  SetAtlasStyle();

//  ht3->GetXaxis()->SetNdivisions(-6);
  ht3->GetXaxis()->SetNdivisions(-407);
  ht3->GetXaxis()->SetLabelOffset(0.015);
  ht3->Draw();

  beamGraph->GetXaxis()->SetTimeDisplay(1);
  runEffGraph->GetXaxis()->SetTimeDisplay(1);
  runEffReadyGraph->GetXaxis()->SetTimeDisplay(1);

  ht3->Draw();
  beamGraph->Draw("f");
//  beamGraph->Draw("l");
  runEffGraph->Draw("f");
//  runEffGraph->Draw("l");
  runEffReadyGraph->Draw("f");
//  runEffReadyGraph->Draw("l");
  axis3->Draw();

  leg = new TLegend(0.20,0.84,0.70,0.89);
  leg->AddEntry(runEffGraph,"Run Eff","f");
  leg->AddEntry(runEffReadyGraph,"Run Eff Physics","f");
  leg->AddEntry(beamGraph,"Beam","f");
  leg->SetShadowColor(0);
  leg->SetNColumns(3);
  leg->SetFillColor(0);
  leg->SetBorderSize(0);
  leg->Draw();

  Color_t color = 1;
  TLatex l;
  l.SetNDC();
  l.SetTextFont(72);
  l.SetTextColor(color);
  Double_t x = 0.49;
  Double_t y = 0.90;
  l.DrawLatex(x,y,"ATLAS");
  l.Draw();
  TLatex ll;
  ll.SetNDC();
  ll.SetTextColor(color);
  Double_t x1 = 0.60;
  Double_t y1 = 0.90;
  ll.DrawLatex(x1,y1,"DAQ Operations");
  ll.Draw();

  gPad->RedrawAxis();
  gPad->SetTicks(0,0);

  c1->Print("/tmp/Eff3Plots.png");
  exit();
}
