{
  TFile myFile("/tmp/eff_combined.root", "READ");
  TCanvas* c1 = new TCanvas("c1","daq running time",50,50,800,600);
  TGraph* beamTimeGraph = (TGraph*) myFile.Get("BeamTimeGraph");
  TGraph* runTimeGraph = (TGraph*) myFile.Get("RunTimeGraph");
  TGraph* runTimeReadyGraph = (TGraph*) myFile.Get("RunTimeReadyGraph");
  beamTimeGraph.SetFillColor(kYellow);
  beamTimeGraph.SetLineWidth(1);
  beamTimeGraph.SetLineColor(kBlack);
  runTimeGraph.SetFillColor(kGreen);
  runTimeGraph.SetLineWidth(1);
  runTimeReadyGraph.SetFillColor(kGray);
  runTimeReadyGraph.SetLineWidth(1);
  runTimeReadyGraph.SetLineColor(kBlack);

  gROOT->LoadMacro("AtlasStyle.C");
  SetAtlasStyle();

  beamTimeGraph->GetXaxis()->SetTimeDisplay(1);
  beamTimeGraph->GetXaxis()->SetLabelOffset(0.015);
  runTimeGraph->GetXaxis()->SetTimeDisplay(1);
  runTimeReadyGraph->GetXaxis()->SetTimeDisplay(1);
//  beamTimeGraph->GetXaxis()->SetNdivisions(-7);
  beamTimeGraph->GetXaxis()->SetNdivisions(-407);
  beamTimeGraph->Draw("af");
  beamTimeGraph->Draw("l");
  runTimeGraph->Draw("f");
  runTimeGraph->Draw("l");
  runTimeReadyGraph->Draw("f");
  runTimeReadyGraph->Draw("l");

  leg = new TLegend(0.22,0.70,0.37,0.88);
  leg->AddEntry(beamTimeGraph,"Beam","f");
  leg->AddEntry(runTimeGraph,"Run","f");
  leg->AddEntry(runTimeReadyGraph,"Physics","f");
  leg->SetFillColor(0);
  leg->SetShadowColor(0);
  leg->SetBorderSize(0);
  leg->Draw();

  Color_t color = 1;
  TLatex l;
  l.SetNDC();
  l.SetTextFont(72);
  l.SetTextColor(color);
  Double_t x = 0.49;
  Double_t y = 0.90;
  l.DrawLatex(x,y,"ATLAS");
  l.Draw();
  TLatex ll;
  ll.SetNDC();
  ll.SetTextColor(color);
  Double_t x1 = 0.615;
  Double_t y1 = 0.90;
  ll.DrawLatex(x1,y1,"DAQ Operations");
  ll.Draw();

  gPad->RedrawAxis();
  c1->Print("/tmp/TimePlot.png");
  exit();
}
