package RCUtils;

import java.util.*;

import javax.swing.JPanel;
import javax.swing.JLabel;
import javax.swing.JFrame;
import javax.swing.*;
import javax.swing.event.*;

import java.awt.*;
import java.io.*;

import org.jfree.chart.JFreeChart;
import org.jfree.chart.ChartPanel;
import org.jfree.chart.ChartFactory;
import org.jfree.chart.ChartUtils;
import org.jfree.chart.axis.NumberAxis;
import org.jfree.data.time.TimeSeriesCollection;
import org.jfree.data.xy.*;
import org.jfree.chart.plot.PlotOrientation;
import org.jfree.data.time.Second;
import org.jfree.data.time.TimeSeries;
import org.jfree.chart.plot.XYPlot;
import org.jfree.chart.renderer.xy.StandardXYItemRenderer;

public class EfficiencyPanel extends JPanel {

  // -----------------------------
  //  panel stuff
  // -----------------------------

  /** vertical SplitPane */
  JSplitPane verticalSplitPanel;

  /** Panel for Run info */
  JPanel topPanel;

  /** Labels for summary */
  JLabel interval;
  JLabel empty;
  JLabel beamType;
  JLabel beamTime;
  JLabel runningTime;
  JLabel deadTime;
  JLabel fractionBeam;

  /** the chart for the time series */
  JFreeChart chart;

  /** the chart panel */
  ChartPanel chartPanel;

  /** The plot. */
  private XYPlot plot;

  private TimeSeriesCollection beamCollection;
  private TimeSeriesCollection runCollection;

  private String intervalName="";
  private String beamTypeName="";
  private String beamTimeName="";
  private String runningTimeName="";
  private String deadTimeName="";
  private String fractionBeamName="";

  public EfficiencyPanel(String option) {

    double runStep = 0.5;
	XYDataset dataset = createDataset(runStep);
    if(option.compareTo("4") == 0) {
		System.out.println("!!!!AICI!!!!");
        runStep = 1.0;

    dataset = createDataset(runStep);
      
    chart = ChartFactory.createTimeSeriesChart(
            "",
            "Time",
            "Efficiency",
            dataset,
            true,
            true,
            false
        );
    this.plot = chart.getXYPlot();
	if(beamCollection.getDomainLowerBound(true) != 0) {
        this.plot.setDataset(1, beamCollection);
	}
    this.plot.setRenderer(1, new StandardXYItemRenderer());
    chart.setAntiAlias(false);
    chartPanel = new ChartPanel(chart);
	}	else if (option.compareTo("2") == 0) {
      chart = ChartFactory.createTimeSeriesChart(
              "",
              "Time",
              "Effciency",
              dataset,
              true,
              true,
              false
          );
      this.plot = chart.getXYPlot();
      this.plot.setDataset(1, beamCollection);
      this.plot.setRenderer(1, new StandardXYItemRenderer());
      this.plot.setDataset(2, runCollection);
      this.plot.setRenderer(2, new StandardXYItemRenderer());
      chart.setAntiAlias(false);
      chartPanel = new ChartPanel(chart);
    }	else if (option.compareTo("1") == 0) {
      chart = ChartFactory.createTimeSeriesChart(
              "",
              "Time",
              "Efficiency",
              dataset,
              true,
              true,
              false
          );
      this.plot = chart.getXYPlot();
      this.plot.setDataset(1, beamCollection);
      this.plot.setRenderer(1, new StandardXYItemRenderer());
      chart.setAntiAlias(false);
      chartPanel = new ChartPanel(chart);
    }	else if (option.compareTo("3") == 0) {
		System.out.println("!!!AICI!!!");
	  //runStep = 1.0;
	  dataset = createDataset(runStep);
      chart = ChartFactory.createTimeSeriesChart(
              "",
              "Time",
              "Efficiency",
              dataset,
              true,
              true,
              false
          );
      this.plot = chart.getXYPlot();
      if(runCollection.getDomainLowerBound(true) != 0)
      {
      	this.plot.setDataset(1, runCollection);
      }
      this.plot.setRenderer(1, new StandardXYItemRenderer());
      chart.setAntiAlias(false);
      chartPanel = new ChartPanel(chart);
      //PUT THE THE Y AXIS RANGE
      //NumberAxis range = (NumberAxis) this.plot.getRangeAxis();
      //range.setRange(0.0,1.2);
    }	else if (option.compareTo("0") == 0) {
      chart = ChartFactory.createTimeSeriesChart(
              "",
              "Time",
              "Efficiency",
              dataset,
              true,
              true,
              false
          );
      this.plot = chart.getXYPlot();
      chart.setAntiAlias(false);
      chartPanel = new ChartPanel(chart);
    }	else {
      System.out.println("Invalid option = " + option + ": Option should be 0, 1, 2, 3 or 4");
      System.exit(0);
    }

//    chartPanel.setMouseZoomable(true, false);
    chartPanel.setPreferredSize(new Dimension(1000, 400));

    interval   = new JLabel(intervalName);
    interval.setBackground(new Color(255, 255, 168));
    interval.setOpaque(true);
    interval.setHorizontalAlignment(SwingConstants.CENTER);
    interval.setFont( new java.awt.Font("dialog.bold", 1, 14) );
    empty = new JLabel("");
    empty.setBackground(new Color(255, 255, 168));
    empty.setOpaque(true);
    empty.setHorizontalAlignment(SwingConstants.CENTER);
    beamType   = new JLabel(beamTypeName);
    beamType.setBackground(new Color(255, 255, 168));
    beamType.setOpaque(true);
    beamType.setHorizontalAlignment(SwingConstants.CENTER);
    beamTime   = new JLabel(beamTimeName);
    beamTime.setBackground(new Color(255, 255, 168));
    beamTime.setOpaque(true);
    beamTime.setHorizontalAlignment(SwingConstants.CENTER);
    runningTime = new JLabel(runningTimeName);
    runningTime.setBackground(new Color(255, 255, 168));
    runningTime.setOpaque(true);
    runningTime.setHorizontalAlignment(SwingConstants.CENTER);
    deadTime = new JLabel(deadTimeName);
    deadTime.setBackground(new Color(255, 255, 168));
    deadTime.setOpaque(true);
    deadTime.setHorizontalAlignment(SwingConstants.CENTER);
    fractionBeam    = new JLabel(fractionBeamName);
    fractionBeam.setBackground(new Color(255, 255, 168));
    fractionBeam.setOpaque(true);
    fractionBeam.setHorizontalAlignment(SwingConstants.CENTER);
    fractionBeam.setFont( new java.awt.Font("dialog.bold", 1, 14) );

    topPanel = new JPanel();
//    topPanel.setLayout(new java.awt.GridLayout(10, 1));
    topPanel.setLayout(new java.awt.GridLayout(7, 1));

    topPanel.add(interval);
    topPanel.add(empty);
    topPanel.add(beamType);
    topPanel.add(beamTime);
    topPanel.add(runningTime);
    topPanel.add(deadTime);
    topPanel.add(fractionBeam);

    verticalSplitPanel = new JSplitPane();
    verticalSplitPanel.setOrientation(JSplitPane.VERTICAL_SPLIT);
    //verticalSplitPanel.setDividerSize(3);
    verticalSplitPanel.setOneTouchExpandable(true);
//    verticalSplitPanel.setDividerLocation(200);
    verticalSplitPanel.setDividerLocation(150);
    verticalSplitPanel.add(topPanel, JSplitPane.TOP);
    verticalSplitPanel.add(chartPanel, JSplitPane.BOTTOM);
    this.add(verticalSplitPanel, BorderLayout.CENTER);
    int aWidth = 1000;
    int aHeight = 380;
    try {
      ChartUtils.writeChartAsPNG( new FileOutputStream("/tmp/EffPlot.png"),
                                         chart,
                                         aWidth, aHeight);
    } catch (IOException ioEx) {
      System.err.println("Error writing PNG file ");
    }
  }

    private XYDataset createDataset(double runValue) {
      TimeSeries timeSeries = new TimeSeries("Run Data");
      final TimeSeries beamSeries = new TimeSeries("Beam Data");
      final TimeSeries runSeries = new TimeSeries("Run Data");

      long lasttime = 0;
      double beamValue = 1.0;
      //double runValue = 0.5;
      
      BufferedReader bufferedReader;
      try {
        bufferedReader = new BufferedReader(new FileReader("/tmp/eff.log"));
        String times = new String("1234");
        timeSeries = new TimeSeries("Efficiency");
        try {
          bufferedReader.mark(900000);
        } catch (java.io.IOException e) {
          System.out.println("mark BufferedReader IOException caught");
        }
        while ( !(times.compareTo("endbeam") == 0)) {
          try {
            times = bufferedReader.readLine();
          } catch (java.io.IOException e) {
            System.out.println("read beam data IOException caught");
          }
        }
        double maxValue = 1.0;
        while ( !(times.compareTo("end") == 0)) {
          try {
            times = bufferedReader.readLine();
            if (!(times.compareTo("end") == 0)) {
              String time = times.substring(0, 13);
              Long timeLong = new Long(time);
              long timelong = timeLong.longValue();
	      lasttime = timelong;
              int length = times.length();
              String value = times.substring(14, length);
              Double valueDouble = new Double(value);
              double valuedouble = valueDouble.doubleValue();
              if (valuedouble > maxValue) {
                maxValue = valuedouble;
              }
              timeSeries.addOrUpdate(new Second(new java.util.Date(timelong)), valuedouble);
                          }
          } catch (java.io.IOException e) {
            System.out.println("read run data IOException caught");
          }
        }
        while ( !(times.compareTo("finalend") == 0)) {
          try {
	    String endOfRun;
            times = bufferedReader.readLine();
            if (!(times.compareTo("finalend") == 0)) {
	      int divider = times.indexOf(" ");
              String startOfRun = times.substring(0, divider);
	      if(startOfRun.compareTo("0") == 0) {
	         runSeries.addOrUpdate(new Second(new java.util.Date(lasttime)),0.0);
	      }
	      else {
                 endOfRun = times.substring(divider+1);
                 Long sOR = new Long(startOfRun);
                 long sor = sOR.longValue();
                 runSeries.addOrUpdate(new Second(new java.util.Date(sor)), 0.0);
                 runSeries.addOrUpdate(new Second(new java.util.Date(sor+1000)), runValue);
                 Long eOR =  new Long(endOfRun);
                 long eor = eOR.longValue();
                 runSeries.addOrUpdate(new Second(new java.util.Date(eor-1000)), runValue);
                 runSeries.addOrUpdate(new Second(new java.util.Date(eor)), 0.0);
              }
            }
          } catch (java.io.IOException e) {
            System.out.println("read run data IOException caught");
          }
        }
        if (maxValue > beamValue) {
          beamValue = maxValue * 1.1;
        }

        try {
          intervalName = bufferedReader.readLine();
          beamTypeName = bufferedReader.readLine();
          beamTimeName = bufferedReader.readLine();
          runningTimeName = bufferedReader.readLine();
          deadTimeName = bufferedReader.readLine();
          fractionBeamName = bufferedReader.readLine();
        } catch (java.io.IOException e) {
           System.out.println("late IOException caught");
        }  
        try {
          bufferedReader.reset();
        } catch (java.io.IOException e) {
           System.out.println("reset IOException caught");
        }
        while ( !(times.compareTo("endbeam") == 0)) {
          try {
            times = bufferedReader.readLine();
            if (!(times.compareTo("endbeam") == 0)) {
              String startOfBeam = times.substring(0, 13);
              Long sOB = new Long(startOfBeam);
              long sob = sOB.longValue();
              beamSeries.addOrUpdate(new Second(new java.util.Date(sob)), 0.0);
              beamSeries.addOrUpdate(new Second(new java.util.Date(sob+1000)), beamValue);
              String endOfBeam = times.substring(14, 27);
              Long eOB =  new Long(endOfBeam);
              long eob = eOB.longValue();
              beamSeries.addOrUpdate(new Second(new java.util.Date(eob-1000)), beamValue);
              beamSeries.addOrUpdate(new Second(new java.util.Date(eob)), 0.0);
            }
          } catch (java.io.IOException e) {
            System.out.println("read beam data IOException caught");
          }
        }
      
      } catch (java.io.FileNotFoundException ex) {
        System.out.println("File /tmp/eff.log not found");
        System.exit(0);
      }
      final TimeSeriesCollection dataset = new TimeSeriesCollection();
      dataset.addSeries(timeSeries);
      beamCollection = new TimeSeriesCollection();
      beamCollection.addSeries(beamSeries);
      runCollection = new TimeSeriesCollection();
      runCollection.addSeries(runSeries);
      return dataset;

    }
  
}
