#ifndef ISCTPCORENAMED_H
#define ISCTPCORENAMED_H

#include <is/namedinfo.h>

#include <string>
#include <ostream>


// <<BeginUserCode>>

// <<EndUserCode>>
/**
 * CTPCORE monitoring values
 * 
 * @author  generated by the IS tool
 * @version 12/07/10
 */

class ISCTPCORENamed : public ISNamedInfo {
public:

    /**
     * Current number of L1A (absolute)
     */
    unsigned int                  L1A_counter;

    /**
     * Overflow bit for the L1A counter (0:ok, 1:overflow)
     */
    bool                          L1A_overflow;

    /**
     * Current L1A counter (lower 24 bits) of the L1ID in the CTPCore
     */
    unsigned int                  L1ID_L1A;

    /**
     * Current ECR counter (highest 8 bits) of the L1ID in the CTPCore
     */
    unsigned int                  L1ID_ECR;

    /**
     * Time in the run in seconds.
     */
    double                        RunTime;

    /**
     * Start-of-run time string
     */
    std::string                   StartRunTimeString;

    /**
     * Current time string
     */
    std::string                   CurrentTimeString;

    /**
     * GPS Time stamp taken in prepareForRun (seconds)
     */
    unsigned int                  GPSTimeStartOfRun_seconds;

    /**
     * GPS Time stamp taken in prepareForRun (nanoseconds)
     */
    unsigned int                  GPSTimeStartOfRun_nanoseconds;

    /**
     * Current GPS time stamp in the CTPCore (seconds)
     */
    unsigned int                  CurrentGPSTime_seconds;

    /**
     * Current GPS time stamp in the CTPCore (nanoseconds)
     */
    unsigned int                  CurrentGPSTime_nanoseconds;

    /**
     * Value of random trigger #1
     */
    unsigned int                  RandomTrigger1;

    /**
     * Value of random trigger #2
     */
    unsigned int                  RandomTrigger2;

    /**
     * Value of prescaled clock #1
     */
    unsigned int                  PrescaledClock1;

    /**
     * Value of prescaled clock #2
     */
    unsigned int                  PrescaledClock2;

    /**
     * CTPCORE monitoring events written to MON FIFO
     */
    unsigned int                  Monitoring_FIFO_Events;

    /**
     * CTPCORE monitoring events filled in histograms
     */
    unsigned int                  Monitoring_Events;

    /**
     * Rate of CTPCORE monitoring events in Hz (from GPS time stamps). NOT the average rate, but rather the rate of a monitoring readout block.
     */
    double                        Monitoring_Rate;

    /**
     * Size of the internal sw buffer in Bytes.
     */
    unsigned int                  Monitoring_SW_FIFO;

    /**
     * Filled percentage of the internal sw buffer.
     */
    double                        Monitoring_SW_FIFO_Percent;

    /**
     * Time in milliseconds spent for readout of MON FIFO and creation of MON events.
     */
    double                        Monitoring_Time;

    /**
     * Block-transfer readout rate of the hw FIFO in KByte/ms.
     */
    double                        Monitoring_BlockTransfer_Rate;

    /**
     * Amount of monitoring data in KByte readout via block transfer from hw FIFO per readout cycle.
     */
    double                        Monitoring_BlockTransfer_KBytes;

    /**
     * Monitoring mode (ONE: monitor on VME command / TWO: monitor on down-scale factor)
     */
    std::string                   Monitoring_Mode;

    /**
     * Monitoring down-scale factor
     */
    unsigned int                  Monitoring_ScaleDown;

    /**
     * Number of events to monitor after a VME salvo
     */
    unsigned int                  Monitoring_SalvoEvents;

    /**
     * LVL2-SLINK LinkDown flag (down:1 / up:0)
     */
    bool                          LVL2_SLINK_Down;

    /**
     * LVL2-SLINK LinkFull flag (full:1 / not full:0)
     */
    bool                          LVL2_SLINK_Full;

    /**
     * LVL2-SLINK LinkWriteEnable flag (enabled:1 / disabled:0)
     */
    bool                          LVL2_SLINK_WriteEnable;

    /**
     * DAQ-SLINK LinkDown flag (down:1 / up:0)
     */
    bool                          DAQ_SLINK_Down;

    /**
     * DAQ-SLINK LinkFull flag (full:1 / not full:0)
     */
    bool                          DAQ_SLINK_Full;

    /**
     * DAQ-SLINK LinkWriteEnable flag (enabled:1 / disabled:0)
     */
    bool                          DAQ_SLINK_WriteEnable;

    /**
     * LVL2-Readout-FIFO Empty flag (empty:1 / not empty:0)
     */
    bool                          LVL2_FIFO_Empty;

    /**
     * LVL2-Readout-FIFO Full flag (full:1 / not full:0)
     */
    bool                          LVL2_FIFO_Full;

    /**
     * LVL2-Readout-FIFO AlmostFull status flag (almost full:1 / not almost full:0) - from the status registers
     */
    bool                          LVL2_FIFO_AlmostFull;

    /**
     * LVL2-Readout-FIFO current # of words
     */
    unsigned int                  LVL2_FIFO_Words;

    /**
     * Percentage of maximum LVL2-Readout-FIFO content
     */
    double                        LVL2_FIFO_Percent;

    /**
     * Mask LVL2-Readout-FIFO AlmostFull flag (if masked:1 / if active:0)
     */
    bool                          LVL2_FIFO_AlmostFull_Masked;

    /**
     * Number of words to raise LVL2-Readout-FIFO AlmostFull flag
     */
    unsigned int                  LVL2_FIFO_AlmostFull_Mark;

    /**
     * LVL2-Readout-FIFO AlmostFull flag (set:1 / not set:0) - from the AlmostFull registers
     */
    bool                          LVL2_FIFO_AlmostFull_Set;

    /**
     * Mask LVL2-Readout-FIFO SLINK FlowControl (if masked:1 / if active:0)
     */
    bool                          LVL2_FIFO_SLINK_FlwCtrl_Masked;

    /**
     * LVL2-Readout-FIFO SLINK FlowControl mode (test mode:1 / normal mode:0)
     */
    bool                          LVL2_FIFO_SLINK_FlwCtrl_Mode;

    /**
     * LVL2-Readout-FIFO SLINK FlowControl (enabled:1 / disabled:0)
     */
    bool                          LVL2_FIFO_SLINK_FlwCtrl;

    /**
     * DAQ-Readout-FIFO Empty flag (empty:1 / not empty:0)
     */
    bool                          DAQ_FIFO_Empty;

    /**
     * DAQ-Readout-FIFO Full flag (full:1 / not full:0)
     */
    bool                          DAQ_FIFO_Full;

    /**
     * DAQ-Readout-FIFO AlmostFull status flag (almost full:1 / not almost full:0) - from the status registers
     */
    bool                          DAQ_FIFO_AlmostFull;

    /**
     * DAQ-Readout-FIFO current # of words
     */
    unsigned int                  DAQ_FIFO_Words;

    /**
     * Percentage of maximum DAQ-Readout-FIFO content
     */
    double                        DAQ_FIFO_Percent;

    /**
     * Mask DAQ-Readout-FIFO AlmostFull flag (if masked:1 / if active:0)
     */
    bool                          DAQ_FIFO_AlmostFull_Masked;

    /**
     * Number of words to raise DAQ-Readout-FIFO AlmostFull flag
     */
    unsigned int                  DAQ_FIFO_AlmostFull_Mark;

    /**
     * DAQ-Readout-FIFO AlmostFull flag (set:1 / not set:0) - from the AlmostFull registers
     */
    bool                          DAQ_FIFO_AlmostFull_Set;

    /**
     * Mask DAQ-Readout-FIFO to SLINK FlowControl (if masked:1 / if active:0)
     */
    bool                          DAQ_FIFO_SLINK_FlwCtrl_Masked;

    /**
     * DAQ-Readout-FIFO to SLINK FlowControl mode (test mode:1 / normal mode:0)
     */
    bool                          DAQ_FIFO_SLINK_FlwCtrl_Mode;

    /**
     * DAQ-Readout-FIFO to SLINK FlowControl (enabled:1 / disabled:0)
     */
    bool                          DAQ_FIFO_SLINK_FlwCtrl;

    /**
     * Monitoring-Readout-FIFO Empty flag (empty:1 / not empty:0)
     */
    bool                          MON_FIFO_Empty;

    /**
     * Monitoring-Readout-FIFO Full flag (full:1 / not full:0)
     */
    bool                          MON_FIFO_Full;

    /**
     * Monitoring-Readout-FIFO AlmostFull status flag (almost full:1 / not almost full:0) - from the status registers
     */
    bool                          MON_FIFO_AlmostFull;

    /**
     * Monitoring-Readout-FIFO current # of words
     */
    unsigned int                  MON_FIFO_Words;

    /**
     * Percentage of maximum Monitoring-Readout-FIFO content
     */
    double                        MON_FIFO_Percent;

    /**
     * Mask Monitoring-Readout-FIFO AlmostFull flag (if masked:1 / if active:0)
     */
    bool                          MON_FIFO_AlmostFull_Masked;

    /**
     * Number of words to raise Monitoring-Readout-FIFO AlmostFull flag
     */
    unsigned int                  MON_FIFO_AlmostFull_Mark;

    /**
     * Monitoring-Readout-FIFO AlmostFull flag (set:1 / not set:0) - from the AlmostFull registers
     */
    bool                          MON_FIFO_AlmostFull_Set;

    /**
     * Lookup-Table block BCID offset
     */
    unsigned int                  LUT_BCID_Offset;

    /**
     * Simple deadtime in units of BCs
     */
    unsigned int                  Simple_Deadtime;

    /**
     * Complex deadtime 1 enable (1: enabled / 0: disabled)
     */
    unsigned int                  Complex_Deadtime1_Enabled;

    /**
     * Bucket level complex deadtime 1
     */
    unsigned int                  Complex_Deadtime1_Level;

    /**
     * Leackage rate complex deadtime 1
     */
    unsigned int                  Complex_Deadtime1_Rate;

    /**
     * Complex deadtime 2 enable (1: enabled / 0: disabled)
     */
    unsigned int                  Complex_Deadtime2_Enabled;

    /**
     * Bucket level complex deadtime 2
     */
    unsigned int                  Complex_Deadtime2_Level;

    /**
     * Leackage rate complex deadtime 2
     */
    unsigned int                  Complex_Deadtime2_Rate;

    /**
     * Busy mask for Readout block (1: enabled / 0: disabled)
     */
    bool                          Busy_Mask_Readout;

    /**
     * Busy mask for Monitoring (1: enabled / 0: disabled)
     */
    bool                          Busy_Mask_Monitoring;

    /**
     * Busy mask for Backplane (1: enabled / 0: disabled)
     */
    bool                          Busy_Mask_Backplane;

    /**
     * Length of readout window in BCs from RDT block
     */
    unsigned int                  RDT_WindowWidth;

    /**
     * Length of readout window in BCs from EventFormat object
     */
    unsigned int                  FMT_WindowWidth;

    /**
     * Size of EventFormat object == size of CTP event in 32-bit words
     */
    unsigned int                  FMT_Size;

    /**
     * Master enable
     */
    std::string                   FMT_Control_MasterEnable;

    /**
     * Ignore GPS time stamp status
     */
    std::string                   FMT_Control_IgnoreTimestamp;

    /**
     */
    std::string                   FMT_Control_ModeOneState;

    /**
     */
    std::string                   FMT_Control_FormatterState;

    /**
     */
    std::string                   FMT_Control_ModeTwoState;

    /**
     */
    std::string                   FMT_Control_FormatterReset;

    /**
     */
    std::string                   FMT_Control_ModeOneReset;

    /**
     */
    std::string                   FMT_Control_ModeTwoReset;

    /**
     */
    std::string                   FMT_Control_ModeOneCommand;

    /**
     */
    std::string                   FMT_Control_ModeTwoEnable;

    /**
     * Length of PIT pipeline in BCs
     */
    unsigned int                  PIT_Pipeline;

    /**
     * PIT pipeline status (empty/not-empy and full/not-full)
     */
    std::string                   PIT_Pipeline_Status;

    /**
     * Length of TBP pipeline in BCs
     */
    unsigned int                  TBP_Pipeline;

    /**
     * TBP pipeline status (empty/not-empy and full/not-full)
     */
    std::string                   TBP_Pipeline_Status;

    /**
     * Length of TAP pipeline in BCs
     */
    unsigned int                  TAP_Pipeline;

    /**
     * TAP pipeline status (empty/not-empy and full/not-full)
     */
    std::string                   TAP_Pipeline_Status;

    /**
     * Length of TAV pipeline in BCs
     */
    unsigned int                  TAV_Pipeline;

    /**
     * TAV pipeline status (empty/not-empy and full/not-full)
     */
    std::string                   TAV_Pipeline_Status;

    /**
     * Busy control PIT/TBP derandomizer FIFO (enabled:1 / disabled:0)
     */
    bool                          PIT_TBP_Busy_Enable;

    /**
     * Number of words to raise busy signal for PIT/TBP derandomizer FIFO
     */
    unsigned int                  PIT_TBP_Busy_MaxWords;

    /**
     * Busy signal PIT/TBP derandomizer FIFO (set:1 / not set:0)
     */
    bool                          PIT_TBP_Busy;

    /**
     * Empty flag PIT/TBP derandomizer FIFO (empty:1 / not empty:0)
     */
    bool                          PIT_TBP_Status_Empty;

    /**
     * Full flag PIT/TBP derandomizer FIFO (full:1 / not full:0)
     */
    bool                          PIT_TBP_Status_Full;

    /**
     * Busy flag PIT/TBP derandomizer FIFO (busy:1 / not busy:0)
     */
    bool                          PIT_TBP_Status_Busy;

    /**
     * Current # of words in PIT/TBP derandomizer FIFO
     */
    unsigned int                  PIT_TBP_Status_Words;

    /**
     * Busy control TAP/TAV derandomizer FIFO (enabled:1 / disabled:0)
     */
    bool                          TAP_TAV_Busy_Enable;

    /**
     * Number of words to raise busy signal for TAP/TAV derandomizer FIFO
     */
    unsigned int                  TAP_TAV_Busy_MaxWords;

    /**
     * Busy signal TAP/TAV derandomizer FIFO (set:1 / not set:0)
     */
    bool                          TAP_TAV_Busy;

    /**
     * Empty flag TAP/TAV derandomizer FIFO (empty:1 / not empty:0)
     */
    bool                          TAP_TAV_Status_Empty;

    /**
     * Full flag TAP/TAV derandomizer FIFO (full:1 / not full:0)
     */
    bool                          TAP_TAV_Status_Full;

    /**
     * Busy flag TAP/TAV derandomizer FIFO (busy:1 / not busy:0)
     */
    bool                          TAP_TAV_Status_Busy;

    /**
     * Current # of words in TAP/TAV derandomizer FIFO
     */
    unsigned int                  TAP_TAV_Status_Words;

    /**
     * Busy control GPS derandomizer FIFO (enabled:1 / disabled:0)
     */
    bool                          GPS_Busy_Enable;

    /**
     * Number of words to raise busy signal for GPS derandomizer FIFO
     */
    unsigned int                  GPS_Busy_MaxWords;

    /**
     * Busy signal GPS derandomizer FIFO (set:1 / not set:0)
     */
    bool                          GPS_Busy;

    /**
     * Empty flag GPS derandomizer FIFO (empty:1 / not empty:0)
     */
    bool                          GPS_Status_Empty;

    /**
     * Full flag GPS derandomizer FIFO (full:1 / not full:0)
     */
    bool                          GPS_Status_Full;

    /**
     * Busy flag GPS derandomizer FIFO (busy:1 / not busy:0)
     */
    bool                          GPS_Status_Busy;

    /**
     * Current # of words in GPS derandomizer FIFO
     */
    unsigned int                  GPS_Status_Words;

    /**
     * Busy control markers (ttype,bcid,l1id,run#) derandomizer FIFO (enabled:1 / disabled:0)
     */
    bool                          MRK_Busy_Enable;

    /**
     * Number of words to raise busy signal for markers derandomizer FIFO
     */
    unsigned int                  MRK_Busy_MaxWords;

    /**
     * Busy signal markers derandomizer FIFO (set:1 / not set:0)
     */
    bool                          MRK_Busy;

    /**
     * Empty flag markers (ttype,bcid,l1id,run#) derandomizer FIFO (empty:1 / not empty:0)
     */
    bool                          MRK_Status_Empty;

    /**
     * Full flag markers (ttype,bcid,l1id,run#) derandomizer FIFO (full:1 / not full:0)
     */
    bool                          MRK_Status_Full;

    /**
     * Busy flag markers (ttype,bcid,l1id,run#) derandomizer FIFO (busy:1 / not busy:0)
     */
    bool                          MRK_Status_Busy;

    /**
     * Current # of words in markers (ttype,bcid,l1id,run#) derandomizer FIFO
     */
    unsigned int                  MRK_Status_Words;

    /**
     * Trigger Mask item 0 to 31 (as usual counting from right)
     */
    std::string                   Trigger_Mask_0;

    /**
     * Trigger Mask item 32 to 63 (as usual counting from right)
     */
    std::string                   Trigger_Mask_1;

    /**
     * Trigger Mask item 64 to 95 (as usual counting from right)
     */
    std::string                   Trigger_Mask_2;

    /**
     * Trigger Mask item 96 to 127 (as usual counting from right)
     */
    std::string                   Trigger_Mask_3;

    /**
     * Trigger Mask item 128 to 159 (as usual counting from right)
     */
    std::string                   Trigger_Mask_4;

    /**
     * Trigger Mask item 160 to 191 (as usual counting from right)
     */
    std::string                   Trigger_Mask_5;

    /**
     * Trigger Mask item 192 to 223 (as usual counting from right)
     */
    std::string                   Trigger_Mask_6;

    /**
     * Trigger Mask item 224 to 255 (as usual counting from right)
     */
    std::string                   Trigger_Mask_7;


    static const ISType & type() {
	static const ISType type_ = ISCTPCORENamed( IPCPartition(), "" ).ISInfo::type();
	return type_;
    }

    virtual std::ostream & print( std::ostream & out ) const {
	ISNamedInfo::print( out );
	out << "L1A_counter: " << L1A_counter << "	//Current number of L1A (absolute)" << std::endl;
	out << "L1A_overflow: " << L1A_overflow << "	//Overflow bit for the L1A counter (0:ok, 1:overflow)" << std::endl;
	out << "L1ID_L1A: " << L1ID_L1A << "	//Current L1A counter (lower 24 bits) of the L1ID in the CTPCore" << std::endl;
	out << "L1ID_ECR: " << L1ID_ECR << "	//Current ECR counter (highest 8 bits) of the L1ID in the CTPCore" << std::endl;
	out << "RunTime: " << RunTime << "	//Time in the run in seconds." << std::endl;
	out << "StartRunTimeString: " << StartRunTimeString << "	//Start-of-run time string" << std::endl;
	out << "CurrentTimeString: " << CurrentTimeString << "	//Current time string" << std::endl;
	out << "GPSTimeStartOfRun_seconds: " << GPSTimeStartOfRun_seconds << "	//GPS Time stamp taken in prepareForRun (seconds)" << std::endl;
	out << "GPSTimeStartOfRun_nanoseconds: " << GPSTimeStartOfRun_nanoseconds << "	//GPS Time stamp taken in prepareForRun (nanoseconds)" << std::endl;
	out << "CurrentGPSTime_seconds: " << CurrentGPSTime_seconds << "	//Current GPS time stamp in the CTPCore (seconds)" << std::endl;
	out << "CurrentGPSTime_nanoseconds: " << CurrentGPSTime_nanoseconds << "	//Current GPS time stamp in the CTPCore (nanoseconds)" << std::endl;
	out << "RandomTrigger1: " << RandomTrigger1 << "	//Value of random trigger #1" << std::endl;
	out << "RandomTrigger2: " << RandomTrigger2 << "	//Value of random trigger #2" << std::endl;
	out << "PrescaledClock1: " << PrescaledClock1 << "	//Value of prescaled clock #1" << std::endl;
	out << "PrescaledClock2: " << PrescaledClock2 << "	//Value of prescaled clock #2" << std::endl;
	out << "Monitoring_FIFO_Events: " << Monitoring_FIFO_Events << "	//CTPCORE monitoring events written to MON FIFO" << std::endl;
	out << "Monitoring_Events: " << Monitoring_Events << "	//CTPCORE monitoring events filled in histograms" << std::endl;
	out << "Monitoring_Rate: " << Monitoring_Rate << "	//Rate of CTPCORE monitoring events in Hz (from GPS time stamps). NOT the average rate, but rather the rate of a monitoring readout block." << std::endl;
	out << "Monitoring_SW_FIFO: " << Monitoring_SW_FIFO << "	//Size of the internal sw buffer in Bytes." << std::endl;
	out << "Monitoring_SW_FIFO_Percent: " << Monitoring_SW_FIFO_Percent << "	//Filled percentage of the internal sw buffer." << std::endl;
	out << "Monitoring_Time: " << Monitoring_Time << "	//Time in milliseconds spent for readout of MON FIFO and creation of MON events." << std::endl;
	out << "Monitoring_BlockTransfer_Rate: " << Monitoring_BlockTransfer_Rate << "	//Block-transfer readout rate of the hw FIFO in KByte/ms." << std::endl;
	out << "Monitoring_BlockTransfer_KBytes: " << Monitoring_BlockTransfer_KBytes << "	//Amount of monitoring data in KByte readout via block transfer from hw FIFO per readout cycle." << std::endl;
	out << "Monitoring_Mode: " << Monitoring_Mode << "	//Monitoring mode (ONE: monitor on VME command / TWO: monitor on down-scale factor)" << std::endl;
	out << "Monitoring_ScaleDown: " << Monitoring_ScaleDown << "	//Monitoring down-scale factor" << std::endl;
	out << "Monitoring_SalvoEvents: " << Monitoring_SalvoEvents << "	//Number of events to monitor after a VME salvo" << std::endl;
	out << "LVL2_SLINK_Down: " << LVL2_SLINK_Down << "	//LVL2-SLINK LinkDown flag (down:1 / up:0)" << std::endl;
	out << "LVL2_SLINK_Full: " << LVL2_SLINK_Full << "	//LVL2-SLINK LinkFull flag (full:1 / not full:0)" << std::endl;
	out << "LVL2_SLINK_WriteEnable: " << LVL2_SLINK_WriteEnable << "	//LVL2-SLINK LinkWriteEnable flag (enabled:1 / disabled:0)" << std::endl;
	out << "DAQ_SLINK_Down: " << DAQ_SLINK_Down << "	//DAQ-SLINK LinkDown flag (down:1 / up:0)" << std::endl;
	out << "DAQ_SLINK_Full: " << DAQ_SLINK_Full << "	//DAQ-SLINK LinkFull flag (full:1 / not full:0)" << std::endl;
	out << "DAQ_SLINK_WriteEnable: " << DAQ_SLINK_WriteEnable << "	//DAQ-SLINK LinkWriteEnable flag (enabled:1 / disabled:0)" << std::endl;
	out << "LVL2_FIFO_Empty: " << LVL2_FIFO_Empty << "	//LVL2-Readout-FIFO Empty flag (empty:1 / not empty:0)" << std::endl;
	out << "LVL2_FIFO_Full: " << LVL2_FIFO_Full << "	//LVL2-Readout-FIFO Full flag (full:1 / not full:0)" << std::endl;
	out << "LVL2_FIFO_AlmostFull: " << LVL2_FIFO_AlmostFull << "	//LVL2-Readout-FIFO AlmostFull status flag (almost full:1 / not almost full:0) - from the status registers" << std::endl;
	out << "LVL2_FIFO_Words: " << LVL2_FIFO_Words << "	//LVL2-Readout-FIFO current # of words" << std::endl;
	out << "LVL2_FIFO_Percent: " << LVL2_FIFO_Percent << "	//Percentage of maximum LVL2-Readout-FIFO content" << std::endl;
	out << "LVL2_FIFO_AlmostFull_Masked: " << LVL2_FIFO_AlmostFull_Masked << "	//Mask LVL2-Readout-FIFO AlmostFull flag (if masked:1 / if active:0)" << std::endl;
	out << "LVL2_FIFO_AlmostFull_Mark: " << LVL2_FIFO_AlmostFull_Mark << "	//Number of words to raise LVL2-Readout-FIFO AlmostFull flag" << std::endl;
	out << "LVL2_FIFO_AlmostFull_Set: " << LVL2_FIFO_AlmostFull_Set << "	//LVL2-Readout-FIFO AlmostFull flag (set:1 / not set:0) - from the AlmostFull registers" << std::endl;
	out << "LVL2_FIFO_SLINK_FlwCtrl_Masked: " << LVL2_FIFO_SLINK_FlwCtrl_Masked << "	//Mask LVL2-Readout-FIFO SLINK FlowControl (if masked:1 / if active:0)" << std::endl;
	out << "LVL2_FIFO_SLINK_FlwCtrl_Mode: " << LVL2_FIFO_SLINK_FlwCtrl_Mode << "	//LVL2-Readout-FIFO SLINK FlowControl mode (test mode:1 / normal mode:0)" << std::endl;
	out << "LVL2_FIFO_SLINK_FlwCtrl: " << LVL2_FIFO_SLINK_FlwCtrl << "	//LVL2-Readout-FIFO SLINK FlowControl (enabled:1 / disabled:0)" << std::endl;
	out << "DAQ_FIFO_Empty: " << DAQ_FIFO_Empty << "	//DAQ-Readout-FIFO Empty flag (empty:1 / not empty:0)" << std::endl;
	out << "DAQ_FIFO_Full: " << DAQ_FIFO_Full << "	//DAQ-Readout-FIFO Full flag (full:1 / not full:0)" << std::endl;
	out << "DAQ_FIFO_AlmostFull: " << DAQ_FIFO_AlmostFull << "	//DAQ-Readout-FIFO AlmostFull status flag (almost full:1 / not almost full:0) - from the status registers" << std::endl;
	out << "DAQ_FIFO_Words: " << DAQ_FIFO_Words << "	//DAQ-Readout-FIFO current # of words" << std::endl;
	out << "DAQ_FIFO_Percent: " << DAQ_FIFO_Percent << "	//Percentage of maximum DAQ-Readout-FIFO content" << std::endl;
	out << "DAQ_FIFO_AlmostFull_Masked: " << DAQ_FIFO_AlmostFull_Masked << "	//Mask DAQ-Readout-FIFO AlmostFull flag (if masked:1 / if active:0)" << std::endl;
	out << "DAQ_FIFO_AlmostFull_Mark: " << DAQ_FIFO_AlmostFull_Mark << "	//Number of words to raise DAQ-Readout-FIFO AlmostFull flag" << std::endl;
	out << "DAQ_FIFO_AlmostFull_Set: " << DAQ_FIFO_AlmostFull_Set << "	//DAQ-Readout-FIFO AlmostFull flag (set:1 / not set:0) - from the AlmostFull registers" << std::endl;
	out << "DAQ_FIFO_SLINK_FlwCtrl_Masked: " << DAQ_FIFO_SLINK_FlwCtrl_Masked << "	//Mask DAQ-Readout-FIFO to SLINK FlowControl (if masked:1 / if active:0)" << std::endl;
	out << "DAQ_FIFO_SLINK_FlwCtrl_Mode: " << DAQ_FIFO_SLINK_FlwCtrl_Mode << "	//DAQ-Readout-FIFO to SLINK FlowControl mode (test mode:1 / normal mode:0)" << std::endl;
	out << "DAQ_FIFO_SLINK_FlwCtrl: " << DAQ_FIFO_SLINK_FlwCtrl << "	//DAQ-Readout-FIFO to SLINK FlowControl (enabled:1 / disabled:0)" << std::endl;
	out << "MON_FIFO_Empty: " << MON_FIFO_Empty << "	//Monitoring-Readout-FIFO Empty flag (empty:1 / not empty:0)" << std::endl;
	out << "MON_FIFO_Full: " << MON_FIFO_Full << "	//Monitoring-Readout-FIFO Full flag (full:1 / not full:0)" << std::endl;
	out << "MON_FIFO_AlmostFull: " << MON_FIFO_AlmostFull << "	//Monitoring-Readout-FIFO AlmostFull status flag (almost full:1 / not almost full:0) - from the status registers" << std::endl;
	out << "MON_FIFO_Words: " << MON_FIFO_Words << "	//Monitoring-Readout-FIFO current # of words" << std::endl;
	out << "MON_FIFO_Percent: " << MON_FIFO_Percent << "	//Percentage of maximum Monitoring-Readout-FIFO content" << std::endl;
	out << "MON_FIFO_AlmostFull_Masked: " << MON_FIFO_AlmostFull_Masked << "	//Mask Monitoring-Readout-FIFO AlmostFull flag (if masked:1 / if active:0)" << std::endl;
	out << "MON_FIFO_AlmostFull_Mark: " << MON_FIFO_AlmostFull_Mark << "	//Number of words to raise Monitoring-Readout-FIFO AlmostFull flag" << std::endl;
	out << "MON_FIFO_AlmostFull_Set: " << MON_FIFO_AlmostFull_Set << "	//Monitoring-Readout-FIFO AlmostFull flag (set:1 / not set:0) - from the AlmostFull registers" << std::endl;
	out << "LUT_BCID_Offset: " << LUT_BCID_Offset << "	//Lookup-Table block BCID offset" << std::endl;
	out << "Simple_Deadtime: " << Simple_Deadtime << "	//Simple deadtime in units of BCs" << std::endl;
	out << "Complex_Deadtime1_Enabled: " << Complex_Deadtime1_Enabled << "	//Complex deadtime 1 enable (1: enabled / 0: disabled)" << std::endl;
	out << "Complex_Deadtime1_Level: " << Complex_Deadtime1_Level << "	//Bucket level complex deadtime 1" << std::endl;
	out << "Complex_Deadtime1_Rate: " << Complex_Deadtime1_Rate << "	//Leackage rate complex deadtime 1" << std::endl;
	out << "Complex_Deadtime2_Enabled: " << Complex_Deadtime2_Enabled << "	//Complex deadtime 2 enable (1: enabled / 0: disabled)" << std::endl;
	out << "Complex_Deadtime2_Level: " << Complex_Deadtime2_Level << "	//Bucket level complex deadtime 2" << std::endl;
	out << "Complex_Deadtime2_Rate: " << Complex_Deadtime2_Rate << "	//Leackage rate complex deadtime 2" << std::endl;
	out << "Busy_Mask_Readout: " << Busy_Mask_Readout << "	//Busy mask for Readout block (1: enabled / 0: disabled)" << std::endl;
	out << "Busy_Mask_Monitoring: " << Busy_Mask_Monitoring << "	//Busy mask for Monitoring (1: enabled / 0: disabled)" << std::endl;
	out << "Busy_Mask_Backplane: " << Busy_Mask_Backplane << "	//Busy mask for Backplane (1: enabled / 0: disabled)" << std::endl;
	out << "RDT_WindowWidth: " << RDT_WindowWidth << "	//Length of readout window in BCs from RDT block" << std::endl;
	out << "FMT_WindowWidth: " << FMT_WindowWidth << "	//Length of readout window in BCs from EventFormat object" << std::endl;
	out << "FMT_Size: " << FMT_Size << "	//Size of EventFormat object == size of CTP event in 32-bit words" << std::endl;
	out << "FMT_Control_MasterEnable: " << FMT_Control_MasterEnable << "	//Master enable" << std::endl;
	out << "FMT_Control_IgnoreTimestamp: " << FMT_Control_IgnoreTimestamp << "	//Ignore GPS time stamp status" << std::endl;
	out << "FMT_Control_ModeOneState: " << FMT_Control_ModeOneState << "	//" << std::endl;
	out << "FMT_Control_FormatterState: " << FMT_Control_FormatterState << "	//" << std::endl;
	out << "FMT_Control_ModeTwoState: " << FMT_Control_ModeTwoState << "	//" << std::endl;
	out << "FMT_Control_FormatterReset: " << FMT_Control_FormatterReset << "	//" << std::endl;
	out << "FMT_Control_ModeOneReset: " << FMT_Control_ModeOneReset << "	//" << std::endl;
	out << "FMT_Control_ModeTwoReset: " << FMT_Control_ModeTwoReset << "	//" << std::endl;
	out << "FMT_Control_ModeOneCommand: " << FMT_Control_ModeOneCommand << "	//" << std::endl;
	out << "FMT_Control_ModeTwoEnable: " << FMT_Control_ModeTwoEnable << "	//" << std::endl;
	out << "PIT_Pipeline: " << PIT_Pipeline << "	//Length of PIT pipeline in BCs" << std::endl;
	out << "PIT_Pipeline_Status: " << PIT_Pipeline_Status << "	//PIT pipeline status (empty/not-empy and full/not-full)" << std::endl;
	out << "TBP_Pipeline: " << TBP_Pipeline << "	//Length of TBP pipeline in BCs" << std::endl;
	out << "TBP_Pipeline_Status: " << TBP_Pipeline_Status << "	//TBP pipeline status (empty/not-empy and full/not-full)" << std::endl;
	out << "TAP_Pipeline: " << TAP_Pipeline << "	//Length of TAP pipeline in BCs" << std::endl;
	out << "TAP_Pipeline_Status: " << TAP_Pipeline_Status << "	//TAP pipeline status (empty/not-empy and full/not-full)" << std::endl;
	out << "TAV_Pipeline: " << TAV_Pipeline << "	//Length of TAV pipeline in BCs" << std::endl;
	out << "TAV_Pipeline_Status: " << TAV_Pipeline_Status << "	//TAV pipeline status (empty/not-empy and full/not-full)" << std::endl;
	out << "PIT_TBP_Busy_Enable: " << PIT_TBP_Busy_Enable << "	//Busy control PIT/TBP derandomizer FIFO (enabled:1 / disabled:0)" << std::endl;
	out << "PIT_TBP_Busy_MaxWords: " << PIT_TBP_Busy_MaxWords << "	//Number of words to raise busy signal for PIT/TBP derandomizer FIFO" << std::endl;
	out << "PIT_TBP_Busy: " << PIT_TBP_Busy << "	//Busy signal PIT/TBP derandomizer FIFO (set:1 / not set:0)" << std::endl;
	out << "PIT_TBP_Status_Empty: " << PIT_TBP_Status_Empty << "	//Empty flag PIT/TBP derandomizer FIFO (empty:1 / not empty:0)" << std::endl;
	out << "PIT_TBP_Status_Full: " << PIT_TBP_Status_Full << "	//Full flag PIT/TBP derandomizer FIFO (full:1 / not full:0)" << std::endl;
	out << "PIT_TBP_Status_Busy: " << PIT_TBP_Status_Busy << "	//Busy flag PIT/TBP derandomizer FIFO (busy:1 / not busy:0)" << std::endl;
	out << "PIT_TBP_Status_Words: " << PIT_TBP_Status_Words << "	//Current # of words in PIT/TBP derandomizer FIFO" << std::endl;
	out << "TAP_TAV_Busy_Enable: " << TAP_TAV_Busy_Enable << "	//Busy control TAP/TAV derandomizer FIFO (enabled:1 / disabled:0)" << std::endl;
	out << "TAP_TAV_Busy_MaxWords: " << TAP_TAV_Busy_MaxWords << "	//Number of words to raise busy signal for TAP/TAV derandomizer FIFO" << std::endl;
	out << "TAP_TAV_Busy: " << TAP_TAV_Busy << "	//Busy signal TAP/TAV derandomizer FIFO (set:1 / not set:0)" << std::endl;
	out << "TAP_TAV_Status_Empty: " << TAP_TAV_Status_Empty << "	//Empty flag TAP/TAV derandomizer FIFO (empty:1 / not empty:0)" << std::endl;
	out << "TAP_TAV_Status_Full: " << TAP_TAV_Status_Full << "	//Full flag TAP/TAV derandomizer FIFO (full:1 / not full:0)" << std::endl;
	out << "TAP_TAV_Status_Busy: " << TAP_TAV_Status_Busy << "	//Busy flag TAP/TAV derandomizer FIFO (busy:1 / not busy:0)" << std::endl;
	out << "TAP_TAV_Status_Words: " << TAP_TAV_Status_Words << "	//Current # of words in TAP/TAV derandomizer FIFO" << std::endl;
	out << "GPS_Busy_Enable: " << GPS_Busy_Enable << "	//Busy control GPS derandomizer FIFO (enabled:1 / disabled:0)" << std::endl;
	out << "GPS_Busy_MaxWords: " << GPS_Busy_MaxWords << "	//Number of words to raise busy signal for GPS derandomizer FIFO" << std::endl;
	out << "GPS_Busy: " << GPS_Busy << "	//Busy signal GPS derandomizer FIFO (set:1 / not set:0)" << std::endl;
	out << "GPS_Status_Empty: " << GPS_Status_Empty << "	//Empty flag GPS derandomizer FIFO (empty:1 / not empty:0)" << std::endl;
	out << "GPS_Status_Full: " << GPS_Status_Full << "	//Full flag GPS derandomizer FIFO (full:1 / not full:0)" << std::endl;
	out << "GPS_Status_Busy: " << GPS_Status_Busy << "	//Busy flag GPS derandomizer FIFO (busy:1 / not busy:0)" << std::endl;
	out << "GPS_Status_Words: " << GPS_Status_Words << "	//Current # of words in GPS derandomizer FIFO" << std::endl;
	out << "MRK_Busy_Enable: " << MRK_Busy_Enable << "	//Busy control markers (ttype,bcid,l1id,run#) derandomizer FIFO (enabled:1 / disabled:0)" << std::endl;
	out << "MRK_Busy_MaxWords: " << MRK_Busy_MaxWords << "	//Number of words to raise busy signal for markers derandomizer FIFO" << std::endl;
	out << "MRK_Busy: " << MRK_Busy << "	//Busy signal markers derandomizer FIFO (set:1 / not set:0)" << std::endl;
	out << "MRK_Status_Empty: " << MRK_Status_Empty << "	//Empty flag markers (ttype,bcid,l1id,run#) derandomizer FIFO (empty:1 / not empty:0)" << std::endl;
	out << "MRK_Status_Full: " << MRK_Status_Full << "	//Full flag markers (ttype,bcid,l1id,run#) derandomizer FIFO (full:1 / not full:0)" << std::endl;
	out << "MRK_Status_Busy: " << MRK_Status_Busy << "	//Busy flag markers (ttype,bcid,l1id,run#) derandomizer FIFO (busy:1 / not busy:0)" << std::endl;
	out << "MRK_Status_Words: " << MRK_Status_Words << "	//Current # of words in markers (ttype,bcid,l1id,run#) derandomizer FIFO" << std::endl;
	out << "Trigger_Mask_0: " << Trigger_Mask_0 << "	//Trigger Mask item 0 to 31 (as usual counting from right)" << std::endl;
	out << "Trigger_Mask_1: " << Trigger_Mask_1 << "	//Trigger Mask item 32 to 63 (as usual counting from right)" << std::endl;
	out << "Trigger_Mask_2: " << Trigger_Mask_2 << "	//Trigger Mask item 64 to 95 (as usual counting from right)" << std::endl;
	out << "Trigger_Mask_3: " << Trigger_Mask_3 << "	//Trigger Mask item 96 to 127 (as usual counting from right)" << std::endl;
	out << "Trigger_Mask_4: " << Trigger_Mask_4 << "	//Trigger Mask item 128 to 159 (as usual counting from right)" << std::endl;
	out << "Trigger_Mask_5: " << Trigger_Mask_5 << "	//Trigger Mask item 160 to 191 (as usual counting from right)" << std::endl;
	out << "Trigger_Mask_6: " << Trigger_Mask_6 << "	//Trigger Mask item 192 to 223 (as usual counting from right)" << std::endl;
	out << "Trigger_Mask_7: " << Trigger_Mask_7 << "	//Trigger Mask item 224 to 255 (as usual counting from right)" << std::endl;
	return out;
    }

    ISCTPCORENamed( const IPCPartition & partition, const std::string & name )
      : ISNamedInfo( partition, name, "ISCTPCORE" )
    {
	initialize();
    }

    ~ISCTPCORENamed(){

// <<BeginUserCode>>

// <<EndUserCode>>
    }

protected:
    ISCTPCORENamed( const IPCPartition & partition, const std::string & name, const std::string & type )
      : ISNamedInfo( partition, name, type )
    {
	initialize();
    }

    void publishGuts( ISostream & out ){
	out << L1A_counter << L1A_overflow << L1ID_L1A << L1ID_ECR << RunTime << StartRunTimeString;
	out << CurrentTimeString << GPSTimeStartOfRun_seconds << GPSTimeStartOfRun_nanoseconds;
	out << CurrentGPSTime_seconds << CurrentGPSTime_nanoseconds << RandomTrigger1 << RandomTrigger2;
	out << PrescaledClock1 << PrescaledClock2 << Monitoring_FIFO_Events << Monitoring_Events;
	out << Monitoring_Rate << Monitoring_SW_FIFO << Monitoring_SW_FIFO_Percent << Monitoring_Time;
	out << Monitoring_BlockTransfer_Rate << Monitoring_BlockTransfer_KBytes << Monitoring_Mode;
	out << Monitoring_ScaleDown << Monitoring_SalvoEvents << LVL2_SLINK_Down << LVL2_SLINK_Full;
	out << LVL2_SLINK_WriteEnable << DAQ_SLINK_Down << DAQ_SLINK_Full << DAQ_SLINK_WriteEnable;
	out << LVL2_FIFO_Empty << LVL2_FIFO_Full << LVL2_FIFO_AlmostFull << LVL2_FIFO_Words;
	out << LVL2_FIFO_Percent << LVL2_FIFO_AlmostFull_Masked << LVL2_FIFO_AlmostFull_Mark;
	out << LVL2_FIFO_AlmostFull_Set << LVL2_FIFO_SLINK_FlwCtrl_Masked << LVL2_FIFO_SLINK_FlwCtrl_Mode;
	out << LVL2_FIFO_SLINK_FlwCtrl << DAQ_FIFO_Empty << DAQ_FIFO_Full << DAQ_FIFO_AlmostFull;
	out << DAQ_FIFO_Words << DAQ_FIFO_Percent << DAQ_FIFO_AlmostFull_Masked << DAQ_FIFO_AlmostFull_Mark;
	out << DAQ_FIFO_AlmostFull_Set << DAQ_FIFO_SLINK_FlwCtrl_Masked << DAQ_FIFO_SLINK_FlwCtrl_Mode;
	out << DAQ_FIFO_SLINK_FlwCtrl << MON_FIFO_Empty << MON_FIFO_Full << MON_FIFO_AlmostFull;
	out << MON_FIFO_Words << MON_FIFO_Percent << MON_FIFO_AlmostFull_Masked << MON_FIFO_AlmostFull_Mark;
	out << MON_FIFO_AlmostFull_Set << LUT_BCID_Offset << Simple_Deadtime << Complex_Deadtime1_Enabled;
	out << Complex_Deadtime1_Level << Complex_Deadtime1_Rate << Complex_Deadtime2_Enabled;
	out << Complex_Deadtime2_Level << Complex_Deadtime2_Rate << Busy_Mask_Readout << Busy_Mask_Monitoring;
	out << Busy_Mask_Backplane << RDT_WindowWidth << FMT_WindowWidth << FMT_Size << FMT_Control_MasterEnable;
	out << FMT_Control_IgnoreTimestamp << FMT_Control_ModeOneState << FMT_Control_FormatterState;
	out << FMT_Control_ModeTwoState << FMT_Control_FormatterReset << FMT_Control_ModeOneReset;
	out << FMT_Control_ModeTwoReset << FMT_Control_ModeOneCommand << FMT_Control_ModeTwoEnable;
	out << PIT_Pipeline << PIT_Pipeline_Status << TBP_Pipeline << TBP_Pipeline_Status;
	out << TAP_Pipeline << TAP_Pipeline_Status << TAV_Pipeline << TAV_Pipeline_Status;
	out << PIT_TBP_Busy_Enable << PIT_TBP_Busy_MaxWords << PIT_TBP_Busy << PIT_TBP_Status_Empty;
	out << PIT_TBP_Status_Full << PIT_TBP_Status_Busy << PIT_TBP_Status_Words << TAP_TAV_Busy_Enable;
	out << TAP_TAV_Busy_MaxWords << TAP_TAV_Busy << TAP_TAV_Status_Empty << TAP_TAV_Status_Full;
	out << TAP_TAV_Status_Busy << TAP_TAV_Status_Words << GPS_Busy_Enable << GPS_Busy_MaxWords;
	out << GPS_Busy << GPS_Status_Empty << GPS_Status_Full << GPS_Status_Busy << GPS_Status_Words;
	out << MRK_Busy_Enable << MRK_Busy_MaxWords << MRK_Busy << MRK_Status_Empty << MRK_Status_Full;
	out << MRK_Status_Busy << MRK_Status_Words << Trigger_Mask_0 << Trigger_Mask_1 << Trigger_Mask_2;
	out << Trigger_Mask_3 << Trigger_Mask_4 << Trigger_Mask_5 << Trigger_Mask_6 << Trigger_Mask_7;
    }

    void refreshGuts( ISistream & in ){
	in >> L1A_counter >> L1A_overflow >> L1ID_L1A >> L1ID_ECR >> RunTime >> StartRunTimeString;
	in >> CurrentTimeString >> GPSTimeStartOfRun_seconds >> GPSTimeStartOfRun_nanoseconds;
	in >> CurrentGPSTime_seconds >> CurrentGPSTime_nanoseconds >> RandomTrigger1 >> RandomTrigger2;
	in >> PrescaledClock1 >> PrescaledClock2 >> Monitoring_FIFO_Events >> Monitoring_Events;
	in >> Monitoring_Rate >> Monitoring_SW_FIFO >> Monitoring_SW_FIFO_Percent >> Monitoring_Time;
	in >> Monitoring_BlockTransfer_Rate >> Monitoring_BlockTransfer_KBytes >> Monitoring_Mode;
	in >> Monitoring_ScaleDown >> Monitoring_SalvoEvents >> LVL2_SLINK_Down >> LVL2_SLINK_Full;
	in >> LVL2_SLINK_WriteEnable >> DAQ_SLINK_Down >> DAQ_SLINK_Full >> DAQ_SLINK_WriteEnable;
	in >> LVL2_FIFO_Empty >> LVL2_FIFO_Full >> LVL2_FIFO_AlmostFull >> LVL2_FIFO_Words;
	in >> LVL2_FIFO_Percent >> LVL2_FIFO_AlmostFull_Masked >> LVL2_FIFO_AlmostFull_Mark;
	in >> LVL2_FIFO_AlmostFull_Set >> LVL2_FIFO_SLINK_FlwCtrl_Masked >> LVL2_FIFO_SLINK_FlwCtrl_Mode;
	in >> LVL2_FIFO_SLINK_FlwCtrl >> DAQ_FIFO_Empty >> DAQ_FIFO_Full >> DAQ_FIFO_AlmostFull;
	in >> DAQ_FIFO_Words >> DAQ_FIFO_Percent >> DAQ_FIFO_AlmostFull_Masked >> DAQ_FIFO_AlmostFull_Mark;
	in >> DAQ_FIFO_AlmostFull_Set >> DAQ_FIFO_SLINK_FlwCtrl_Masked >> DAQ_FIFO_SLINK_FlwCtrl_Mode;
	in >> DAQ_FIFO_SLINK_FlwCtrl >> MON_FIFO_Empty >> MON_FIFO_Full >> MON_FIFO_AlmostFull;
	in >> MON_FIFO_Words >> MON_FIFO_Percent >> MON_FIFO_AlmostFull_Masked >> MON_FIFO_AlmostFull_Mark;
	in >> MON_FIFO_AlmostFull_Set >> LUT_BCID_Offset >> Simple_Deadtime >> Complex_Deadtime1_Enabled;
	in >> Complex_Deadtime1_Level >> Complex_Deadtime1_Rate >> Complex_Deadtime2_Enabled;
	in >> Complex_Deadtime2_Level >> Complex_Deadtime2_Rate >> Busy_Mask_Readout >> Busy_Mask_Monitoring;
	in >> Busy_Mask_Backplane >> RDT_WindowWidth >> FMT_WindowWidth >> FMT_Size >> FMT_Control_MasterEnable;
	in >> FMT_Control_IgnoreTimestamp >> FMT_Control_ModeOneState >> FMT_Control_FormatterState;
	in >> FMT_Control_ModeTwoState >> FMT_Control_FormatterReset >> FMT_Control_ModeOneReset;
	in >> FMT_Control_ModeTwoReset >> FMT_Control_ModeOneCommand >> FMT_Control_ModeTwoEnable;
	in >> PIT_Pipeline >> PIT_Pipeline_Status >> TBP_Pipeline >> TBP_Pipeline_Status;
	in >> TAP_Pipeline >> TAP_Pipeline_Status >> TAV_Pipeline >> TAV_Pipeline_Status;
	in >> PIT_TBP_Busy_Enable >> PIT_TBP_Busy_MaxWords >> PIT_TBP_Busy >> PIT_TBP_Status_Empty;
	in >> PIT_TBP_Status_Full >> PIT_TBP_Status_Busy >> PIT_TBP_Status_Words >> TAP_TAV_Busy_Enable;
	in >> TAP_TAV_Busy_MaxWords >> TAP_TAV_Busy >> TAP_TAV_Status_Empty >> TAP_TAV_Status_Full;
	in >> TAP_TAV_Status_Busy >> TAP_TAV_Status_Words >> GPS_Busy_Enable >> GPS_Busy_MaxWords;
	in >> GPS_Busy >> GPS_Status_Empty >> GPS_Status_Full >> GPS_Status_Busy >> GPS_Status_Words;
	in >> MRK_Busy_Enable >> MRK_Busy_MaxWords >> MRK_Busy >> MRK_Status_Empty >> MRK_Status_Full;
	in >> MRK_Status_Busy >> MRK_Status_Words >> Trigger_Mask_0 >> Trigger_Mask_1 >> Trigger_Mask_2;
	in >> Trigger_Mask_3 >> Trigger_Mask_4 >> Trigger_Mask_5 >> Trigger_Mask_6 >> Trigger_Mask_7;
    }

private:
    void initialize()
    {
	L1A_counter = 0;
	L1A_overflow = false;
	L1ID_L1A = 0;
	L1ID_ECR = 0;
	Monitoring_FIFO_Events = 0;
	Monitoring_Events = 0;

// <<BeginUserCode>>

// <<EndUserCode>>
    }


// <<BeginUserCode>>

// <<EndUserCode>>
};

// <<BeginUserCode>>

// <<EndUserCode>>
inline std::ostream & operator<<( std::ostream & out, const ISCTPCORENamed & info ) {
    info.print( out );
    return out;
}

#endif // ISCTPCORENAMED_H
