#ifndef ISCTPOUTNAMED_H
#define ISCTPOUTNAMED_H

#include <is/namedinfo.h>

#include <string>
#include <ostream>


// <<BeginUserCode>>

// <<EndUserCode>>
/**
 * CTPOUT monitoring values
 * 
 * @author  generated by the IS tool
 * @version 08/09/08
 */

class ISCTPOUTNamed : public ISNamedInfo {
public:

    /**
     * Busy on demand ( ENABLED / DISABLED )
     */
    std::string                   busy_on_demand;

    /**
     * Name of input source from LTP connector 0
     */
    std::string                   connector0_name;

    /**
     * Name of input source from LTP connector 1
     */
    std::string                   connector1_name;

    /**
     * Name of input source from LTP connector 2
     */
    std::string                   connector2_name;

    /**
     * Name of input source from LTP connector 3
     */
    std::string                   connector3_name;

    /**
     * Name of input source from LTP connector 4
     */
    std::string                   connector4_name;

    /**
     * Take busy from  from LTP connector 0 (ON: take into account, OFF: mask it out)
     */
    std::string                   connector0_busy;

    /**
     * Take busy from  from LTP connector 1 (ON: take into account, OFF: mask it out)
     */
    std::string                   connector1_busy;

    /**
     * Take busy from  from LTP connector 2 (ON: take into account, OFF: mask it out)
     */
    std::string                   connector2_busy;

    /**
     * Take busy from  from LTP connector 3 (ON: take into account, OFF: mask it out)
     */
    std::string                   connector3_busy;

    /**
     * Take busy from  from LTP connector 4 (ON: take into account, OFF: mask it out)
     */
    std::string                   connector4_busy;


    static const ISType & type() {
	static const ISType type_ = ISCTPOUTNamed( IPCPartition(), "" ).ISInfo::type();
	return type_;
    }

    virtual std::ostream & print( std::ostream & out ) const {
	ISNamedInfo::print( out );
	out << "busy_on_demand: " << busy_on_demand << "	//Busy on demand ( ENABLED / DISABLED )" << std::endl;
	out << "connector0_name: " << connector0_name << "	//Name of input source from LTP connector 0" << std::endl;
	out << "connector1_name: " << connector1_name << "	//Name of input source from LTP connector 1" << std::endl;
	out << "connector2_name: " << connector2_name << "	//Name of input source from LTP connector 2" << std::endl;
	out << "connector3_name: " << connector3_name << "	//Name of input source from LTP connector 3" << std::endl;
	out << "connector4_name: " << connector4_name << "	//Name of input source from LTP connector 4" << std::endl;
	out << "connector0_busy: " << connector0_busy << "	//Take busy from  from LTP connector 0 (ON: take into account, OFF: mask it out)" << std::endl;
	out << "connector1_busy: " << connector1_busy << "	//Take busy from  from LTP connector 1 (ON: take into account, OFF: mask it out)" << std::endl;
	out << "connector2_busy: " << connector2_busy << "	//Take busy from  from LTP connector 2 (ON: take into account, OFF: mask it out)" << std::endl;
	out << "connector3_busy: " << connector3_busy << "	//Take busy from  from LTP connector 3 (ON: take into account, OFF: mask it out)" << std::endl;
	out << "connector4_busy: " << connector4_busy << "	//Take busy from  from LTP connector 4 (ON: take into account, OFF: mask it out)" << std::endl;
	return out;
    }

    ISCTPOUTNamed( const IPCPartition & partition, const std::string & name )
      : ISNamedInfo( partition, name, "ISCTPOUT" )
    {
	initialize();
    }

    ~ISCTPOUTNamed(){

// <<BeginUserCode>>

// <<EndUserCode>>
    }

protected:
    ISCTPOUTNamed( const IPCPartition & partition, const std::string & name, const std::string & type )
      : ISNamedInfo( partition, name, type )
    {
	initialize();
    }

    void publishGuts( ISostream & out ){
	out << busy_on_demand << connector0_name << connector1_name << connector2_name << connector3_name;
	out << connector4_name << connector0_busy << connector1_busy << connector2_busy << connector3_busy;
	out << connector4_busy;
    }

    void refreshGuts( ISistream & in ){
	in >> busy_on_demand >> connector0_name >> connector1_name >> connector2_name >> connector3_name;
	in >> connector4_name >> connector0_busy >> connector1_busy >> connector2_busy >> connector3_busy;
	in >> connector4_busy;
    }

private:
    void initialize()
    {

// <<BeginUserCode>>

// <<EndUserCode>>
    }


// <<BeginUserCode>>

// <<EndUserCode>>
};

// <<BeginUserCode>>

// <<EndUserCode>>
inline std::ostream & operator<<( std::ostream & out, const ISCTPOUTNamed & info ) {
    info.print( out );
    return out;
}

#endif // ISCTPOUTNAMED_H
