#ifndef TRIGCONFL1BGKEYNAMED_H
#define TRIGCONFL1BGKEYNAMED_H

#include <is/namedinfo.h>

#include <string>
#include <ostream>


// <<BeginUserCode>>

// <<EndUserCode>>
/**
 * Current L1 bunch group key
 * 
 * @author  generated by the IS tool
 * @version 12/09/08
 */

class TrigConfL1BgKeyNamed : public ISNamedInfo {
public:

    /**
     * LVL1 bunch group key of the trigger configuration
     */
    unsigned int                  L1BunchGroupKey;

    /**
     * LVL1 bunch group comment
     */
    std::string                   L1BunchGroupComment;


    static const ISType & type() {
	static const ISType type_ = TrigConfL1BgKeyNamed( IPCPartition(), "" ).ISInfo::type();
	return type_;
    }

    virtual std::ostream & print( std::ostream & out ) const {
	ISNamedInfo::print( out );
	out << "L1BunchGroupKey: " << L1BunchGroupKey << "	//LVL1 bunch group key of the trigger configuration" << std::endl;
	out << "L1BunchGroupComment: " << L1BunchGroupComment << "	//LVL1 bunch group comment" << std::endl;
	return out;
    }

    TrigConfL1BgKeyNamed( const IPCPartition & partition, const std::string & name )
      : ISNamedInfo( partition, name, "TrigConfL1BgKey" )
    {
	initialize();
    }

    ~TrigConfL1BgKeyNamed(){

// <<BeginUserCode>>

// <<EndUserCode>>
    }

protected:
    TrigConfL1BgKeyNamed( const IPCPartition & partition, const std::string & name, const std::string & type )
      : ISNamedInfo( partition, name, type )
    {
	initialize();
    }

    void publishGuts( ISostream & out ){
	out << L1BunchGroupKey << L1BunchGroupComment;
    }

    void refreshGuts( ISistream & in ){
	in >> L1BunchGroupKey >> L1BunchGroupComment;
    }

private:
    void initialize()
    {

// <<BeginUserCode>>

// <<EndUserCode>>
    }


// <<BeginUserCode>>

// <<EndUserCode>>
};

// <<BeginUserCode>>

// <<EndUserCode>>
inline std::ostream & operator<<( std::ostream & out, const TrigConfL1BgKeyNamed & info ) {
    info.print( out );
    return out;
}

#endif // TRIGCONFL1BGKEYNAMED_H
