#ifndef idlhelper_H_INCLUDED
#define idlhelper_H_INCLUDED
#include <iostream>

#include <rmgr/rmgr.hh>
#include <string>
#include <boost/spirit/include/karma.hpp>
#include <iostream>

namespace daq
{
namespace rmgr
{

//common useful functions
void convert2string(long int& inp, std::string& out);
void convert2string(int& inp, std::string& out);
void convert2string(CORBA::Long& inp,  std::string& out);
//void addLong(long int& inp, std::string& out);
void addLong(CORBA::Long& inp, std::string& out);

class Handle_InfoHelper {
private:
  friend std::ostream& operator<<(std::ostream& str, Handle_InfoHelper& helper);
public:
  Handle_Info* info;
  Handle_InfoHelper( Handle_Info* inf) : info(inf) {}
  ~Handle_InfoHelper() {
    if( (void*)info != 0) {
       delete info;
       info = 0;
    }
  }
  const std::string getAsString() const;
};

/*
class Allocated_ResourceHelper {
public:
  Allocated_Resource* alloc;
};
*/


class Allocated_InfoHelper {
private:
  friend std::ostream& operator<<(std::ostream& str, Allocated_InfoHelper& helper);
public:
  Allocated_Info* allocInfo;
  Allocated_InfoHelper( Allocated_Info* inf ) : allocInfo(inf) {}
  ~Allocated_InfoHelper() {
    //void* tmp = (void*)allocInfo;
    if( (void*)allocInfo != 0 ) {
        delete allocInfo;
        allocInfo = 0;
    }
  }
};

//std::ostream& operator<<(std::ostream& str, Allocated_InfoHelper& helper);

class Rmstr_lstHelper {
private:
  friend std::ostream& operator<<(std::ostream& str, Rmstr_lstHelper& helper);
public:
  Rmstr_lst* list;
  Rmstr_lstHelper( Rmstr_lst* lst) : list( lst) {}
  ~Rmstr_lstHelper() {
     if( (void*)list != 0 ) {
        delete list;
        list = 0;
     }
  }
  std::vector<std::string> getList();
};

class Config_updateHelper {
private:
  friend std::ostream& operator<<(std::ostream& str, Config_updateHelper& helper);
public:
  Config_update* cinfo;
  Config_updateHelper( Config_update* inf ) : cinfo(inf) {}
  ~Config_updateHelper() {
     if( (void*)cinfo != 0 ) {
         delete cinfo;
         cinfo = 0;
     }
  }
};
  
} //rm
} //daq
#endif /* idlhelper_H_INCLUDED */
