#include <stdio.h>
#include <iostream>
#include <cmdl/cmdargs.h>
#include <ers/ers.h>
#include <ipc/core.h>
#include <ResourceManager/RM_Client.h>
  daq::rmgr::RM_Client* RMC = (daq::rmgr::RM_Client*)0;
int main(int argc, char** argv)
{
 	// Declare arguments
 	CmdArgStr  rm_server_name('n', "rm_server", "rm_server_name", 
			  "resource manager server name; use only for tests.");
	// Declare command object and its argument-iterator
 	CmdLine cmd(*argv, &rm_server_name, NULL);
 	CmdArgvIter arg_iter(--argc, ++argv);
        cmd.description( "Show list all partitions that were registered in the Resource Manager. Information about each partition is enclosed in parentheses.\n Partition unique identifier and configuration DB name separated by semicolomn is shown for each partition.");
       // Parse arguments
	cmd.parse(arg_iter);
  try {
     IPCCore::init(argc, argv);
  }
  catch( daq::ipc::Exception & ex ) {
     ers::fatal( ex );
  }  

  if (rm_server_name.isNULL())
    RMC = new daq::rmgr::RM_Client();
  else
    RMC = new daq::rmgr::RM_Client(rm_server_name);
  if (RMC == (daq::rmgr::RM_Client*)0)
     exit(-1);  // server do not found
  try {
    std::ostringstream txt ;
    txt<<"The following partitions are registered in the RM:" << std::endl << *RMC->getPartitionsList();
    ers::info( ers::Message( ERS_HERE, txt.str()));
  }
  catch (daq::rmgr::Exception & ex) {
     ers::error(ex);
  }
 delete RMC; 
}
