#include <iostream>
#include <cmdl/cmdargs.h>
#include <ipc/core.h>
#include <ResourceManager/RM_Client.h>
#include "ers/ers.h"
  daq::rmgr::RM_Client* RMC = (daq::rmgr::RM_Client*)0;
int main(int argc, char** argv)
{
 	// Declare arguments
 	CmdArgStr  rm_server_name('n', "rm_server", "rm_server_name", 
			  "resource manager server name; use only for tests.");
	// Declare command object and its argument-iterator
 	CmdLine cmd(*argv,  
                    &rm_server_name, NULL);
 	CmdArgvIter arg_iter(--argc, ++argv);
        cmd.description( "Show information of loaded into Resource Manager server configuration resources and SW_Objects.");
       // Parse arguments
	cmd.parse(arg_iter);

	std::string   p;
  try {
     IPCCore::init(argc, argv);
  }
  catch( daq::ipc::Exception & ex ) {
     ers::fatal( ex );
  }

  if (rm_server_name.isNULL())
    RMC = new daq::rmgr::RM_Client();
  else
    RMC = new daq::rmgr::RM_Client(rm_server_name);
  if (RMC == (daq::rmgr::RM_Client*)0)
     exit(-1);  // server do not found

  std::ostringstream txt ;
  try {
       daq::rmgr::Config_updateHelper* res = RMC->getConfigInfo();
       txt<< *res;
       ers::info( ers::Message( ERS_HERE, txt.str()));
       delete res;
  }
  catch (daq::ipc::Exception & exipc) {
           ers::error(exipc);
  }
  catch(CORBA::SystemException & ex) {
           txt<<"CORBA::SystemException " << ex._name() << " received.";
           ers::info( ers::Message( ERS_HERE, txt.str()));
  }
  catch (daq::rmgr::Exception & ex) {
           ers::error(ex);
  }

  delete RMC; 
}
