#include <iostream>
#include <cmdl/cmdargs.h>
#include <ipc/core.h>
#include <ResourceManager/RM_Client.h>
#include "ers/ers.h"
  daq::rmgr::RM_Client* RMC = (daq::rmgr::RM_Client*)0;
int main(int argc, char** argv)
{
 	// Declare arguments
 	CmdArgStr	partition_name('p', "partition", "partition_name", "partition name (mandatory); only resources that were granted in scope of this partition will be shown.");
 	CmdArgStr  rm_server_name('n', "rm_server", "rm_server_name", 
			  "resource manager server name; use only for tests.");

	// Declare command object and its argument-iterator
 	CmdLine cmd(*argv, &partition_name, 
                    &rm_server_name, NULL);
 	CmdArgvIter arg_iter(--argc, ++argv);
        cmd.description( "Show information about granted in partition Resource Manager resources.");
       // Parse arguments
	cmd.parse(arg_iter);

	std::string   p;
  try {
     IPCCore::init(argc, argv);
  }
  catch( daq::ipc::Exception & ex ) {
     ers::fatal( ex );
  }

  if (rm_server_name.isNULL())
    RMC = new daq::rmgr::RM_Client();
  else
    RMC = new daq::rmgr::RM_Client(rm_server_name);
  if (RMC == (daq::rmgr::RM_Client*)0)
     exit(-1);  // server do not found

  std::ostringstream txt ;
//  if(partition_name.isNULL()) {
//        txt<<"rm_get_resource_info: No  partition name and resource name in input.";
//        ers::info( ers::Message( ERS_HERE, txt.str()));
//	delete RMC; 
//	exit(-1);
//  }
  std::string pname = "*";
  if( !partition_name.isNULL() )
    pname =(const char*) partition_name;
  try {
       //daq::rmgr::Allocated_InfoHelper* getPartitionInfo( const std::string& partition );
       daq::rmgr::Allocated_InfoHelper* res = RMC->getPartitionInfo(pname);
       txt<< *res;
       ers::info( ers::Message( ERS_HERE, txt.str()));
       delete res;
  }
  catch (daq::rmgr::PartitionNotFound & exp) {
           ers::error(exp);
  }
  catch (daq::ipc::Exception & exipc) {
           ers::error(exipc);
  }
  catch(CORBA::SystemException & ex) {
           txt<<"CORBA::SystemException " << ex._name() << " received.";
           ers::info( ers::Message( ERS_HERE, txt.str()));
  }
  catch (daq::rmgr::Exception & ex) {
           ers::error(ex);
  }

  delete RMC; 
}
