#include <iostream>
#include <cmdl/cmdargs.h>
#include <ipc/core.h>
//#include <rmgr/rmgr.hh> //AI 2018
#include <ResourceManager/RM_Client.h>
#include "ers/ers.h"
  daq::rmgr::RM_Client* RMC = (daq::rmgr::RM_Client*)0;
int main(int argc, char** argv)
{
        // Declare arguments
///////        CmdArgStr       partition_name('p', "partition", "partition_id", "partition identifier. Environment value \"TDAQ_PARTITION\" is used in case of this parameter is absent.");
        //AI 2018
        //CmdArgStr       dbname_name('d', "dbname", "dbname_name", "configuration database name. Environment value \"TDAQ_DB\" is used in case of this parameter is absent.");
        CmdArgStr       dbname_name('d', "dbname", "dbname_name", "configuration database name. The value is ignored in current version.",CmdArg::isOPT);
        CmdArgStr  rm_server_name('n', "rm_server", "rm_server_name",
                          "resource manager server name; may be used only for tests.");
        // Declare command object and its argument-iterator
        CmdLine cmd(*argv, /////&partition_name,
                    &dbname_name, &rm_server_name, NULL);
        CmdArgvIter arg_iter(--argc, ++argv);
        cmd.description("Update configuartion data in the Resource Manager"); //AI 2018 using configuration data in DB.");
       // Parse arguments
        cmd.parse(arg_iter);

  std::string oksdatarwc;
  try {
     IPCCore::init(argc, argv);
  }
  catch( daq::ipc::Exception & ex ) {
     ers::fatal( ex );
  }

  if (rm_server_name.isNULL())
    RMC = new daq::rmgr::RM_Client();
  else
    RMC = new daq::rmgr::RM_Client(rm_server_name);
  if (RMC == (daq::rmgr::RM_Client*)0)
     exit(-1);  // server do not found
  std::ostringstream txt ;

  //AI 2018 "if" commented
  if (dbname_name.isNULL()){
        char * df = getenv("TDAQ_DB") ;
        if ( df == NULL ) {
           char * instP = getenv("TDAQ_INST_PATH") ;
           std::string tst(instP);
           tst = "oksconfig:" + tst;
           tst += "/share/data/daq/sw/repository.data.xml";
//                txt<<"rm_update_config: No dbame in input.";
//                ers::info( ers::Message( ERS_HERE, txt.str()));
//                exit(41);
           oksdatarwc = tst;
        }
        else
           oksdatarwc = df ;
  }
  else{
    oksdatarwc = dbname_name;
  }


//  ERS_DEBUG(0, "Update my partition start.");
//std::cerr<<"Update config for " <<  oksdatarwc<<std::endl;
  try {
       RMC->rmConfigurationUpdate( oksdatarwc.c_str() );
      txt<<"Update configuration finished. ";
      ers::info( ers::Message( ERS_HERE, txt.str()));
  }
  catch ( daq::rmgr::ConfigException& exE) {
        //ers::error(exE);
        std::cerr<<"Exception on RM_Server: " << exE.reason<<std::endl;
        return -1;
  }
  catch ( daq::rmgr::Exception & ex) {
          ers::error(ex);
          return -1;
  }
  delete RMC;
  return (0);
}

