#include <ResourceManager/idlhelper.h>

//common useful functions
void daq::rmgr::convert2string(long int& inp, std::string& out){
    char buf[16]; ///// = {0};
    char* ptr = buf;
    boost::spirit::karma::generate(ptr, boost::spirit::long_, inp);
    out.assign( buf, ptr - buf );
}
void daq::rmgr::convert2string(int& inp, std::string& out){
    char buf[16];
    char* ptr = buf;
    boost::spirit::karma::generate(ptr, boost::spirit::int_, inp);
    out.assign( buf, ptr - buf );
}

//void daq::rmgr::addLong(long int& inp, std::string& out){
void daq::rmgr::addLong(CORBA::Long& inp, std::string& out){
    char buf[16]; ///// = {0};
    char* ptr = buf;
    boost::spirit::karma::generate(ptr, boost::spirit::long_, inp);
    out.append(buf, ptr - buf);
}
/*
void daq::rmgr::convert2string(CORBA::Long& inp,  std::string& out) {
     daq::rmgr::convert2string((long int&) inp, out);
}
*/
const std::string daq::rmgr::Handle_InfoHelper::getAsString() const {
    if((void*)info == 0)
      return "Handle_Info={ empty }";
    std::string handleStr;
    daq::rmgr::convert2string(/*(long int)*/info->handle, handleStr);
    std::string pidStr;
    daq::rmgr::convert2string(/*(long int)*/info->pid, pidStr);
    std::string retv("Handle_Info={ handle=" + handleStr + ", SWObj="
                       + (const std::string)info->swObj + " computer="
                       + (const std::string)info->computer + ", partition=" 
                       + (const std::string)info->partition
                       + ", client=" + (const std::string)info->client 
                       + ", pid=" + pidStr + " Resources=");
    const std::string types[] = { "SW", "HW" };
    for(unsigned int i=0; i<info->resDetails.length(); i++) {
       retv += " { resource=" + (const std::string)info->resDetails[i].resource
                  + ", type=" + types[info->resDetails[i].type]
                  + ", maxPP=";
       daq::rmgr::addLong(info->resDetails[i].maxPP,retv);
       retv += ", maxTotal=";
       daq::rmgr::addLong(info->resDetails[i].maxTotal, retv);
       retv += ", allocPP=";
       daq::rmgr::addLong(info->resDetails[i].allocPP, retv);
       retv += ", allocTotal=";
       daq::rmgr::addLong(info->resDetails[i].allocTotal, retv);
       retv += " } \n";
    }
    return retv;
}

std::ostream& daq::rmgr::operator<<(std::ostream& str, daq::rmgr::Handle_InfoHelper& helper) {
   daq::rmgr::Handle_Info* info = helper.info;
   if((void*)info == 0) {
     str << "Handle_Info={ empty }" <<std::endl;
     return str;
   }
   str << "Handle_Info={" << std::endl;
   str << " handle=" << info->handle << std::endl;
  // str << " application=" << info->appName  << std::endl;
   str << " swObj=" << info->swObj;
   str << " computer=" << info->computer;
   str << " partition=" << info->partition;//  << std::endl;
   str << " client=" << info->client;// << std::endl;
   str << " pid=" << info->pid << std::endl;
   str << "  Resources:" << std::endl;
   const std::string types[] = { "SW", "HW" };
   for(unsigned int i=0; i<info->resDetails.length(); i++) {
     str << "  {";//<< std::endl;
     str << "   resource=" << info->resDetails[i].resource;// << std::endl;
     str << "   type=" << types[info->resDetails[i].type];// << std::endl;
     str << "   maxPP=" << info->resDetails[i].maxPP;// << std::endl;
     str << "   maxTotal=" << info->resDetails[i].maxTotal << std::endl;
     str << "   allocPP=" << info->resDetails[i].allocPP;// << std::endl;
     str << "   allocTotal=" << info->resDetails[i].allocTotal;// << std::endl;
     str << "  }"<< std::endl;
   }
   return str;
}

std::ostream& daq::rmgr::operator<<(std::ostream& str,  daq::rmgr::Allocated_InfoHelper& helper) {
   const std::string types[] = { "SW", "HW" };
   daq::rmgr::Allocated_Info* info = helper.allocInfo;
   str << "Allocated_Info= " << std::endl;
   for( unsigned int i=0; i<helper.allocInfo->length(); i++) {
     str << "{" << std::endl;
     str << " handle=" << (*info)[i].handle;// << std::endl;
     str << " resource=" << (*info)[i].resource;// << std::endl;
     str << " type=" << types[(*info)[i].type];// << std::endl;
     str << " maxPP=" << (*info)[i].maxPP;// << std::endl;
     str << " maxTotal=" << (*info)[i].maxTotal;// << std::endl;
     str << " hwClass=" << (*info)[i].hwClass << std::endl;	
     str << " swObj=" << (*info)[i].swObj;// << std::endl;
     str << " partition=" << (*info)[i].partition;// << std::endl;
     str << " client=" << (*(helper.allocInfo))[i].client << std::endl;
     str << " computer=" << (*info)[i].computer;// << std::endl;
     str << " pid=" << (*info)[i].pid;// << std::endl;
     str << " hwId=" << (*info)[i].hwId;// << std::endl;
     str << " allocPP=" << (*info)[i].allocPP;// << std::endl;
     str << " allocTotal=" << (*info)[i].allocTotal;// << std::endl;
     str << "}" << std::endl;
   }
   return str;
}

std::vector<std::string> daq::rmgr::Rmstr_lstHelper::getList() {
   std::vector<std::string> retv;
   for (unsigned int i=0; i<list->length(); i++) {
     std::string addme ( (*list)[i].val );
     retv.push_back(addme);
   }
   return retv;
}

std::ostream& daq::rmgr::operator<<(std::ostream& str, daq::rmgr::Rmstr_lstHelper& helper) {
  daq::rmgr::Rmstr_lst* mylist = helper.list;
  if( mylist->length() == 1) {
     str << (*mylist)[0].val;
     return str;
  }
  str << " Members= ";
  for (unsigned int i=0; i<mylist->length(); i++)
     str << " { " << (*mylist)[i].val << " } ";
  str << std::endl;
  return str;
}

std::ostream& daq::rmgr::operator<<(std::ostream& str, daq::rmgr::Config_updateHelper& helper) {
  daq::rmgr::Config_update* myinfo = helper.cinfo;
  str << "Config_update = {"<<std::endl << "  SW_Resources= {";
  if( myinfo->swr_lst.length() == 0 )
     str << "  }" << std::endl;
  else
     str << std::endl;
  unsigned int i;
  for(i=0; i < myinfo->swr_lst.length(); i++) {
      str << "    {  id="<<myinfo->swr_lst[i].rid;
      str << " max_total=" << myinfo->swr_lst[i].max_total;
      str << " max_pp=" << myinfo->swr_lst[i].max_pp;
      str << "  }" <<std::endl;
  }
  if( myinfo->swr_lst.length() > 0 )
      str << "   }"<<std::endl;
  str << "   HW_Resources= {";
  if( myinfo->hwcr_lst.length() == 0 )
     str << "  }" << std::endl;
  else
     str << std::endl;
  for( i=0; i < myinfo->hwcr_lst.length(); i++) {
      str << "    {  id="<< myinfo->hwcr_lst[i].rid;
      str << " max_total=" << myinfo->hwcr_lst[i].max_total;
      str << " max_pp=" << myinfo->hwcr_lst[i].max_pp;
      str << " hwClass=" << myinfo->hwcr_lst[i].hwClass;
      str << "  }" <<std::endl; 
  }
  if( myinfo->hwcr_lst.length() > 0 )
      str << "   }"<<std::endl;
  str << "    SWObjects= {";
  if( myinfo->swobj_lst.length() == 0 )
      str << "  }" << std::endl;
  else
      str<<std::endl;
  for(i=0; i < myinfo->swobj_lst.length();  i++) {
     str << "swObj="<<myinfo->swobj_lst[i].swid<< "  Resources={ ";
     for(unsigned int j=0; j < myinfo->swobj_lst[i].res_list.length(); j++)
         str << " {"<<myinfo->swobj_lst[i].res_list[j].id << "}";
     str << "  }"<<std::endl;
  }
  str << "   }"<<std::endl<<"} end of Config_update"<<std::endl;
  return str;
}
