#include <stdio.h>
#include <iostream>
#include <ipc/core.h>

#include <ResourceManager/RM_Client.h>
#include <ResourceManager/idlhelper.h>
#include "src/RM_Server.h"
#include <signal.h>
#include <sys/types.h>
#include <unistd.h>
#include <ers/ers.h>
//#include <boost/spirit/include/karma.hpp>

  daq::rmgr::RM_Server* RMS = (daq::rmgr::RM_Server*)0; 
  daq::rmgr::RM_Client* RMC = (daq::rmgr::RM_Client*)0;
  int debug_reload = 0; //1; //0;

/*
namespace daq {
namespace rm {
void convert2string(long int& inp, std::string& out){
    char buf[16]; ///// = {0};
    char* ptr = buf;
    boost::spirit::karma::generate(ptr, boost::spirit::long_, inp);
    out.assign( buf, ptr - buf );
}

void convert2string(int& inp, std::string& out){
    char buf[16];
    char* ptr = buf;
    boost::spirit::karma::generate(ptr, boost::spirit::int_, inp);
    out.assign( buf, ptr - buf );
}

}
}
*/

void test_performance(int num) {
    daq::rmgr::Config_update idl_conf;
 // prepare test partition with num computers, num sw binaries and each 
 // binary has 1 HW resource
    std::string compName = "testComputer_";
    std::string swName = "testSW_";
    std::string resName = "testHWres_"; 
    idl_conf.swr_lst.length( 0 );
    idl_conf.hwcr_lst.length( num );
    idl_conf.swobj_lst.length( num );

    std::string numstr;
    std::ostringstream text;

    //set all values
    for(int i=0; i<num; i++) {
      text << i;
      numstr = text.str();
      std::string cn = compName + numstr;
      std::string rn = resName + numstr;
      idl_conf.hwcr_lst[i].rid = CORBA::string_dup( rn.c_str() );
      idl_conf.hwcr_lst[i].max_total = 1;
      idl_conf.hwcr_lst[i].max_pp = 1;
      std::string swn = swName + numstr;
      idl_conf.swobj_lst[i].swid = CORBA::string_dup( swn.c_str() );
      idl_conf.swobj_lst[i].res_list.length( 1 );
      idl_conf.swobj_lst[i].res_list[0].id  = CORBA::string_dup(idl_conf.hwcr_lst[i].rid);
    }
   try{
    RMC->rmConfigurationUpdate4MyTest( idl_conf );
   }
   catch( ...) {
      
   }
    for(int j=0; j<2; j++) {
      text << j;
      numstr = text.str();
      std::string cn2 = compName + numstr;
      std::string swn2 = swName + numstr;
      char * cn2c = const_cast<char*> (cn2.c_str());
      char * swn2c = const_cast<char*> (swn2.c_str());
      char* const argv[] = { const_cast<char*> ("rm_request_resources"), 
                             const_cast<char*> ("-p"),
                             const_cast<char*>( "virtualPartition"),
                             const_cast<char*> ("-b"),
                             swn2c,
                             const_cast<char*> ("-c"), 
                             cn2c, NULL};
      execv("rm_request_resources", argv );
    }
    //now start request resources in sep. processes at the same time
     
}

 long test_request_resource4process(const std::string partition, const std::string resource, const std::string computer, const std::string client, int wait_result) {
 long retv = -1;
 std::string wait_str[] = {"UNSUCCESS","SUCCESS"};
  std::cerr << "+++++++++++++++++++"<<std::endl;
 std::cerr << " ... RMC->requestResourceForMyProcess for resource UID=\""
           << resource << "\" and for computer=\"" << computer << "\"."<<std::endl;
 std::cerr << "         Should be "<<wait_str[wait_result]<<" in this operation (check by:handle>0 or exception info in case of unsucces)." << std::endl;
  try {
     retv = RMC->requestResourceForMyProcess(partition, resource, computer, client);
    std::cerr << "Granted handle="<< retv << std::endl;
    std::cerr << "Handle info=" << (*RMC->getHandleInfo( retv )) << std::endl;//->getAsString();
  }
  catch ( daq::rmgr::Exception & exproc) {
          ers::error(exproc);
  }
  std::cerr << "                +++++++++++++++++++++++++++++"<<std::endl;
  return retv;
}

void test_free_process_resource(const std::string partition, const std::string computer, unsigned long mypid, int wait_result) {
  std::string wait_str[] = {"UNSUCCESS","SUCCESS"};
  std::cerr << "-------------------"<<std::endl;
  std::cerr << " ... RMC->freeProcessResources in use. Result should be "<<wait_str[wait_result]<<" (If unsuccess --> exception message)."<< std::endl;
 try{
    RMC->freeProcessResources(partition, computer, mypid);
 }
 catch ( daq::rmgr::Exception & ex) {
          ers::error(ex);
 }
  std::cerr << "                -------------------"<<std::endl;
} 

//int main()
int main(int argc, char **argv)
{
 int serv_pid = -1;
 int okcheck = 1;
//    sleep(15);
   if(debug_reload)
      sleep(30);
//   std::cerr << "serv_pid=" << serv_pid <<std::endl;
//    std::cerr << "PARENT ALIVE" << std::endl;
//    std::cerr << "PARENT ALIVE" << std::endl;
 try {
  IPCCore::init(argc,argv);
 }
 catch( daq::ipc::Exception & ex ) {
        ers::fatal( ex );
 }
  RMC = new daq::rmgr::RM_Client("RM_Server_check");
  std::cerr << "rmcheckshort running." << std::endl;

  const char* pname = "par1";
  //SW objects IDs for appl[] in the same order
  std::string swobjs[] = { "Binary1_sw1_fca29","Binary1_comp1_fca29", "Binary1_sw2_fca30", "Binary3_hw1_fca29", "Binary2_hw1_fca33" };
  //computers names for appl[] in the same order. Now ID instead of names
  std::string comps[] = { "fca29", "fca29", "fca30", "fca29", "fca33" };

  std::string bin[] = {"Binary1_comp1_fca29", "Binary1_sw2_fca30","Binary2_hw1_fca33"};
  std::string comp[] = {"fca29","fca30","fca33","fca31"}; //IDs
  int binSize =3,compSize=3;
  int applsize = 5;

  //SW object IDs for applTempl[]
  std::string swobjsTempl[] = { "Binary1_sw2_fca30", "Binary2_comp1_fca30",
        "Binary3_hw1_fca29", "Binary4_hw2_fca30", "Binary2_hw1_fca33"};
  std::string compsTempl[] = { "fca30", "fca30", "fca29", "fca30", "fca33" }; //IDs
  std::string resources[] = {"computer_res1", "hw_res1", "sw_res1"};
//have also hw_res0 , hw_res2 
///  const std:: string  dbname = "oksconfig:../data/daq/partition1.data.xml";
  const std:: string  dbname = "oksconfig:../data/daq/pp1.data.xml";
 //restore original (before changes in db) config data
 std::string command = "cp -f ../data/daq/orig/binary.data.xml  ../data/daq/binary.data.xml";
 system ( command.data() );
 command = "cp -f ../data/daq/orig/res.data.xml  ../data/daq/res.data.xml";
 system (command.data());
/* remove, use in future if need
 if(!debug_reload) {
//try to load nonexisting partition
std::cerr << "registerPartition: dbname=\"kukuruza\"" << " as wrong partition" << std::endl;
  try {
     RMC->rmConfigurationUpdate ( "oksconfig:kukuruza" );
  }
  catch ( daq::rmgr::Exception & ex) {
          ers::error(ex);
  }

 std::cerr << "**************************************************************" <<std::endl << std::endl;
 }
*/
/*
if(debug_reload) {
     std::cerr << "!!!!!!!!!!!!!!!!! partition info for debug_reload short..."<<std::endl;
     std::cerr << RMC->getPartitionInfo(pname, (const char*) "*",  0);
     std::cerr << "============================================================"<<std::endl;
     std::cerr << "   WITH HANDLES  partition info for debug_reload"<<std::endl;
     std::cerr << RMC->getPartitionInfo(pname, (const char*) "*", 1);
      std::cerr<< "!!!!!!!!!!!!!!!!Let us try to save backup"<<std::endl;
     std::cerr << "============================================================"
<<std::endl;
     std::cerr << " Now try to save backup with debug_reload branch into testBackupReloaded"<<std::endl;
     RMC->saveBackup( );
  std::cerr<< "!!!!!!!!!!!....Save backup finished....."<<std::endl;
  if( serv_pid > 0 )
    kill(serv_pid, SIGTERM); 
  exit(0);
}
*/


  //+============================================================
//  Let us load "Partition1" into RMDDB 
// using loading config in client side
  std::cerr << "registerMyPartition: dbname=" << dbname << std::endl;
 try{
//temporary test
Configuration * sw_conf = 0;
int debug_temp = 0;
    if(debug_temp) {
       try {
           sw_conf = new Configuration(dbname);
           RMC->rmConfigurationUpdate( sw_conf );
              std::cerr <<"register ok for registerMyPartition (sw_conf , pcdb )" << std::endl;
       }
       catch (daq::config::Exception & ex) {
           std::cerr << "daq::config::Exception" << std::endl;
       }
       if( !(sw_conf) )
          delete sw_conf;
    }
    else {
     RMC->rmConfigurationUpdate( dbname );
      std::cerr << "Ok in register" << std::endl;
      daq::rmgr::Config_updateHelper* helper0 = RMC->getConfigInfo();
      std::cerr << *helper0<<std::endl;
      delete helper0;
    }
 }
 catch ( daq::rmgr::Exception & ex) {
          ers::error(ex);
 }
  
/*
// Let us see what inside of "par1" now 
 try{
  std::cerr << *RMC->getPartitionInfo(pname);
 }
  catch ( daq::rmgr::Exception & ex) {
          ers::error(ex);
  }
 std::cerr<< "**************************************************************" <<std::endl;
 */

  //+============================================================
 long hndlId;
 std::string client0 = "client";
 std::string client;
 std::string ival;

    okcheck = 0;
  long hndlidProc = -1;
 std::cerr << "*------------------------------------------------------*************************************************************" <<std::endl;
std::cerr<<"     test request by process and free by handle"<<std::endl;
  hndlidProc = test_request_resource4process(pname, resources[1], comp[3], "mio", 1);
  if( hndlidProc > 0 ) {
         daq::rmgr::Handle_InfoHelper* inf = RMC->getHandleInfo(hndlidProc);
         std::cerr<< *inf<<std::endl;
         delete inf;
      }
  std::cerr<<"    NOW FREE BY HANDLE"<<std::endl;
try{  
  RMC->freeResources( hndlidProc );
  std::cerr<<" FREE RESOURCES DONE!!"<<std::endl;
}
 catch ( daq::rmgr::Exception & exproc) {
      ers::error(exproc);
//      okcheck = 1;
 }

std::cerr << "     getPartitionInfo : should be EMPTY"<<std::endl;
try{
  std::cerr << *RMC->getPartitionInfo(pname);
  std::cerr << "Partitions in RM_Server: " << *RMC->getPartitionsList() <<  std::endl;
 }
 catch ( daq::rmgr::Exception & exproc) {
      ers::error(exproc);
 }
 
 std::cerr << "**************************************************************" <<std::endl; std::cerr << "**************************************************************" <<std::endl;



 std::cerr << "Request 3 resources for the same process on the same computer and then free them by 1 free request)"<<std::endl;
  hndlidProc = test_request_resource4process(pname, resources[1], comp[3], "mio", 1); // "hw_res1"
  hndlidProc = test_request_resource4process(pname, "sw_res2", comp[3], "mio",1);
  hndlidProc = test_request_resource4process(pname, "sw_res3", comp[3], "mio",0);//no sw_res3 ,1);
try{
   std::cerr << "Info for " << resources[1]<< ": " << *RMC->getResourceInfo(pname, (const char*)"sw_res1");
   std::cerr << "Info for sw_res2: " << *RMC->getResourceInfo(pname, (const char*)"sw_res2");
   std::cerr << "Info for sw_res3: " << *RMC->getResourceInfo(pname, (const char*)"sw_res3"); //no res 1);
 }
 catch ( daq::rmgr::Exception & exproc) {
      ers::error(exproc);
 }

 unsigned long mypid1 = getpid();
 std::cerr << "Request sw_res1...sw_res3 done. Now let us free by process " << mypid1<<std::endl;
 try{
   RMC->freeProcessResources( pname, comp[3], mypid1 );
   std::cerr << "Info after free process resources:"<<std::endl;
 }
 catch ( daq::rmgr::Exception & exproc) {
      ers::error(exproc);
 }
 try{
   std::cerr << "Info for hw_res1: " << *RMC->getResourceInfo(pname, (const char*)"hw_res1");
   std::cerr << "Info for sw_res: " << *RMC->getResourceInfo(pname, (const char*)"sw_res2");
   std::cerr << "Info for sw_res3: " << *RMC->getResourceInfo(pname, (const char*)"sw_res3");
 std::cerr << "**************************************************************" <<std::endl;
 std::cerr << "ALL partition info for partition "<< pname << std::endl;
  std::cerr << *RMC->getPartitionInfo(pname);
 }
 catch ( daq::rmgr::Exception & exproc) {
      ers::error(exproc);
 }

 std::cerr << "**************************************************************" <<std::endl;
 std::cerr << "**************************************************************" <<std::endl;
 std::cerr << "**************************************************************" <<std::endl;



 std::cerr << "**************************************************************" <<std::endl;
// Try to allocate 5 times the same resources for the same application
 for (int i=0; i < 5; i++){
     daq::rmgr::convert2string(i, ival);
     client = client0 + ival;
     if(i == 0) // for i==0 should be enough resource (set to 1 in try)
        okcheck = 0;
    try {
         hndlId = RMC->requestResources(pname, swobjs[i].c_str(), comps[i].c_str(), client.c_str() );
         okcheck = 1;
         std::cerr << "requestResources operation handle ID = " << hndlId << std::endl;
//         std::cerr << "HandleInfo=" << RMC->getHandleInfo(hndlId)->getAsString();
         std::cerr  << *RMC->getHandleInfo(hndlId) <<std::endl;
    }
    catch ( daq::rmgr::Exception & ex) {
         ers::error(ex);
    }
 }
 std::cerr << "**************************************************************" <<std::endl;
try{
  std::cerr << *RMC->getPartitionInfo(pname);
 }
 catch ( daq::rmgr::Exception & exproc) {
      ers::error(exproc);
 }

//try to ask resources for unknown binary
try{
  hndlId = RMC->requestResources(pname, "kukuruza_bin_id", comps[0].c_str());
  std::cerr << "requestResources for unknown \"kukuruza_bin_id\". Should be handle id ==0. handle ID = " << hndlId << std::endl;
}
catch ( daq::rmgr::Exception & exx ) {
         ers::error(exx);
}

/*TODO
 //get clients for granted resources
 std::cerr << "getResourceOwners for partition=" << pname << " in use:" << std::endl; 
 for (int ir=0; ir<3; ir++){
   try {
        std::cerr << "        owners for resurce=" << resources[ir] << " clients=";

        std::cerr << std::endl << RMC->getResourceOwners(resources[ir].c_str(), pname) << std::endl;
   }
  catch ( daq::rmgr::Exception & ex) {
          ers::error(ex);
  }
 }
*/
 std::cerr << "**************************************************************" <<std::endl;
  //allocate all in arrayt applTeml[] (appl[0] already done).
  for (int jt=0; jt<applsize; jt++) {
    std::cerr << "Call RMC->requestResourcesResources("<<pname<<", "
              << swobjsTempl[jt].c_str()<<'@'<<compsTempl[jt]<<")" << std::endl;
    try {
          hndlId = RMC->requestResources(pname, swobjsTempl[jt].c_str(), compsTempl[jt].c_str());
          std::cerr << "requestResources operation  Handle ID = " << hndlId << std::endl;
    }
    catch ( daq::rmgr::Exception & ex) {
          ers::error(ex);
    }
  }
try{
  std::cerr << "pname=" << pname<<std::endl;
  std::cerr << *RMC->getPartitionInfo(pname);
 }
 catch ( daq::rmgr::Exception & exproc) {
      ers::error(exproc);
 }

 std::cerr << "**************************************************************" <<std::endl;
 
  //allocate all in arrayt appl[] (appl[0] already done).
  for (int j=1; j<applsize; j++) {
    std::cerr << "Call RMC->requestResourcesResources("<<pname<<", "
             << swobjs[j].c_str()<<comps[j]<<")" << std::endl;
    try {
       hndlId = RMC->requestResources(pname, swobjs[j].c_str(), comps[j].c_str());
       std::cerr << "requestResources operation (different types of resources in use). Handle ID = " << hndlId << std::endl;
    }
    catch ( daq::rmgr::Exception & ex) {
          ers::error(ex);
    }
  }
 std::cerr << "**************************************************************" <<std::endl;
try{
  std::cerr << "pname=" << pname<<std::endl;
  std::cerr << *RMC->getPartitionInfo(pname);
 }
 catch ( daq::rmgr::Exception & exproc) {
      ers::error(exproc);
 }

//test request resource for process methods: no resource available here
 std::cerr << "Call RMC->requestResourceForMyProcess for resource UID=\""
           << resources[1] << "\" and for computer=\"" << comp[0] << "\". Should be refuse to grant resource (was used already)." << std::endl; 
  hndlidProc = -1;
  try {
     hndlidProc = RMC->requestResourceForMyProcess(pname, resources[1], comp[0], "mio");
  }
  catch ( daq::rmgr::Exception & exproc) {
          ers::error(exproc);
  }


  hndlidProc = test_request_resource4process(pname, resources[1], comp[3], "mio", 1);
  hndlidProc = test_request_resource4process(pname, "hw_res0", comp[3], "mio2",1);
  hndlidProc = test_request_resource4process(pname, "hw_res0", comp[1], "mio2",1);

/* NO SUCH ACTION
//test saveBackup
 std::cerr << "Backup start after resource4process ..." << std::endl;
  try{
    RMC->saveBackup();
    std::cerr << "Backup finished for resource4process ..." << std::endl;
  }
  catch ( daq::rmgr::Exception & exproc) {
          ers::error(exproc);
  }

 
 std::cerr << "**************************************************************" <<std::endl;
*/
 
  //+============================================================
// Get token info for all that was allocated in "Partition1"
  std::cerr << "Partition info for all resources in partition "<< pname<<":" << std::endl;
 try {
  std::cerr << *RMC->getPartitionInfo(pname);
 }
 catch ( daq::rmgr::Exception & exproc) {
      ers::error(exproc);
 }

  std::cerr << "**************************************************************" <<std::endl;

  //+============================================================
 // update configuration data
 command = "cp -f ../data/daq/orig/binary_1applchanged.data.xml  ../data/daq/binary.data.xml";
 system ( command.data() );
 command = "cp -f ../data/daq/orig/res_compres1changed.data.xml  ../data/daq/res.data.xml";
 system (command.data());

// check udate RM  data operation
 try{
   RMC->rmConfigurationUpdate( dbname );
   daq::rmgr::Config_updateHelper* helper = RMC->getConfigInfo();
   std::cerr << *helper<<std::endl;
   delete helper;
 }
 catch ( daq::rmgr::Exception & exproc) {
    ers::error(exproc);
 }

 std::cerr << "!!!!!! After updatePartition operation for partition" << pname << " info:" << std::endl;
 try{
    std::cerr << *RMC->getPartitionInfo(pname); 
 }
 catch ( daq::rmgr::Exception & exproc) {
    ers::error(exproc);
 }
 std::cerr << "**************************************************************" <<std::endl;

  //+============================================================

// Now let us free  resources (using 2 hadles)
  for(int ii=1; ii<2; ii++) {
     long hndlId = ii;
     try {
          RMC->freeResources(hndlId);
          std::cerr  << "freeResources operation for handleId=" << hndlId<<std::endl;
     }
     catch ( daq::rmgr::Exception & ex) {
         ers::error(ex);
     }
  }
 std::cerr << "**************************************************************" <<std::endl;
//free process resources test
//were: resources[1], comp[0]: unsucces in request
//      resources[1], comp[3]: success
//      "hw_res0", comp[1]: success

 unsigned long mypid = getpid();
 test_free_process_resource( pname, comp[0], mypid, 0 );
 test_free_process_resource( pname, comp[3], mypid, 1 );
 test_free_process_resource( pname, comp[1], mypid, 1 );
 std::cerr << "**************************************************************" <<std::endl;
 try{
    std::cerr <<  *RMC->getPartitionInfo(pname);
 }
 catch ( daq::rmgr::Exception & exproc) {
    ers::error(exproc);
 }
 std::cerr << "**************************************************************" <<std::endl;
  std::cerr<<"........ and now again allocate process resources befroe ALL free operation"<<std::endl;

  hndlidProc = test_request_resource4process(pname, resources[1], comp[3], "mio", 1);
  hndlidProc = test_request_resource4process(pname, "hw_res0", comp[3], "mio2", 1);

 std::cerr << "**************************************************************" <<std::endl;
 try{
    std::cerr <<  *RMC->getPartitionInfo(pname);
 }
 catch ( daq::rmgr::Exception & exproc) {
    ers::error(exproc);
 }
 std::cerr << "**************************************************************" <<std::endl;

//free all partition resources
 try{
    std::cerr << "**** FreeAllResouces in use..." << std::endl;
    RMC->freePartition(pname); //freeAllResources(pname);
    std::cerr << "FreeAllResouces for partition " << pname
	    << " finished." << std::endl;
 }
 catch ( daq::rmgr::Exception & exproc) {
    ers::error(exproc);
 }

 std::cerr << "Info for partition where all resources should be free: should be empty info";
 try {
  std::cerr << *RMC->getPartitionInfo(pname);
 }
 catch (daq::rmgr::Exception & ex) {
          ers::error(ex);
 }

  //+============================================================
// test request resourses
  for(int j=0;j<binSize;j++)
    for(int jj=0;jj<compSize;jj++){
      try{
        int kk = j==2 ? 2 : 1;
       for(int ll=0; ll<kk; ll++) {
      	hndlId = RMC->requestResources(pname,bin[j].c_str(),comp[jj].c_str());
        std::cerr << "requestResources operation (different types of resources in use). sw_object = "<<bin[j].c_str()<<"comp name = "<<comp[jj].c_str()<<" Handle ID = " << hndlId << std::endl; 
//        std::cerr << "HandleInfo=" << RMC->getHandleInfo(hndlId)->getAsString();
        std::cerr  << *RMC->getHandleInfo(hndlId) <<std::endl;
       }
      }
      catch ( daq::rmgr::Exception & ex) {
          ers::error(ex);
      }
    }
/* NO save backup in interface. Need to test in other way 
 try{
   std::cerr<<"############ before save backup partition info short:"<<std::endl;
   std::cerr << RMC->getPartitionInfo(pname, (const char*)"*", 0);
   std::cerr<<"#########################################################"<<std::endl;
   std::cerr<<"############ before save backup partition info with handles:"<<std::endl;
   std::cerr << RMC->getPartitionInfo(pname, (const char*)"*", 1);
   std::cerr<<"#########################################################"<<std::endl;
   std::cerr<<"############ STATISTICS before save backup"<<std::endl;
   std::cerr << std::endl << std::endl << "Last Statistics granted/refused for partition = " << pname << std::endl;
 }
 catch ( daq::rmgr::Exception & ex) {
   ers::error(ex);
 }

 try{
    RMC->saveBackup();
    std::cerr<< "!!!!!!!!!!!Save backup finished..."<<std::endl;
 }
 catch ( daq::rmgr::Exception & ex) {
   ers::error(ex);
 }

 try{
    std::cerr << RMC->getPartitionInfo(pname, (const char*)"*", 1);
 }
 catch ( daq::rmgr::Exception & ex) {
      ers::error(ex);
 }

 //see partitions list
 std::cerr << std::endl << "Partitions in RM_Server: " << RMC->getPartitionsList() <<  std::endl;
*/

 try{
   std::cerr<<"TEST: handle for id == 29:"<<std::endl;
   hndlId = 29;
//   std::cerr<< *RMC->getHandleInfo(hndlId)->getAsString() << std::endl;
   std::cerr  << *RMC->getHandleInfo(hndlId) <<std::endl;
 }
 catch(daq::rmgr::Exception & exttt) {
      ers::error(exttt);
 }
   //unload all partitions
 std::cerr << "Unload partition resources (remove partition from RM_Server)"  <<  std::endl;
 try {
   RMC->freePartition(pname); //freeAllResources(pname);
 }
 catch( daq::rmgr::Exception & ex) {
      ers::error(ex);
 }

 try {
    std::cerr << "Partitions in RM_Server: " << *RMC->getPartitionsList() <<  std::endl;
//check allocate by appl, allocate by process process and free
// all process and handle allocations in one request
   std::cerr<<"    test request by sw+comp, by process and free by handle and process in one request"<<std::endl;
    std::cerr<<"Allocate twice  by process"<<std::endl;
    hndlidProc = test_request_resource4process(pname, resources[1], comp[3], "mio", 1);
    hndlidProc = test_request_resource4process(pname, resources[1], comp[3], "mio", 1);
    std::cerr<<"For handleId="<<hndlidProc<<" :result info for second:" << std::endl;
//<< RMC->getHandleInfo( hndlidProc )->getAsString(); 
    std::cerr  << *RMC->getHandleInfo(hndlidProc) <<std::endl;

    std::string swtest("rc_empty_controller");
    //just to be not emty partition
    hndlId = RMC->requestResources(pname, swtest.c_str(), comp[3].c_str(), "mio" );
    std::cerr<<"Allocate by application<<" << swtest <<'@'<<comp[3]<<std::endl;
    hndlId = RMC->requestResources(pname, swtest.c_str(), comp[3].c_str(), "mio" );
    std::cerr<<"For handleId="<<hndlId<<" :result info :" <<std::endl;
    std::cerr << *RMC->getHandleInfo( hndlId ) <<std::endl; //->getAsString();
    std::cerr<<"    NOW FREE BY HANDLE="<<hndlId<<" and PID="<< mypid <<std::endl;
    RMC->freeAllProcessResources( hndlId, pname, comp[3], mypid );
    std::cerr<<" FREE DONE!!"<<std::endl;
 }
 catch( daq::rmgr::Exception & ex) {
    ers::error(ex);
 }


 try{
      std::cerr << *RMC->getPartitionInfo(pname);
 }
 catch ( daq::rmgr::Exception & exproc) {
      ers::error(exproc);
 }
//check hardware resources
 command = "cp -f ../data/daq/orig/binary.data.xml  ../data/daq/binary.data.xml";
 system ( command.data() );
 command = "cp -f ../data/daq/orig/res.data.xml  ../data/daq/res.data.xml";
 system (command.data());

try{
     RMC->rmConfigurationUpdate( dbname );
      std::cerr << "Ok in register" << std::endl;
      daq::rmgr::Config_updateHelper* helper0 = RMC->getConfigInfo();
      std::cerr << *helper0<<std::endl;
      delete helper0;

  std::cerr<<"request resources for Binary1_hw11_robin. Should be 0 as result"<<std::endl;
  hndlId = RMC->requestResources(pname, "Binary1_hw11_robin", comp[3].c_str(), "mio" );
  std::cerr  << "hndlid="<< hndlId <<std::endl;
  std::cerr<<"request resources for Binary1_hw11_comp_robin. Should be 1 resource allocated"<<std::endl;
  hndlId = RMC->requestResources(pname, "Binary1_hw11_comp_robin", comp[3].c_str(), "mio" );
  std::cerr  << *RMC->getHandleInfo(hndlId) <<std::endl;
  std::cerr<<"request hardware resources for Binary1_hw11_comp_robin" <<std::endl;
  hndlId = RMC->requestHWResources( pname, "Binary1_hw11_comp_robin", comp[3].c_str(),
                                    2222, "Robin", "Robin1", "mio" );
  std::cerr  << *RMC->getHandleInfo(hndlId) <<std::endl;
  std::cerr<<"request hardware resource hw_res_robin. Should be refuse"<<std::endl;
  hndlId = RMC->requestHWResourceForProcess(pname, "hw_res_robin",  comp[3].c_str(),
                                    "Robin1", 3333,  "mio" ); 
  std::cerr  << *RMC->getHandleInfo(hndlId) <<std::endl;
}
catch( daq::rmgr::Exception & ex) {
    ers::error(ex);
}

 std::cerr << "okcheck= " << okcheck << std::endl;
 if (okcheck)
    std::cerr << "RM checking is OK." << std::endl;
 else
    std::cerr << "RM checking: something wrong" << std::endl;
 delete RMC;
 if(serv_pid > 0)
    kill(serv_pid, SIGTERM);
 return !okcheck;
}

