#ifndef TM_RESCACHE_H
#define TM_RESCACHE_H

#include <string>
#include <vector>
#include <tuple>

#include <tbb/concurrent_hash_map.h>

#include <TestManager/Test.h>
#include <TM/TestResult.h>

namespace daq::tm {

class ResultsCache {

public:

    ResultsCache () {} ;
    ~ResultsCache() { m_cache.clear() ; } ;    

    void cacheResult(const std::string& comp_id, const std::string& test_id, const TestResult& res) ; // key = objectId@testId
 
    std::tuple<bool, TestResult> getCachedResult(const std::string& comp_id, const daq::tm::Test& test) ;

    void resetCachedResult(const std::string& comp_id, const std::vector<const daq::tm::Test*>& tests) ;

private:

    std::string build_id(const std::string& comp_id, const std::string& test_id) { return comp_id + "@" + test_id ; } ;

    tbb::concurrent_hash_map<std::string, TestResult> m_cache ;
} ;

}
#endif