#ifndef TM_TIMEOUTH_H
#define TM_TIMEOUTH_H

#include <chrono>
#include <thread>
#include <memory>
#include <mutex>
#include <atomic>
#include <shared_mutex>
#include <string>
#include <condition_variable>
#include <memory>
// #include <unordered_map>
#include <tbb/concurrent_unordered_map.h>

namespace daq {
namespace tm {

class TestTask ;

// a class which owns a thread which awakes every second and checks for timeouts in Testers
class TimeoutHandler
{
    // start time, timeout, TestTask pointer
// using timeout_data_t = std::tuple<std::chrono::system_clock::time_point, uint32_t, std::weak_ptr<daq::tm::TestTask>> ; 

const long s_lapse = 1l ; // seconds

mutable std::shared_mutex m_shrdmtx ;
std::mutex m_cndmtx ;
std::condition_variable m_condition ;
std::atomic_bool m_to_stop ;
std::thread m_thread ;
tbb::concurrent_unordered_map<std::string, std::weak_ptr<daq::tm::TestTask>> m_tasks ;

void run() ;

protected:
void destroy() ;

public:
TimeoutHandler() ;
~TimeoutHandler() ;

void addTask(const std::string& key, const std::shared_ptr<daq::tm::TestTask>& task) ;
void removeTask(const std::string& key) ;

} ;

}}

#endif
