#ifndef BRANCH_H
#define BRANCH_H

#include <is/info.h>

#include <string>
#include <ostream>
#include <vector>
#include <owl/time.h>


// <<BeginUserCode>>

// <<EndUserCode>>
/**
 * 
 * @author  generated by the IS tool
 * @version 21/04/09
 */

class Branch : public ISInfo {
public:

    /**
     * Describes Key (could be a chain name)
     */
    std::string                   Key;

    /**
     * List of values associated  to Key (could  be list of chains, nodes connected)
     */
    std::vector<std::string>      Values;

    /**
     * RunNumber (duplicated from Tree in order to use the branch class alone as a single level tree)
     */
    unsigned int                  RunNumber;

    /**
     * LuminosityBlock (cf RunNumber)
     */
    unsigned short                LumiBlock;

    /**
     * String describing generig data for configuration (can be menu name)
     */
    std::vector<std::string>      ConfigItem;

    /**
     * TimeStamp of generation of this object (to have it different from the one IS puts)
     */
    OWLTime                       TimeStamp;


    static const ISType & type() {
	static const ISType type_ = Branch( ).ISInfo::type();
	return type_;
    }

    virtual std::ostream & print( std::ostream & out ) const {
	ISInfo::print( out );
	out << "Key: " << Key << "	//Describes Key (could be a chain name)" << std::endl;
	out << "Values[" << Values.size() << "]:	//List of values associated  to Key (could  be list of chains, nodes connected)" << std::endl;
	for ( size_t i = 0; i < Values.size(); ++i )
	    out << i << ": " << Values[i] << std::endl;
	out << "RunNumber: " << RunNumber << "	//RunNumber (duplicated from Tree in order to use the branch class alone as a single level tree)" << std::endl;
	out << "LumiBlock: " << LumiBlock << "	//LuminosityBlock (cf RunNumber)" << std::endl;
	out << "ConfigItem[" << ConfigItem.size() << "]:	//String describing generig data for configuration (can be menu name)" << std::endl;
	for ( size_t i = 0; i < ConfigItem.size(); ++i )
	    out << i << ": " << ConfigItem[i] << std::endl;
	out << "TimeStamp: " << TimeStamp << "	//TimeStamp of generation of this object (to have it different from the one IS puts)" << std::endl;
	return out;
    }

    Branch( )
      : ISInfo( "Branch" )
    {
	initialize();
    }

    ~Branch(){

// <<BeginUserCode>>

// <<EndUserCode>>
    }

protected:
    Branch( const std::string & type )
      : ISInfo( type )
    {
	initialize();
    }

    void publishGuts( ISostream & out ){
	out << Key << Values << RunNumber << LumiBlock << ConfigItem << TimeStamp;
    }

    void refreshGuts( ISistream & in ){
	in >> Key >> Values >> RunNumber >> LumiBlock >> ConfigItem >> TimeStamp;
    }

private:
    void initialize()
    {
	Key = "xxx";
	Values.resize( 1 );
	Values[0] = "0";
	RunNumber = 0;
	LumiBlock = 0;
	TimeStamp = OWLTime("01/01/70");

// <<BeginUserCode>>

// <<EndUserCode>>
    }


// <<BeginUserCode>>
 public:
    void EraseCont(){
      Values.clear();
      Key="";
      ConfigItem.clear();
    }
// <<EndUserCode>>
};

// <<BeginUserCode>>

// <<EndUserCode>>
inline std::ostream & operator<<( std::ostream & out, const Branch & info ) {
    info.print( out );
    return out;
}

#endif // BRANCH_H
