#ifndef CTPCOREITEMRATEINFO_H
#define CTPCOREITEMRATEINFO_H

#include <is/info.h>

#include <string>
#include <ostream>


// <<BeginUserCode>>

// <<EndUserCode>>

namespace L1CT
{
/**
 * 
 * @author  generated by the IS tool
 * @version 09/09/14
 */

class CtpcoreItemRateInfo : public ISInfo {
public:

    /**
     * Name
     */
    std::string                        name;

    /**
     * Trigger item number
     */
    unsigned int                       ctp_id;

    /**
     * Partition number {0=ATLAS, 1=Part.1, 2=Part.2, 3=Part.3}
     */
    unsigned int                       partition;

    /**
     * Enabledness in trigger mask, via the L1PS set (See publ. by the CtpConfigurator)
     */
    bool                               enabled;

    /**
     * Effective prescale
     */
    float                              prescale;

    /**
     * Trigger rate before prescale [Hz].
     */
    float                              tbp;

    /**
     * Trigger rate after prescale [Hz].
     */
    float                              tap;

    /**
     * Trigger rate after veto [Hz].
     */
    float                              tav;

    /**
     * Ratio before/after prescale (tbp divided by tap)
     */
    float                              tap_tbp_ratio;


    static const ISType & type() {
	static const ISType type_ = CtpcoreItemRateInfo( ).ISInfo::type();
	return type_;
    }

    virtual std::ostream & print( std::ostream & out ) const {
	ISInfo::print( out );
	out << std::endl;
	out << "name: " << name << "\t// Name" << std::endl;
	out << "ctp_id: " << ctp_id << "\t// Trigger item number" << std::endl;
	out << "partition: " << partition << "\t// Partition number {0=ATLAS, 1=Part.1, 2=Part.2, 3=Part.3}" << std::endl;
	out << "enabled: " << enabled << "\t// Enabledness in trigger mask, via the L1PS set (See publ. by the CtpConfigurator)" << std::endl;
	out << "prescale: " << prescale << "\t// Effective prescale" << std::endl;
	out << "tbp: " << tbp << "\t// Trigger rate before prescale [Hz]." << std::endl;
	out << "tap: " << tap << "\t// Trigger rate after prescale [Hz]." << std::endl;
	out << "tav: " << tav << "\t// Trigger rate after veto [Hz]." << std::endl;
	out << "tap_tbp_ratio: " << tap_tbp_ratio << "\t// Ratio before/after prescale (tbp divided by tap)";
	return out;
    }

    CtpcoreItemRateInfo( )
      : ISInfo( "CtpcoreItemRateInfo" )
    {
	initialize();
    }

    ~CtpcoreItemRateInfo(){

// <<BeginUserCode>>

// <<EndUserCode>>
    }

protected:
    CtpcoreItemRateInfo( const std::string & type )
      : ISInfo( type )
    {
	initialize();
    }

    void publishGuts( ISostream & out ){
	out << name << ctp_id << partition << enabled << prescale << tbp << tap << tav << tap_tbp_ratio;
    }

    void refreshGuts( ISistream & in ){
	in >> name >> ctp_id >> partition >> enabled >> prescale >> tbp >> tap >> tav >> tap_tbp_ratio;
    }

private:
    void initialize()
    {
	enabled = true;

// <<BeginUserCode>>

// <<EndUserCode>>
    }


// <<BeginUserCode>>

// <<EndUserCode>>
};

// <<BeginUserCode>>

// <<EndUserCode>>
inline std::ostream & operator<<( std::ostream & out, const CtpcoreItemRateInfo & info ) {
    info.print( out );
    return out;
}

}

#endif // CTPCOREITEMRATEINFO_H
