#ifndef CTPCOREPITRATEINFO_H
#define CTPCOREPITRATEINFO_H

#include <is/info.h>

#include <string>
#include <ostream>


// <<BeginUserCode>>

// <<EndUserCode>>

namespace L1CT
{
/**
 * 
 * @author  generated by the IS tool
 * @version 01/03/17
 */

class CtpcorePITRateInfo : public ISInfo {
public:

    /**
     * PIT number
     */
    unsigned int                  pit_number;

    /**
     * Threshold name (See publ. by the CtpConfigurator)
     */
    std::string                   threshold_name;

    /**
     * Threshold bit (See publ. by the CtpConfigurator)
     */
    unsigned int                  threshold_bit;

    /**
     * Threshold id (See publ. by the CtpConfigurator)
     */
    unsigned int                  threshold_id;

    /**
     * Cable bit
     */
    unsigned int                  cable_bit;

    /**
     * Ctpin slot
     */
    unsigned int                  ctpin_slot;

    /**
     * Connector number
     */
    unsigned int                  ctpin_connector;

    /**
     * PIT rate [Hz] (See publ. by the CtpMonitoringServer)
     */
    float                         rate;


    static const ISType & type() {
	static const ISType type_ = CtpcorePITRateInfo( ).ISInfo::type();
	return type_;
    }

    virtual std::ostream & print( std::ostream & out ) const {
	ISInfo::print( out );
	out << std::endl;
	out << "pit_number: " << pit_number << "\t// PIT number" << std::endl;
	out << "threshold_name: " << threshold_name << "\t// Threshold name (See publ. by the CtpConfigurator)" << std::endl;
	out << "threshold_bit: " << threshold_bit << "\t// Threshold bit (See publ. by the CtpConfigurator)" << std::endl;
	out << "threshold_id: " << threshold_id << "\t// Threshold id (See publ. by the CtpConfigurator)" << std::endl;
	out << "cable_bit: " << cable_bit << "\t// Cable bit" << std::endl;
	out << "ctpin_slot: " << ctpin_slot << "\t// Ctpin slot" << std::endl;
	out << "ctpin_connector: " << ctpin_connector << "\t// Connector number" << std::endl;
	out << "rate: " << rate << "\t// PIT rate [Hz] (See publ. by the CtpMonitoringServer)";
	return out;
    }

    CtpcorePITRateInfo( )
      : ISInfo( "CtpcorePITRateInfo" )
    {
	initialize();
    }

    ~CtpcorePITRateInfo(){

// <<BeginUserCode>>

// <<EndUserCode>>
    }

protected:
    CtpcorePITRateInfo( const std::string & type )
      : ISInfo( type )
    {
	initialize();
    }

    void publishGuts( ISostream & out ){
	out << pit_number << threshold_name << threshold_bit << threshold_id << cable_bit;
	out << ctpin_slot << ctpin_connector << rate;
    }

    void refreshGuts( ISistream & in ){
	in >> pit_number >> threshold_name >> threshold_bit >> threshold_id >> cable_bit;
	in >> ctpin_slot >> ctpin_connector >> rate;
    }

private:
    void initialize()
    {

// <<BeginUserCode>>

// <<EndUserCode>>
    }


// <<BeginUserCode>>

// <<EndUserCode>>
};

// <<BeginUserCode>>

// <<EndUserCode>>
inline std::ostream & operator<<( std::ostream & out, const CtpcorePITRateInfo & info ) {
    info.print( out );
    return out;
}

}

#endif // CTPCOREPITRATEINFO_H
