#ifndef CTPINRATEINFO_H
#define CTPINRATEINFO_H

#include <is/info.h>

#include <TRP/CtpinRateInfoCounter.h>
#include <string>
#include <ostream>
#include <vector>


// <<BeginUserCode>>

// <<EndUserCode>>

namespace L1CT
{
/**
 * 
 * @author  generated by the IS tool
 * @version 01/03/17
 */

class CtpinRateInfo : public ISInfo {
public:

    /**
     * ATLAS run number
     */
    unsigned int                        run_number;

    /**
     * Current luminosity number
     */
    unsigned int                        lumiblock_number;

    /**
     */
    std::vector<CtpinRateInfoCounter>   counters;


    static const ISType & type() {
	static const ISType type_ = CtpinRateInfo( ).ISInfo::type();
	return type_;
    }

    virtual std::ostream & print( std::ostream & out ) const {
	ISInfo::print( out );
	out << std::endl;
	out << "run_number: " << run_number << "\t// ATLAS run number" << std::endl;
	out << "lumiblock_number: " << lumiblock_number << "\t// Current luminosity number" << std::endl;
	out << "counters[" << counters.size() << "]:\t// " << std::endl;
	for ( size_t i = 0; i < counters.size(); ++i )
	    out << i << " : " << counters[i] << std::endl;
	return out;
    }

    CtpinRateInfo( )
      : ISInfo( "CtpinRateInfo" )
    {
	initialize();
    }

    ~CtpinRateInfo(){

// <<BeginUserCode>>

// <<EndUserCode>>
    }

protected:
    CtpinRateInfo( const std::string & type )
      : ISInfo( type )
    {
	initialize();
    }

    void publishGuts( ISostream & out ){
	out << run_number << lumiblock_number << counters;
    }

    void refreshGuts( ISistream & in ){
	in >> run_number >> lumiblock_number >> counters;
    }

private:
    void initialize()
    {

// <<BeginUserCode>>

// <<EndUserCode>>
    }


// <<BeginUserCode>>

// <<EndUserCode>>
};

// <<BeginUserCode>>

// <<EndUserCode>>
inline std::ostream & operator<<( std::ostream & out, const CtpinRateInfo & info ) {
    info.print( out );
    return out;
}

}

#endif // CTPINRATEINFO_H
