#ifndef CTPINRATEINFOCOUNTER_H
#define CTPINRATEINFOCOUNTER_H

#include <is/info.h>

#include <string>
#include <ostream>


// <<BeginUserCode>>

// <<EndUserCode>>

namespace L1CT
{
/**
 * 
 * @author  generated by the IS tool
 * @version 01/03/17
 */

class CtpinRateInfoCounter : public ISInfo {
public:

    /**
     * Name
     */
    std::string                         name;

    /**
     * Ctpin slot number
     */
    unsigned int                        slot;

    /**
     * Cable number
     */
    unsigned int                        cable_number;

    /**
     * Counter number
     */
    unsigned int                        counter_number;

    /**
     * Number of orbits
     */
    uint64_t                            orbit;

    /**
     * Counter value
     */
    uint64_t                            value;

    /**
     * Counter rate [Hz]
     */
    double                              rate;

    /**
     * Overflow
     */
    bool                                overflow;

    /**
     * If the counter belongs to the partition
     */
    bool                                in_partition;


    static const ISType & type() {
	static const ISType type_ = CtpinRateInfoCounter( ).ISInfo::type();
	return type_;
    }

    virtual std::ostream & print( std::ostream & out ) const {
	ISInfo::print( out );
	out << std::endl;
	out << "name: " << name << "\t// Name" << std::endl;
	out << "slot: " << slot << "\t// Ctpin slot number" << std::endl;
	out << "cable_number: " << cable_number << "\t// Cable number" << std::endl;
	out << "counter_number: " << counter_number << "\t// Counter number" << std::endl;
	out << "orbit: " << orbit << "\t// Number of orbits" << std::endl;
	out << "value: " << value << "\t// Counter value" << std::endl;
	out << "rate: " << rate << "\t// Counter rate [Hz]" << std::endl;
	out << "overflow: " << overflow << "\t// Overflow" << std::endl;
	out << "in_partition: " << in_partition << "\t// If the counter belongs to the partition";
	return out;
    }

    CtpinRateInfoCounter( )
      : ISInfo( "CtpinRateInfoCounter" )
    {
	initialize();
    }

    ~CtpinRateInfoCounter(){

// <<BeginUserCode>>

// <<EndUserCode>>
    }

protected:
    CtpinRateInfoCounter( const std::string & type )
      : ISInfo( type )
    {
	initialize();
    }

    void publishGuts( ISostream & out ){
	out << name << slot << cable_number << counter_number << orbit << value << rate << overflow;
	out << in_partition;
    }

    void refreshGuts( ISistream & in ){
	in >> name >> slot >> cable_number >> counter_number >> orbit >> value >> rate >> overflow;
	in >> in_partition;
    }

private:
    void initialize()
    {
	in_partition = true;

// <<BeginUserCode>>

// <<EndUserCode>>
    }


// <<BeginUserCode>>

// <<EndUserCode>>
};

// <<BeginUserCode>>

// <<EndUserCode>>
inline std::ostream & operator<<( std::ostream & out, const CtpinRateInfoCounter & info ) {
    info.print( out );
    return out;
}

}

#endif // CTPINRATEINFOCOUNTER_H
