#ifndef DEADTIMEMON_H
#define DEADTIMEMON_H

#include <is/info.h>

#include <string>
#include <ostream>


// <<BeginUserCode>>

// <<EndUserCode>>
/**
 * Deadtime monitoring
 * 
 * @author  generated by the IS tool
 * @version 03/07/11
 */

class DeadtimeMon : public ISInfo {
public:

    /**
     * simple deadtime
     */
    float                         simpleDT;

    /**
     * complex deadtime
     */
    float                         complexDT;

    /**
     * DAQ deadtime
     */
    float                         DAQDT;

    /**
     * Total deadtime priority 1
     */
    float                         TOTCplx1DT;


    static const ISType & type() {
	static const ISType type_ = DeadtimeMon( ).ISInfo::type();
	return type_;
    }

    virtual std::ostream & print( std::ostream & out ) const {
	ISInfo::print( out );
	out << std::endl;
	out << "simpleDT: " << simpleDT << "\t// simple deadtime" << std::endl;
	out << "complexDT: " << complexDT << "\t// complex deadtime" << std::endl;
	out << "DAQDT: " << DAQDT << "\t// DAQ deadtime" << std::endl;
	out << "TOTCplx1DT: " << TOTCplx1DT << "\t// Total deadtime priority 1";
	return out;
    }

    DeadtimeMon( )
      : ISInfo( "DeadtimeMon" )
    {
	initialize();
    }

    ~DeadtimeMon(){

// <<BeginUserCode>>

// <<EndUserCode>>
    }

protected:
    DeadtimeMon( const std::string & type )
      : ISInfo( type )
    {
	initialize();
    }

    void publishGuts( ISostream & out ){
	out << simpleDT << complexDT << DAQDT << TOTCplx1DT;
    }

    void refreshGuts( ISistream & in ){
	in >> simpleDT >> complexDT >> DAQDT >> TOTCplx1DT;
    }

private:
    void initialize()
    {

// <<BeginUserCode>>

// <<EndUserCode>>
    }


// <<BeginUserCode>>

// <<EndUserCode>>
};

// <<BeginUserCode>>

// <<EndUserCode>>
inline std::ostream & operator<<( std::ostream & out, const DeadtimeMon & info ) {
    info.print( out );
    return out;
}

#endif // DEADTIMEMON_H
