#ifndef GLOBAL_OFFSET_H
#define GLOBAL_OFFSET_H

#include <is/info.h>

#include <string>
#include <vector>
#include <ostream>

/**
 * Xmon Global Offset Data
 * 2019-09-19 Nick Felice
 */

class Global_Offset : public ISInfo {
public:
    
    /**
     * output of kolmogorov smirnov test
     */
    float               ks;

    /**
     * avg difference between the means of the histograms
     */
    float               meanerr;

    /**
     * included triggers
     */
    std::vector<std::string>    trigs;


    static const ISType & type() {
        static const ISType type_ = Global_Offset( ).ISInfo::type();
        return type_;
    }

    virtual std::ostream & print( std::ostream & out ) const {
        ISInfo::print( out );
        out << "ks: " << ks << "    //output of kolmogorov smirnov test" << std::endl;
        out << "meanerr: " << meanerr << "  //avg difference between the means of the histograms" << std::endl;
        out << "trigs[" << trigs.size() << "]:  //included triggers" << std::endl;
        for (size_t i = 0; i < trigs.size(); ++i)
            out << i << ": " << trigs[i] << std::endl;
        return out;
    }

    Global_Offset( )
      : ISInfo( "Global_Offset" )
    {
        initialize();
    }

    ~Global_Offset(){

    }

protected:
    Global_Offset( const std::string & type )
      : ISInfo( type )
    {
        initialize();
    }

    void publishGuts( ISostream & out ){
        out << ks << meanerr << trigs;
    }

    void refreshGuts( ISistream & in){
        in >> ks >> meanerr >> trigs;
    }

private:
    void initialize()
    {


    }


};


inline std::ostream & operator<<(std::ostream & out, const Global_Offset & info) {
    info.print( out );
    return out;
}

#endif
