#ifndef ISCTPCOREPSKEY_H
#define ISCTPCOREPSKEY_H

#include <is/info.h>

#include <string>
#include <ostream>


// <<BeginUserCode>>

// <<EndUserCode>>
/**
 * Current L1 prescale key loaded   in the CORE
 * 
 * @author  generated by the IS tool
 * @version 18/04/09
 */

class ISCTPCOREPSKey : public ISInfo {
public:

    /**
     * LVL1 prescale key of the   trigger configuration DB.
     */
    unsigned int                  L1PrescaleKey;

    /**
     * Lumi block for which this prescale set was loaded.
     */
    unsigned int                  LumiBlock;


    static const ISType & type() {
	static const ISType type_ = ISCTPCOREPSKey( ).ISInfo::type();
	return type_;
    }

    virtual std::ostream & print( std::ostream & out ) const {
	ISInfo::print( out );
	out << "L1PrescaleKey: " << L1PrescaleKey << "	//LVL1 prescale key of the   trigger configuration DB." << std::endl;
	out << "LumiBlock: " << LumiBlock << "	//Lumi block for which this prescale set was loaded." << std::endl;
	return out;
    }

    ISCTPCOREPSKey( )
      : ISInfo( "ISCTPCOREPSKey" )
    {
	initialize();
    }

    ~ISCTPCOREPSKey(){

// <<BeginUserCode>>

// <<EndUserCode>>
    }

protected:
    ISCTPCOREPSKey( const std::string & type )
      : ISInfo( type )
    {
	initialize();
    }

    void publishGuts( ISostream & out ){
	out << L1PrescaleKey << LumiBlock;
    }

    void refreshGuts( ISistream & in ){
	in >> L1PrescaleKey >> LumiBlock;
    }

private:
    void initialize()
    {

// <<BeginUserCode>>

// <<EndUserCode>>
    }


// <<BeginUserCode>>

// <<EndUserCode>>
};

// <<BeginUserCode>>

// <<EndUserCode>>
inline std::ostream & operator<<( std::ostream & out, const ISCTPCOREPSKey & info ) {
    info.print( out );
    return out;
}

#endif // ISCTPCOREPSKEY_H
