#ifndef ISMIOCTSECTOR_H
#define ISMIOCTSECTOR_H

#include <is/info.h>

#include <string>
#include <ostream>
#include <vector>


// <<BeginUserCode>>

// <<EndUserCode>>

namespace L1CT
{
/**
 * 
 * @author  generated by the IS tool
 * @version 03/03/15
 */

class ISMIOCTSector : public ISInfo {
public:

    /**
     */
    std::string                                         Name;

    /**
     * MIOCT slot
     */
    unsigned char                                       MioctSlot;

    /**
     * Input number of MIOCT
     */
    unsigned char                                       MioctInput;

    /**
     */
    std::string                                         Mode;

    /**
     * Input pipeline in bunch crossings
     */
    unsigned char                                       Pipeline;

    /**
     * Phase in nanoseconds
     */
    unsigned char                                       Phase;

    /**
     * Insert BCID
     */
    bool                                                InsertBCID;

    /**
     * Rate of 1st candidate in Hertz for pt1..pt6
     */
    std::vector<double>                                 Rate_cand1;

    /**
     * Rate of 2nd candidate in Hertz for pt1..pt6
     */
    std::vector<double>                                 Rate_cand2;


    static const ISType & type() {
	static const ISType type_ = ISMIOCTSector( ).ISInfo::type();
	return type_;
    }

    virtual std::ostream & print( std::ostream & out ) const {
	ISInfo::print( out );
	out << std::endl;
	out << "Name: " << Name << "\t// " << std::endl;
	out << "MioctSlot: " << MioctSlot << "\t// MIOCT slot" << std::endl;
	out << "MioctInput: " << MioctInput << "\t// Input number of MIOCT" << std::endl;
	out << "Mode: " << Mode << "\t// " << std::endl;
	out << "Pipeline: " << Pipeline << "\t// Input pipeline in bunch crossings" << std::endl;
	out << "Phase: " << Phase << "\t// Phase in nanoseconds" << std::endl;
	out << "InsertBCID: " << InsertBCID << "\t// Insert BCID" << std::endl;
	out << "Rate_cand1[" << Rate_cand1.size() << "]:\t// Rate of 1st candidate in Hertz for pt1..pt6" << std::endl;
	for ( size_t i = 0; i < Rate_cand1.size(); ++i )
	    out << i << " : " << Rate_cand1[i] << std::endl;
	out << "Rate_cand2[" << Rate_cand2.size() << "]:\t// Rate of 2nd candidate in Hertz for pt1..pt6" << std::endl;
	for ( size_t i = 0; i < Rate_cand2.size(); ++i )
	    out << i << " : " << Rate_cand2[i] << std::endl;
	return out;
    }

    ISMIOCTSector( )
      : ISInfo( "ISMIOCTSector" )
    {
	initialize();
    }

    ~ISMIOCTSector(){

// <<BeginUserCode>>

// <<EndUserCode>>
    }

protected:
    ISMIOCTSector( const std::string & type )
      : ISInfo( type )
    {
	initialize();
    }

    void publishGuts( ISostream & out ){
	out << Name << MioctSlot << MioctInput << Mode << Pipeline << Phase << InsertBCID;
	out << Rate_cand1 << Rate_cand2;
    }

    void refreshGuts( ISistream & in ){
	in >> Name >> MioctSlot >> MioctInput >> Mode >> Pipeline >> Phase >> InsertBCID;
	in >> Rate_cand1 >> Rate_cand2;
    }

private:
    void initialize()
    {
	MioctSlot = 4;
	MioctInput = 0;

// <<BeginUserCode>>

// <<EndUserCode>>
    }


// <<BeginUserCode>>

// <<EndUserCode>>
};

// <<BeginUserCode>>

// <<EndUserCode>>
inline std::ostream & operator<<( std::ostream & out, const ISMIOCTSector & info ) {
    info.print( out );
    return out;
}

}

#endif // ISMIOCTSECTOR_H
