#ifndef ISMIOCTSECTORNAMED_H
#define ISMIOCTSECTORNAMED_H

#include <is/namedinfo.h>

#include <string>
#include <ostream>
#include <vector>


// <<BeginUserCode>>

// <<EndUserCode>>
/**
 * 
 * @author  generated by the IS tool
 * @version 11/11/09
 */

class ISMIOCTSectorNamed : public ISNamedInfo {
public:

    /**
     */
    std::string                   Name;

    /**
     * MIOCT slot
     */
    unsigned char                 MioctSlot;

    /**
     * Input number of MIOCT
     */
    unsigned char                 MioctInput;

    /**
     */
    std::string                   Mode;

    /**
     * Input pipeline in bunch crossings
     */
    unsigned char                 Pipeline;

    /**
     * Phase in nanoseconds
     */
    unsigned char                 Phase;

    /**
     * Insert BCID
     */
    bool                          InsertBCID;

    /**
     * Rate of 1st candidate in Hertz for pt1..pt6
     */
    std::vector<double>           Rate_cand1;

    /**
     * Rate of 2nd candidate in Hertz for pt1..pt6
     */
    std::vector<double>           Rate_cand2;


    static const ISType & type() {
	static const ISType type_ = ISMIOCTSectorNamed( IPCPartition(), "" ).ISInfo::type();
	return type_;
    }

    virtual std::ostream & print( std::ostream & out ) const {
	ISNamedInfo::print( out );
	out << "Name: " << Name << "	//" << std::endl;
	out << "MioctSlot: " << MioctSlot << "	//MIOCT slot" << std::endl;
	out << "MioctInput: " << MioctInput << "	//Input number of MIOCT" << std::endl;
	out << "Mode: " << Mode << "	//" << std::endl;
	out << "Pipeline: " << Pipeline << "	//Input pipeline in bunch crossings" << std::endl;
	out << "Phase: " << Phase << "	//Phase in nanoseconds" << std::endl;
	out << "InsertBCID: " << InsertBCID << "	//Insert BCID" << std::endl;
	out << "Rate_cand1[" << Rate_cand1.size() << "]:	//Rate of 1st candidate in Hertz for pt1..pt6" << std::endl;
	for ( size_t i = 0; i < Rate_cand1.size(); ++i )
	    out << i << ": " << Rate_cand1[i] << std::endl;
	out << "Rate_cand2[" << Rate_cand2.size() << "]:	//Rate of 2nd candidate in Hertz for pt1..pt6" << std::endl;
	for ( size_t i = 0; i < Rate_cand2.size(); ++i )
	    out << i << ": " << Rate_cand2[i] << std::endl;
	return out;
    }

    ISMIOCTSectorNamed( const IPCPartition & partition, const std::string & name )
      : ISNamedInfo( partition, name, "ISMIOCTSector" )
    {
	initialize();
    }

    ~ISMIOCTSectorNamed(){

// <<BeginUserCode>>

// <<EndUserCode>>
    }

protected:
    ISMIOCTSectorNamed( const IPCPartition & partition, const std::string & name, const std::string & type )
      : ISNamedInfo( partition, name, type )
    {
	initialize();
    }

    void publishGuts( ISostream & out ){
	out << Name << MioctSlot << MioctInput << Mode << Pipeline << Phase << InsertBCID;
	out << Rate_cand1 << Rate_cand2;
    }

    void refreshGuts( ISistream & in ){
	in >> Name >> MioctSlot >> MioctInput >> Mode >> Pipeline >> Phase >> InsertBCID;
	in >> Rate_cand1 >> Rate_cand2;
    }

private:
    void initialize()
    {
	MioctSlot = 4;
	MioctInput = 0;

// <<BeginUserCode>>

// <<EndUserCode>>
    }


// <<BeginUserCode>>

// <<EndUserCode>>
};

// <<BeginUserCode>>

// <<EndUserCode>>
inline std::ostream & operator<<( std::ostream & out, const ISMIOCTSectorNamed & info ) {
    info.print( out );
    return out;
}

#endif // ISMIOCTSECTORNAMED_H
