#ifndef L1CALORATES_H
#define L1CALORATES_H

#include <is/info.h>

#include <string>
#include <ostream>
#include <vector>


// <<BeginUserCode>>

// <<EndUserCode>>
/**
 * Generic IS variable for storing a set of rates (from PPM or CMM)
 * 
 * @author  generated by the IS tool
 * @version 28/04/10
 */

class L1CaloRates : public ISInfo {
public:

    /**
     * Overall label describing the rates in this IS variable.
     */
    std::string                   label;

    /**
     * Longer description of the meaning of the rates in this IS variable.
     */
    std::string                   description;

    /**
     * Array of names or labels for each value in the rates array.
     */
    std::vector<std::string>      names;

    /**
     * Arrays of values of rates (Hz).
     */
    std::vector<double>           rates;


    static const ISType & type() {
	static const ISType type_ = L1CaloRates( ).ISInfo::type();
	return type_;
    }

    virtual std::ostream & print( std::ostream & out ) const {
	ISInfo::print( out );
	out << "label: " << label << "	//Overall label describing the rates in this IS variable." << std::endl;
	out << "description: " << description << "	//Longer description of the meaning of the rates in this IS variable." << std::endl;
	out << "names[" << names.size() << "]:	//Array of names or labels for each value in the rates array." << std::endl;
	for ( size_t i = 0; i < names.size(); ++i )
	    out << i << ": " << names[i] << std::endl;
	out << "rates[" << rates.size() << "]:	//Arrays of values of rates (Hz)." << std::endl;
	for ( size_t i = 0; i < rates.size(); ++i )
	    out << i << ": " << rates[i] << std::endl;
	return out;
    }

    L1CaloRates( )
      : ISInfo( "L1CaloRates" )
    {
	initialize();
    }

    ~L1CaloRates(){

// <<BeginUserCode>>

// <<EndUserCode>>
    }

protected:
    L1CaloRates( const std::string & type )
      : ISInfo( type )
    {
	initialize();
    }

    void publishGuts( ISostream & out ){
	out << label << description << names << rates;
    }

    void refreshGuts( ISistream & in ){
	in >> label >> description >> names >> rates;
    }

private:
    void initialize()
    {
	rates.resize( 1 );
	rates[0] = 0;

// <<BeginUserCode>>

// <<EndUserCode>>
    }


// <<BeginUserCode>>

// <<EndUserCode>>
};

// <<BeginUserCode>>

// <<EndUserCode>>
inline std::ostream & operator<<( std::ostream & out, const L1CaloRates & info ) {
    info.print( out );
    return out;
}

#endif // L1CALORATES_H
