#ifndef L2PU_H
#define L2PU_H

#include <is/info.h>

#include <string>
#include <ostream>


// <<BeginUserCode>>

// <<EndUserCode>>
/**
 * Basic info to monitor the L2PU
 * 
 * @author  generated by the IS tool
 * @version 23/06/08
 */

class L2PU : public ISInfo {
public:

    /**
     * Total number of errors
     */
    unsigned int                  Errors;

    /**
     * Number of disabled ROSs
     */
    unsigned int                  disableCnt;

    /**
     * Number of LVL1 results
     */
    uint64_t                      NumLVL1Results;

    /**
     * Number of LVL2 accepts
     */
    uint64_t                      NumLVL2Accepts;

    /**
     * Number of LVL2 rejects
     */
    uint64_t                      NumLVL2Rejects;

    /**
     * Number of LVL2 decisions
     */
    uint64_t                      NumLVL2Decisions;

    /**
     * Interval length(s)
     */
    double                        IntervalTime;

    /**
     * Interval LVL2 decision rate(Hz)
     */
    double                        LVL2IntervalRate;

    /**
     * Average LVL2 decision rate(Hz)
     */
    double                        LVL2AverageRate;

    /**
     * Data rate from ROS(MB/s)
     */
    double                        TotalDataRate;


    static const ISType & type() {
	static const ISType type_ = L2PU( ).ISInfo::type();
	return type_;
    }

    virtual std::ostream & print( std::ostream & out ) const {
	ISInfo::print( out );
	out << "Errors: " << Errors << "	//Total number of errors" << std::endl;
	out << "disableCnt: " << disableCnt << "	//Number of disabled ROSs" << std::endl;
	out << "NumLVL1Results: " << NumLVL1Results << "	//Number of LVL1 results" << std::endl;
	out << "NumLVL2Accepts: " << NumLVL2Accepts << "	//Number of LVL2 accepts" << std::endl;
	out << "NumLVL2Rejects: " << NumLVL2Rejects << "	//Number of LVL2 rejects" << std::endl;
	out << "NumLVL2Decisions: " << NumLVL2Decisions << "	//Number of LVL2 decisions" << std::endl;
	out << "IntervalTime: " << IntervalTime << "	//Interval length(s)" << std::endl;
	out << "LVL2IntervalRate: " << LVL2IntervalRate << "	//Interval LVL2 decision rate(Hz)" << std::endl;
	out << "LVL2AverageRate: " << LVL2AverageRate << "	//Average LVL2 decision rate(Hz)" << std::endl;
	out << "TotalDataRate: " << TotalDataRate << "	//Data rate from ROS(MB/s)" << std::endl;
	return out;
    }

    L2PU( )
      : ISInfo( "L2PU" )
    {
	initialize();
    }

    ~L2PU(){

// <<BeginUserCode>>

// <<EndUserCode>>
    }

protected:
    L2PU( const std::string & type )
      : ISInfo( type )
    {
	initialize();
    }

    void publishGuts( ISostream & out ){
	out << Errors << disableCnt << NumLVL1Results << NumLVL2Accepts << NumLVL2Rejects;
	out << NumLVL2Decisions << IntervalTime << LVL2IntervalRate << LVL2AverageRate << TotalDataRate;
    }

    void refreshGuts( ISistream & in ){
	in >> Errors >> disableCnt >> NumLVL1Results >> NumLVL2Accepts >> NumLVL2Rejects;
	in >> NumLVL2Decisions >> IntervalTime >> LVL2IntervalRate >> LVL2AverageRate >> TotalDataRate;
    }

private:
    void initialize()
    {

// <<BeginUserCode>>

// <<EndUserCode>>
    }


// <<BeginUserCode>>

// <<EndUserCode>>
};

// <<BeginUserCode>>

// <<EndUserCode>>
inline std::ostream & operator<<( std::ostream & out, const L2PU & info ) {
    info.print( out );
    return out;
}


class L2PU_compact {
public:
	L2PU_compact() {
		Errors = 0;
		LVL2IntervalRate = 0;
	}

	L2PU_compact(const L2PU& l) {
		Errors = l.Errors;
		LVL2IntervalRate = l.LVL2IntervalRate;
	}

    unsigned int                  Errors;
	//    unsigned int                  disableCnt;
	//    uint64_t                      NumLVL1Results;
	//    uint64_t                      NumLVL2Accepts;
	//    uint64_t                      NumLVL2Rejects;
	//    uint64_t                      NumLVL2Decisions;
	//    double                        IntervalTime;
    double                        LVL2IntervalRate;
	//    double                        LVL2AverageRate;
	//    double                        TotalDataRate;
};

#endif // L2PU_H
