#ifndef LUMIRAW_H
#define LUMIRAW_H

#include <is/info.h>

#include <string>
#include <ostream>


// <<BeginUserCode>>

// <<EndUserCode>>
/**
 * Raw luminosity information
 * 
 * @author  generated by the IS tool
 * @version 06/12/09
 */

class LumiRaw : public ISInfo {
public:

    /**
     * Run number the calculated luminosities refer to
     */
    unsigned int                  RunNumber;

    /**
     * Lumi block number the calculated luminosities refer to
     */
    unsigned int                  LBN;

    /**
     * Data quality: 0=GOOD
     */
    int                           Quality;

    /**
     * Raw data
     */
    double                        RawData;

    /**
     * Mask of active channels
     */
    unsigned int                  ChannelMask;

    /**
     * Length of integration time interval in number of LHC turns
     */
    unsigned int                  NumberOfTurns;

    /**
     * Number of filled BC per turn (if applicable)
     */
    unsigned int                  NumberOfFilledBunches;


    static const ISType & type() {
	static const ISType type_ = LumiRaw( ).ISInfo::type();
	return type_;
    }

    virtual std::ostream & print( std::ostream & out ) const {
	ISInfo::print( out );
	out << "RunNumber: " << RunNumber << "	//Run number the calculated luminosities refer to" << std::endl;
	out << "LBN: " << LBN << "	//Lumi block number the calculated luminosities refer to" << std::endl;
	out << "Quality: " << Quality << "	//Data quality: 0=GOOD" << std::endl;
	out << "RawData: " << RawData << "	//Raw data" << std::endl;
	out << "ChannelMask: " << ChannelMask << "	//Mask of active channels" << std::endl;
	out << "NumberOfTurns: " << NumberOfTurns << "	//Length of integration time interval in number of LHC turns" << std::endl;
	out << "NumberOfFilledBunches: " << NumberOfFilledBunches << "	//Number of filled BC per turn (if applicable)" << std::endl;
	return out;
    }

    LumiRaw( )
      : ISInfo( "LumiRaw" )
    {
	initialize();
    }

    ~LumiRaw(){

// <<BeginUserCode>>

// <<EndUserCode>>
    }

protected:
    LumiRaw( const std::string & type )
      : ISInfo( type )
    {
	initialize();
    }

    void publishGuts( ISostream & out ){
	out << RunNumber << LBN << Quality << RawData << ChannelMask << NumberOfTurns << NumberOfFilledBunches;
    }

    void refreshGuts( ISistream & in ){
	in >> RunNumber >> LBN >> Quality >> RawData >> ChannelMask >> NumberOfTurns >> NumberOfFilledBunches;
    }

private:
    void initialize()
    {
	Quality = 1;
	RawData = 0;
	ChannelMask = 0x0;
	NumberOfTurns = 0;
	NumberOfFilledBunches = 0xffff;

// <<BeginUserCode>>

// <<EndUserCode>>
    }


// <<BeginUserCode>>

// <<EndUserCode>>
};

// <<BeginUserCode>>

// <<EndUserCode>>
inline std::ostream & operator<<( std::ostream & out, const LumiRaw & info ) {
    info.print( out );
    return out;
}

#endif // LUMIRAW_H
