#ifndef PMGPUBLISHEDAGENTDATA_H
#define PMGPUBLISHEDAGENTDATA_H

#include <is/info.h>

#include <string>
#include <ostream>


// <<BeginUserCode>>

// <<EndUserCode>>
/**
 * This class contains information about the PC running the agent and the agent serving the partition for which the infrormation server is running
 * 
 * @author  generated by the IS tool
 * @version 02/09/09
 */

class PMGPublishedAgentData : public ISInfo {
public:

    /**
     * The name with which PMG agent publish itself in IS.
     */
    std::string                   name;

    /**
     * Total system memory (kB) (GLOBAL)
     */
    unsigned int                  totalram;

    /**
     * Used memory (%) (GLOBAL)
     */
    unsigned int                  ram;

    /**
     * Total system swap memory (kB) (GLOBAL)
     */
    unsigned int                  totalswap;

    /**
     * Used swap (%) (GLOBAL)
     */
    unsigned int                  swap;

    /**
     * Number of processors the operating system configured (GLOBAL)
     */
    unsigned int                  nCPU;

    /**
     * Number of current processes (GLOBAL)
     */
    unsigned short                procs;

    /**
     * File system usage (GLOBAL)
     */
    std::string                   fs;

    /**
     * 1 minute load average (GLOBAL)
     */
    double                        load1;

    /**
     * 5 minute load average (GLOBAL)
     */
    double                        load5;

    /**
     * 15 minute load average (GLOBAL)
     */
    double                        load15;

    /**
     * Amount of time that this process has been scheduled in user mode (ms)
     */
    uint64_t                      utime;

    /**
     * Amount of time that this process has been scheduled in kernel mode (ms)
     */
    uint64_t                      stime;

    /**
     * Total program size (kB)
     */
    int64_t                       size;

    /**
     * Resident set size (kB)
     */
    int64_t                       resident;

    /**
     * Number of threads in this process
     */
    int64_t                       num_threads;


    static const ISType & type() {
	static const ISType type_ = PMGPublishedAgentData( ).ISInfo::type();
	return type_;
    }

    virtual std::ostream & print( std::ostream & out ) const {
	ISInfo::print( out );
	out << "name: " << name << "	//The name with which PMG agent publish itself in IS." << std::endl;
	out << "totalram: " << totalram << "	//Total system memory (kB) (GLOBAL)" << std::endl;
	out << "ram: " << ram << "	//Used memory (%) (GLOBAL)" << std::endl;
	out << "totalswap: " << totalswap << "	//Total system swap memory (kB) (GLOBAL)" << std::endl;
	out << "swap: " << swap << "	//Used swap (%) (GLOBAL)" << std::endl;
	out << "nCPU: " << nCPU << "	//Number of processors the operating system configured (GLOBAL)" << std::endl;
	out << "procs: " << procs << "	//Number of current processes (GLOBAL)" << std::endl;
	out << "fs: " << fs << "	//File system usage (GLOBAL)" << std::endl;
	out << "load1: " << load1 << "	//1 minute load average (GLOBAL)" << std::endl;
	out << "load5: " << load5 << "	//5 minute load average (GLOBAL)" << std::endl;
	out << "load15: " << load15 << "	//15 minute load average (GLOBAL)" << std::endl;
	out << "utime: " << utime << "	//Amount of time that this process has been scheduled in user mode (ms)" << std::endl;
	out << "stime: " << stime << "	//Amount of time that this process has been scheduled in kernel mode (ms)" << std::endl;
	out << "size: " << size << "	//Total program size (kB)" << std::endl;
	out << "resident: " << resident << "	//Resident set size (kB)" << std::endl;
	out << "num_threads: " << num_threads << "	//Number of threads in this process" << std::endl;
	return out;
    }

    PMGPublishedAgentData( )
      : ISInfo( "PMGPublishedAgentData" )
    {
	initialize();
    }

    ~PMGPublishedAgentData(){

// <<BeginUserCode>>

// <<EndUserCode>>
    }

protected:
    PMGPublishedAgentData( const std::string & type )
      : ISInfo( type )
    {
	initialize();
    }

    void publishGuts( ISostream & out ){
	out << name << totalram << ram << totalswap << swap << nCPU << procs << fs << load1;
	out << load5 << load15 << utime << stime << size << resident << num_threads;
    }

    void refreshGuts( ISistream & in ){
	in >> name >> totalram >> ram >> totalswap >> swap >> nCPU >> procs >> fs >> load1;
	in >> load5 >> load15 >> utime >> stime >> size >> resident >> num_threads;
    }

private:
    void initialize()
    {
	nCPU = 0;
	utime = 0;
	stime = 0;
	size = 0;
	resident = 0;
	num_threads = 0;

// <<BeginUserCode>>

// <<EndUserCode>>
    }


// <<BeginUserCode>>

// <<EndUserCode>>
};

// <<BeginUserCode>>

// <<EndUserCode>>
inline std::ostream & operator<<( std::ostream & out, const PMGPublishedAgentData & info ) {
    info.print( out );
    return out;
}

#endif // PMGPUBLISHEDAGENTDATA_H
