#ifndef PROC_H
#define PROC_H

#include <is/info.h>

#include <string>
#include <ostream>


// <<BeginUserCode>>

// <<EndUserCode>>
/**
 * 
 * @author  generated by the IS tool
 * @version 23/06/08
 */

class PROC : public ISInfo {
public:

    /**
     * Time since last reset (s)
     */
    unsigned int                  Run_time_s_;

    /**
     * Estimated CPU usage since last reset (%)
     */
    unsigned int                  TotalCPU;

    /**
     * Time since last update (s)
     */
    double                        IntervalTime;

    /**
     * Estimated CPU usage since last update (%)
     */
    unsigned int                  IntervalCPU;

    /**
     * User time since last update (ms)
     */
    unsigned int                  IntervalUtime;

    /**
     * System time since last update (ms)
     */
    unsigned int                  IntervalStime;

    /**
     * Number of Processors Available
     */
    unsigned int                  NProcessor;

    /**
     * Total Number of Threads
     */
    unsigned int                  NThread;

    /**
     * Number of Running Threads
     */
    unsigned int                  NActiveThread;

    /**
     * Total Physical Memory (kb)
     */
    unsigned int                  TotalRAM;

    /**
     * Unused Physical Memory Available (kb)
     */
    unsigned int                  UnusedRAM;

    /**
     * System 1 minute load average (%)
     */
    unsigned int                  LoadAvg1Min;

    /**
     * System 5 minutes load average (%)
     */
    unsigned int                  LoadAvg5Min;

    /**
     * System 15 minutes load average (%)
     */
    unsigned int                  LoadAvg15Min;

    /**
     * Total User Time (ms)
     */
    unsigned int                  TotalUtime;

    /**
     * Total System Time (ms)
     */
    unsigned int                  TotalStime;

    /**
     * Total Virtual Memory Size (kb)
     */
    unsigned int                  TotalVirtualSize;

    /**
     * RSS Size (kb)
     */
    unsigned int                  RSSSize;

    /**
     * Executable Size (kb)
     */
    unsigned int                  ExeSize;

    /**
     * Total Shared Library Size (kb)
     */
    unsigned int                  LibSize;

    /**
     * Total Stack Size (kb)
     */
    unsigned int                  StackSize;

    /**
     * Minor Page Faults Since Start
     */
    unsigned int                  MinorPageFaults;

    /**
     * Accumulated Minor Page Faults Since Start
     */
    unsigned int                  AccMinorPageFaults;

    /**
     * Major Page Faults Since Start
     */
    unsigned int                  MajorPageFaults;

    /**
     * Accumulated Major Page Faults Since Start
     */
    unsigned int                  AccMajorPageFaults;

    /**
     * Number of Times I Swapped
     */
    unsigned int                  NumberOfSwaps;

    /**
     * Number File Descriptors Opened
     */
    unsigned int                  NumberOfFileDescsOpened;

    /**
     * Host name
     */
    std::string                   HostName;


    static const ISType & type() {
	static const ISType type_ = PROC( ).ISInfo::type();
	return type_;
    }

    virtual std::ostream & print( std::ostream & out ) const {
	ISInfo::print( out );
	out << "Run_time_s_: " << Run_time_s_ << "	//Time since last reset (s)" << std::endl;
	out << "TotalCPU: " << TotalCPU << "	//Estimated CPU usage since last reset (%)" << std::endl;
	out << "IntervalTime: " << IntervalTime << "	//Time since last update (s)" << std::endl;
	out << "IntervalCPU: " << IntervalCPU << "	//Estimated CPU usage since last update (%)" << std::endl;
	out << "IntervalUtime: " << IntervalUtime << "	//User time since last update (ms)" << std::endl;
	out << "IntervalStime: " << IntervalStime << "	//System time since last update (ms)" << std::endl;
	out << "NProcessor: " << NProcessor << "	//Number of Processors Available" << std::endl;
	out << "NThread: " << NThread << "	//Total Number of Threads" << std::endl;
	out << "NActiveThread: " << NActiveThread << "	//Number of Running Threads" << std::endl;
	out << "TotalRAM: " << TotalRAM << "	//Total Physical Memory (kb)" << std::endl;
	out << "UnusedRAM: " << UnusedRAM << "	//Unused Physical Memory Available (kb)" << std::endl;
	out << "LoadAvg1Min: " << LoadAvg1Min << "	//System 1 minute load average (%)" << std::endl;
	out << "LoadAvg5Min: " << LoadAvg5Min << "	//System 5 minutes load average (%)" << std::endl;
	out << "LoadAvg15Min: " << LoadAvg15Min << "	//System 15 minutes load average (%)" << std::endl;
	out << "TotalUtime: " << TotalUtime << "	//Total User Time (ms)" << std::endl;
	out << "TotalStime: " << TotalStime << "	//Total System Time (ms)" << std::endl;
	out << "TotalVirtualSize: " << TotalVirtualSize << "	//Total Virtual Memory Size (kb)" << std::endl;
	out << "RSSSize: " << RSSSize << "	//RSS Size (kb)" << std::endl;
	out << "ExeSize: " << ExeSize << "	//Executable Size (kb)" << std::endl;
	out << "LibSize: " << LibSize << "	//Total Shared Library Size (kb)" << std::endl;
	out << "StackSize: " << StackSize << "	//Total Stack Size (kb)" << std::endl;
	out << "MinorPageFaults: " << MinorPageFaults << "	//Minor Page Faults Since Start" << std::endl;
	out << "AccMinorPageFaults: " << AccMinorPageFaults << "	//Accumulated Minor Page Faults Since Start" << std::endl;
	out << "MajorPageFaults: " << MajorPageFaults << "	//Major Page Faults Since Start" << std::endl;
	out << "AccMajorPageFaults: " << AccMajorPageFaults << "	//Accumulated Major Page Faults Since Start" << std::endl;
	out << "NumberOfSwaps: " << NumberOfSwaps << "	//Number of Times I Swapped" << std::endl;
	out << "NumberOfFileDescsOpened: " << NumberOfFileDescsOpened << "	//Number File Descriptors Opened" << std::endl;
	out << "HostName: " << HostName << "	//Host name" << std::endl;
	return out;
    }

    PROC( )
      : ISInfo( "PROC" )
    {
	initialize();
    }

    ~PROC(){

// <<BeginUserCode>>

// <<EndUserCode>>
    }

protected:
    PROC( const std::string & type )
      : ISInfo( type )
    {
	initialize();
    }

    void publishGuts( ISostream & out ){
	out << Run_time_s_ << TotalCPU << IntervalTime << IntervalCPU << IntervalUtime << IntervalStime;
	out << NProcessor << NThread << NActiveThread << TotalRAM << UnusedRAM << LoadAvg1Min;
	out << LoadAvg5Min << LoadAvg15Min << TotalUtime << TotalStime << TotalVirtualSize;
	out << RSSSize << ExeSize << LibSize << StackSize << MinorPageFaults << AccMinorPageFaults;
	out << MajorPageFaults << AccMajorPageFaults << NumberOfSwaps << NumberOfFileDescsOpened;
	out << HostName;
    }

    void refreshGuts( ISistream & in ){
	in >> Run_time_s_ >> TotalCPU >> IntervalTime >> IntervalCPU >> IntervalUtime >> IntervalStime;
	in >> NProcessor >> NThread >> NActiveThread >> TotalRAM >> UnusedRAM >> LoadAvg1Min;
	in >> LoadAvg5Min >> LoadAvg15Min >> TotalUtime >> TotalStime >> TotalVirtualSize;
	in >> RSSSize >> ExeSize >> LibSize >> StackSize >> MinorPageFaults >> AccMinorPageFaults;
	in >> MajorPageFaults >> AccMajorPageFaults >> NumberOfSwaps >> NumberOfFileDescsOpened;
	in >> HostName;
    }

private:
    void initialize()
    {

// <<BeginUserCode>>

// <<EndUserCode>>
    }


// <<BeginUserCode>>

// <<EndUserCode>>
};

// <<BeginUserCode>>

// <<EndUserCode>>
inline std::ostream & operator<<( std::ostream & out, const PROC & info ) {
    info.print( out );
    return out;
}


class PROC_compact {
public:
	PROC_compact() {
		IntervalTime = 0;
		IntervalCPU = 0;
		TotalVirtualSize = 0;
	}

	PROC_compact(const PROC& p) {
		IntervalTime = p.IntervalTime;
		IntervalCPU = p.IntervalCPU;
		TotalVirtualSize = p.TotalVirtualSize;
	}

	//	unsigned int Run_time_s_;
	//	unsigned int TotalCPU;
    double IntervalTime;
    unsigned int IntervalCPU;
	//    unsigned int IntervalUtime;
	//    unsigned int IntervalStime;
	//    unsigned int NProcessor;
	//    unsigned int NThread;
	//    unsigned int NActiveThread;
	//    unsigned int TotalRAM;
	//    unsigned int UnusedRAM;
	//    unsigned int LoadAvg1Min;
	//    unsigned int LoadAvg5Min;
	//    unsigned int LoadAvg15Min;
	//    unsigned int TotalUtime;
	//    unsigned int TotalStime;
    unsigned int TotalVirtualSize;
	//    unsigned int RSSSize;
	//    unsigned int ExeSize;
	//    unsigned int LibSize;
	//    unsigned int StackSize;
	//    unsigned int MinorPageFaults;
	//    unsigned int AccMinorPageFaults;
	//    unsigned int MajorPageFaults;
	//    unsigned int AccMajorPageFaults;
	//    unsigned int NumberOfSwaps;
	//    unsigned int NumberOfFileDescsOpened;
	//    std::string HostName;
};

#endif // PROC_H
