#ifndef PT_H
#define PT_H

#include <is/info.h>

#include <string>
#include <ostream>


// <<BeginUserCode>>

// <<EndUserCode>>
/**
 * 
 * @author  generated by the IS tool
 * @version 23/06/08
 */

class PT : public ISInfo {
public:

    /**
     * Time since start of process
     */
    std::string                   StartTime;

    /**
     */
    unsigned int                  Run_time_s_;

    /**
     */
    double                        Time_since_last_event_s_;

    /**
     * The last HLT configuration string read by the PT and applied to the framework
     */
    std::string                   LastHLTConfigString;

    /**
     * Number of configuration errors
     */
    unsigned int                  ConfigurationErrors;

    /**
     * Number of other errors
     */
    unsigned int                  OtherErrors;

    /**
     * Number of Event Filter Accept decisions
     */
    unsigned int                  EF_Accepts;

    /**
     * Number of Event Filter Rejects decisions
     */
    unsigned int                  EF_Rejects;

    /**
     * Total Number of Event Filter decisions
     */
    unsigned int                  EF_decisions;

    /**
     * CPU time spent in algorithms (seconds)
     */
    double                        Cpu_time_used_by_algorithms;

    /**
     * CPU time as percentage of total run time
     */
    double                        Cpu_time_as___of_total_run_time;

    /**
     * Name of the SubFarm where the PT is running
     */
    std::string                   SubFarmName;


    static const ISType & type() {
	static const ISType type_ = PT( ).ISInfo::type();
	return type_;
    }

    virtual std::ostream & print( std::ostream & out ) const {
	ISInfo::print( out );
	out << "StartTime: " << StartTime << "	//Time since start of process" << std::endl;
	out << "Run_time_s_: " << Run_time_s_ << "	//" << std::endl;
	out << "Time_since_last_event_s_: " << Time_since_last_event_s_ << "	//" << std::endl;
	out << "LastHLTConfigString: " << LastHLTConfigString << "	//The last HLT configuration string read by the PT and applied to the framework" << std::endl;
	out << "ConfigurationErrors: " << ConfigurationErrors << "	//Number of configuration errors" << std::endl;
	out << "OtherErrors: " << OtherErrors << "	//Number of other errors" << std::endl;
	out << "EF_Accepts: " << EF_Accepts << "	//Number of Event Filter Accept decisions" << std::endl;
	out << "EF_Rejects: " << EF_Rejects << "	//Number of Event Filter Rejects decisions" << std::endl;
	out << "EF_decisions: " << EF_decisions << "	//Total Number of Event Filter decisions" << std::endl;
	out << "Cpu_time_used_by_algorithms: " << Cpu_time_used_by_algorithms << "	//CPU time spent in algorithms (seconds)" << std::endl;
	out << "Cpu_time_as___of_total_run_time: " << Cpu_time_as___of_total_run_time << "	//CPU time as percentage of total run time" << std::endl;
	out << "SubFarmName: " << SubFarmName << "	//Name of the SubFarm where the PT is running" << std::endl;
	return out;
    }

    PT( )
      : ISInfo( "PT" )
    {
	initialize();
    }

    ~PT(){

// <<BeginUserCode>>

// <<EndUserCode>>
    }

protected:
    PT( const std::string & type )
      : ISInfo( type )
    {
	initialize();
    }

    void publishGuts( ISostream & out ){
	out << StartTime << Run_time_s_ << Time_since_last_event_s_ << LastHLTConfigString;
	out << ConfigurationErrors << OtherErrors << EF_Accepts << EF_Rejects << EF_decisions;
	out << Cpu_time_used_by_algorithms << Cpu_time_as___of_total_run_time << SubFarmName;
    }

    void refreshGuts( ISistream & in ){
	in >> StartTime >> Run_time_s_ >> Time_since_last_event_s_ >> LastHLTConfigString;
	in >> ConfigurationErrors >> OtherErrors >> EF_Accepts >> EF_Rejects >> EF_decisions;
	in >> Cpu_time_used_by_algorithms >> Cpu_time_as___of_total_run_time >> SubFarmName;
    }

private:
    void initialize()
    {

// <<BeginUserCode>>

// <<EndUserCode>>
    }


// <<BeginUserCode>>

// <<EndUserCode>>
};

// <<BeginUserCode>>

// <<EndUserCode>>
inline std::ostream & operator<<( std::ostream & out, const PT & info ) {
    info.print( out );
    return out;
}


class PT_compact {
public:
	PT_compact() {
		ConfigurationErrors = 0;
		OtherErrors = 0;
		EF_decisions = 0;
	}

	PT_compact(const PT& p) {
		ConfigurationErrors = p.ConfigurationErrors;
		OtherErrors = p.OtherErrors;
		EF_decisions = p.EF_decisions;
	}

	//    std::string                   StartTime;
	//    unsigned int                  Run_time_s_;
	//    double                        Time_since_last_event_s_;
	//    std::string                   LastHLTConfigString;
	unsigned int                  ConfigurationErrors;
    unsigned int                  OtherErrors;
	//    unsigned int                  EF_Accepts;
	//    unsigned int                  EF_Rejects;
	unsigned int                  EF_decisions;
	//    double                        Cpu_time_used_by_algorithms;
	//    double                        Cpu_time_as___of_total_run_time;
	//    std::string                   SubFarmName;
};

#endif // PT_H
