#ifndef RPCL1RATES_H
#define RPCL1RATES_H

#include <is/info.h>

#include <string>
#include <ostream>
#include <vector>


// <<BeginUserCode>>

// <<EndUserCode>>
/**
 * Muon Barrel LVL1 rates monitoring values
 * 
 * @author  generated by the IS tool
 * @version 22/10/09
 */

class RPCL1Rates : public ISInfo {
public:

    /**
     * Label encoding the muon-barrel LVL1 sub-system, and the exact origin of the data. Separate fields should be separated by a dot, that is, period, like this: L1CT.CTPIN.InputCounters or L1Muon.RPC.Sector5.TowerXY
     */
    std::string                   label;

    /**
     * Further description or explanation of the kind of data. Not used for parsing, but will be displayed along with the data.
     */
    std::string                   description;

    /**
     * Labels of the counters of incoming signals
     */
    std::vector<std::string>      rateLabels;

    /**
     * Counters of incoming signals
     */
    std::vector<double>           rateValues;


    static const ISType & type() {
	static const ISType type_ = RPCL1Rates( ).ISInfo::type();
	return type_;
    }

    virtual std::ostream & print( std::ostream & out ) const {
	ISInfo::print( out );
	out << "label: " << label << "	//Label encoding the muon-barrel LVL1 sub-system, and the exact origin of the data. Separate fields should be separated by a dot, that is, period, like this: L1CT.CTPIN.InputCounters or L1Muon.RPC.Sector5.TowerXY" << std::endl;
	out << "description: " << description << "	//Further description or explanation of the kind of data. Not used for parsing, but will be displayed along with the data." << std::endl;
	out << "rateLabels[" << rateLabels.size() << "]:	//Labels of the counters of incoming signals" << std::endl;
	for ( size_t i = 0; i < rateLabels.size(); ++i )
	    out << i << ": " << rateLabels[i] << std::endl;
	out << "rateValues[" << rateValues.size() << "]:	//Counters of incoming signals" << std::endl;
	for ( size_t i = 0; i < rateValues.size(); ++i )
	    out << i << ": " << rateValues[i] << std::endl;
	return out;
    }

    RPCL1Rates( )
      : ISInfo( "RPCL1Rates" )
    {
	initialize();
    }

    ~RPCL1Rates(){

// <<BeginUserCode>>

// <<EndUserCode>>
    }

protected:
    RPCL1Rates( const std::string & type )
      : ISInfo( type )
    {
	initialize();
    }

    void publishGuts( ISostream & out ){
	out << label << description << rateLabels << rateValues;
    }

    void refreshGuts( ISistream & in ){
	in >> label >> description >> rateLabels >> rateValues;
    }

private:
    void initialize()
    {
	rateLabels.resize( 1 );
	rateLabels[0] = "";
	rateValues.resize( 1 );
	rateValues[0] = 0;

// <<BeginUserCode>>

// <<EndUserCode>>
    }


// <<BeginUserCode>>

// <<EndUserCode>>
};

// <<BeginUserCode>>

// <<EndUserCode>>
inline std::ostream & operator<<( std::ostream & out, const RPCL1Rates & info ) {
    info.print( out );
    return out;
}

#endif // RPCL1RATES_H
