#ifndef TIMEPOINT_IS_H
#define TIMEPOINT_IS_H

#include <is/info.h>

#include <string>
#include <ostream>
#include <vector>
#include <owl/time.h>


// <<BeginUserCode>>

// <<EndUserCode>>
/**
 * 
 * @author  generated by the IS tool
 * @version 05/03/09
 */

class TimePoint_IS : public ISInfo {
public:

    /**
     * Run Number
     */
    unsigned int                  RunNumber;

    /**
     * TimeStamp
     */
    OWLTime                       TimeStamp;

    /**
     * Luminosity Block number
     */
    unsigned short                LumiBlock;

    /**
     * Labels of X axis (e.g. Chainnames)
     */
    std::vector<std::string>      XLabels;

    /**
     * Labels for Y axis (e.g.  Input, Stip1, PS, PT)
     */
    std::vector<std::string>      YLabels;

    /**
     * vector to store arrays of floats Data[0]...Data[NumCol-1] Data[NumCol]...Data[NumCol+(NumCol-1)] ... Data[(NumRow-1) x NumCol]...Data[(NumRow-1) x NumCol]
     */
    std::vector<float>            Data;

    /**
     * metadata info
     */
    std::vector<std::string>      MetaData;


    static const ISType & type() {
	static const ISType type_ = TimePoint_IS( ).ISInfo::type();
	return type_;
    }

    virtual std::ostream & print( std::ostream & out ) const {
	ISInfo::print( out );
	out << "RunNumber: " << RunNumber << "	//Run Number" << std::endl;
	out << "TimeStamp: " << TimeStamp << "	//TimeStamp" << std::endl;
	out << "LumiBlock: " << LumiBlock << "	//Luminosity Block number" << std::endl;
	out << "XLabels[" << XLabels.size() << "]:	//Labels of X axis (e.g. Chainnames)" << std::endl;
	for ( size_t i = 0; i < XLabels.size(); ++i )
	    out << i << ": " << XLabels[i] << std::endl;
	out << "YLabels[" << YLabels.size() << "]:	//Labels for Y axis (e.g.  Input, Stip1, PS, PT)" << std::endl;
	for ( size_t i = 0; i < YLabels.size(); ++i )
	    out << i << ": " << YLabels[i] << std::endl;
	out << "Data[" << Data.size() << "]:	//vector to store arrays of floats Data[0]...Data[NumCol-1] Data[NumCol]...Data[NumCol+(NumCol-1)] ... Data[(NumRow-1) x NumCol]...Data[(NumRow-1) x NumCol]" << std::endl;
	for ( size_t i = 0; i < Data.size(); ++i )
	    out << i << ": " << Data[i] << std::endl;
	out << "MetaData[" << MetaData.size() << "]:	//metadata info" << std::endl;
	for ( size_t i = 0; i < MetaData.size(); ++i )
	    out << i << ": " << MetaData[i] << std::endl;
	return out;
    }

    TimePoint_IS( )
      : ISInfo( "TimePoint_IS" )
    {
	initialize();
    }

    ~TimePoint_IS(){

// <<BeginUserCode>>

// <<EndUserCode>>
    }

protected:
    TimePoint_IS( const std::string & type )
      : ISInfo( type )
    {
	initialize();
    }

    void publishGuts( ISostream & out ){
	out << RunNumber << TimeStamp << LumiBlock << XLabels << YLabels << Data << MetaData;
    }

    void refreshGuts( ISistream & in ){
	in >> RunNumber >> TimeStamp >> LumiBlock >> XLabels >> YLabels >> Data >> MetaData;
    }

private:
    void initialize()
    {
	RunNumber = 0;
	TimeStamp = OWLTime((time_t)0);
	LumiBlock = 0;
	XLabels.resize( 1 );
	XLabels[0] = "xxx";
	YLabels.resize( 1 );
	YLabels[0] = "yyy";
	Data.resize( 1 );
	Data[0] = -1;

// <<BeginUserCode>>

	m_IsFreshData = true;

// <<EndUserCode>>
    }


// <<BeginUserCode>>
public:
  void SetXAxis(const std::vector<std::string> &x);
  void SetYAxis(const std::vector<std::string> &y);
  int NumCol();
  int NumRow();
  void EraseCont();
  void EraseData();
  std::ostream & dump( std::ostream & out ) const;

  void clear();
  void format(const std::vector<std::string> &x, 
              const std::vector<std::string> &y);
  bool get(const std::string &x, const std::string &y, float &value) const;
  bool set(const std::string &x, const std::string &y, float value);

  bool get(unsigned int x, unsigned int y, float &value) const;
  bool set(unsigned int x, unsigned int y, float value);
  void print_as_table(std::ostream & out) const;
  bool get_xy(unsigned int id, std::string &x, std::string &y) const;
  void Scale(float scale_factor);

private:
  /**
   * this map is used to provide fast lookup from the labels to the 
   * memory location which holds the actual values
   */
  typedef std::map<std::string, int > LUT;
  mutable LUT m_XLabelsMap;
  mutable LUT m_YLabelsMap;

  bool index(const std::string& x, const std::string& y, unsigned int&) const;
  bool index(unsigned int x, unsigned int y, unsigned int&) const;


  /**
   * Variable gets set to true whenever the labels are updated 
   */
  mutable bool m_IsFreshData; 

  
  /**
   * Updates the lookup map from labels to mem location
   */
  void updateMap() const;  

// <<EndUserCode>>
};

// <<BeginUserCode>>

// <<EndUserCode>>
inline std::ostream & operator<<( std::ostream & out, const TimePoint_IS & info ) {
    info.print( out );
    return out;
}

#endif // TIMEPOINT_IS_H
