#ifndef TREE_H
#define TREE_H

#include <is/info.h>

#include <TRP/Branch.h>
#include <string>
#include <ostream>
#include <vector>
#include <owl/time.h>


// <<BeginUserCode>>

// <<EndUserCode>>
/**
 * Class to represent in IS trees with two levels (like  the one for trigger menu) can be used also for farm structure
 * 
 * @author  generated by the IS tool
 * @version 21/04/09
 */

class Tree : public ISInfo {
public:

    /**
     * RunNumber
     */
    unsigned int                  RunNumber;

    /**
     * LuminosityBlock
     */
    unsigned short                LumiBlock;

    /**
     * Key for tree. could be stream name
     */
    std::string                   Key;

    /**
     * String describing generig data for configuration (can be menu name)
     */
    std::vector<std::string>      ConfigItem;

    /**
     * TimeStamp of generation of this object (to have it different from the one IS puts)
     */
    OWLTime                       TimeStamp;

    /**
     * List of Branches associated  to the tree (indexed by key)
     */
    std::vector<Branch>           branchlist;


    static const ISType & type() {
	static const ISType type_ = Tree( ).ISInfo::type();
	return type_;
    }

    virtual std::ostream & print( std::ostream & out ) const {
	ISInfo::print( out );
	out << "RunNumber: " << RunNumber << "	//RunNumber" << std::endl;
	out << "LumiBlock: " << LumiBlock << "	//LuminosityBlock" << std::endl;
	out << "Key: " << Key << "	//Key for tree. could be stream name" << std::endl;
	out << "ConfigItem[" << ConfigItem.size() << "]:	//String describing generig data for configuration (can be menu name)" << std::endl;
	for ( size_t i = 0; i < ConfigItem.size(); ++i )
	    out << i << ": " << ConfigItem[i] << std::endl;
	out << "TimeStamp: " << TimeStamp << "	//TimeStamp of generation of this object (to have it different from the one IS puts)" << std::endl;
	out << "branchlist[" << branchlist.size() << "]:	//List of Branches associated  to the tree (indexed by key)" << std::endl;
	for ( size_t i = 0; i < branchlist.size(); ++i )
	    out << i << ": " << branchlist[i] << std::endl;
	return out;
    }

    Tree( )
      : ISInfo( "Tree" )
    {
	initialize();
    }

    ~Tree(){

// <<BeginUserCode>>

// <<EndUserCode>>
    }

protected:
    Tree( const std::string & type )
      : ISInfo( type )
    {
	initialize();
    }

    void publishGuts( ISostream & out ){
	out << RunNumber << LumiBlock << Key << ConfigItem << TimeStamp << branchlist;
    }

    void refreshGuts( ISistream & in ){
	in >> RunNumber >> LumiBlock >> Key >> ConfigItem >> TimeStamp >> branchlist;
    }

private:
    void initialize()
    {
	RunNumber = 0;
	LumiBlock = 0;
	Key = "xxx";
	TimeStamp = OWLTime("01/01/70");

// <<BeginUserCode>>

// <<EndUserCode>>
    }


// <<BeginUserCode>>
 public:
    void EraseCont(){
      std::vector<Branch>::iterator it;
      for(it=branchlist.begin();it!=branchlist.end();++it){
	it->EraseCont();
      }
     Key="";
     ConfigItem.clear();	
    }
// <<EndUserCode>>
};

// <<BeginUserCode>>

// <<EndUserCode>>
inline std::ostream & operator<<( std::ostream & out, const Tree & info ) {
    info.print( out );
    return out;
}

#endif // TREE_H
