#ifndef TRIGCONFKEYS_H
#define TRIGCONFKEYS_H

#include <is/info.h>

#include <string>
#include <ostream>


// <<BeginUserCode>>

// <<EndUserCode>>
/**
 * Trigger configuration database keys in use
 * 
 * @author  generated by the IS tool
 * @version 20/05/08
 */

class TrigConfKeys : public ISInfo {
public:

    /**
     * Supermaster key of the trigger configuration.
     */
    unsigned int                  SuperMasterKey;

    /**
     * LVL1 master key of the trigger configuration.
     */
    unsigned int                  L1MasterKey;

    /**
     * LVL1 prescale key of the trigger configuration.
     */
    unsigned int                  L1PrescaleKey;


    static const ISType & type() {
	static const ISType type_ = TrigConfKeys( ).ISInfo::type();
	return type_;
    }

    virtual std::ostream & print( std::ostream & out ) const {
	ISInfo::print( out );
	out << "SuperMasterKey: " << SuperMasterKey << "	//Supermaster key of the trigger configuration." << std::endl;
	out << "L1MasterKey: " << L1MasterKey << "	//LVL1 master key of the trigger configuration." << std::endl;
	out << "L1PrescaleKey: " << L1PrescaleKey << "	//LVL1 prescale key of the trigger configuration." << std::endl;
	return out;
    }

    TrigConfKeys( )
      : ISInfo( "TrigConfKeys" )
    {
	initialize();
    }

    ~TrigConfKeys(){

// <<BeginUserCode>>

// <<EndUserCode>>
    }

    void setKeys(){
      SuperMasterKey=123;
      L1MasterKey=456;
      L1PrescaleKey=789;
    }
    
protected:
    TrigConfKeys( const std::string & type )
      : ISInfo( type )
    {
	initialize();
    }

    void publishGuts( ISostream & out ){
	out << SuperMasterKey << L1MasterKey << L1PrescaleKey;
    }

    void refreshGuts( ISistream & in ){
	in >> SuperMasterKey >> L1MasterKey >> L1PrescaleKey;
    }

private:
    void initialize()
    {

// <<BeginUserCode>>

// <<EndUserCode>>
    }


// <<BeginUserCode>>

// <<EndUserCode>>
};

// <<BeginUserCode>>

// <<EndUserCode>>
inline std::ostream & operator<<( std::ostream & out, const TrigConfKeys & info ) {
    info.print( out );
    return out;
}

#endif // TRIGCONFKEYS_H

