#ifndef TRIGCONFL1BGKEY_H
#define TRIGCONFL1BGKEY_H

#include <is/info.h>

#include <string>
#include <ostream>


// <<BeginUserCode>>

// <<EndUserCode>>
/**
 * Current L1 bunch group key
 * 
 * @author  generated by the IS tool
 * @version 14/01/15
 */

class TrigConfL1BgKey : public ISInfo {
public:

    /**
     * LVL1 bunch group key of the trigger configuration
     */
    unsigned int                  L1BunchGroupKey;

    /**
     * LVL1 bunch group comment
     */
    std::string                   L1BunchGroupComment;


    static const ISType & type() {
	static const ISType type_ = TrigConfL1BgKey( ).ISInfo::type();
	return type_;
    }

    virtual std::ostream & print( std::ostream & out ) const {
	ISInfo::print( out );
	out << std::endl;
	out << "L1BunchGroupKey: " << L1BunchGroupKey << "\t// LVL1 bunch group key of the trigger configuration" << std::endl;
	out << "L1BunchGroupComment: " << L1BunchGroupComment << "\t// LVL1 bunch group comment";
	return out;
    }

    TrigConfL1BgKey( )
      : ISInfo( "TrigConfL1BgKey" )
    {
	initialize();
    }

    ~TrigConfL1BgKey(){

// <<BeginUserCode>>

// <<EndUserCode>>
    }

protected:
    TrigConfL1BgKey( const std::string & type )
      : ISInfo( type )
    {
	initialize();
    }

    void publishGuts( ISostream & out ){
	out << L1BunchGroupKey << L1BunchGroupComment;
    }

    void refreshGuts( ISistream & in ){
	in >> L1BunchGroupKey >> L1BunchGroupComment;
    }

private:
    void initialize()
    {

// <<BeginUserCode>>

// <<EndUserCode>>
    }


// <<BeginUserCode>>

// <<EndUserCode>>
};

// <<BeginUserCode>>

// <<EndUserCode>>
inline std::ostream & operator<<( std::ostream & out, const TrigConfL1BgKey & info ) {
    info.print( out );
    return out;
}

#endif // TRIGCONFL1BGKEY_H
