#ifndef TRIGCONFL1DEADTIMES_H
#define TRIGCONFL1DEADTIMES_H

#include <is/info.h>

#include <string>
#include <ostream>


// <<BeginUserCode>>

// <<EndUserCode>>
/**
 * Central trigger deadtimes values
 * 
 * @author  generated by the IS tool
 * @version 16/08/09
 */

class TrigConfL1Deadtimes : public ISInfo {
public:

    /**
     * Simple dead-time in units of bunch crossings
     */
    unsigned int                  Simple;

    /**
     * Cmplx rate, for 'ComplexRate1' bunch crossings, the bucket level is decremented by 1.
     */
    unsigned int                  ComplexRate1;

    /**
     * Bucket level, counter increments per L1A, dead-time is imposed if counter reaches 'ComplexLevel1'.
     */
    unsigned int                  ComplexLevel1;

    /**
     * Cmplx rate, for 'ComplexRate2' bunch crossings, the bucket level is decremented by 1.
     */
    unsigned int                  ComplexRate2;

    /**
     * Bucket level, counter increments per L1A, dead-time is imposed if counter reaches 'ComplexLevel1'.
     */
    unsigned int                  ComplexLevel2;


    static const ISType & type() {
	static const ISType type_ = TrigConfL1Deadtimes( ).ISInfo::type();
	return type_;
    }

    virtual std::ostream & print( std::ostream & out ) const {
	ISInfo::print( out );
	out << "Simple: " << Simple << "	//Simple dead-time in units of bunch crossings" << std::endl;
	out << "ComplexRate1: " << ComplexRate1 << "	//Cmplx rate, for 'ComplexRate1' bunch crossings, the bucket level is decremented by 1." << std::endl;
	out << "ComplexLevel1: " << ComplexLevel1 << "	//Bucket level, counter increments per L1A, dead-time is imposed if counter reaches 'ComplexLevel1'." << std::endl;
	out << "ComplexRate2: " << ComplexRate2 << "	//Cmplx rate, for 'ComplexRate2' bunch crossings, the bucket level is decremented by 1." << std::endl;
	out << "ComplexLevel2: " << ComplexLevel2 << "	//Bucket level, counter increments per L1A, dead-time is imposed if counter reaches 'ComplexLevel1'." << std::endl;
	return out;
    }

    TrigConfL1Deadtimes( )
      : ISInfo( "TrigConfL1Deadtimes" )
    {
	initialize();
    }

    ~TrigConfL1Deadtimes(){

// <<BeginUserCode>>

// <<EndUserCode>>
    }

protected:
    TrigConfL1Deadtimes( const std::string & type )
      : ISInfo( type )
    {
	initialize();
    }

    void publishGuts( ISostream & out ){
	out << Simple << ComplexRate1 << ComplexLevel1 << ComplexRate2 << ComplexLevel2;
    }

    void refreshGuts( ISistream & in ){
	in >> Simple >> ComplexRate1 >> ComplexLevel1 >> ComplexRate2 >> ComplexLevel2;
    }

private:
    void initialize()
    {

// <<BeginUserCode>>

// <<EndUserCode>>
    }


// <<BeginUserCode>>

// <<EndUserCode>>
};

// <<BeginUserCode>>

// <<EndUserCode>>
inline std::ostream & operator<<( std::ostream & out, const TrigConfL1Deadtimes & info ) {
    info.print( out );
    return out;
}

#endif // TRIGCONFL1DEADTIMES_H
