#include "TROOT.h"
#include "TRint.h"
#include <string.h>
#include "TChain.h"
#include "TFile.h"
#include "TCanvas.h"
#include "TH1.h"
#include "TTree.h"
#include "TKey.h"
#include "Riostream.h"
#include "TRegexp.h"

TList *HistoList;
TFile *Target;
TFile *Input;

TString *dir_str;
TString *histo_str;
TH1 *global_sum;
bool first_histo= true;

TH1F *time_histo[10];
const Int_t n_xbin = 5000;
const char *x_label[n_xbin];
Int_t i_lab=0;


Float_t GetLastBin(TH1 *h,Int_t y_id){
  Float_t out = -1;
  Int_t nbin = h->GetXaxis()->GetNbins();
  out	=h->GetBinContent(nbin, y_id);

  return(out);
}

Float_t GetFirstBin(TH1 *h,Int_t y_id){
  Float_t out = -1;
  out	=h->GetBinContent(1, y_id);
  return(out);
}

void add_histo_rates(TDirectory *dir, bool do_sum) {
   // in an interactive ROOT session, edit the file names
   // Target and FileList, then
   // root > .L hadd.C
   // root > hadd()
  TRegexp reg_dir("Histogramming-L2-.*",true);
  TDirectory *dirsav = gDirectory;
  TIter next(dir->GetListOfKeys());
  TKey *key;
  while ((key = (TKey*)next())) {
    TClass *cl = gROOT->GetClass(key->GetClassName());
    //    cl->Dump();
    if (cl->InheritsFrom("TH1")){
      TString name_str =  key->GetMotherDir()->GetMotherDir()->GetMotherDir()->GetMotherDir()->GetName();
      //      if(name_str.Contains(reg_dir)){
      //      if(name_str.Contains("Histogramming-L2-")){
      if(name_str.Contains("Histogramming-EF-")){
	TH1 *h = (TH1*)key->ReadObj();
	TString name_histo =  key->GetMotherDir()->GetMotherDir()->GetMotherDir()->GetName();
	std::cout << "name Pu=" << name_histo << std::endl;
	if(do_sum){
	  time_histo[0]->Fill(name_histo,GetLastBin(h,1));
	  time_histo[1]->Fill(name_histo,GetLastBin(h,2));
	  time_histo[2]->Fill(name_histo,GetLastBin(h,3));
	  time_histo[3]->Fill(name_histo,GetLastBin(h,4));
	  time_histo[4]->Fill(name_histo,GetFirstBin(h,1));
	  time_histo[5]->Fill(name_histo,GetFirstBin(h,4));
	  
	  if(first_histo){
	    global_sum = (TH1*)h;
	    first_histo = false;
	  } else {
	    global_sum->Add( h );
	  }
	} else {
	  x_label[i_lab] = name_histo;
	  ++i_lab;
	}
      }
      
      
    } else {
      if (key->IsFolder()) {
	dir->cd(key->GetName());
	TString name_str =  key->GetName();
	TDirectory *subdir = gDirectory;
	add_histo_rates(subdir,do_sum);
	dirsav->cd();
	continue;
      }
    }
  }
}   

void allCode(){
// Input = TFile::Open( "/tmp/sidoti/run_156705_2010-06-05-22-06-all_l2pus_rate.root", 
//		      "READ");
// Input = TFile::Open( "/tmp/sidoti/sum_205Hz_OK.root",   "READ");
  Input = TFile::Open( "/tmp/sidoti/run_156705_2010-06-05-22-06-all_efpus_rate.root", 
		       "READ");

  Target = TFile::Open( "result.root", "RECREATE" );
 
  
  dir_str = new TString("Histogramming-L2-.*");
  histo_str = new TString("L2PU.*");


  add_histo_rates(Input,false);
  time_histo[0] = new TH1F("time_histo_0","Date Day",3,0,3);
  time_histo[1] = new TH1F("time_histo_1","Date Hour",3,0,3);
  time_histo[2] = new TH1F("time_histo_2","Date Min",3,0,3);
  time_histo[3] = new TH1F("time_histo_3","Date Sec",3,0,3);
  time_histo[4] = new TH1F("time_histo_4","Total Input",3,0,3);
  time_histo[5] = new TH1F("time_histo_5","Total Output",3,0,3);


  add_histo_rates(Input,true);

  TCanvas *c1 = new TCanvas("c1","The HSUM example",200,10,600,400);
  c1->cd();
  global_sum->Draw("TEXT");
  global_sum->Write();
  c1->Print("pippo.root");
  
  time_histo[0]->Write();
  time_histo[1]->Write();
  time_histo[2]->Write();
  time_histo[3]->Write();
  time_histo[4]->Write();
  time_histo[5]->Write();
  





}
