/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package triggerdb.Entities.HLT;

import com.mockrunner.jdbc.BasicJDBCTestCaseAdapter;
import com.mockrunner.jdbc.PreparedStatementResultSetHandler;
import com.mockrunner.mock.jdbc.MockConnection;
import java.sql.SQLException;
import java.util.ArrayList;
import org.junit.After;
import org.junit.Before;
import org.junit.Test;
import static org.junit.Assert.*;
import triggerdb.Connections.ConnectionManager;
import triggerdb.Connections.InitInfo;
import triggerdb.Entities.FakeAbstractTable;
import static triggerdb.Entities.HLT.HLTPrescaleType.*;
import com.mockrunner.jdbc.BasicJDBCTestCaseAdapter;
import com.mockrunner.jdbc.*;
import com.mockrunner.mock.jdbc.*;
import java.util.logging.Logger;
import javax.swing.tree.DefaultMutableTreeNode;
import triggerdb.Connections.ConnectionManager;
import triggerdb.Connections.InitInfo;
import triggerdb.Entities.AbstractTable;
import triggerdb.Entities.FakeAbstractTable;

/**
 *
 * @author dwthomas
 */
public class HLTSetupTest extends BasicJDBCTestCaseAdapter {
    private FakeAbstractTable table;
    private PreparedStatementResultSetHandler resultSetHandler;
    
    public HLTSetupTest() {
    }
    
    @Override
    @Before
    public void setUp() throws Exception {
        super.setUp();
        table = new FakeAbstractTable();
        
        // Mock DB setup
        MockConnection connection = getJDBCMockObjectFactory().getMockConnection();
        ConnectionManager.getInstance().setTestingConnection(connection);        
        resultSetHandler = connection.getPreparedStatementResultSetHandler();
    }
    
    @Override
    @After
    public void tearDown() throws Exception {
        super.tearDown();
        ConnectionManager.getInstance().unsetTestingConnection();
        }

    void setEmptyInitInfo() {
        ConnectionManager.getInstance().setInitInfo(new InitInfo());
        }

    @Test
    public void testForceLoad() throws Exception {
    }

    @Test
    public void testAddToTree() throws Exception {
    }

    @Test
    public void testClone() {
        HLTSetup instance = new HLTSetup();
        Object expResult = instance;
        Object result = instance.clone();
        assertEquals(expResult, result);
    }

    @Test
    public void testDoDiff() throws Exception {
    }

    @Test
    public void testSave() throws Exception {
         System.out.println("save");
         HLTSetup instance = new HLTSetup();
         MockResultSet resultset = resultSetHandler.createResultSet();
         setEmptyInitInfo();
         Integer expResult = 1;
         Object Result = instance.save();
         assertEquals (Result, expResult);
    }

    @Test
    public void testCompactsave() throws Exception {
         System.out.println("compactsave");
         HLTSetup instance = new HLTSetup();
         MockResultSet resultset = resultSetHandler.createResultSet();
         setEmptyInitInfo();
         Integer expResult = 1;
         Object Result = instance.compactsave();
         assertEquals (Result, expResult);
    }

    @Test
    public void testToString() {
        HLTSetup instance = new HLTSetup();
        String expResult = "HLT I-Setup";
        String result = instance.toString();
        assertEquals(expResult, result);
        
        HLTSetup instance2 = getHLTSetupWithID(-99);
        String expResult2 = "HLT I-SETUP: ID=-99, Name=, Version=1";
        String result2 = instance2.toString();
        assertEquals(expResult2, result2);
    }

    
    
       public HLTSetup getHLTSetupWithID(int id) {
        HLTSetup result = null;
        try {
            result = new HLTSetup(id);
        } catch (SQLException e) {
            fail(e.toString());
        }
        return result;
    }
       
       
    @Test
    public void testGetInfraStructureComponents() throws Exception {
         System.out.println("getInfraStructureComponents");
         HLTSetup instance = new HLTSetup();
         MockResultSet resultset = resultSetHandler.createResultSet();
         setEmptyInitInfo();
         instance.set_id(27);
         ArrayList<HLTComponent> expResult = new ArrayList<>();
         Object Result = instance.getInfraStructureComponents();
         assertEquals (Result, expResult);
    }

    @Test
    public void testGet_min_names() {
        System.out.println("get_min_names");
        HLTSetup instance = getHLTSetupWithID(-1992);
        
        ArrayList<String> expResult = new ArrayList<>();
        expResult.add("ID");
        expResult.add("Name");
        expResult.add("Version");
        expResult.add("Linked Menus");
        
        ArrayList<String> result = instance.get_min_names();
        assertEquals(expResult, result);
    }

    @Test
    public void testGet_min_info() {
        System.out.println("get_min_info");
        HLTSetup instance = getHLTSetupWithID(-1992);
        instance.set_version(92);
        
        ArrayList<Object> expResult = new ArrayList<>();
       
        expResult.add(-1992);
        expResult.add("");
        expResult.add(92);
        expResult.add("");        
        
        ArrayList<Object> result = instance.get_min_info();
        assertEquals(expResult, result);
    }

    @Test
    public void testGetTableName() {
        System.out.println("getTableName");
        HLTSetup instance = new HLTSetup();
        String expResult = "HLT_SETUP";
        String result = instance.getTableName();
        assertEquals(expResult, result);
    }
    
}