# TriggerCommander

Package: [TriggerCommander](https://gitlab.cern.ch/atlas-tdaq-software/TriggerCommander)

**Clients**

A backward compatible change (for clients) has been introduced in the 
`TriggerCommander/MasterTrigger.h` interface. The `hold()` method
has been extended with a boolean flag `extended_lvl1id` which defaults
to `false`.

The method will return the last ECR as it did in the past. When the 
new flag is set to `true` it will instead return the full Level 1 ID
(from which the ECR can be extracted as the uppermost 8 bits).


**Implementations of the MasterTrigger interface**

An implementation of the `MasterTrigger` interface has to modify 
its overloaded method:

```c++
class X : public MasterTrigger {
  ...

  uint32_t hold(const std::string& dm, bool extended_lvl1id = false) override;
  ...
};
```
