package triggerpanel;

import Igui.IguiLogger;
import java.sql.SQLException;
import java.util.ArrayList;
import static triggerpanel.ExpertPanelImpl.NoAliasAvailable;

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
/**
 *
 * @author William
 */
public class AliasSelectionDialog extends javax.swing.JDialog {

    PrescaleSetAliasHandle aliasHandle = null;
    int smk = 0;
    String runMode = "";
    KeyDescriptor newl1 = null;
    KeyDescriptor newhlt = null;
    String newAlias = null;
    Boolean cancelled = false;
    Boolean fillingAliasComboBox = true;

    /**
     * Creates new form AliasSelectionDialog
     *
     * @param parent
     * @param modal
     * @param mode
     * @param smkey
     * @param currentAlias
     * @param currentL1PSK
     * @param currentHLTPSK
     * @throws java.sql.SQLException
     */
    public AliasSelectionDialog(java.awt.Frame parent, boolean modal, String mode, final int smkey, final String currentAlias, final String currentL1PSK, final String currentHLTPSK) throws SQLException {
        super(parent, modal);
        initComponents();
        smk = smkey;
        runMode = mode;
        MainLabel.setText("Select Alias for " + runMode);
        currentAliasNameLabel.setText(currentAlias);
        currentL1ValueLabel.setText(currentL1PSK);
        currentHLTValueLabel.setText(currentHLTPSK);
        SelectButton.setEnabled(false);
        matchWarningLabel.setForeground(TPGlobal.uncommittedclr);
        matchWarningLabel.setVisible(false);
        if (runMode.equals("PHYSICS")) {
            newPrescalesLabel.setVisible(false);
            newHLTLabel.setVisible(false);
            newHLTValueLabel.setVisible(false);
            newL1Label.setVisible(false);
            newL1ValueLabel.setVisible(false);
            overrideWarningLabel.setVisible(true);
            SelectButton.setText("Select");
        } else {
            SelectButton.setText("Apply");
            overrideWarningLabel.setVisible(false);
        }
        if (initPanel()) {
        }
    }

    private boolean initPanel() throws SQLException {
        TPGlobal.getDbKeysLoader().SetSMK(smk);
        aliasHandle = TPGlobal.getDbKeysLoader().GetAliases();
        if (aliasHandle == null) {
            IguiLogger.error("Aliases don't exist");
            return true;
        }
        IguiLogger.info("Will update the " + runMode + " comboboxes for SMK " + smk);
        AliasComboBox.removeAllItems();
        aliasHandle.getAliasComponents().stream()
                .forEach((comp) -> {
                    if (runMode.equals("STANDBY")) {
                        if (comp.getType().equals("STANDBY") || comp.getType().equals("COSMIC") || comp.getType().equals("OTHER")) {
                            IguiLogger.info("Adding standby/cosmic/other item " + comp.getName());
                            AliasComboBox.addItem(comp.getName());
                        }
                    } else if (runMode.equals("EMITTANCE")) {
                        if (comp.getType().equals("EMITTANCE")) {
                            IguiLogger.info("Adding emittance item " + comp.getName());
                            AliasComboBox.addItem(comp.getName());
                        }
                    } else if (runMode.equals("PHYSICS")) {
                        if (comp.getType().equals("PHYSICS")) {
                            IguiLogger.info("Adding physics item " + comp.getName());
                            AliasComboBox.addItem(comp.getName());
                        }
                    } else {
                        TPL.error("INVALID RUN MODE! " + runMode);
                    }

                }
                );
        fillingAliasComboBox = false;

        AliasComboBox.setEnabled(AliasComboBox.getItemCount() > 0);
        AliasComboBox.setSelectedIndex(
                -1);
        if (AliasComboBox.getItemCount()
                == 0) {
            AliasComboBox.addItem(NoAliasAvailable);
        } else {
            IguiLogger.info("Will select alias item 0");
            AliasComboBox.setSelectedIndex(0);
        }
        boolean physicsCBHasContent
                = AliasComboBox.getItemCount() > 0
                && !AliasComboBox.getItemAt(0).equals(NoAliasAvailable);

        AliasComboBox.setEnabled(physicsCBHasContent);

        return false;
    }

    public KeyDescriptor getL1Key() {
        return newl1;
    }

    public KeyDescriptor getHLTKey() {
        return newhlt;
    }

    public String getAlias() {
        return newAlias;
    }

    public Boolean wasCancelled() {
        return cancelled;
    }

    public String getSelectedAliasName() {
        return (String) AliasComboBox.getSelectedItem();
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        AliasSelectionPanel = new javax.swing.JPanel();
        MainLabel = new javax.swing.JLabel();
        CancelButton = new javax.swing.JButton();
        SelectButton = new javax.swing.JButton();
        matchWarningLabel = new javax.swing.JLabel();
        jPanel1 = new javax.swing.JPanel();
        currentPrescalesLabel = new javax.swing.JLabel();
        currentL1Label = new javax.swing.JLabel();
        currentL1ValueLabel = new javax.swing.JLabel();
        currentHLTLabel = new javax.swing.JLabel();
        currentHLTValueLabel = new javax.swing.JLabel();
        currentAliasLabel = new javax.swing.JLabel();
        currentAliasNameLabel = new javax.swing.JLabel();
        jPanel2 = new javax.swing.JPanel();
        AliasComboBox = new javax.swing.JComboBox<>();
        currentAliasLabel1 = new javax.swing.JLabel();
        newPrescalesLabel = new javax.swing.JLabel();
        newL1Label = new javax.swing.JLabel();
        newL1ValueLabel = new javax.swing.JLabel();
        newHLTLabel = new javax.swing.JLabel();
        newHLTValueLabel = new javax.swing.JLabel();
        overrideWarningLabel = new javax.swing.JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);

        MainLabel.setFont(new java.awt.Font("Tahoma", 1, 18)); // NOI18N
        MainLabel.setText("Select Alias for MODE");

        CancelButton.setText("Cancel");
        CancelButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                CancelButtonActionPerformed(evt);
            }
        });

        SelectButton.setText("Select");
        SelectButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                SelectButtonActionPerformed(evt);
            }
        });

        matchWarningLabel.setFont(new java.awt.Font("Tahoma", 2, 13)); // NOI18N
        matchWarningLabel.setText("Selected Alias Matches Current One!");

        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder(""));

        currentPrescalesLabel.setFont(new java.awt.Font("Tahoma", 1, 13)); // NOI18N
        currentPrescalesLabel.setText("Current Prescales:");

        currentL1Label.setText("L1");

        currentL1ValueLabel.setText("PSK");

        currentHLTLabel.setText("HLT");

        currentHLTValueLabel.setText("PSK");

        currentAliasLabel.setFont(new java.awt.Font("Tahoma", 1, 13)); // NOI18N
        currentAliasLabel.setText("Current Alias: ");

        currentAliasNameLabel.setText("jLabel3");

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addComponent(currentAliasLabel)
                        .addGap(11, 11, 11)
                        .addComponent(currentAliasNameLabel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addComponent(currentL1Label)
                        .addGap(18, 18, 18)
                        .addComponent(currentL1ValueLabel)
                        .addGap(70, 70, 70)
                        .addComponent(currentHLTLabel)
                        .addGap(18, 18, 18)
                        .addComponent(currentHLTValueLabel))
                    .addComponent(currentPrescalesLabel))
                .addContainerGap())
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(currentAliasLabel)
                    .addComponent(currentAliasNameLabel))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 14, Short.MAX_VALUE)
                .addComponent(currentPrescalesLabel)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(currentL1Label)
                    .addComponent(currentL1ValueLabel)
                    .addComponent(currentHLTLabel)
                    .addComponent(currentHLTValueLabel))
                .addGap(26, 26, 26))
        );

        jPanel2.setBorder(javax.swing.BorderFactory.createTitledBorder(""));

        AliasComboBox.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));
        AliasComboBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                AliasComboBoxActionPerformed(evt);
            }
        });

        currentAliasLabel1.setFont(new java.awt.Font("Tahoma", 1, 13)); // NOI18N
        currentAliasLabel1.setText("New Alias: ");
        currentAliasLabel1.setMaximumSize(new java.awt.Dimension(94, 16));
        currentAliasLabel1.setMinimumSize(new java.awt.Dimension(94, 16));
        currentAliasLabel1.setName(""); // NOI18N
        currentAliasLabel1.setPreferredSize(new java.awt.Dimension(94, 16));

        newPrescalesLabel.setFont(new java.awt.Font("Tahoma", 1, 13)); // NOI18N
        newPrescalesLabel.setText("New Prescales:");

        newL1Label.setText("L1");

        newL1ValueLabel.setText("PSK");

        newHLTLabel.setText("HLT");

        newHLTValueLabel.setText("PSK");

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel2Layout.createSequentialGroup()
                        .addComponent(currentAliasLabel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(11, 11, 11)
                        .addComponent(AliasComboBox, 0, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                    .addGroup(jPanel2Layout.createSequentialGroup()
                        .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(newPrescalesLabel)
                            .addGroup(jPanel2Layout.createSequentialGroup()
                                .addComponent(newL1Label)
                                .addGap(18, 18, 18)
                                .addComponent(newL1ValueLabel)
                                .addGap(70, 70, 70)
                                .addComponent(newHLTLabel)
                                .addGap(18, 18, 18)
                                .addComponent(newHLTValueLabel)))
                        .addGap(0, 513, Short.MAX_VALUE)))
                .addContainerGap())
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(AliasComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(currentAliasLabel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(newPrescalesLabel)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(newL1Label)
                    .addComponent(newL1ValueLabel)
                    .addComponent(newHLTLabel)
                    .addComponent(newHLTValueLabel))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        overrideWarningLabel.setFont(new java.awt.Font("Tahoma", 2, 13)); // NOI18N
        overrideWarningLabel.setText("WARNING: changing physics alias will remove override!");

        javax.swing.GroupLayout AliasSelectionPanelLayout = new javax.swing.GroupLayout(AliasSelectionPanel);
        AliasSelectionPanel.setLayout(AliasSelectionPanelLayout);
        AliasSelectionPanelLayout.setHorizontalGroup(
            AliasSelectionPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(AliasSelectionPanelLayout.createSequentialGroup()
                .addGroup(AliasSelectionPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(AliasSelectionPanelLayout.createSequentialGroup()
                        .addGap(27, 27, 27)
                        .addComponent(MainLabel, javax.swing.GroupLayout.PREFERRED_SIZE, 454, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(AliasSelectionPanelLayout.createSequentialGroup()
                        .addGap(67, 67, 67)
                        .addGroup(AliasSelectionPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(AliasSelectionPanelLayout.createSequentialGroup()
                                .addComponent(overrideWarningLabel)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 324, Short.MAX_VALUE)
                                .addComponent(CancelButton)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                .addComponent(SelectButton))
                            .addGroup(AliasSelectionPanelLayout.createSequentialGroup()
                                .addGroup(AliasSelectionPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                                    .addComponent(matchWarningLabel)
                                    .addComponent(jPanel2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                    .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                                .addGap(0, 0, Short.MAX_VALUE)))))
                .addContainerGap())
        );
        AliasSelectionPanelLayout.setVerticalGroup(
            AliasSelectionPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(AliasSelectionPanelLayout.createSequentialGroup()
                .addGap(25, 25, 25)
                .addComponent(MainLabel, javax.swing.GroupLayout.PREFERRED_SIZE, 25, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(26, 26, 26)
                .addComponent(matchWarningLabel)
                .addGroup(AliasSelectionPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(AliasSelectionPanelLayout.createSequentialGroup()
                        .addGap(9, 9, 9)
                        .addGroup(AliasSelectionPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(CancelButton)
                            .addComponent(SelectButton)))
                    .addGroup(AliasSelectionPanelLayout.createSequentialGroup()
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(overrideWarningLabel)))
                .addContainerGap())
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(AliasSelectionPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(AliasSelectionPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void AliasComboBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_AliasComboBoxActionPerformed

        if (fillingAliasComboBox) {
            return;
        }
        ArrayList<String> types = new ArrayList<>();
        switch (runMode) {
            case "STANDBY":
                types.add("STANDBY");
                types.add("COSMIC");
                types.add("OTHER");
                break;
            case "EMITTANCE":
                types.add("EMITTANCE");
                break;
            case "PHYSICS":
                types.add("PHYSICS");
                break;
            default:
                break;
        }

        PrescaleSetAliasHandle.AliasComponent selectedComp = null;
        for (String type : types) {
            PrescaleSetAliasHandle.AliasComponent comp;
            try {
                comp = TPGlobal.getDbKeysLoader().GetAliases().getAliasComponent(type, (String) AliasComboBox.getSelectedItem());
                if (comp != null) {
                    selectedComp = comp;
                }
            } catch (SQLException ex) {
                TPL.error("SQL exception extracting alias list: " + ex.getMessage(), true);
            }

        }
        if (selectedComp != null) {
            if (selectedComp.getName().equals(currentAliasNameLabel.getText())) {
                matchWarningLabel.setVisible(true);
                SelectButton.setEnabled(false);
            } else {
                matchWarningLabel.setVisible(false);
                SelectButton.setEnabled(true);
            }
            if (!runMode.equals("PHYSICS")) {
                newL1ValueLabel.setText(Integer.toString(selectedComp.getLumis().get(0).l1psk));
                newHLTValueLabel.setText(Integer.toString(selectedComp.getLumis().get(0).hltpsk));
            }
        } else {
            TPL.warning("Could not find any aliases for type: " + types, true);
        }
    }//GEN-LAST:event_AliasComboBoxActionPerformed

    private void CancelButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_CancelButtonActionPerformed
        cancelled = true;
        dispose();
    }//GEN-LAST:event_CancelButtonActionPerformed

    private void SelectButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_SelectButtonActionPerformed
        if (!runMode.equals("PHYSICS")) {
            newl1 = new KeyDescriptor(Integer.parseInt(newL1ValueLabel.getText()), "0", 0, "0", false);
            newhlt = new KeyDescriptor(Integer.parseInt(newHLTValueLabel.getText()), "0", 0, "0", false);
        }
        newAlias = (String) AliasComboBox.getSelectedItem();
        dispose();
    }//GEN-LAST:event_SelectButtonActionPerformed


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JComboBox<String> AliasComboBox;
    private javax.swing.JPanel AliasSelectionPanel;
    private javax.swing.JButton CancelButton;
    private javax.swing.JLabel MainLabel;
    private javax.swing.JButton SelectButton;
    private javax.swing.JLabel currentAliasLabel;
    private javax.swing.JLabel currentAliasLabel1;
    private javax.swing.JLabel currentAliasNameLabel;
    private javax.swing.JLabel currentHLTLabel;
    private javax.swing.JLabel currentHLTValueLabel;
    private javax.swing.JLabel currentL1Label;
    private javax.swing.JLabel currentL1ValueLabel;
    private javax.swing.JLabel currentPrescalesLabel;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JLabel matchWarningLabel;
    private javax.swing.JLabel newHLTLabel;
    private javax.swing.JLabel newHLTValueLabel;
    private javax.swing.JLabel newL1Label;
    private javax.swing.JLabel newL1ValueLabel;
    private javax.swing.JLabel newPrescalesLabel;
    private javax.swing.JLabel overrideWarningLabel;
    // End of variables declaration//GEN-END:variables
}
