/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package triggerpanel;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;



public class BGSelectionDialogImpl extends BGSelectionDialog {

    private int currentBGSK = 0;
    private KeyDescriptor selectedBGSK = null;
    private boolean cancelled = false;

    public boolean isCancelled() {
        return cancelled;
    }

    public KeyDescriptor getSelectedBGSK() {
        return selectedBGSK;
    }

    public BGSelectionDialogImpl(boolean modal, final int currentBGSK) {
        super(null, modal);
        this.currentBGSK = currentBGSK;
        curBGSLabel.setText(Integer.toString(this.currentBGSK));
        (new BGSKLoader()).execute();
        
        selectButton.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                dispose();
            }
        });

        cancelButton.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                cancelled = true;
                dispose();
            }
        });
    
        comboL1BunchGroupKey.addItemListener(new java.awt.event.ItemListener() {
            @Override
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                if(evt.getStateChange()==ItemEvent.SELECTED) {
                    selectedBGSK = (KeyDescriptor) evt.getItem();
                    setButtonStatus();
                }
            }
        });
        
        selectedBGSK = (KeyDescriptor) comboL1BunchGroupKey.getSelectedItem();
    
    }
   
    private class BGSKLoader extends javax.swing.SwingWorker<Void, Void> {

        @Override
        public Void doInBackground() {
            TPGlobal.getDbKeysLoader().UpdateBunchgroups();
            return null;
        }

        @Override
        public void done() {
            fillDropDownBox();
            setVisible(true);
        }
    }
    
    private void setButtonStatus() {
        if( selectedBGSK.key != currentBGSK ) {
            selectButton.setEnabled(true);
            cancelButton.setEnabled(true);
        } else {
            selectButton.setEnabled(false);
            cancelButton.setEnabled(true);
        }

    }
    
    private void fillDropDownBox() {
        for(KeyDescriptor kd : TPGlobal.getDbKeysLoader().GetBunchgroups()) {
            comboL1BunchGroupKey.addItem(kd);
            if(kd.key == this.currentBGSK) { // set the current one as selected
                comboL1BunchGroupKey.setSelectedItem(kd);
            }
        }
    }
    
}
