package triggerpanel;

import Igui.IguiConstants;
import Igui.IguiConstants.AccessControlStatus;
import Igui.IguiLogger;
import Igui.RunControlFSM.State;
import triggerpanel.TP.LBMODE;

final class GUIState {

    private GUIState() {}
    
    static State               currentState = State.ABSENT;
    static AccessControlStatus currentAccess = AccessControlStatus.DISPLAY;

    // public boolean     isReadyForPhysics = false;
    static TP.RS          readyState = TP.RS.STANDBY;
    static Boolean        emittanceState = false;
    
    static private LBMODE lbmode = LBMODE.TIME;
    static int            lbinterval = 0;

    // prescale keys for standby and physics
    static int            standbyl1psk = 0;
    static int            standbyhltpsk = 0;
    static int            physicsl1psk = 0;
    static int            physicshltpsk = 0;
    static int            emittancel1psk = 0;
    static int            emittancehltpsk = 0;

    // run and LB number
    static int            runNumber = 0;
    static int            lbNumber = 0;

    static void setLbMode(final LBMODE mode) { 
        IguiLogger.info( "Setting LB mode to " + mode );
        lbmode = mode;
    }
    
    static boolean lbmodeIsTime() { return lbmode == LBMODE.TIME; }

    static TP.RS ReadyState() { return readyState; }

    static boolean isControl() {
        return currentAccess==IguiConstants.AccessControlStatus.CONTROL;
    }

}
