package triggerpanel;

import Igui.IguiLogger;
import java.awt.Color;
import java.awt.Font;
import java.awt.Frame;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import javax.swing.GroupLayout;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JTextField;
import javax.swing.LayoutStyle;
import javax.swing.WindowConstants;

/**
 *
 * @author  markowen
 * @author  Joerg Stelzer 
 */
@SuppressWarnings("serial")
class LumiBlockIntervalDialogNew extends javax.swing.JDialog {

    int current_value = 120;

    /** Creates new form lumiBlockIntervalDialog
     * @param parent
     * @param modal
     * @param thepanel */
    LumiBlockIntervalDialogNew(Frame parent, TriggerPanel thepanel) {
        super((JDialog)null);
        setLocationRelativeTo(parent);

        //super(parent, modal);
        initComponents();
        triggerPanel = thepanel;

        if(triggerPanel != null) {
            current_value = GUIState.lbinterval;
        }

        timeTextField.setText(Integer.toString(current_value));
    }

    // Pointer back to the trigger panel
    private TriggerPanel triggerPanel = null;
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    private void initComponents() {
        setDefaultCloseOperation( WindowConstants.DISPOSE_ON_CLOSE );


        JLabel title = new JLabel("Select LB interval length");
        title.setFont(new Font("Serif", 1, 16));
        title.setForeground(new Color(0, 0, 153));

        JLabel timeLabel = new JLabel("Time limit");
        timeLabel.setFont(new Font("Dialog", 0, 14));


        timeTextField = new JTextField();
        timeTextField.setFont(new Font("SansSerif", 0, 12));
        timeTextField.setHorizontalAlignment(JTextField.RIGHT);
        timeTextField.addKeyListener(new KeyAdapter() {
            @Override
            public void keyReleased(KeyEvent evt) {
                timeTextFieldKeyReleased(evt);
            }
        });

        updateButton = new JButton("Apply");
        updateButton.setEnabled(false);
        updateButton.addActionListener(new java.awt.event.ActionListener() {
            @Override
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                updateButtonActionPerformed(evt);
            }
        });

        JButton cancelButton = new JButton("Cancel");
        cancelButton.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent evt) {
                cancelButtonActionPerformed(evt);
            }
        });


        JLabel secLabel = new JLabel("seconds");
        secLabel.setFont(new Font("Dialog", 0, 12));


        GroupLayout layout = new GroupLayout(getContentPane());
        getContentPane().setLayout(layout);

        layout.setHorizontalGroup(layout.createSequentialGroup()
                                  .addContainerGap()
                                  .addGroup( layout.createParallelGroup(GroupLayout.Alignment.LEADING)
                                             .addComponent(title)
                                             .addGroup( layout.createSequentialGroup()
                                                        .addContainerGap()
                                                        .addComponent(timeLabel)
                                                        .addPreferredGap(LayoutStyle.ComponentPlacement.RELATED)
                                                        .addComponent(timeTextField, GroupLayout.PREFERRED_SIZE, 50, GroupLayout.PREFERRED_SIZE)
                                                        .addGap(12)
                                                        .addComponent(secLabel)
                                                        .addContainerGap()
                                                        )
                                             .addGroup( layout.createSequentialGroup()
                                                        .addContainerGap()
                                                        .addGap(150)
                                                        .addComponent(updateButton)
                                                        .addPreferredGap(LayoutStyle.ComponentPlacement.RELATED)
                                                        .addComponent(cancelButton)
                                                        .addContainerGap()
                                                        )
                                             )
                                  .addContainerGap()
                                  );
        layout.setVerticalGroup(layout.createSequentialGroup()
                                .addContainerGap()
                                .addComponent(title)
                                .addGap(18)
                                .addGroup( layout.createParallelGroup(GroupLayout.Alignment.BASELINE)
                                           .addComponent(timeLabel)
                                           .addComponent(timeTextField)
                                           .addComponent(secLabel)
                                           )
                                .addGap(24)
                                .addGroup( layout.createParallelGroup(GroupLayout.Alignment.BASELINE)
                                           .addComponent(updateButton)
                                           .addComponent(cancelButton)
                                           )
                                .addContainerGap()
                                );

        secLabel.getAccessibleContext().setAccessibleName("secLabel");

        pack();
    }




    // Send the update to the run control
    private void updateButtonActionPerformed(ActionEvent evt) {
        //read the time units
        try {
            Integer time = Integer.parseInt(timeTextField.getText());
            triggerPanel.changeLumiBlockInterval(true,time);
        }
        catch (NumberFormatException ex) {
            IguiLogger.warning("Invalid number in the time field");
            return; //allow the string to be re-entered
        }
        dispose();
    }

    private void cancelButtonActionPerformed(java.awt.event.ActionEvent evt) {
        dispose();
    }

    private void timeTextFieldKeyReleased(java.awt.event.KeyEvent evt) {
        try {
            int value = Integer.parseInt(timeTextField.getText());
            boolean unchanged = (current_value==value);
            updateButton.setEnabled(!unchanged);
        } catch (NumberFormatException ex) {
            updateButton.setEnabled(false);
        }
    }


    private JButton updateButton;
    private JTextField timeTextField;

}
