
/*
 * PSSelectionDialog.java
 *
 * @author Mark Owen
 * Created on Nov 18, 2009, 2:29:01 PM
 */

package triggerpanel;

import java.awt.event.WindowEvent;
import javax.swing.JDialog;
import javax.swing.JFrame;


/**
 *
 * @author markowen
 */
@SuppressWarnings("serial")
class PSSelectionDialog extends JDialog {


    /** Creates new form PSSelectionDialog */
    public PSSelectionDialog(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        title = new javax.swing.JLabel();
        selPanel = new javax.swing.JPanel();
        standbyPanel = new javax.swing.JPanel();
        StandbyHLTLbl = new javax.swing.JLabel();
        StandbyL1CB = new javax.swing.JComboBox<KeyDescriptor>();
        StandbyHLTCB = new javax.swing.JComboBox<KeyDescriptor>();
        StandbyL1Lbl = new javax.swing.JLabel();
        curL1Label = new javax.swing.JLabel();
        curHLTLabel = new javax.swing.JLabel();
        buttonPanel = new javax.swing.JPanel();
        selectButton = new javax.swing.JButton();
        cancelButton = new javax.swing.JButton();
        showHidden = new javax.swing.JCheckBox();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Prescale Selection");
        setAlwaysOnTop(true);

        title.setFont(new java.awt.Font("Serif", 1, 16)); // NOI18N
        title.setForeground(new java.awt.Color(0, 0, 153));
        title.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        title.setText("Select MODE prescale keys"); // NOI18N
        title.setVerticalAlignment(javax.swing.SwingConstants.BOTTOM);
        title.setAlignmentX(0.5F);

        StandbyHLTLbl.setFont(new java.awt.Font("Dialog", 0, 14)); // NOI18N
        StandbyHLTLbl.setText("HLT Psk:"); // NOI18N

        StandbyL1CB.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                StandbyL1CBItemStateChanged(evt);
            }
        });

        StandbyHLTCB.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                StandbyHLTCBItemStateChanged(evt);
            }
        });

        StandbyL1Lbl.setFont(new java.awt.Font("Dialog", 0, 14)); // NOI18N
        StandbyL1Lbl.setText("L1 Psk:"); // NOI18N

        curL1Label.setFont(new java.awt.Font("Dialog", 1, 14)); // NOI18N
        curL1Label.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        curL1Label.setText("0"); // NOI18N

        curHLTLabel.setFont(new java.awt.Font("Dialog", 1, 14)); // NOI18N
        curHLTLabel.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        curHLTLabel.setText("0"); // NOI18N

        selectButton.setText("Apply"); // NOI18N
        selectButton.setEnabled(false);
        selectButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                selectButtonActionPerformed(evt);
            }
        });

        cancelButton.setMnemonic('c');
        cancelButton.setText("Cancel"); // NOI18N
        cancelButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cancelButtonActionPerformed(evt);
            }
        });

        showHidden.setMnemonic('h');
        showHidden.setText("show hidden");
        showHidden.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                showHiddenActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout buttonPanelLayout = new javax.swing.GroupLayout(buttonPanel);
        buttonPanel.setLayout(buttonPanelLayout);
        buttonPanelLayout.setHorizontalGroup(
            buttonPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, buttonPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(showHidden)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 326, Short.MAX_VALUE)
                .addComponent(cancelButton, javax.swing.GroupLayout.PREFERRED_SIZE, 81, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(selectButton, javax.swing.GroupLayout.PREFERRED_SIZE, 79, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );
        buttonPanelLayout.setVerticalGroup(
            buttonPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, buttonPanelLayout.createSequentialGroup()
                .addContainerGap(16, Short.MAX_VALUE)
                .addGroup(buttonPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(showHidden)
                    .addComponent(cancelButton)
                    .addComponent(selectButton))
                .addContainerGap())
        );

        javax.swing.GroupLayout standbyPanelLayout = new javax.swing.GroupLayout(standbyPanel);
        standbyPanel.setLayout(standbyPanelLayout);
        standbyPanelLayout.setHorizontalGroup(
            standbyPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(standbyPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(standbyPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(StandbyL1Lbl, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(StandbyHLTLbl, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addGap(18, 18, 18)
                .addGroup(standbyPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(curHLTLabel, javax.swing.GroupLayout.DEFAULT_SIZE, 41, Short.MAX_VALUE)
                    .addComponent(curL1Label, javax.swing.GroupLayout.DEFAULT_SIZE, 41, Short.MAX_VALUE))
                .addGap(9, 9, 9)
                .addGroup(standbyPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(StandbyL1CB, 0, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(StandbyHLTCB, 0, 461, Short.MAX_VALUE))
                .addGap(28, 28, 28))
            .addComponent(buttonPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );

        standbyPanelLayout.linkSize(javax.swing.SwingConstants.HORIZONTAL, new java.awt.Component[] {curHLTLabel, curL1Label});

        standbyPanelLayout.setVerticalGroup(
            standbyPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(standbyPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(standbyPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(StandbyL1Lbl)
                    .addComponent(curL1Label)
                    .addComponent(StandbyL1CB, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(23, 23, 23)
                .addGroup(standbyPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(StandbyHLTLbl)
                    .addComponent(curHLTLabel)
                    .addComponent(StandbyHLTCB, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(buttonPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );

        standbyPanelLayout.linkSize(javax.swing.SwingConstants.VERTICAL, new java.awt.Component[] {curHLTLabel, curL1Label});

        javax.swing.GroupLayout selPanelLayout = new javax.swing.GroupLayout(selPanel);
        selPanel.setLayout(selPanelLayout);
        selPanelLayout.setHorizontalGroup(
            selPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(selPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(standbyPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        selPanelLayout.setVerticalGroup(
            selPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(selPanelLayout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(standbyPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(selPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(title, javax.swing.GroupLayout.PREFERRED_SIZE, 451, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addComponent(title, javax.swing.GroupLayout.PREFERRED_SIZE, 46, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(selPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        pack();
        setLocationRelativeTo(null);
    }// </editor-fold>//GEN-END:initComponents

    private void selectButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_selectButtonActionPerformed
        selectButtonActionPerformedImpl(evt);
}//GEN-LAST:event_selectButtonActionPerformed
    void selectButtonActionPerformedImpl(java.awt.event.ActionEvent evt){
        dispose();
    }
        
    private void cancelButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cancelButtonActionPerformed
        cancelButtonActionPerformedImpl(evt);
    }//GEN-LAST:event_cancelButtonActionPerformed
    void cancelButtonActionPerformedImpl(java.awt.event.ActionEvent evt){
        dispose();
    }
    
    private void StandbyL1CBItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_StandbyL1CBItemStateChanged
        StandbyL1CBItemStateChangedImpl(evt);
    }//GEN-LAST:event_StandbyL1CBItemStateChanged
    void StandbyL1CBItemStateChangedImpl(java.awt.event.ItemEvent evt) {}

    private void StandbyHLTCBItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_StandbyHLTCBItemStateChanged
        StandbyHLTCBItemStateChangedImpl(evt);
    }//GEN-LAST:event_StandbyHLTCBItemStateChanged
    void StandbyHLTCBItemStateChangedImpl(java.awt.event.ItemEvent evt){}
    
private void showHiddenActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_showHiddenActionPerformed
        showHiddenActionPerformedImpl(evt);
}//GEN-LAST:event_showHiddenActionPerformed
    void showHiddenActionPerformedImpl(java.awt.event.ActionEvent evt){};



    // Variables declaration - do not modify//GEN-BEGIN:variables
    protected javax.swing.JComboBox<KeyDescriptor> StandbyHLTCB;
    protected javax.swing.JLabel StandbyHLTLbl;
    protected javax.swing.JComboBox<KeyDescriptor> StandbyL1CB;
    protected javax.swing.JLabel StandbyL1Lbl;
    private javax.swing.JPanel buttonPanel;
    protected javax.swing.JButton cancelButton;
    protected javax.swing.JLabel curHLTLabel;
    protected javax.swing.JLabel curL1Label;
    private javax.swing.JPanel selPanel;
    protected javax.swing.JButton selectButton;
    protected javax.swing.JCheckBox showHidden;
    private javax.swing.JPanel standbyPanel;
    protected javax.swing.JLabel title;
    // End of variables declaration//GEN-END:variables
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException | InstantiationException | IllegalAccessException | javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(SMKSelectionDialog.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>
        
        //</editor-fold>

        /* Create and display the dialog */
        java.awt.EventQueue.invokeLater(new Runnable() {
            @Override
            public void run() {
                PSSelectionDialog dialog;
                dialog = new PSSelectionDialog(new JFrame(), false);
                dialog.addWindowListener(new java.awt.event.WindowAdapter() {
                    @Override
                    public void windowClosed(WindowEvent e) {
                        System.exit(0);
                    }
                    
                });
                dialog.StandbyL1CB.addItem(new KeyDescriptor(0,"1  Hello this is a very long super master key that should not fit, I will repeat, it is very very long",0,"",false));
                dialog.pack();
                dialog.setVisible(true);
            }
        });
    }

}
