/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package triggerpanel;

import Igui.IguiLogger;
import java.util.concurrent.ExecutionException;
import javax.swing.SwingUtilities;

@SuppressWarnings("serial")
class SMKSelectionDialogImpl extends SMKSelectionDialog {

    //private TriggerPanel triggerPanel = null;
    private int currentSMK = 0;
    private int selectedSMK = 0;
    private boolean canceled;

    public int getSelectedSMK() {
        return selectedSMK;
    }

    public boolean isCancelled() {
        return canceled;
    }

    SMKSelectionDialogImpl(boolean modal, final int currentSMK) {
        super(null, modal);
        setTitle("Menu Selection");
        this.currentSMK = currentSMK;
        (new SMKSelectionDialogImpl.smLoader()).execute();
        SMK.setText(Integer.toString(this.currentSMK));
    }
    /**
     * Small utility class to load super masters from db on a worker thread.
     * Once loaded
     */
    private class smLoader extends javax.swing.SwingWorker<Void, Void> {

        @Override
            public Void doInBackground() {
            TPGlobal.getDbKeysLoader().UpdateMenus();
            return null;
        }

        @Override
            public void done() {
            try{
                this.get();
            } catch(InterruptedException | ExecutionException ex) {
                IguiLogger.warning("Problem in smLoader: " + ex.getMessage());
                ex.printStackTrace();
            }
            fillDropDownBox();
            setVisible(true);
        }

    }

    private void fillDropDownBox() {
        SMKdropdown.removeAllItems();
        for(KeyDescriptor kd : TPGlobal.getDbKeysLoader().GetMenus()) {
            if(!showHidden.isSelected() && kd.hidden) {
                continue;
            }
            //String el = kd.key + ":  " + kd.name + "  v." + kd.version;
            SMKdropdown.addItem(kd);
            if(kd.key==currentSMK) {
                SMKdropdown.setSelectedItem(kd);
            }
        }
    }

    @Override
    final void showHiddenActionPerformedImpl(java.awt.event.ActionEvent evt) {
        SwingUtilities.invokeLater( new Runnable() {
            @Override
            public void run() {
                fillDropDownBox();
            }
        });
    }
    
    @Override
    final void okButtonActionPerformedImpl(java.awt.event.ActionEvent evt) {
//        if(okButton.getText().equals("Apply")) {
//            IguiLogger.info("Applying SMK selected from dropdown: " + selectedSMK + ", was " + triggerPanel.getCurrentSMK());
//            triggerPanel.applyNewSMK(selectedSMK);
//        }
        
        IguiLogger.info("Applying SMK selected from dropdown: " + selectedSMK + ", was " + currentSMK);
        canceled = ! okButton.getText().equals("Apply");
        dispose();
    }

    @Override
    final void cancelButtonActionPerformedImpl(java.awt.event.ActionEvent evt){
        selectedSMK = currentSMK;
        canceled = true;
        dispose();
    }

    @Override
    final void SMKdropdownActionPerformedImpl(java.awt.event.ActionEvent evt) {                                            
        SwingUtilities.invokeLater( new Runnable() {
            @Override
            public void run() {
                /*try {
                  selectedSMK = Integer.parseInt(SMKdropdown.getSelectedItem().toString().split(":")[0]);
                  } catch(NumberFormatException ex) {
                  IguiLogger.warning("Invalid selection for super master key from the drop down box." + ex.getMessage());
                  }*/
                selectedSMK = ((KeyDescriptor)SMKdropdown.getSelectedItem()).key;
                boolean keyChanged = (selectedSMK != currentSMK);
                okButton.setText(keyChanged?"Apply":"Close");
                cancelButton.setEnabled(keyChanged);
            }
        });
    }                                           
    
    
}
