package triggerpanel;

import java.util.Objects;

class TP {

    static final class LVL {
        
        static LVL L1   = new LVL("L1");
        static LVL HLT  = new LVL("HLT");
        static LVL MENU = new LVL("Menu"); // not really a level

        final String name;

        private LVL(final String name) { this.name = name; }

        @Override
        public String toString() { return name; }

        @Override
        public int hashCode() {
            int hash = 5;
            hash = 79 * hash + Objects.hashCode(this.name);
            return hash;
        }

        @Override
        public boolean equals(Object obj) {
            if (obj == null) {
                return false;
            }
            if (getClass() != obj.getClass()) {
                return false;
            }
            final LVL other = (LVL) obj;
            if (!Objects.equals(this.name, other.name)) {
                return false;
            }
            return true;
        }
    }

    static class RS {
        
        static RS STANDBY = new RS("STANDBY");
        static RS PHYSICS = new RS("PHYSICS");
        static RS EMITTANCE = new RS("EMITTANCE");

        final String name;

        private RS(final String name) { this.name = name; }

        @Override
        public String toString() { return name; }
        
        @Override
        public boolean equals(Object o) {
            throw new UnsupportedOperationException();
        }
    }

    static class LBMODE {
        
        static LBMODE TIME = new LBMODE("TIME");
        static LBMODE EVENTS = new LBMODE("EVENTS");

        final String name;

        private LBMODE(final String name) { this.name = name; }

        @Override
        public String toString() { return name; }

        @Override
        public boolean equals(Object o) {
            throw new UnsupportedOperationException();
        }
        
    }

    // run with
    // java -classpath ./InstallArea/share/lib/TriggerPanel.jar triggerpanel.TP
    public static void main(String[] args) {
        System.out.println(TP.LVL.L1 + " == " + TP.LVL.HLT + ": " + (TP.LVL.L1 == TP.LVL.HLT));
        System.out.println(TP.RS.STANDBY + " == " + TP.RS.PHYSICS + ": " + (TP.RS.STANDBY == TP.RS.PHYSICS));
        System.out.println(TP.RS.STANDBY + " == " + TP.RS.STANDBY + ": " + (TP.RS.STANDBY == TP.RS.STANDBY));
        System.out.println(TP.LVL.L1);
    }

}

