/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package triggerpanel;

import Igui.IguiConstants;
import Igui.IguiLogger;
import Igui.RunControlFSM;
import Igui.RunControlFSM.State;
import TRIGGER.CommandExecutionFailed;
import bunchgroupupdate.BunchGroupUploadDialog;
import static ers.Logger.error;
import is.InfoNotCompatibleException;
import is.RepositoryNotFoundException;
import java.awt.Color;
import java.awt.MouseInfo;
import java.awt.Point;
import java.awt.event.ActionEvent;
import java.sql.SQLException;
import java.util.concurrent.ExecutionException;
import javax.swing.JOptionPane;
import javax.swing.SwingUtilities;
import javax.swing.SwingWorker;
import javax.swing.border.TitledBorder;
import triggerdb.Entities.L1.L1BunchGroupSet;
import static triggerpanel.TPGlobal.OKS;


@SuppressWarnings("serial")
public class TriggerPanelGUIImpl extends TriggerPanelGUI {

    private final TriggerPanel triggerPanel;

    final private Color activemodeclr   = new Color(86, 185, 18);
    final private Color inactivemodeclr = new Color(180, 180, 180);
    final private Color uncommittedclr  = new Color(247, 21, 218);
    final private Color black           = new Color(0, 0, 0);

    // constructor
    TriggerPanelGUIImpl(TriggerPanel tp) {

        this.triggerPanel = tp;

        getStandardPanel().getChangeSMButton().addActionListener((ActionEvent evt) -> {
            SMKSelectionDialogImpl dialog = new SMKSelectionDialogImpl(true, triggerPanel.getCurrentSMK());
            dialog.setVisible(true);
            if(dialog.isCancelled()) {
                return;
            }
            int newsmk = dialog.getSelectedSMK();
            new smOksWriteWorker(newsmk).execute();
        });
        
        getStandardPanel().getStandbyChangeButton().addActionListener((ActionEvent evt) -> {
            changeButtonActionPerformed(TP.RS.STANDBY);
        });
    
        getStandardPanel().getPhysicsChangeButton().addActionListener((ActionEvent evt) -> {
            changeButtonActionPerformed(TP.RS.PHYSICS);
        });
  
          
        getStandardPanel().getEmittanceChangeButton().addActionListener((ActionEvent evt) -> {
            changeButtonActionPerformed(TP.RS.EMITTANCE);
        });
        
        getStandardPanel().getChangeBunchGroupButton().addActionListener((ActionEvent e) -> {
            BGSelectionDialogImpl dialog = new BGSelectionDialogImpl(true,triggerPanel.getCurrentBG());
            dialog.setVisible(true);
            if(dialog.isCancelled()) {
                return;
            }
            int bgsk = dialog.getSelectedBGSK().key;
            new bgWriterWorker(bgsk).execute();
        });
        
        getStandardPanel().getChangeLumiBLengthButton().addActionListener((ActionEvent e)-> {
                LumiBlockIntervalDialogNew lbdialog = new LumiBlockIntervalDialogNew(null, triggerPanel);
                lbdialog.setVisible(true);
        });

        getStandardPanel().getCreateBGSButton().addActionListener((ActionEvent e)-> {
                try {
                    createBGSButtonActionPerformed();
                } catch (SQLException ex) {
                    Utils.logException(ex);
                }
        });

        getStandardPanel().getStartNewLumiBlockButton().addActionListener((ActionEvent evt) -> {
            getStandardPanel().getStartNewLumiBlockButton().setEnabled(false);
            Thread worker = new Thread() {
                @Override
                public void run() {
                    triggerPanel.increaseLB();
                    // Report the result using invokeLater().
                    SwingUtilities.invokeLater(() -> {
                        getStandardPanel().getStartNewLumiBlockButton().setEnabled(true);
                    });
                }
            };
            worker.start();
        });
        
        getStandardPanel().getChangeDeadtimeButton().addActionListener((ActionEvent e)-> {
            changeDeadtimeButtonActionPerformed();
        });


        getNewPanel().setTriggerPanel(tp);
        
        // bind to IS changes
        TPGlobal.IS.CurrentL1Psk.bind(this::UpdateLabelCurrentL1PSK);

        TPGlobal.IS.CurrentHLTPsk.bind(this::UpdateLabelCurrentHLTPSK);

        TPGlobal.IS.CurrentBGSk.bind(this::UpdateLabelCurrentL1BGKey);
//        TPGlobal.IS.ScheduledBGSk.bind(new TPCallable() {
//            @Override
//            public void call() {
//                UpdateLabelCurrentL1BGKey();
//            }
//        });
        TPGlobal.IS.StandbyL1Psk.bind(() -> {
            try {
                triggerPanel.panel.UpdatePrescaleKeys( TP.LVL.L1, TP.RS.STANDBY );
            } catch (SQLException ex) {
                IguiLogger.error("", ex);
            }
        });
        TPGlobal.IS.PhysicsL1Psk.bind(() -> {
            try {
                triggerPanel.panel.UpdatePrescaleKeys( TP.LVL.L1, TP.RS.PHYSICS );
            } catch (SQLException ex) {
                IguiLogger.error("", ex);
            }
        });
        TPGlobal.IS.StandbyHltPsk.bind(() -> {
            try {
                triggerPanel.panel.UpdatePrescaleKeys( TP.LVL.HLT, TP.RS.STANDBY );
            } catch (SQLException ex) {
                IguiLogger.error("", ex);
            }
        });
        TPGlobal.IS.PhysicsHltPsk.bind(() -> {
            try {
                triggerPanel.panel.UpdatePrescaleKeys( TP.LVL.HLT, TP.RS.PHYSICS );
            } catch (SQLException ex) {
                IguiLogger.error("", ex);
            }
        });
        TPGlobal.IS.EmittanceL1Psk.bind(() -> {
            try {
                triggerPanel.panel.UpdatePrescaleKeys( TP.LVL.L1, TP.RS.EMITTANCE );
            } catch (SQLException ex) {
                IguiLogger.error("", ex);
            }
        });
        TPGlobal.IS.EmittanceHltPsk.bind(() -> {
            try {
                triggerPanel.panel.UpdatePrescaleKeys( TP.LVL.HLT, TP.RS.EMITTANCE );
            } catch (SQLException ex) {
                IguiLogger.error("", ex);
            }
        });
        TPGlobal.IS.CurrentLBInt.bind(() -> triggerPanel.panel.UpdateLabelLumiInterval());
        TPGlobal.IS.CurrentReady4Physics.bind(() -> triggerPanel.panel.UpdatePanelPhysicsReady());
        //TPGlobal.IS.CurrentLBInt.bind(() -> triggerPanel.panel.UpdateLabelLumiInterval());
        TPGlobal.IS.CurrentEmittance.bind(() -> triggerPanel.panel.UpdatePanelPhysicsReady());


        
    }

    /**
     * Called by TriggerPanel during panelInit
     */
    void Initialize() {
        //getStandardPanel().Initialize();
        getNewPanel().Initialize();
    }
    
    public void createBGSButtonActionPerformed() throws SQLException {
        boolean runupdate=true;

        // first check if we are on LHC clock
        String clock = TPGlobal.IS.clockStatusISRec.getCurrentClock();
        if(clock==null) {// IS failed somehow
            String message = "Warning: Unable to determine clock type from IS.\n";
            message += "IS Clock type = null (see Igui log for error)";
            message += "\nDo you wish to continue to upload Bunch Groups?";
            int result = JOptionPane.showConfirmDialog(null, message, "Warning for Clock Type", JOptionPane.YES_NO_OPTION);
            IguiLogger.info("Did not recognise clock type null");
            if(result == JOptionPane.NO_OPTION) {
                runupdate = false;
            }
        } else {
            if(clock.equalsIgnoreCase("internal")) { //internal clock
                IguiLogger.info("On internal clock, blocking bunch group upload");
                TPGlobal.igui.internalMessage(IguiConstants.MessageSeverity.INFORMATION,"Using Internal clock, cannot upload new bunch grouPanelState.");
                runupdate=false;
            } else {
                if( ! (clock.equalsIgnoreCase("BC1") || clock.equalsIgnoreCase("BC2")) ) { // unknown clock
                    String message = "Warning: Unable to determine clock type from IS.\n";
                    message += "IS Clock type = ";
                    message += clock;
                    message += "\nDo you wish to continue to upload Bunch Groups?";
                    int result = JOptionPane.showConfirmDialog(null, message, "Warning for Clock Type", JOptionPane.YES_NO_OPTION);
                    IguiLogger.info("Did not recognise clock type " + clock);
                    if(result == JOptionPane.NO_OPTION) {
                        runupdate = false;
                    }
                }
            }//not internal
        }//not null

        if(!runupdate) {
            IguiLogger.info("Not updating bunch groups due to clock setting");
            return;
        }

        // Now we can upload the recommended set
        L1BunchGroupSet recset = TPGlobal.IS.bunchGroupISRec.getRecommendedBunchGroups();
        if(recset!=null) {
            TPGlobal.getDbKeysLoader().DbConnect();  // just in case the connection was lost
            BunchGroupUploadDialog diag = new BunchGroupUploadDialog(null,false,new L1BunchGroupSet(triggerPanel.getCurrentBG()),recset);
            diag.setVisible(true);
        } else {
            TPGlobal.igui.internalMessage(IguiConstants.MessageSeverity.ERROR,"Unable to get Recommended Bunch Groups from IS");
            IguiLogger.warning("Could not get recommended bunch groups from IS, connection details: " + TPGlobal.IS.bunchGroupISRec.getConnString());
        }
    }

    private void changeButtonActionPerformed(TP.RS state) {
        PSSelectionDialogImpl di = new PSSelectionDialogImpl(null, true, this.triggerPanel, state);

        if(di.isCancelled()) {
            IguiLogger.info("Clicked on cancel");
            return;
        }

        KeyDescriptor newl1 = di.selectedL1PS();
        KeyDescriptor newhlt = di.selectedHLTPS();
        if(newl1==null || newhlt==null) {
            IguiLogger.error("One of the prescales is null, not applying");
            return;
        }

        IguiLogger.info("Sending " + state.toString() + " L1PS = " + newl1.key + " HLTPS = " + newhlt.key + " back to the TrigPanel");
        ChangePrescales(state, newl1, newhlt);

    }

    /**
     * Function to change standby prescales
     * @param readyState
     * @param newl1
     * @param newhlt
     */
    public void ChangePrescales(final TP.RS readyState, final KeyDescriptor newl1, final KeyDescriptor newhlt) {

        if(TPGlobal.igui.getAccessLevel()!=IguiConstants.AccessControlStatus.CONTROL) {
            IguiLogger.warning("Somehow you are trying to change Standby prescales without access rights, aborting");
            return;
        }

        new SendPrescalesToISWorker(newl1, newhlt, readyState).execute();
        
        // get state
        State rcState = TPGlobal.igui.getRCState();
        if( readyState==TP.RS.STANDBY && State.INITIAL.follows(rcState) )  { // < INITIAL write to RDB
            new psOksWriter( newl1.key, newhlt.key).execute();
        }
        if (! State.INITIAL.follows(rcState)) { // >= INITIAL and above we should apply them in the CTP (if we are in STANDBY)
            if( GUIState.readyState == readyState && !GUIState.emittanceState || (GUIState.emittanceState && readyState == TP.RS.EMITTANCE) ) {
                //sendPrescalesToMasterTrigger( newl1, newhlt );
                new SendPrescalesToMasterTriggerWorker(newl1, newhlt).execute();
            }
        }

        //updateLabelError();

    }

    private void changeDeadtimeButtonActionPerformed() {
        CTPDeadtimeDialog dialog = new CTPDeadtimeDialog(null, true);
        Point loc = MouseInfo.getPointerInfo().getLocation();
        loc.setLocation(loc.x - 100, loc.y - 100);
        dialog.setLocation(loc);
        dialog.setVisible(true);
        UpdateLabelCTPDeadtimeConfig();
        UpdateLabelColor();
    }
    

    /**
     * Utility to write PS to OKS on another thread
     */
    private class psOksWriter extends javax.swing.SwingWorker<Void, Void> {
        private int l1ps=-1;
        private int hltps=-1;
        public psOksWriter(final int l1ps, final int hltps) {
            super();
            this.l1ps  = l1ps;
            this.hltps = hltps;
        }
        @Override
        public Void doInBackground() {
            TPGlobal.OKS.getL1PSKVar().setValue(l1ps);
            OKS.getHLTPSKVar().setValue(hltps);
            return null;
        }
        @Override
        protected void done() {
            UpdateLabelColor();
        }
        
    }

    class SendPrescalesToISWorker extends SwingWorker<Void, Void> {

        private final KeyDescriptor l1ps;
        private final KeyDescriptor hltps;
        private final TP.RS readyState;

        public SendPrescalesToISWorker(final KeyDescriptor l1ps, final KeyDescriptor hltps, final TP.RS readyState) {
            this.l1ps = l1ps;
            this.hltps = hltps;
            this.readyState = readyState;
        }

        @Override
        protected Void doInBackground() throws Exception {
            // always write to IS
            try {
                triggerPanel.ChangePrescaleInIS(TP.LVL.L1, readyState, l1ps);
                triggerPanel.ChangePrescaleInIS(TP.LVL.HLT, readyState, hltps);
            } catch (RepositoryNotFoundException | InfoNotCompatibleException ex) {
                IguiLogger.error("Prescale keys can not be written to IS, will not send them in the CTP");
            }
            return null;

        }
    }
    
    class SendPrescalesToMasterTriggerWorker extends SwingWorker<Void,Void> {
        private final KeyDescriptor l1ps;
        private final KeyDescriptor hltps;
        public SendPrescalesToMasterTriggerWorker(final KeyDescriptor l1ps, final KeyDescriptor hltps) {
            this.l1ps = l1ps;
            this.hltps = hltps;
        }
        @Override
        protected Void doInBackground() throws Exception {
            triggerPanel.sendPrescalesToMasterTrigger(l1ps, hltps);
            return null;
        }
    }

    private class smOksWriteWorker extends javax.swing.SwingWorker<Void,Void> {
        private final int smk;
        smOksWriteWorker(final int smk) {
            super();
            this.smk = smk;
        }
        @Override
        public Void doInBackground() throws SQLException {

            // write to OKS
            OKS.getSMKVar().setValue(smk);

            // update prescales
            TPGlobal.getDbKeysLoader().UpdatePrescales( OKS.getSMKVar().value() );

            // check if keys are still valid for current smk. If not, set to 0 in IS
            if( triggerPanel.getKeyDescriptor( GUIState.standbyl1psk, TP.LVL.L1) == KeyDescriptor.NotValidForSMK ) {
                try {
                    triggerPanel.ChangePrescaleInIS( TP.LVL.L1,  TP.RS.STANDBY, KeyDescriptor.NotValidForSMK);
                } catch (RepositoryNotFoundException | InfoNotCompatibleException ex) {
                    IguiLogger.warning("Can't reset L1 standby keys in IS", ex);
                }
                OKS.getL1PSKVar().setValue(0);
            }
            if( triggerPanel.getKeyDescriptor( GUIState.standbyhltpsk, TP.LVL.HLT) == KeyDescriptor.NotValidForSMK ) {
                try {
                    triggerPanel.ChangePrescaleInIS( TP.LVL.HLT, TP.RS.STANDBY, KeyDescriptor.NotValidForSMK);
                } catch (RepositoryNotFoundException | InfoNotCompatibleException ex) {
                    IguiLogger.warning("Can't reset HLT standby keys in IS", ex);
                }
                OKS.getHLTPSKVar().setValue(0);
            }
            if( triggerPanel.getKeyDescriptor( GUIState.physicsl1psk, TP.LVL.L1) == KeyDescriptor.NotValidForSMK ) {
                try {
                    triggerPanel.ChangePrescaleInIS( TP.LVL.L1,  TP.RS.PHYSICS, KeyDescriptor.NotValidForSMK);
                } catch (RepositoryNotFoundException | InfoNotCompatibleException ex) {
                    IguiLogger.warning("Can't reset L1 physics keys in IS", ex);
                }
            }
            if( triggerPanel.getKeyDescriptor( GUIState.physicshltpsk, TP.LVL.HLT) == KeyDescriptor.NotValidForSMK ) {
                try {
                    triggerPanel.ChangePrescaleInIS( TP.LVL.HLT, TP.RS.PHYSICS, KeyDescriptor.NotValidForSMK);
                } catch (RepositoryNotFoundException | InfoNotCompatibleException ex) {
                    IguiLogger.warning("Can't reset HLT physics keys in IS", ex);
                }
            }
                        // check if keys are still valid for current smk. If not, set to 0 in IS
            if( triggerPanel.getKeyDescriptor( GUIState.emittancel1psk, TP.LVL.L1) == KeyDescriptor.NotValidForSMK ) {
                try {
                    triggerPanel.ChangePrescaleInIS( TP.LVL.L1,  TP.RS.EMITTANCE, KeyDescriptor.NotValidForSMK);
                } catch (RepositoryNotFoundException | InfoNotCompatibleException ex) {
                    IguiLogger.warning("Can't reset L1 standby keys in IS", ex);
                }
            }
            // check if keys are still valid for current smk. If not, set to 0 in IS
            if( triggerPanel.getKeyDescriptor( GUIState.emittancehltpsk, TP.LVL.HLT) == KeyDescriptor.NotValidForSMK ) {
                try {
                    triggerPanel.ChangePrescaleInIS( TP.LVL.HLT,  TP.RS.EMITTANCE, KeyDescriptor.NotValidForSMK);
                } catch (RepositoryNotFoundException | InfoNotCompatibleException ex) {
                    IguiLogger.warning("Can't reset HLT standby keys in IS", ex);
                }
            }

            
            return null;
        }

        @Override
        public void done() {
            UpdateLabelColor();
            try {
                this.get();
            } catch(InterruptedException | ExecutionException ex) {
                error(new TriggerPanelIssue("Error when trying to write to OKS", ex));
                Utils.logException(ex);
            }
            // update panel
            UpdateLabelCurrentSMK();
            triggerPanel.setBusy(false);
        }
    }
   
    private class bgWriterWorker extends SwingWorker<Void,Void> {
        private final int bgsk;
        bgWriterWorker(final int bgsk) {
            this.bgsk = bgsk;
        }
        @Override
        public Void doInBackground() {
            RunControlFSM.State state = TPGlobal.igui.getRCState();
            // >= INITIAL: send update to L1
            if( ! RunControlFSM.State.INITIAL.follows(state) )  {
                try {
                    TPL.info( "Sending bunch group " + bgsk + " to TriggerCommander.", true );
                    triggerPanel.triggerCommander.setBunchGroup(bgsk);
                    if(state==RunControlFSM.State.RUNNING) {
                        triggerPanel.increaseLB();
                    }
                } catch (CommandExecutionFailed ex) {
                    TPL.error( "Could not send new bunch group " + bgsk + " to CTP \n" + ex.toString(), true );
                }
            }
            // < INITIAL: write to OKS
            if( RunControlFSM.State.INITIAL.follows(state) )  {
                OKS.getBGSKVar().setValue(bgsk); // setting the value automatically writes to RDB server
            }
            return null;
        }

        @Override
        protected void done() {
            RunControlFSM.State state = TPGlobal.igui.getRCState();
            // < INITIAL: write to OKS
            if( RunControlFSM.State.INITIAL.follows(state) )  {
                UpdateLabelCurrentL1BGKey();
                UpdateLabelColor();
            }

        }
        

    }

    void UpdateLabelsAfterOKSRead() {
        UpdateLabelCurrentSMK();
        UpdateLabelCurrentL1PSK();
        UpdateLabelCurrentHLTPSK();
        UpdateLabelCurrentL1BGKey();
        UpdateLabelCTPDeadtimeConfig();
        UpdateLabelColor();
    }

    /**
     * Change appropriate text when SM key changes
     */
    private void UpdateLabelCurrentSMK() {
        SwingWorker<Void, Void> swingWorker = new SwingWorker<Void, Void>() {
            KeyDescriptor kd;
            @Override
            protected void done() {
                getStandardPanel().getCurrentSMNameLabel().setText(kd.name);
                getStandardPanel().getCurrentSMNameLabel().setToolTipText( Utils.CreateToolTip(kd.comment) );
                getStandardPanel().getCurrentSMLabel().setText(""+kd.key);
                UpdateLabelColor();
            }
            @Override
            protected Void doInBackground() throws Exception {
                kd = triggerPanel.getKeyDescriptor(triggerPanel.getCurrentSMK(),TP.LVL.MENU);
                if(kd==null) {
                    kd = new KeyDescriptor(0, "not available", 0, "needs to be set", false);
                }
                return null;
            }
        };
        swingWorker.execute();
    }

    protected void UpdateLabelCurrentL1PSK() {
        SwingUtilities.invokeLater(() -> {
            getStandardPanel().getCurrentL1PSNameLabel().setText(""+triggerPanel.getCurrentL1PSK());
            getStandardPanel().getCurrentL1PSNameLabel().setToolTipText( triggerPanel.getCurrentL1PSKInfo() );
            UpdateLabelError();
        });
    }

    protected void UpdateLabelCurrentHLTPSK() {
        SwingUtilities.invokeLater(() -> {
            getStandardPanel().getCurrentHLTPSNameLabel().setText(""+triggerPanel.getCurrentHLTPSK());
            getStandardPanel().getCurrentHLTPSNameLabel().setToolTipText( triggerPanel.getCurrentHLTPSKInfo() );
            UpdateLabelError();
        });
    }

    protected void UpdateLabelCurrentL1BGKey() {
        SwingUtilities.invokeLater(() -> {
            getStandardPanel().getBunchGroupLabel().setText(""+triggerPanel.getCurrentBG());
            getStandardPanel().getBunchGroupLabel().setToolTipText( triggerPanel.getCurrentBGInfo() );
        });
    }
    
    protected void UpdateLabelCTPDeadtimeConfig() {
        SwingUtilities.invokeLater(() -> {
            getStandardPanel().getCTPDeadtimeConfigLabel().setText(""+triggerPanel.getCurrentDeadtimeConfig());
        });
    }

    protected void UpdateLabelLumiInterval() {
        SwingUtilities.invokeLater(() -> {
            if(GUIState.lbinterval>0) {
                final String text = GUIState.lbinterval + ( GUIState.lbmodeIsTime() ? " seconds" : " events" );
                getStandardPanel().getLumiBlockLengthLabel().setText(text);
                getStandardPanel().getLumiBlockLengthLabel().setToolTipText(TPGlobal.IS.CurrentLBInt.infoProvider());
            } else {
                getStandardPanel().getLumiBlockLengthLabel().setText("Info not found");
                getStandardPanel().getLumiBlockLengthLabel().setToolTipText(TPGlobal.IS.CurrentLBInt.stateInfo());
            }
        });
    }

    void UpdateLabelColor() {
        if(GUIState.isControl()) {
            IguiLogger.info("Uncommited DB changes:"+( OKS.uncommitedDbChanges()?"TRUE":"FALSE"));
            getStandardPanel().getCommitMessage().setText( OKS.uncommitedDbChanges()?"Please 'Commit & Reload' before leaving this panel":"");
            getStandardPanel().getCurrentSMLabel().setForeground( OKS.getSMKVar().isCommitted()?black:uncommittedclr);
            getStandardPanel().getStandbyL1psLabel().setForeground( OKS.getL1PSKVar().isCommitted()?black:uncommittedclr);
            getStandardPanel().getStandbyHltpsLabel().setForeground( OKS.getHLTPSKVar().isCommitted()?black:uncommittedclr);
            getStandardPanel().getBunchGroupLabel().setForeground( OKS.getBGSKVar().isCommitted()?black:uncommittedclr);
            getStandardPanel().getCTPDeadtimeConfigLabel().setForeground( OKS.getCTPDeadtimeVar().isCommitted()?black:uncommittedclr);
        } else {
            getStandardPanel().getCommitMessage().setText("");
            getStandardPanel().getCurrentSMLabel().setForeground(black);
            getStandardPanel().getStandbyL1psLabel().setForeground(black);
            getStandardPanel().getStandbyHltpsLabel().setForeground(black);
            getStandardPanel().getBunchGroupLabel().setForeground(black);
            getStandardPanel().getCTPDeadtimeConfigLabel().setForeground(black);
        }
    }

    private void UpdateLabelError() {
        /// Change text - should be done in EDT
        final String errormsg = GetUpdatedLabelError();
        SwingUtilities.invokeLater(() -> {
            getStandardPanel().getErrorlabel().setText(errormsg);
        });
    }

    private String GetUpdatedLabelError() {
        // if we are not running, don't complain
        String msg = "";

        if(State.RUNNING.follows(GUIState.currentState)) {
            return msg;
        }

        KeyDescriptor currentL1psKD = triggerPanel.getKeyDescriptor( triggerPanel.getCurrentL1PSK(), TP.LVL.L1 );
        if(currentL1psKD == null) {
            return msg;
        }
        if(currentL1psKD.name.startsWith("AUTO_")) {
            msg = "L1 prescale is auto generated (hot items)";
        } else {
            int error = 0;
            if(GUIState.emittanceState){
                if(triggerPanel.getCurrentL1PSK() != GUIState.emittancel1psk) {
                    error += 1;
                }
                if(triggerPanel.getCurrentHLTPSK() != GUIState.emittancehltpsk) {
                    error += 2;
                }
            }
            else if( GUIState.ReadyState() == TP.RS.PHYSICS ) {
                if(triggerPanel.getCurrentL1PSK() != GUIState.physicsl1psk) {
                    error += 1;
                }
                if(triggerPanel.getCurrentHLTPSK() != GUIState.physicshltpsk) {
                    error += 2;
                }
            } else {
                if(triggerPanel.getCurrentL1PSK() != GUIState.standbyl1psk) {
                    error += 1;
                }
                if(triggerPanel.getCurrentHLTPSK() != GUIState.standbyhltpsk) {
                    error += 2;
                }        
            }
            if(error==0) {
                IguiLogger.info("Current keys are consistent with state");
                return "";
            }
            if(GUIState.emittanceState){
                msg = "Current prescales do not match current state EMITTANCE";
            }
            else{
                msg = "Current prescales do not match current state " + GUIState.ReadyState();
            }
        }
        IguiLogger.info(msg);
        return msg;
    }

    void UpdatePrescaleKeys(final TP.LVL level, final TP.RS readystate) throws SQLException {
        SwingWorker<Void, Void> swingWorker = new SwingWorker<Void, Void>() {
            KeyDescriptor kd;
            @Override
            protected Void doInBackground() throws Exception {
                kd = triggerPanel.getKeyDescriptor(level, readystate);
                return null;
            }
            @Override
            protected void done() {
                getStandardPanel().setKeys(readystate, level, kd);
                UpdateLabelError();
            }
        };
        swingWorker.execute();
    }

    void UpdatePanelPhysicsReady() {
        SwingUtilities.invokeLater(() -> {
            if(GUIState.emittanceState){
                TPL.info("updatePanelPhysicsReady with Emittance: " + GUIState.emittanceState);                
                getStandardPanel().getStandbyLabel().setForeground( inactivemodeclr );
                getStandardPanel().getEmittanceLabel().setForeground( activemodeclr );
                getStandardPanel().getPhysicsLabel().setForeground( inactivemodeclr );

            }
            else{
            TPL.info("updatePanelPhysicsReady with ReadyForPhysics: " + GUIState.ReadyState());
                getStandardPanel().getStandbyLabel().setForeground( GUIState.ReadyState() == TP.RS.STANDBY ? activemodeclr : inactivemodeclr );
                getStandardPanel().getEmittanceLabel().setForeground( inactivemodeclr );
                getStandardPanel().getPhysicsLabel().setForeground( GUIState.ReadyState() == TP.RS.PHYSICS ? activemodeclr : inactivemodeclr );
            }
// TODO                standbyPSSelPanel.setActive( GUIState.ReadyState() == TP.RS.STANDBY ); <- what is todo?
// TODO               physicsPSSelPanel.setActive( GUIState.ReadyState() == TP.RS.PHYSICS );
        });
    }
    
    /**
     * Function sets up the status of all the buttons depending
     * on the run state & access control level.
     */
    void UpdatePanelForState() {

        final RunControlFSM.State state = GUIState.currentState;
        final IguiConstants.AccessControlStatus a = GUIState.currentAccess;
        
        IguiLogger.info("Updating panel: state="+state.toString()+", access control="+a.toString());

        SwingUtilities.invokeLater(() -> {
            ShifterPanel shifterPanel = getStandardPanel();
            
            if(a==IguiConstants.AccessControlStatus.DISPLAY) {
                
                // DISPLAY
                
                shifterPanel.getChangeSMButton().setEnabled(false);
                shifterPanel.standbyChangeButton.setEnabled(false);
                shifterPanel.physicsChangeButton.setEnabled(false);
                shifterPanel.emittanceChangeButton.setEnabled(false);
                shifterPanel.getChangeBunchGroupButton().setEnabled(false);
                shifterPanel.getChangeLumiBLengthButton().setEnabled(false);
                shifterPanel.getStartNewLumiBlockButton().setEnabled(false);
                shifterPanel.getCreateBGSButton().setEnabled(true);
                shifterPanel.getChangeDeadtimeButton().setEnabled(false);
            } else {
                
                // CONTROL
                
                shifterPanel.getChangeSMButton().setEnabled(state == State.NONE );
                shifterPanel.standbyChangeButton.setEnabled(state==State.NONE || state==State.RUNNING);
                shifterPanel.physicsChangeButton.setEnabled(state==State.NONE || state==State.RUNNING);
                shifterPanel.emittanceChangeButton.setEnabled(state==State.NONE || state==State.RUNNING);
                shifterPanel.getChangeBunchGroupButton().setEnabled(state==State.NONE || state==State.RUNNING);
                shifterPanel.getChangeLumiBLengthButton().setEnabled(state==State.NONE || state==State.RUNNING);
                shifterPanel.getStartNewLumiBlockButton().setEnabled(state.equals(State.RUNNING));
                shifterPanel.getCreateBGSButton().setEnabled(false);
                shifterPanel.getChangeDeadtimeButton().setEnabled(state==State.NONE);
                
            }
            
            if( State.INITIAL.follows(state) ) {  // < INITIAL
                ((TitledBorder)shifterPanel.getCurrentPrescalesPanel().getBorder()).setTitle("current prescales (oks)");
            }
            else {
                ((TitledBorder)shifterPanel.getCurrentPrescalesPanel().getBorder()).setTitle("current prescales (ctp)");
            }
            shifterPanel.getCurrentPrescalesPanel().repaint();
            
            UpdateLabelCurrentL1PSK();
            UpdateLabelCurrentHLTPSK();
            
            final String errormsg = GetUpdatedLabelError();
            shifterPanel.getErrorlabel().setText(errormsg);
            
            UpdateLabelColor();
        });
        
        getNewPanel().UpdateStateAccessControl();

    }


    
}
