/*
 * BugReport.java
 *
 * Created on April 12, 2008, 9:47 PM
 */
package triggertool.Components;

import triggerdb.Connections.ConnectionManager;
import javax.swing.JDialog;
import javax.swing.JFrame;
import triggerdb.Connections.UserMode;

///Screen that allows a user to write to the trigger logs table
/**
 * Dialog Box generally useful for inputting long strings
 * @author Simon Head
 * @author Paul Bell
 */
public class InputDialog extends JDialog {

    private boolean set=false;

    /**
     *
     */
    public static enum Panel{

        /**
         *
         */
        SMT,

        /**
         *
         */
        HLTPARAM
    }
    /** Creates new form BugReport
     * @param parameter
     * @param header
     * @param panelType */
    public InputDialog(String parameter, String header, InputDialog.Panel panelType, JFrame parent) {
    
        super((JDialog)null);
        
        initComponents();

        InitPanel(header, parameter, panelType, parent);
        
    }
    
    private void InitPanel(String header, String parameter, InputDialog.Panel panelType, JFrame parent) {
        
        if(panelType == Panel.HLTPARAM){
            parameter = parameter.replaceAll(",",",\n");
        }        
        setModal(true);
        
        jLabelHeader.setText(header);
        jTextArea1.setText(parameter);
        jTextArea1.setEnabled(true);
        jTextArea1.setEditable(true);
        jTextArea1.setVisible(true);
    
        if(ConnectionManager.getInstance().getInitInfo().getUserMode().ordinal()>= UserMode.SHIFTER.ordinal()) {
            jButton1.setEnabled(true);
            jTextArea1.setEditable(true);
        }else{
            jButton1.setEnabled(false);
            jTextArea1.setEditable(false);
        }
        
        setLocationRelativeTo(parent);
        setVisible(true);
    }
    
    /**
     *
     * @return
     */
    public String getNewval(){
        if(set){
            return jTextArea1.getText();
        }else{
            return null;
        }
    }
    
    /** 
     * This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jScrollPane1 = new javax.swing.JScrollPane();
        jTextArea1 = new javax.swing.JTextArea();
        jButton1 = new javax.swing.JButton();
        jButton2 = new javax.swing.JButton();
        jLabelHeader = new javax.swing.JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setMinimumSize(new java.awt.Dimension(715, 370));
        setResizable(false);

        jTextArea1.setColumns(20);
        jTextArea1.setRows(5);
        jTextArea1.setVerifyInputWhenFocusTarget(false);
        jScrollPane1.setViewportView(jTextArea1);

        jButton1.setText("OK");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });

        jButton2.setText("Cancel");
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton2ActionPerformed(evt);
            }
        });

        jLabelHeader.setText("HeaderInfo");

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jScrollPane1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 691, Short.MAX_VALUE)
                    .add(jLabelHeader, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                        .add(0, 0, 0)
                        .add(jButton2)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jButton1)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .add(jLabelHeader)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.UNRELATED)
                .add(jScrollPane1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 236, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jButton1)
                    .add(jButton2))
                .add(6, 6, 6))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    /**
     * Update record in memory (in the end) and close
     * 
     * @param evt The event that fires this function.
     */
private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
    
    set=true;
    dispose();
}//GEN-LAST:event_jButton1ActionPerformed

    /**
     * Just close the form and don't do anything.
     * 
     * @param evt The event that fires this function.
     */
private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
    dispose();
}//GEN-LAST:event_jButton2ActionPerformed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JLabel jLabelHeader;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTextArea jTextArea1;
    // End of variables declaration//GEN-END:variables
}
