package triggertool.Components;

import triggerdb.Connections.ConnectionManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JDialog;
import javax.swing.JOptionPane;

///Dialog box to change atonr shifter password
/**
 * Dialog box to enable trigger shifters to change their password on atonr
 * 
 * @author Paul Bell
 */
public class UsersDialogShifter extends JDialog {

    /**
     *
     */
    protected static final Logger logger = Logger.getLogger("TriggerTool");
    ///The shifter logged on
    private String shifter = "";
    
    ///Creates new form UsersDialog.
    /**
     * Create and display the form to add / modify user access rights.
     * 
     * @param parent Parent form can be null.
     */
    public UsersDialogShifter(java.awt.Frame parent) {
        super((JDialog)null);
        initComponents();
   
        load();

        setVisible(true);
    }

    ///Load all the suers from the database,.
    /**
     * Load all the users and add them to the list on the left.
     */
    private void load() {
    
        shifter = ConnectionManager.getInstance().getInitInfo().getSystemUsername();

        //should only find one result
        String query = "SELECT TT_LEVEL, TT_USER FROM TT_USERS WHERE TT_USER = ?";
        query = ConnectionManager.getInstance().fix_schema_name(query);
        //System.out.println(query);
         
        try {
            PreparedStatement ps = ConnectionManager.getInstance().getConnection().prepareStatement(query);
            ps.setString(1, shifter);
            ResultSet rset = ps.executeQuery();

            while (rset.next()) {
                textUsername.setText(rset.getString("TT_USER"));
                textUserLevel.setText(rset.getString("TT_LEVEL"));
            }

            rset.close();
            ps.close();
        } catch (SQLException ex) {
            ex.printStackTrace();
            logger.log(Level.SEVERE, "Exception: {0}", ex);
        }
    }

    ///Netbeans. Don't edit.
    /** 
     * This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        buttonDone = new javax.swing.JButton();
        jPanel1 = new javax.swing.JPanel();
        textUsername = new javax.swing.JTextField();
        textPassword = new javax.swing.JPasswordField();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        textUserLevel = new javax.swing.JTextField();
        buttonSave = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);

        buttonDone.setText("Done");
        buttonDone.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonDoneActionPerformed(evt);
            }
        });

        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder("User Details"));

        textUsername.setEditable(false);
        textUsername.setText("jTextField1");

        textPassword.setText("jPasswordField1");

        jLabel1.setText("Username");

        jLabel2.setText("Level");

        jLabel3.setText("Password");

        textUserLevel.setEditable(false);
        textUserLevel.setText("jTextField1");

        org.jdesktop.layout.GroupLayout jPanel1Layout = new org.jdesktop.layout.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jLabel1)
                    .add(jLabel2)
                    .add(jLabel3))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, textUsername, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 305, Short.MAX_VALUE)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, textPassword, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 305, Short.MAX_VALUE)
                    .add(textUserLevel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 305, Short.MAX_VALUE)))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel1)
                    .add(textUsername, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel2)
                    .add(textUserLevel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .add(12, 12, 12)
                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel3)
                    .add(textPassword, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        buttonSave.setText("Update Password");
        buttonSave.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonSaveActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(jPanel1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .add(layout.createSequentialGroup()
                        .add(buttonSave)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.UNRELATED)
                        .add(buttonDone)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(buttonDone)
                    .add(buttonSave))
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    ///Done button, close the form.
    /**
     * Close the form.
     * 
     * @param evt Event that started this function.
     */
private void buttonDoneActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonDoneActionPerformed
    dispose();
}//GEN-LAST:event_buttonDoneActionPerformed

    ///Save the user information.
    /**
     * Save the user.
     * 
     * @param evt Event that started this function.
     */
private void buttonSaveActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonSaveActionPerformed
    
    if (new String(textPassword.getPassword()).isEmpty()) {
        JOptionPane.showMessageDialog(this, "Please enter a new password.", "Information Incomplete", JOptionPane.INFORMATION_MESSAGE);
        return;
    }

    //get the new password
    String pw = ConnectionManager.getInstance().getInitInfo().encrypt(new String(textPassword.getPassword()));

    try {
        String query = "UPDATE TT_USERS SET TT_PASSWORD=? WHERE TT_USER=?";
        query = ConnectionManager.getInstance().fix_schema_name(query);

        PreparedStatement ps = ConnectionManager.getInstance().getConnection().prepareStatement(query);
        ps.setString(2, shifter);
        ps.setString(1, pw);
        
        ps.executeUpdate();

        ps.close();
    } catch (SQLException ex) {
        ex.printStackTrace();
        logger.log(Level.SEVERE, "Exception: {0}", ex);
    }

    JOptionPane.showMessageDialog(this, "Password updated for user " +  shifter, "Credentials updated", JOptionPane.INFORMATION_MESSAGE);

    load();
}//GEN-LAST:event_buttonSaveActionPerformed

    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    ///Close the window button.
    private javax.swing.JButton buttonDone;
    ///Save user button.
    private javax.swing.JButton buttonSave;
    ///Username label.
    private javax.swing.JLabel jLabel1;
    ///Level label.
    private javax.swing.JLabel jLabel2;
    ///Password label.
    private javax.swing.JLabel jLabel3;
    ///Box.
    private javax.swing.JPanel jPanel1;
    ///Password.
    private javax.swing.JPasswordField textPassword;
    ///Username.
    private javax.swing.JTextField textUserLevel;
    ///Username.
    private javax.swing.JTextField textUsername;
    // End of variables declaration//GEN-END:variables

    
}
