/*
 * DiffSMTSelDialog.java
 *
 * Created on February 23, 2009, 10:17 AM
 */
package triggertool.Diff;

import triggerdb.Connections.ConnectionManager;

import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.logging.Level;

import java.util.logging.Logger;

/**
 *
 * @author  markowen
 */
public class DiffSMTSelDialog extends javax.swing.JDialog {

    /// Super master id selected from combox box 1
    private int smt1_id = -1;
    /// Super master id selected from combox box 2
    private int smt2_id = -1;
    /// Do we want to run the diff
    private boolean dodiff = false;
    ///Message Log.

    /**
     *
     */
    protected static final Logger logger = Logger.getLogger("TriggerTool");

    /** Creates new form DiffSMTSelDialog
     * @param parent
     * @param modal */
    public DiffSMTSelDialog(java.awt.Frame parent, Boolean modal) {
        super(parent,modal);
        initComponents();
        setupSelectionDialog();
        setTitle("Diff SMTs");
        setLocationRelativeTo(parent);
        setVisible(true);
    }

    /// Which smk has been selected?

    /**
     *
     * @return
     */
    public int GetSMK1() {
        return smt1_id;
    }
    /// Which smk has been selected?

    /**
     *
     * @return
     */
    public int GetSMK2() {
        return smt2_id;
    }

    /**
     * Function to tell if we pressed cancel or Diff.
     * @return
     */
    public boolean doDiff() {
        return dodiff;
    }

    /**
     * Function to full the dialog box with the available super master tables.
     */
    private void setupSelectionDialog() {
        setSize(500, 300);
        String query = "SELECT SMT_ID, SMT_COMMENT FROM SUPER_MASTER_TABLE ORDER BY SMT_ID DESC";

        try {

            query = ConnectionManager.getInstance().fix_schema_name(query);
            PreparedStatement ps = ConnectionManager.getInstance().getConnection().prepareStatement(query);
            ResultSet rset = ps.executeQuery();
            while (rset.next()) {
                int id = rset.getInt("SMT_ID");
                StringBuffer entry = new StringBuffer(String.valueOf(id));
                entry.append(" ");
                entry.append(rset.getString("SMT_COMMENT"));
                String sentry = entry.toString();
                smt1ComboBox.addItem(sentry);
                smt2ComboBox.addItem(sentry);
            }
            rset.close();
            ps.close();
        } catch (SQLException ex) {
            logger.log(Level.SEVERE, ex.getMessage(), ex);
            dispose();
            return;
        }
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jLayeredPane1 = new javax.swing.JLayeredPane();
        jPanel1 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jPanel2 = new javax.swing.JPanel();
        smt1ComboBox = new javax.swing.JComboBox<>();
        jLabel2 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        smt2ComboBox = new javax.swing.JComboBox<>();
        diffButton = new javax.swing.JButton();
        cancelButton = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setMinimumSize(new java.awt.Dimension(500, 250));

        jLabel1.setFont(new java.awt.Font("Lucida Grande", 1, 18)); // NOI18N
        jLabel1.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel1.setText("Select Super Master Keys to Diff:");

        org.jdesktop.layout.GroupLayout jPanel1Layout = new org.jdesktop.layout.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jLabel1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jLabel1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 56, Short.MAX_VALUE)
        );

        smt1ComboBox.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "Select SMT ...." }));
        smt1ComboBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                smt1ComboBoxActionPerformed(evt);
            }
        });

        jLabel2.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        jLabel2.setText("Super Master Key 1:");

        jLabel3.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        jLabel3.setText("Super Master Key 2:");

        smt2ComboBox.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "Select SMT ...." }));
        smt2ComboBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                smt2ComboBoxActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout jPanel2Layout = new org.jdesktop.layout.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(smt1ComboBox, 0, 213, Short.MAX_VALUE)
                    .add(jLabel2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 208, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(smt2ComboBox, 0, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .add(jLabel3, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 225, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addContainerGap())
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel2Layout.createSequentialGroup()
                .add(5, 5, 5)
                .add(jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel2)
                    .add(jLabel3))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(smt1ComboBox, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(smt2ComboBox, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        diffButton.setText("Diff");
        diffButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                diffButtonActionPerformed(evt);
            }
        });

        cancelButton.setText("Cancel");
        cancelButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cancelButtonActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .add(jPanel2, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .add(cancelButton)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(diffButton)
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(jPanel1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(diffButton)
                    .add(cancelButton))
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

private void smt1ComboBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_smt1ComboBoxActionPerformed
    Integer id = null;
    try {
        String res = ((String) smt1ComboBox.getSelectedItem()).split(" ")[0].trim();
        id = Integer.parseInt(res);
    } catch (NumberFormatException ex) {
        logger.warning("Selecting something in the combo box which is not a valid id");
        return;
    }
    smt1_id = id;
    logger.log(Level.INFO, "Selected SMT {0} in combobox 1", smt1_id);
}//GEN-LAST:event_smt1ComboBoxActionPerformed

private void smt2ComboBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_smt2ComboBoxActionPerformed
    Integer id = null;
    try {
        String res = ((String) smt2ComboBox.getSelectedItem()).split(" ")[0].trim();
        id = Integer.parseInt(res);
    } catch (NumberFormatException ex) {
        logger.warning("Selecting something in the combo box which is not a valid id");
        return;
    }
    smt2_id = id;
    logger.log(Level.INFO, "Selected SMT {0} in combobox 2", smt2_id);
}//GEN-LAST:event_smt2ComboBoxActionPerformed

private void diffButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_diffButtonActionPerformed
    dodiff = true;
    dispose();
}//GEN-LAST:event_diffButtonActionPerformed

private void cancelButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cancelButtonActionPerformed
    dodiff = false;
    dispose();
}//GEN-LAST:event_cancelButtonActionPerformed
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton cancelButton;
    private javax.swing.JButton diffButton;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLayeredPane jLayeredPane1;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JComboBox<String> smt1ComboBox;
    private javax.swing.JComboBox<String> smt2ComboBox;
    // End of variables declaration//GEN-END:variables
}
