#ifndef MSGINFO_H
#define MSGINFO_H

#include <is/info.h>

#include <string>
#include <ostream>
#include <vector>


// <<BeginUserCode>>

// <<EndUserCode>>
/**
 * 
 * @author  generated by the IS tool
 * @version 04/03/13
 */

class MsgInfo : public ISInfo {
public:

    /**
     * Generic name of machine as returned by hostname()
     */
    std::string                   Hostname;

    /**
     * A list of network addresses in the form IPAddr/Netmask. Both IPV4 and IPV6 are allowed.
     */
    std::vector<std::string>      Addresses;

    /**
     * Port number
     */
    unsigned short                Port;


    static const ISType & type() {
	static const ISType type_ = MsgInfo( ).ISInfo::type();
	return type_;
    }

    virtual std::ostream & print( std::ostream & out ) const {
	ISInfo::print( out );
	out << std::endl;
	out << "Hostname: " << Hostname << "\t// Generic name of machine as returned by hostname()" << std::endl;
	out << "Addresses[" << Addresses.size() << "]:\t// A list of network addresses in the form IPAddr/Netmask. Both IPV4 and IPV6 are allowed." << std::endl;
	for ( size_t i = 0; i < Addresses.size(); ++i )
	    out << i << " : " << Addresses[i] << std::endl;
	out << "Port: " << Port << "\t// Port number";
	return out;
    }

    MsgInfo( )
      : ISInfo( "MsgInfo" )
    {
	initialize();
    }

    ~MsgInfo(){

// <<BeginUserCode>>

// <<EndUserCode>>
    }

protected:
    MsgInfo( const std::string & type )
      : ISInfo( type )
    {
	initialize();
    }

    void publishGuts( ISostream & out ){
	out << Hostname << Addresses << Port;
    }

    void refreshGuts( ISistream & in ){
	in >> Hostname >> Addresses >> Port;
    }

private:
    void initialize()
    {

// <<BeginUserCode>>

// <<EndUserCode>>
    }


// <<BeginUserCode>>

// <<EndUserCode>>
};

// <<BeginUserCode>>

// <<EndUserCode>>
inline std::ostream & operator<<( std::ostream & out, const MsgInfo & info ) {
    info.print( out );
    return out;
}

#endif // MSGINFO_H
