#ifndef MULTICASTGROUP_H
#define MULTICASTGROUP_H

#include <is/info.h>

#include <string>
#include <ostream>


// <<BeginUserCode>>

// <<EndUserCode>>
/**
 * 
 * @author  generated by the IS tool
 * @version 04/11/15
 */

class MultiCastGroup : public ISInfo {
public:

    /**
     * The name of the partition where this multicast group is used.
     */
    std::string                   Partition;

    /**
     * The address of the multicast group. It must be in the 224.*.*.* range.
     */
    std::string                   MulticastAddress;

    /**
     * The network address where multicast packages are being sent. This determines the outgoing interface and should be the network part of the 
     */
    std::string                   MulticastNetwork;


    static const ISType & type() {
	static const ISType type_ = MultiCastGroup( ).ISInfo::type();
	return type_;
    }

    virtual std::ostream & print( std::ostream & out ) const {
	ISInfo::print( out );
	out << std::endl;
	out << "Partition: " << Partition << "\t// The name of the partition where this multicast group is used." << std::endl;
	out << "MulticastAddress: " << MulticastAddress << "\t// The address of the multicast group. It must be in the 224.*.*.* range." << std::endl;
	out << "MulticastNetwork: " << MulticastNetwork << "\t// The network address where multicast packages are being sent. This determines the outgoing interface and should be the network part of the ";
	return out;
    }

    MultiCastGroup( )
      : ISInfo( "MultiCastGroup" )
    {
	initialize();
    }

    ~MultiCastGroup(){

// <<BeginUserCode>>

// <<EndUserCode>>
    }

protected:
    MultiCastGroup( const std::string & type )
      : ISInfo( type )
    {
	initialize();
    }

    void publishGuts( ISostream & out ){
	out << Partition << MulticastAddress << MulticastNetwork;
    }

    void refreshGuts( ISistream & in ){
	in >> Partition >> MulticastAddress >> MulticastNetwork;
    }

private:
    void initialize()
    {
	MulticastAddress = "224.200.100.100";
	MulticastNetwork = "10.149.0.0";

// <<BeginUserCode>>

// <<EndUserCode>>
    }


// <<BeginUserCode>>

// <<EndUserCode>>
};

// <<BeginUserCode>>

// <<EndUserCode>>
inline std::ostream & operator<<( std::ostream & out, const MultiCastGroup & info ) {
    info.print( out );
    return out;
}

#endif // MULTICASTGROUP_H
