"""Module for AppPanel class and related methods.
"""

#--------------------------------
#  Imports of standard modules --
#--------------------------------

#-----------------------------
# Imports for other modules --
#-----------------------------

#----------------------------------
# Local non-exported definitions --
#----------------------------------

#------------------------
# Exported definitions --
#------------------------


class AppPanel(object):
    """Interface definition for application panels.
    """

    def title(self):
        """Return string displayed as a panel title"""
        raise NotImplementedError()

    def hints(self):
        """Return list of hints.

        Each hint is a tuple of two strings, first string is the name of
        a key and second is the name of the action, e.g. ("^E", "Menu").
        Default implementation returns empty list.
        """
        return []

    def status(self):
        """Return status string.

        Default implementation returns empty string.
        """
        return ""
