#!/usr/bin/env tdaq_python

from __future__ import print_function

import cx_Oracle
import coral_auth
import sys

def test(*connect_params):
    try:
        if len(connect_params) == 1:
            connection = cx_Oracle.connect(connect_params[0])
        else:
            connection = cx_Oracle.connect(*connect_params)
    except LookupError as err:
        print(err)
        sys.exit(1)

    cursor = connection.cursor()
    result = cursor.execute("select * from partition_ids where tdaq_release = 'tdaq-06-01-01'")
    r = cursor.fetchall()
    print(r[0])

print('Testing: get_connection_string...')
test(coral_auth.get_connection_string("LOG_MANAGER"))

print('Testing: get_connection_parameters...')
test(*coral_auth.get_connection_parameters("LOG_MANAGER"))

print('Testing: get_connection_parameters_from_connection_string...')
test(*coral_auth.get_connection_parameters_from_connection_string(
       "oracle://ATONR_ADG/ATLAS_LOG_MESSG"))
