/*! \file ListView.cpp Implements the dqm_display::gui::ListView class.
 * \author Anyes Taffard, Kevin Slagle
 * \version 1.0
 */

#include <dqm_display/gui/ListView.h>
#include <QDebug>

namespace dqm_display { 
namespace gui {

ListView::ListView(QWidget *parent)
  : ViewBase<QListView>(parent)
{
    connect(this, SIGNAL(clicked(const QModelIndex &)),
	this, SLOT(when_clicked(const QModelIndex &)));

    connect(this, SIGNAL(customContextMenuRequested(const QPoint &)),
	this, SLOT(when_menu_requested(const QPoint &)));

    connect(&m_menu, SIGNAL(nodeActivated(const core::TreeNode *)),
	this, SIGNAL(nodeActivated(const core::TreeNode *)));
}

} }
