/*
 * ParameterFilterModel.cpp
 *
 *  Created on: Oct 9, 2013
 *      Author: kolos
 */

#include <QDebug>
#include <QTreeView>

#include <dqm_display/gui/ParameterFilterModel.h>

namespace dqm_display {
namespace gui {

ParameterFilterModel::ParameterFilterModel(QObject * parent, QAbstractItemModel* source)
  : QSortFilterProxyModel(parent),
    m_row(-1)
{
    setSourceModel(source);
}

void
ParameterFilterModel::setVisibleItem(QTreeView * view, const QModelIndex & index)
{
    m_row = index.row();
    m_parent = index.parent();
    view->setRootIndex(m_parent);
    invalidate();
}

bool
ParameterFilterModel::filterAcceptsRow(int sourceRow, const QModelIndex & parent) const
{
    return (parent != m_parent || m_row == sourceRow);
}

}}

