/* \author Serguei Kolos
 * \version 1.0
 */

#include <memory>

#include <RunControl/Common/Controllable.h>
#include <dqmf/Configuration.h>

namespace dqmf
{         
    class Agent : public daq::rc::Controllable
    {
      public:
    
	Agent(	const std::string & db_connect_string, 
		const IPCPartition & partition,
                const std::string & name );

      private:
	void configure(const daq::rc::TransitionCmd&);
                
	void prepareForRun(const daq::rc::TransitionCmd&);
                
	void stopArchiving(const daq::rc::TransitionCmd&);
        
	void unconfigure(const daq::rc::TransitionCmd&);
        
        void user(const daq::rc::UserCmd&);

      private:
	const std::string		m_connect_string;
	const IPCPartition		m_partition;
	const std::string		m_name;
        std::unique_ptr<Configuration>	m_config;
    };
}
