#ifndef RESULT_H
#define RESULT_H

#include <is/info.h>

#include <dqmf/is/Tag.h>
#include <string>
#include <ostream>
#include <vector>


// <<BeginUserCode>>

// <<EndUserCode>>

namespace dqmf
{

namespace is
{
/**
 * 
 * @author  generated by the IS tool
 * @version 01/11/10
 */

class Result : public ISInfo {
public:
    enum Status {Disabled=-1,Undefined,Red,Yellow,Green};


    /**
     * Describes the overall status of a particular DQM Parameter
     */
    Status                        status;

    /**
     * List of ids which can be used for locating the TObject objects produced by DQ algorithm as part of this DQ result.
     */
    std::vector<std::string>      objects;

    /**
     */
    std::vector<Tag>              tags;


    static const ISType & type() {
	static const ISType type_ = Result( ).ISInfo::type();
	return type_;
    }

    virtual std::ostream & print( std::ostream & out ) const {
	ISInfo::print( out );
	out << "status: " << status << "	//Describes the overall status of a particular DQM Parameter" << std::endl;
	out << "objects[" << objects.size() << "]:	//List of ids which can be used for locating the TObject objects produced by DQ algorithm as part of this DQ result." << std::endl;
	for ( size_t i = 0; i < objects.size(); ++i )
	    out << i << ": " << objects[i] << std::endl;
	out << "tags[" << tags.size() << "]:	//" << std::endl;
	for ( size_t i = 0; i < tags.size(); ++i )
	    out << i << ": " << tags[i] << std::endl;
	return out;
    }

    Result( )
      : ISInfo( "Result" )
    {
	initialize();
    }

    ~Result(){

// <<BeginUserCode>>

// <<EndUserCode>>
    }

protected:
    Result( const std::string & type )
      : ISInfo( type )
    {
	initialize();
    }

    void publishGuts( ISostream & out ){
	out << status << objects << tags;
    }

    void refreshGuts( ISistream & in ){
	in >> status >> objects >> tags;
    }

private:
    void initialize()
    {
	status = Undefined;

// <<BeginUserCode>>

// <<EndUserCode>>
    }


// <<BeginUserCode>>

// <<EndUserCode>>
};

// <<BeginUserCode>>

// <<EndUserCode>>
inline std::ostream & operator<<( std::ostream & out, const Result & info ) {
    info.print( out );
    return out;
}

}

}

#endif // RESULT_H
