/*
 * ClientThread.h
 *
 *  Created on: Jun 26, 2020
 *      Author: kolos
 */

#ifndef FELIX_PROXY_CLIENTTHREAD_H_
#define FELIX_PROXY_CLIENTTHREAD_H_

#include <memory>

#include <felix/felix_client_thread_interface.hpp>

namespace felix_proxy {
    class ClientThread: public FelixClientThreadInterface {

    public:
        explicit ClientThread(const Config &config);
        ~ClientThread();

        void send_data(uint64_t elink_id, const uint8_t *data, size_t size, bool flush) override;

        void subscribe(uint64_t elink_id) override;

        void unsubscribe(uint64_t elink_id) override;

        void exec(const UserFunction &user_function) override;

    private:
        void * m_lib_handler;
        std::unique_ptr<FelixClientThreadInterface> m_implementation;
    };
}

#endif /* FELIX_PROXY_CLIENTTHREAD_H_ */
