////////////////////////////////////////////////////////////////////////////
//      factory.h
//
//      Implementation of the IPC proxy application
//
//      Sergei Kolos August 2007
//
//      description:
//              This file contains implementation of the IPC proxy factory
//
////////////////////////////////////////////////////////////////////////////

#ifndef IPC_PROXY_FACTORY_H
#define IPC_PROXY_FACTORY_H

#include <ipc/object.h>
#include <ipc/proxy/factorybase.h>
#include <ipc/proxy/manager.h>
#include <ipc/proxy/object.h>

template <class I, class POA_I, template <class > class POA_I_tie>
class IPCProxyFactory : public IPCProxyFactoryBase
{
    typedef IPCProxyObject<I,POA_I,POA_I_tie> Object;
    
  public:
    
    IPCProxyFactory( )
      : interface_( I::_PD_repoId )
    {
    	IPCSingleton<IPCProxyManager>::instance().registerFactory( this );
    }
            
    IPCProxyObjectBase * create( const char * ior )
    {
	return new Object( ior );
    }
    
    const std::string & interfaceId( )
    {
    	return interface_;
    };
    
  private:
    std::string interface_;
};

#endif
