SHELL = /bin/sh

#########################################################
#	Header files
#########################################################

INCLUDES	= -I. -I${TDAQ_INST_PATH}/include -I${TDAQ_INST_PATH}/${CMTCONFIG}/include \
		  -I. -I${TDAQC_INST_PATH}/include

#########################################################
#	Socket libraries (platform dependant)
#########################################################

#Uncomment this for Solaris
#SOCKET_LIBS 	=  -lsocket

SOCKET_LIBS 	= 

#########################################################
#	Thread library (platform dependant)
#########################################################

#Uncomment this for Solaris
#THREAD_LIB 	=  -lthread

#Uncomment this for LynxOS
#THREAD_LIB 	=  -mthreads

#Uncomment this for Linux
THREAD_LIB 	= -lpthread

#########################################################
#	Online libraries
#########################################################

LIBDIR 		= -L${TDAQ_INST_PATH}/${CMTCONFIG}/lib -L${TDAQC_INST_PATH}/${CMTCONFIG}/lib
LIBS 		= -lcmdline -lis -lipc -lowl ${SOCKET_LIBS} ${THREAD_LIB}

#########################################################
#	CC Flags 
#########################################################
#Uncomment this for Solaris 2.6
#CCFLAGS 	= 

#Uncomment this for Linux
CCFLAGS  	= -D_GNU_SOURCE -fPIC -m32 -ansi -pedantic -Wno-long-long

#########################################################
#	Compiler 
#########################################################

#Uncomment this for Solaris
#CC 		= CC ${CCFLAGS}

#Uncomment this for the other platforms
CC 		= g++ ${CCFLAGS}

#########################################################
#	Build 
#########################################################

all: create_info

create_info : PersonNamed.h EmployeeNamed.h create_info.o 
	${CC} -o create_info create_info.o ${LIBDIR} ${LIBS}

#########################################################
#	generation target
#########################################################
PersonNamed.h EmployeeNamed.h : ../data/example.xml
	is_generator.sh -cpp -n ../data/example.xml

%.o : %.cc
	${CC} ${INCLUDES} -c $< -o $@


#########################################################
#	clean target
#########################################################

clean:
	rm -f *.o create_info
	
