#ifndef AXIS_H
#define AXIS_H

#include <is/info.h>

#include <string>
#include <ostream>
#include <vector>


// <<BeginUserCode>>

// <<EndUserCode>>

namespace oh
{
/**
 * This class is used to describe histogram axis
 * 
 * @author  generated by the IS tool
 * @version 06/05/19
 */

class Axis : public ISInfo {
public:
    enum Kind { NoAxis, Fixed, Variable };


    /**
     * Type of this axis
     */
    Kind                              kind;

    /**
     * Number of bins
     */
    int                               nbins;

    /**
     * Title of this axis
     */
    std::string                       title;

    /**
     * Axis range (contents depends on axis type)
     */
    std::vector<double>               range;

    /**
     * Indices of labeled bins
     */
    std::vector<int>                  indices;

    /**
     * Labels for this axis
     */
    std::vector<std::string>          labels;


    static const ISType & type() {
	static const ISType type_ = Axis( ).ISInfo::type();
	return type_;
    }

    virtual std::ostream & print( std::ostream & out ) const {
	ISInfo::print( out );
	out << std::endl;
	out << "kind: " << kind << "\t// Type of this axis" << std::endl;
	out << "nbins: " << nbins << "\t// Number of bins" << std::endl;
	out << "title: " << title << "\t// Title of this axis" << std::endl;
	out << "range[" << range.size() << "]:\t// Axis range (contents depends on axis type)" << std::endl;
	for ( size_t i = 0; i < range.size(); ++i )
	    out << i << " : " << range[i] << std::endl;
	out << "indices[" << indices.size() << "]:\t// Indices of labeled bins" << std::endl;
	for ( size_t i = 0; i < indices.size(); ++i )
	    out << i << " : " << indices[i] << std::endl;
	out << "labels[" << labels.size() << "]:\t// Labels for this axis" << std::endl;
	for ( size_t i = 0; i < labels.size(); ++i )
	    out << i << " : " << labels[i] << std::endl;
	return out;
    }

    Axis( )
      : ISInfo( "Axis" )
    {
	initialize();
    }

    ~Axis(){

// <<BeginUserCode>>

// <<EndUserCode>>
    }

protected:
    Axis( const std::string & type )
      : ISInfo( type )
    {
	initialize();
    }

    void publishGuts( ISostream & out ){
	out << kind << nbins << title << range << indices << labels;
    }

    void refreshGuts( ISistream & in ){
	in >> kind >> nbins >> title >> range >> indices >> labels;
    }

private:
    void initialize()
    {

// <<BeginUserCode>>

// <<EndUserCode>>
    }


// <<BeginUserCode>>
public:
    enum ID { X, Y, Z };

// <<EndUserCode>>
};

// <<BeginUserCode>>

// <<EndUserCode>>
inline std::ostream & operator<<( std::ostream & out, const Axis & info ) {
    info.print( out );
    return out;
}

}

#endif // AXIS_H
