#ifndef GRAPH2D_H
#define GRAPH2D_H

#include <oh/core/Object.h>
#include <string>
#include <ostream>
#include <vector>


// <<BeginUserCode>>

// <<EndUserCode>>

namespace oh
{
/**
 * Used to store 2 dimensional graphs in the IS
 * 
 * @author  generated by the IS tool
 * @version 06/05/19
 */

class Graph2D : public Object {
public:
    enum ErrorStyle {None,Symmetric};


    /**
     * Optional error values for the points
     */
    std::vector<double>                        errors;

    /**
     * How to use the errors: None(TGraph2D), Symmetric(TGraph2DErrors)
     */
    ErrorStyle                                 errorStyle;

    /**
     * Values of all the points in the graph
     */
    std::vector<double>                        points;


    static const ISType & type() {
	static const ISType type_ = Graph2D( ).ISInfo::type();
	return type_;
    }

    virtual std::ostream & print( std::ostream & out ) const {
	Object::print( out );
	out << std::endl;
	out << "errors[" << errors.size() << "]:\t// Optional error values for the points" << std::endl;
	for ( size_t i = 0; i < errors.size(); ++i )
	    out << i << " : " << errors[i] << std::endl;
	out << "errorStyle: " << errorStyle << "\t// How to use the errors: None(TGraph2D), Symmetric(TGraph2DErrors)" << std::endl;
	out << "points[" << points.size() << "]:\t// Values of all the points in the graph" << std::endl;
	for ( size_t i = 0; i < points.size(); ++i )
	    out << i << " : " << points[i] << std::endl;
	return out;
    }

    Graph2D( )
      : Object( "Graph2D" )
    {
	initialize();
    }

    ~Graph2D(){

// <<BeginUserCode>>

// <<EndUserCode>>
    }

protected:
    Graph2D( const std::string & type )
      : Object( type )
    {
	initialize();
    }

    void publishGuts( ISostream & out ){
	Object::publishGuts( out );
	out << errors << errorStyle << points;
    }

    void refreshGuts( ISistream & in ){
	Object::refreshGuts( in );
	in >> errors >> errorStyle >> points;
    }

private:
    void initialize()
    {
	errorStyle = None;

// <<BeginUserCode>>

// <<EndUserCode>>
    }


// <<BeginUserCode>>
  public:
    static const unsigned int dimension = 2;

// <<EndUserCode>>
};

// <<BeginUserCode>>

// <<EndUserCode>>
inline std::ostream & operator<<( std::ostream & out, const Graph2D & info ) {
    info.print( out );
    return out;
}

}

#endif // GRAPH2D_H
