#ifndef HISTOGRAM_H
#define HISTOGRAM_H

#include <oh/core/Object.h>
#include <string>
#include <ostream>
#include <vector>


// <<BeginUserCode>>

// <<EndUserCode>>

namespace oh
{
/**
 * This class is used to store histograms in the IS
 * 
 * @author  generated by the IS tool
 * @version 06/05/19
 */

class Histogram : public Object {
public:
    enum Dimension { D1 = 1, D2, D3 };


    /**
     * Histogram dimension
     */
    Dimension                                  dimension;

    /**
     * Optional error values for the bins
     */
    std::vector<double>                        errors;

    /**
     * Statistics values
     */
    std::vector<double>                        statistics;


    static const ISType & type() {
	static const ISType type_ = Histogram( ).ISInfo::type();
	return type_;
    }

    virtual std::ostream & print( std::ostream & out ) const {
	Object::print( out );
	out << std::endl;
	out << "dimension: " << dimension << "\t// Histogram dimension" << std::endl;
	out << "errors[" << errors.size() << "]:\t// Optional error values for the bins" << std::endl;
	for ( size_t i = 0; i < errors.size(); ++i )
	    out << i << " : " << errors[i] << std::endl;
	out << "statistics[" << statistics.size() << "]:\t// Statistics values" << std::endl;
	for ( size_t i = 0; i < statistics.size(); ++i )
	    out << i << " : " << statistics[i] << std::endl;
	return out;
    }

    Histogram( )
      : Object( "Histogram" )
    {
	initialize();
    }

    ~Histogram(){

// <<BeginUserCode>>

// <<EndUserCode>>
    }

protected:
    Histogram( const std::string & type )
      : Object( type )
    {
	initialize();
    }

    void publishGuts( ISostream & out ){
	Object::publishGuts( out );
	out << dimension << errors << statistics;
    }

    void refreshGuts( ISistream & in ){
	Object::refreshGuts( in );
	in >> dimension >> errors >> statistics;
    }

private:
    void initialize()
    {

// <<BeginUserCode>>

// <<EndUserCode>>
    }


// <<BeginUserCode>>

// <<EndUserCode>>
};

// <<BeginUserCode>>

// <<EndUserCode>>
inline std::ostream & operator<<( std::ostream & out, const Histogram & info ) {
    info.print( out );
    return out;
}

}

#endif // HISTOGRAM_H
