#ifndef OBJECT_H
#define OBJECT_H

#include <is/info.h>

#include <oh/core/Axis.h>
#include <string>
#include <ostream>
#include <vector>


// <<BeginUserCode>>

// <<EndUserCode>>

namespace oh
{
/**
 * This class is used to distinguish OH objects from any other IS ones
 * 
 * @author  generated by the IS tool
 * @version 06/05/19
 */

class Object : public ISInfo {
public:

    /**
     * Object title
     */
    std::string                                title;

    /**
     * Number of entries
     */
    uint64_t                                   entries;

    /**
     * Axes for this object
     */
    std::vector<Axis>                          axes;


    static const ISType & type() {
	static const ISType type_ = Object( ).ISInfo::type();
	return type_;
    }

    virtual std::ostream & print( std::ostream & out ) const {
	ISInfo::print( out );
	out << std::endl;
	out << "title: " << title << "\t// Object title" << std::endl;
	out << "entries: " << entries << "\t// Number of entries" << std::endl;
	out << "axes[" << axes.size() << "]:\t// Axes for this object" << std::endl;
	for ( size_t i = 0; i < axes.size(); ++i )
	    out << i << " : " << axes[i] << std::endl;
	return out;
    }

    Object( )
      : ISInfo( "Object" )
    {
	initialize();
    }

    ~Object(){

// <<BeginUserCode>>

// <<EndUserCode>>
    }

protected:
    Object( const std::string & type )
      : ISInfo( type )
    {
	initialize();
    }

    void publishGuts( ISostream & out ){
	out << title << entries << axes;
    }

    void refreshGuts( ISistream & in ){
	in >> title >> entries >> axes;
    }

private:
    void initialize()
    {

// <<BeginUserCode>>

// <<EndUserCode>>
    }


// <<BeginUserCode>>

// <<EndUserCode>>
};

// <<BeginUserCode>>

// <<EndUserCode>>
inline std::ostream & operator<<( std::ostream & out, const Object & info ) {
    info.print( out );
    return out;
}

}

#endif // OBJECT_H
