/*
 * TTraits.h
 *
 *  Created on: Apr 12, 2019
 *      Author: kolos
 */

#ifndef OH_CORE_TTRAITS_H_
#define OH_CORE_TTRAITS_H_

#include <TH2.h>
#include <TH3.h>
#include <TProfile.h>
#include <TProfile2D.h>
#include <TProfile3D.h>

namespace oh {
    template<typename T>
    struct TTraits;

    template<> struct TTraits<TH1C> {
        typedef char Type;
        enum _void_ { StatsSize = 4 };
    };
    template<> struct TTraits<TH1S> {
        typedef short Type;
        enum _void_ { StatsSize = 4 };
    };
    template<> struct TTraits<TH1I> {
        typedef int Type;
        enum _void_ { StatsSize = 4 };
    };
    template<> struct TTraits<TH1F> {
        typedef float Type;
        enum _void_ { StatsSize = 4 };
    };
    template<> struct TTraits<TH1D> {
        typedef double Type;
        enum _void_ { StatsSize = 4 };
    };
    template<> struct TTraits<TProfile> {
        typedef double Type;
        enum _void_ { StatsSize = 6 };
    };

    template<> struct TTraits<TH2C> {
        typedef char Type;
        enum _void_ { StatsSize = 7 };
    };
    template<> struct TTraits<TH2S> {
        typedef short Type;
        enum _void_ { StatsSize = 7 };
    };
    template<> struct TTraits<TH2I> {
        typedef int Type;
        enum _void_ { StatsSize = 7 };
    };
    template<> struct TTraits<TH2F> {
        typedef float Type;
        enum _void_ { StatsSize = 7 };
   };
    template<> struct TTraits<TH2D> {
        typedef double Type;
        enum _void_ { StatsSize = 7 };
    };
    template<> struct TTraits<TProfile2D> {
        typedef double Type;
        enum _void_ { StatsSize = 9 };
    };

    template<> struct TTraits<TH3C> {
        typedef char Type;
        enum _void_ { StatsSize = 11 };
    };
    template<> struct TTraits<TH3S> {
        typedef short Type;
        enum _void_ { StatsSize = 11 };
    };
    template<> struct TTraits<TH3I> {
        typedef int Type;
        enum _void_ { StatsSize = 11 };
    };
    template<> struct TTraits<TH3F> {
        typedef float Type;
        enum _void_ { StatsSize = 11 };
    };
    template<> struct TTraits<TH3D> {
        typedef double Type;
        enum _void_ { StatsSize = 11 };
    };
    template<> struct TTraits<TProfile3D> {
        typedef double Type;
        enum _void_ { StatsSize = 13 };
    };
}

#endif /* OH_CORE_TTRAITS_H_ */
