/*!
    \page main Online Histogramming Developer's Manual
    
    This manual contains information about the OH core in addition to what
    is available in the public manual, some sourcecode to the OH is also
    included.
    
    The core contains parts of the OH which should not be used directly 
    by histogram provider tasks or user histogram tasks and this documentation
    is primarly for maintenance purpose or people who intend to extend the OH
    by adding histogram import or export functionality.
    
    \section extending Extending the OH
    
    The OH core is designed to provide a generic interface for histogram
    representation, selection and transportation. The core provides a
    foundation for importing and exporting histograms, the actual user
    interfaces are provided by specific provider and receiver classes in the
    public package.

    \subsection providers Adding a provider class to the OH
    
    Check the documentation for OHHistogramProvider to find out how to add a
    new provider class. Also check the implementation of the currently existing
    provider classes
    - OHRawProvider
    - OHRootProvider
    
    \subsection receivers Adding a receiver class to the OH
    
    Check the documentation for OHHistogramReceiver to find out how to add a
    new receiver class. Also check the implementation of the currently existing
    receiver classes
    - OHRootReceiver

    \section nameconventions Naming conventions
    
    The unique identifier used to identify a histogram or set of histograms
    currently has the following structure:
    
    servername.OH:providername:histogramname:YYYYMMDDhhmmss:counter
    
    Where servername is the name of an OH (IS) server, providername is the name
    of the provider who published the histogram, histogramname is a name
    describing the histogram and YYYYMMDDhhmmss is the time when the
    histogram was published. Counter is a 'collision counter' used to make
    the identifier unique, the value of this counter does NOT imply a specific
    ordering among histograms with otherwise identical identifiers.
    
    The histogram providers publish their name in the OH (IS) server which
    they belong to upon construction, the name is published as an instance
    of the HistogramProvider information type with the following name:
    
    servername.providername
    
    Where servername is the name of an IS server, providername is the name
    of the provider who is activated. The information type is removed from
    the server when the provider is destroyed.
    IMPORTANT: Provider name must not contain '.' symbol!

*/
