#ifndef CONFIGVERSIONS_H
#define CONFIGVERSIONS_H

#include <is/info.h>

#include <string>
#include <ostream>


// <<BeginUserCode>>

// <<EndUserCode>>

/**
 * The class is used to store archive versions of the OKS database used for given run.
 * 
 * @author  generated by the IS tool
 * @version 02/07/13
 */

class ConfigVersions : public ISInfo {
public:

    /**
     * The version of the schema from OKS Archive.
     */
    int                           SchemaVersion;

    /**
     * The version of the data from OKS Archive.
     */
    int                           DataVersion;


    static const ISType & type() {
	static const ISType type_ = ConfigVersions( ).ISInfo::type();
	return type_;
    }

    virtual std::ostream & print( std::ostream & out ) const {
	ISInfo::print( out );
	out << std::endl;
	out << "SchemaVersion: " << SchemaVersion << "\t// The version of the schema from OKS Archive." << std::endl;
	out << "DataVersion: " << DataVersion << "\t// The version of the data from OKS Archive.";
	return out;
    }

    ConfigVersions( )
      : ISInfo( "ConfigVersions" )
    {
	initialize();
    }

    ~ConfigVersions(){

// <<BeginUserCode>>

// <<EndUserCode>>
    }

protected:
    ConfigVersions( const std::string & type )
      : ISInfo( type )
    {
	initialize();
    }

    void publishGuts( ISostream & out ){
	out << SchemaVersion << DataVersion;
    }

    void refreshGuts( ISistream & in ){
	in >> SchemaVersion >> DataVersion;
    }

private:
    void initialize()
    {

// <<BeginUserCode>>

// <<EndUserCode>>
    }


// <<BeginUserCode>>

// <<EndUserCode>>
};

// <<BeginUserCode>>

// <<EndUserCode>>
inline std::ostream & operator<<( std::ostream & out, const ConfigVersions & info ) {
    info.print( out );
    return out;
}

#endif // CONFIGVERSIONS_H
