#ifndef OWL_MUTEXRW_H
#define OWL_MUTEXRW_H

#include <pthread.h>

class [[deprecated("Use std::shared_mutex instead")]] OWLMutexRW
{
    pthread_rwlock_t lock_;
  
    OWLMutexRW( const OWLMutexRW & );
    OWLMutexRW & operator=( const OWLMutexRW & );
  
public:

    OWLMutexRW ( );
  
    ~OWLMutexRW ( );

    void read_lock ( );
    bool try_read_lock ( );
    bool try_write_lock ( );
    void unlock ( );
    void write_lock ( );
};

class OWLMutexRLock 
{
    OWLMutexRW & lock_;
  
    OWLMutexRLock( const OWLMutexRLock & );
    OWLMutexRLock & operator=( const OWLMutexRLock & );
  
public:
    OWLMutexRLock( OWLMutexRW& mutex ) : lock_( mutex ) { lock_.read_lock( ); }
  
    ~OWLMutexRLock( ) { lock_.unlock(); }
};

class OWLMutexWLock 
{
    OWLMutexRW & lock_;
    
    OWLMutexWLock( const OWLMutexWLock & );
    OWLMutexWLock & operator=( const OWLMutexWLock & );
public:
    OWLMutexWLock( OWLMutexRW & mutex ) : lock_( mutex ) { lock_.write_lock( ); }
  
    ~OWLMutexWLock( ) { lock_.unlock(); }
};

class OWLMutexTryWLock 
{
    OWLMutexRW & lock_;
    const bool acquired_;
    
    OWLMutexTryWLock( const OWLMutexWLock & );
    OWLMutexTryWLock & operator=( const OWLMutexWLock & );
public:
    OWLMutexTryWLock( OWLMutexRW & mutex ) 
      : lock_( mutex ), acquired_ ( lock_.try_write_lock( ) ) { ; }
  
    ~OWLMutexTryWLock( ) { if ( acquired_ ) lock_.unlock(); }
    
    bool acquired() const { return acquired_; }
};

class OWLMutexTryRLock 
{
    OWLMutexRW & lock_;
    const bool acquired_;
    
    OWLMutexTryRLock( const OWLMutexRLock & );
    OWLMutexTryRLock & operator=( const OWLMutexRLock & );
public:
    OWLMutexTryRLock( OWLMutexRW & mutex ) 
      : lock_( mutex ), acquired_ ( lock_.try_write_lock( ) ) { ; }
  
    ~OWLMutexTryRLock( ) { if ( acquired_ ) lock_.unlock(); }
    
    bool acquired() const { return acquired_; }
};

#endif
