#ifndef PBEASTREPOSITORYSERVERMON_H
#define PBEASTREPOSITORYSERVERMON_H

#include <is/info.h>

#include <string>
#include <ostream>


// <<BeginUserCode>>

// <<EndUserCode>>
/**
 * Monitoring information published by P-BEAST repository server application
 * 
 * @author  generated by the IS tool
 * @version 28/05/18
 */

class PBeastRepositoryServerMon : public ISInfo {
public:

    /**
     * Number of get downsample data calls per second
     */
    double                        num_of_ds_calls;

    /**
     * Number of get raw data calls per second
     */
    double                        num_of_raw_calls;

    /**
     * Average time of get downsample data call (in milliseconds)
     */
    double                        avearge_time_of_ds_call;

    /**
     * Average time of get raw data call (in milliseconds)
     */
    double                        avearge_time_of_raw_call;

    /**
     * Maximum time of get downsample data call (in milliseconds)
     */
    double                        max_time_of_ds_call;

    /**
     * Maximum time of get raw data call (in milliseconds)
     */
    double                        max_time_of_raw_call;

    /**
     * Number of returned downsample objects per second
     */
    double                        num_of_ds_objects;

    /**
     * Number of returned raw objects per second
     */
    double                        num_of_raw_objects;

    /**
     * Number of returned downsample data points per second
     */
    double                        num_of_ds_data_points;

    /**
     * Number of returned raw data points per second
     */
    double                        num_of_raw_data_points;

    /**
     * Size of returned downsample data (excluding timestamps) per second
     */
    double                        size_of_ds_data;

    /**
     * Size of returned raw data (excluding timestamps) per second
     */
    double                        size_of_raw_data;

    /**
     * Number of read data files per second
     */
    double                        num_of_data_files;

    /**
     * Number of read void files per second
     */
    double                        num_of_void_files;

    /**
     * Number of downsampled files per second
     */
    double                        num_of_downsampled_files;

    /**
     * Size of written downsampled files per second
     */
    double                        size_of_downsampled_files;

    /**
     * Size of read file headers per second
     */
    double                        size_of_read_headers;

    /**
     * Number of info series cache hits per second
     */
    double                        num_of_info_series_cache_hits;

    /**
     * Size of info series read from cache
     */
    double                        size_of_info_series_cache_hits;

    /**
     * Number of read primitive data items per second
     */
    double                        num_of_primitive_data_reads;

    /**
     * Number of void item reads per second
     */
    double                        num_of_void_timestamps_reads;

    /**
     * Size of info series in-memory cache
     */
    uint64_t                      info_series_cache_size;

    /**
     * Size of downsample data cache
     */
    uint64_t                      downsampled_data_cache_size;


    static const ISType & type() {
	static const ISType type_ = PBeastRepositoryServerMon( ).ISInfo::type();
	return type_;
    }

    virtual std::ostream & print( std::ostream & out ) const {
	ISInfo::print( out );
	out << std::endl;
	out << "num_of_ds_calls: " << num_of_ds_calls << "\t// Number of get downsample data calls per second" << std::endl;
	out << "num_of_raw_calls: " << num_of_raw_calls << "\t// Number of get raw data calls per second" << std::endl;
	out << "avearge_time_of_ds_call: " << avearge_time_of_ds_call << "\t// Average time of get downsample data call (in milliseconds)" << std::endl;
	out << "avearge_time_of_raw_call: " << avearge_time_of_raw_call << "\t// Average time of get raw data call (in milliseconds)" << std::endl;
	out << "max_time_of_ds_call: " << max_time_of_ds_call << "\t// Maximum time of get downsample data call (in milliseconds)" << std::endl;
	out << "max_time_of_raw_call: " << max_time_of_raw_call << "\t// Maximum time of get raw data call (in milliseconds)" << std::endl;
	out << "num_of_ds_objects: " << num_of_ds_objects << "\t// Number of returned downsample objects per second" << std::endl;
	out << "num_of_raw_objects: " << num_of_raw_objects << "\t// Number of returned raw objects per second" << std::endl;
	out << "num_of_ds_data_points: " << num_of_ds_data_points << "\t// Number of returned downsample data points per second" << std::endl;
	out << "num_of_raw_data_points: " << num_of_raw_data_points << "\t// Number of returned raw data points per second" << std::endl;
	out << "size_of_ds_data: " << size_of_ds_data << "\t// Size of returned downsample data (excluding timestamps) per second" << std::endl;
	out << "size_of_raw_data: " << size_of_raw_data << "\t// Size of returned raw data (excluding timestamps) per second" << std::endl;
	out << "num_of_data_files: " << num_of_data_files << "\t// Number of read data files per second" << std::endl;
	out << "num_of_void_files: " << num_of_void_files << "\t// Number of read void files per second" << std::endl;
	out << "num_of_downsampled_files: " << num_of_downsampled_files << "\t// Number of downsampled files per second" << std::endl;
	out << "size_of_downsampled_files: " << size_of_downsampled_files << "\t// Size of written downsampled files per second" << std::endl;
	out << "size_of_read_headers: " << size_of_read_headers << "\t// Size of read file headers per second" << std::endl;
	out << "num_of_info_series_cache_hits: " << num_of_info_series_cache_hits << "\t// Number of info series cache hits per second" << std::endl;
	out << "size_of_info_series_cache_hits: " << size_of_info_series_cache_hits << "\t// Size of info series read from cache" << std::endl;
	out << "num_of_primitive_data_reads: " << num_of_primitive_data_reads << "\t// Number of read primitive data items per second" << std::endl;
	out << "num_of_void_timestamps_reads: " << num_of_void_timestamps_reads << "\t// Number of void item reads per second" << std::endl;
	out << "info_series_cache_size: " << info_series_cache_size << "\t// Size of info series in-memory cache" << std::endl;
	out << "downsampled_data_cache_size: " << downsampled_data_cache_size << "\t// Size of downsample data cache";
	return out;
    }

    PBeastRepositoryServerMon( )
      : ISInfo( "PBeastRepositoryServerMon" )
    {
	initialize();
    }

    ~PBeastRepositoryServerMon(){

// <<BeginUserCode>>

// <<EndUserCode>>
    }

protected:
    PBeastRepositoryServerMon( const std::string & type )
      : ISInfo( type )
    {
	initialize();
    }

    void publishGuts( ISostream & out ){
	out << num_of_ds_calls << num_of_raw_calls << avearge_time_of_ds_call << avearge_time_of_raw_call;
	out << max_time_of_ds_call << max_time_of_raw_call << num_of_ds_objects << num_of_raw_objects;
	out << num_of_ds_data_points << num_of_raw_data_points << size_of_ds_data << size_of_raw_data;
	out << num_of_data_files << num_of_void_files << num_of_downsampled_files << size_of_downsampled_files;
	out << size_of_read_headers << num_of_info_series_cache_hits << size_of_info_series_cache_hits;
	out << num_of_primitive_data_reads << num_of_void_timestamps_reads << info_series_cache_size;
	out << downsampled_data_cache_size;
    }

    void refreshGuts( ISistream & in ){
	in >> num_of_ds_calls >> num_of_raw_calls >> avearge_time_of_ds_call >> avearge_time_of_raw_call;
	in >> max_time_of_ds_call >> max_time_of_raw_call >> num_of_ds_objects >> num_of_raw_objects;
	in >> num_of_ds_data_points >> num_of_raw_data_points >> size_of_ds_data >> size_of_raw_data;
	in >> num_of_data_files >> num_of_void_files >> num_of_downsampled_files >> size_of_downsampled_files;
	in >> size_of_read_headers >> num_of_info_series_cache_hits >> size_of_info_series_cache_hits;
	in >> num_of_primitive_data_reads >> num_of_void_timestamps_reads >> info_series_cache_size;
	in >> downsampled_data_cache_size;
    }

private:
    void initialize()
    {

// <<BeginUserCode>>

// <<EndUserCode>>
    }


// <<BeginUserCode>>

// <<EndUserCode>>
};

// <<BeginUserCode>>

// <<EndUserCode>>
inline std::ostream & operator<<( std::ostream & out, const PBeastRepositoryServerMon & info ) {
    info.print( out );
    return out;
}

#endif // PBEASTREPOSITORYSERVERMON_H
