#ifndef PBEASTSERVERUSERMON_H
#define PBEASTSERVERUSERMON_H

#include <is/info.h>

#include <string>
#include <ostream>


// <<BeginUserCode>>

// <<EndUserCode>>
/**
 * Monitoring information published by P-BEAST server application per user
 * 
 * @author  generated by the IS tool
 * @version 06/10/17
 */

class PBeastServerUserMon : public ISInfo {
public:

    /**
     * Number of requests per second
     */
    float                         num_of_requests;

    /**
     * Average size of returned data since last publication
     */
    uint64_t                      average_size_of_data_per_inteval;

    /**
     * Maximum size of returned data since last publication
     */
    uint64_t                      max_size_of_data_per_inteval;

    /**
     * Average processing time since last publication (in milliseconds)
     */
    uint64_t                      average_processing_time_per_inteval;

    /**
     * Maximum processing time since last publication (in milliseconds)
     */
    uint64_t                      max_processing_time_per_inteval;

    /**
     * Total number of requests
     */
    uint64_t                      total_num_of_requests;

    /**
     * Total size of returned data
     */
    uint64_t                      total_size_of_data;

    /**
     * Maximum size of returned data
     */
    uint64_t                      max_size_of_data;

    /**
     * Total processing time (in milliseconds)
     */
    uint64_t                      total_processing_time;

    /**
     * Maximum processing time (in milliseconds)
     */
    uint64_t                      max_processing_time;


    static const ISType & type() {
	static const ISType type_ = PBeastServerUserMon( ).ISInfo::type();
	return type_;
    }

    virtual std::ostream & print( std::ostream & out ) const {
	ISInfo::print( out );
	out << std::endl;
	out << "num_of_requests: " << num_of_requests << "\t// Number of requests per second" << std::endl;
	out << "average_size_of_data_per_inteval: " << average_size_of_data_per_inteval << "\t// Average size of returned data since last publication" << std::endl;
	out << "max_size_of_data_per_inteval: " << max_size_of_data_per_inteval << "\t// Maximum size of returned data since last publication" << std::endl;
	out << "average_processing_time_per_inteval: " << average_processing_time_per_inteval << "\t// Average processing time since last publication (in milliseconds)" << std::endl;
	out << "max_processing_time_per_inteval: " << max_processing_time_per_inteval << "\t// Maximum processing time since last publication (in milliseconds)" << std::endl;
	out << "total_num_of_requests: " << total_num_of_requests << "\t// Total number of requests" << std::endl;
	out << "total_size_of_data: " << total_size_of_data << "\t// Total size of returned data" << std::endl;
	out << "max_size_of_data: " << max_size_of_data << "\t// Maximum size of returned data" << std::endl;
	out << "total_processing_time: " << total_processing_time << "\t// Total processing time (in milliseconds)" << std::endl;
	out << "max_processing_time: " << max_processing_time << "\t// Maximum processing time (in milliseconds)";
	return out;
    }

    PBeastServerUserMon( )
      : ISInfo( "PBeastServerUserMon" )
    {
	initialize();
    }

    ~PBeastServerUserMon(){

// <<BeginUserCode>>

// <<EndUserCode>>
    }

protected:
    PBeastServerUserMon( const std::string & type )
      : ISInfo( type )
    {
	initialize();
    }

    void publishGuts( ISostream & out ){
	out << num_of_requests << average_size_of_data_per_inteval << max_size_of_data_per_inteval;
	out << average_processing_time_per_inteval << max_processing_time_per_inteval << total_num_of_requests;
	out << total_size_of_data << max_size_of_data << total_processing_time << max_processing_time;
    }

    void refreshGuts( ISistream & in ){
	in >> num_of_requests >> average_size_of_data_per_inteval >> max_size_of_data_per_inteval;
	in >> average_processing_time_per_inteval >> max_processing_time_per_inteval >> total_num_of_requests;
	in >> total_size_of_data >> max_size_of_data >> total_processing_time >> max_processing_time;
    }

private:
    void initialize()
    {

// <<BeginUserCode>>

// <<EndUserCode>>
    }


// <<BeginUserCode>>

// <<EndUserCode>>
};

// <<BeginUserCode>>

// <<EndUserCode>>
inline std::ostream & operator<<( std::ostream & out, const PBeastServerUserMon & info ) {
    info.print( out );
    return out;
}

#endif // PBEASTSERVERUSERMON_H
