#ifndef PUDUMMYSTEERING_H
#define PUDUMMYSTEERING_H

#include <is/info.h>

#include <string>
#include <ostream>


// <<BeginUserCode>>
/**
 * IS information for the PuDummySteering.
*/
// <<EndUserCode>>
/**
 * 
 * @author  generated by the IS tool
 * @version 16/11/15
 */

class PuDummySteering : public ISInfo {
public:

    /**
     * Last processed LVL1 ID
     */
    uint64_t                      last_lvl1_id;

    /**
     * Number of LVL1 events
     */
    uint64_t                      lvl1_events;

    /**
     * Number of accepted events
     */
    uint64_t                      accepted;

    /**
     * Number of rejected events
     */
    uint64_t                      rejected;

    /**
     * Number of events not processed
     */
    unsigned int                  not_processed;

    /**
     * Number processing timeouts
     */
    unsigned int                  processing_timeout;

    /**
     * Avg number of collected ROBs per accepted event
     */
    double                        avgROBsAcceptedEvent;

    /**
     * Avg number of collected ROBs per rejected event
     */
    double                        avgROBsRejectedEvent;

    /**
     * Avg number of steps per event
     */
    double                        stepsPerEvent;

    /**
     * Number of ROBs not available for RoI or Calibration data request
     */
    uint64_t                      notEnoughROBs;

    /**
     * Number of accesses to an empty subdetector
     */
    uint64_t                      emptySubdetectorAccess;

    /**
     * Number of empty calibration tags
     */
    uint64_t                      emptyCalibrationTags;

    /**
     * Number of duplicate ROBs selected
     */
    uint64_t                      duplicateROBsSelected;


    static const ISType & type() {
	static const ISType type_ = PuDummySteering( ).ISInfo::type();
	return type_;
    }

    virtual std::ostream & print( std::ostream & out ) const {
	ISInfo::print( out );
	out << std::endl;
	out << "last_lvl1_id: " << last_lvl1_id << "\t// Last processed LVL1 ID" << std::endl;
	out << "lvl1_events: " << lvl1_events << "\t// Number of LVL1 events" << std::endl;
	out << "accepted: " << accepted << "\t// Number of accepted events" << std::endl;
	out << "rejected: " << rejected << "\t// Number of rejected events" << std::endl;
	out << "not_processed: " << not_processed << "\t// Number of events not processed" << std::endl;
	out << "processing_timeout: " << processing_timeout << "\t// Number processing timeouts" << std::endl;
	out << "avgROBsAcceptedEvent: " << avgROBsAcceptedEvent << "\t// Avg number of collected ROBs per accepted event" << std::endl;
	out << "avgROBsRejectedEvent: " << avgROBsRejectedEvent << "\t// Avg number of collected ROBs per rejected event" << std::endl;
	out << "stepsPerEvent: " << stepsPerEvent << "\t// Avg number of steps per event" << std::endl;
	out << "notEnoughROBs: " << notEnoughROBs << "\t// Number of ROBs not available for RoI or Calibration data request" << std::endl;
	out << "emptySubdetectorAccess: " << emptySubdetectorAccess << "\t// Number of accesses to an empty subdetector" << std::endl;
	out << "emptyCalibrationTags: " << emptyCalibrationTags << "\t// Number of empty calibration tags" << std::endl;
	out << "duplicateROBsSelected: " << duplicateROBsSelected << "\t// Number of duplicate ROBs selected";
	return out;
    }

    PuDummySteering( )
      : ISInfo( "PuDummySteering" )
    {
	initialize();
    }

    ~PuDummySteering(){

// <<BeginUserCode>>

// <<EndUserCode>>
    }

protected:
    PuDummySteering( const std::string & type )
      : ISInfo( type )
    {
	initialize();
    }

    void publishGuts( ISostream & out ){
	out << last_lvl1_id << lvl1_events << accepted << rejected << not_processed << processing_timeout;
	out << avgROBsAcceptedEvent << avgROBsRejectedEvent << stepsPerEvent << notEnoughROBs;
	out << emptySubdetectorAccess << emptyCalibrationTags << duplicateROBsSelected;
    }

    void refreshGuts( ISistream & in ){
	in >> last_lvl1_id >> lvl1_events >> accepted >> rejected >> not_processed >> processing_timeout;
	in >> avgROBsAcceptedEvent >> avgROBsRejectedEvent >> stepsPerEvent >> notEnoughROBs;
	in >> emptySubdetectorAccess >> emptyCalibrationTags >> duplicateROBsSelected;
    }

private:
    void initialize()
    {

// <<BeginUserCode>>
      last_lvl1_id = lvl1_events = accepted = rejected = not_processed = processing_timeout = notEnoughROBs = emptySubdetectorAccess = emptyCalibrationTags = duplicateROBsSelected = 0;
      avgROBsAcceptedEvent = avgROBsRejectedEvent = stepsPerEvent = 0.0;
// <<EndUserCode>>
    }


// <<BeginUserCode>>

// <<EndUserCode>>
};

// <<BeginUserCode>>

// <<EndUserCode>>
inline std::ostream & operator<<( std::ostream & out, const PuDummySteering & info ) {
    info.print( out );
    return out;
}

#endif // PUDUMMYSTEERING_H
