package test_rdb;

import ipc.*;
import rdb.*;
 
public class Test {

  public static void main(String args[]) {

    ipc.Partition p = new ipc.Partition();

    rdb.cursor read_cursor = null;

    try {
      read_cursor = (rdb.cursor)p.lookup( rdb.cursor.class, args[0] );
    }
    catch(ers.Issue ex) {
      ;
    }

    rdb.writer write_cursor = null;
    long write_session_id = 0;
    rdb.WriterPing cb = null;
    rdb.ProcessInfo proc_info = null;

    if ( read_cursor == null ) {
      try {
        write_cursor = (rdb.writer)p.lookup( rdb.writer.class, args[0] );
      }
      catch(ers.Issue ex) {
        ;
      }

      if(write_cursor == null) {
        System.err.println( "ERROR: can not find db server" );
        System.exit(1);
      }
      else {
        try {
          cb = new rdb.WriterPing();
          proc_info = rdb.CreateProcessInfo.get(null);
          write_session_id = write_cursor.open_session(proc_info, cb._this( ipc.Core.getORB() ));
          cb.set_session_id(write_session_id);
        }
        catch(org.omg.CORBA.SystemException ex) {
          System.err.println( "ERROR: rdb.writer.open_session() failed\n\twas caused by CORBA system exception " + ex.toString() );
          System.exit(1);
        }

      }
    }

    rdb.RDBClassListHolder list = new rdb.RDBClassListHolder();

    try {
      if(read_cursor != null) {
        read_cursor.get_all_classes( list );
      }
      else {
        write_cursor.get_all_classes( write_session_id, list );
      }
    }
    catch(rdb.SessionNotFound ex) {
      System.err.println( "ERROR: get_all_classes() failed\n\twas caused by rdb.SessionNotFound exception: session " + ex.session_id + " is not found" );
      System.exit(1);
    }
    catch(org.omg.CORBA.SystemException ex) {
      System.err.println( "ERROR: get_all_classes() failed\n\twas caused by CORBA system exception " + ex.toString() ); 
      System.exit(1);
    }

    System.out.println( "Classes in the \"" + args[0] + "\" database are :");

    for ( int i = 0; i < list.value.length; i++ ) {
      System.out.println( "  " + list.value[i].name );
    }

    if(write_cursor != null) {
      try {
        write_cursor.close_session( write_session_id, proc_info );
      }
      catch(rdb.SessionNotFound ex) {
        System.err.println( "ERROR: close_session() failed\n\twas caused by rdb.SessionNotFound exception: session " + ex.session_id + " is not found" );
        System.exit(1);
      }
      catch(org.omg.CORBA.SystemException ex) {
        System.err.println( "ERROR: close_session() failed\n\twas caused by CORBA system exception " + ex.toString() );
        System.exit(1);
      }
    }

	// Destroy remote database. This call stops the remote server
	// Do not do this under normal conditions

    // cursor.shutdown();
  }
}

