package rdb;

import java.net.InetAddress;
import java.io.File;
import java.io.IOException;


public final class CreateProcessInfo
{
  static public ProcessInfo get(String app_name)
  {
      // get username

    String user_id = System.getProperty("user.name");


      // get pid

    int process_id = 0;

    try {
      process_id = Integer.parseInt( ( new File("/proc/self")).getCanonicalFile().getName() );
    }
    catch (NumberFormatException e) {
      e.printStackTrace();
    }
    catch (IOException e) {
      e.printStackTrace();
    }


      // get hostname

    String hostname = null;
    try {
      hostname = java.net.InetAddress.getLocalHost().getCanonicalHostName();
    }
    catch(java.net.UnknownHostException e) {
      hostname = new String("(unknown:" + e.getMessage() + ")");
    }


      // calculate app name

    if(app_name == null) {
      try {
        app_name = System.getenv("TDAQ_APPLICATION_NAME");
      }
      catch (SecurityException e) {
        e.printStackTrace();
      }

      if(app_name == null) {
        app_name = new String("(unknown Java)");
      }
    }

    return new ProcessInfo(user_id, hostname, process_id, app_name);
  }
}

