/*
 * ROBFragmentShredder.cpp
 *
 *  Created on: Jul 16, 2019
 *      Author: kolos
 */


#include "ROBFragmentShredder.h"

#include <swrod/Core.h>
#include <swrod/Factory.h>

using namespace swrod;
using namespace boost::property_tree;

namespace {
    Factory<ROBFragmentConsumer>::Registrator __reg__(
            "ROBFragmentShredder",
            [](const boost::property_tree::ptree& config, const Core& core) {
                return std::make_shared<ROBFragmentShredder>(config, core);
            });
}

ROBFragmentShredder::ROBFragmentShredder(
        const boost::property_tree::ptree& config, const Core& core) :
        ROBFragmentConsumerBase(config,
                [](auto &){},
                ROBFragmentConsumerBase::QueuingPolicy::Wait,
                ROBFragmentConsumerBase::ForwardingPolicy::AfterProcessing,
                "ROB" + (config.count("RobConfig")
                            ? config.get<std::string>("RobConfig.Id")
                            : std::string("")) + "-shredder")
{
}
