/** \page main How to use the WMI package
\li \ref PluginBaseClass
\li \ref BaseHTMLClass
\li \ref OutputStream 
\li \ref ConfigurationFile
\li \ref AddNewPlugin 

The goal of the Web Monitoring Interface(WMI) is to provide Web access to monitoring data from Point 1. 
WMI has some classes implementation some HTML object. Use these classes plug-ins can produce TDAQ data in form HTML pages.   
WMI periodically starts varius plug-ins and copy html pages generated by plug-ins to public Web Server. Each pug-in download (dynamic) from its library. Example of plug-ins you can find in directory "/src/plugins/".    

\section PluginBaseClass Base plug-in class
Base class of each plug-in must inherit class "PluginBase" and implemented all its abstract methods. Class "PluginBase" has following abstract methods:
	\li start
	\li stop
	\li configuration

\section BaseHTMLClass Base HTML class
All HTML classes inherit class "Basehtmlobject". Use these classes plug-in visualized data. Now WMI has following HTML classes:
	\li BR
	\li HR
	\li Link
	\li List
	\li Picture
	\li Table
	\li Text
	
\section ConfigurationFile Configuration File
WMI has configuration file (example of configuration file you can find in WMI package "data/setup.xml") with following settings:
	\li HTTPServer - defines the name of server where running Web Server.
	\li HTTPRootDir - defines the root directory of WMI on Web Server
	\li OutputDir - defines working directory of WMI on computer where WMI was started.
	\li WMIOutputImpl - the name of class implementation output stream of WMI (now define only "WMIHTMLOutput")
	\li plugins - Sequence of plug-ins and information about it which need run. Each plug-in has following information:
1)	Name
2)	Location of lib
3)	Sequence of parameters for plug-in

\section OutputStream Output stream of WMI
 Now WMI has only one output stream with class name "HTMLOutputStream". This output stream saves all data in form real html files.
 Each plug-in have pointer of WMI output stream and can used following methods of this pointer for write HTML classes to file:
	\li open (with various parameters)
	\li write
	\li close (with various parameters)
	\li closeAll (recommended always used when plug-in finish work)

\section AddNewPlugin Add new plug-in
For adding new you need doing following steps:
\li Write new plug-in (base class of new plug-in must inherit class "PluginBase".
\li Create library from this plug-in.
\li Add to configuration file of WMI information about new plug-in. 
For example (information about "Data Quality Monitoring" plug-in):
\code
    <plugin name="Data Quality Monitoring" fullPath="libwmidqm.so" period="60">
    <parameters name="picture_height" value="350"/>
    <parameters name="picture_width" value="500"/>
    </plugin>
\endcode
\li Start (restart) WMI.


*/

