#include "OHPictures.h"

#include <TSystem.h>
#include <TGPicture.h>
#include <TImage.h>

static const char * exit_xpm[] = {
"16 16 178 2",
"  	c None",
". 	c #D49C6D",
"+ 	c #D29A6A",
"@ 	c #CF9766",
"# 	c #D69E70",
"$ 	c #DAB185",
"% 	c #B9915A",
"& 	c #CB9360",
"* 	c #808080",
"= 	c #7E7E7E",
"- 	c #7C7C7C",
"; 	c #7A7A7A",
"> 	c #777777",
", 	c #757575",
"' 	c #727272",
") 	c #D49E71",
"! 	c #D69E6F",
"~ 	c #DCB287",
"{ 	c #E8D3AB",
"] 	c #E6D0A9",
"^ 	c #B89058",
"/ 	c #C68E59",
"( 	c #7D7D7D",
"_ 	c #999999",
": 	c #9A9A9A",
"< 	c #9B9B9B",
"[ 	c #D39D6F",
"} 	c #E7D1AA",
"| 	c #E7D1AB",
"1 	c #E1C798",
"2 	c #DEC291",
"3 	c #B78F56",
"4 	c #C18952",
"5 	c #599152",
"6 	c #999A99",
"7 	c #9C9C9C",
"8 	c #D09A6C",
"9 	c #E5CEA7",
"0 	c #DFC18F",
"a 	c #DCBD89",
"b 	c #DCBD8B",
"c 	c #B68D53",
"d 	c #BC844B",
"e 	c #458A3D",
"f 	c #4F8A49",
"g 	c #9D9D9D",
"h 	c #CC9666",
"i 	c #E3CBA2",
"j 	c #DAB983",
"k 	c #DAB984",
"l 	c #B58B51",
"m 	c #B67E43",
"n 	c #4D9444",
"o 	c #4B9142",
"p 	c #488D3F",
"q 	c #45893D",
"r 	c #65A45D",
"s 	c #61A05A",
"t 	c #4B8345",
"u 	c #9E9E9E",
"v 	c #C99260",
"w 	c #E2C79E",
"x 	c #DAB883",
"y 	c #D7B47D",
"z 	c #D7B37E",
"A 	c #B4894F",
"B 	c #B1793B",
"C 	c #4A9041",
"D 	c #9FD294",
"E 	c #9AD091",
"F 	c #96CD8D",
"G 	c #92CB89",
"H 	c #8DC884",
"I 	c #589851",
"J 	c #467C41",
"K 	c #9F9F9F",
"L 	c #C48E5A",
"M 	c #E0C398",
"N 	c #D7B37C",
"O 	c #D6AF74",
"P 	c #EDC45E",
"Q 	c #B3884B",
"R 	c #AB7334",
"S 	c #468B3E",
"T 	c #99CE8F",
"U 	c #87C67D",
"V 	c #81C378",
"W 	c #7CC073",
"X 	c #7CC074",
"Y 	c #81C279",
"Z 	c #4F9049",
"` 	c #577F54",
" .	c #BF8954",
"..	c #DDBF94",
"+.	c #D4AD75",
"@.	c #E1B863",
"#.	c #FFD44B",
"$.	c #B88B42",
"%.	c #A66E2C",
"&.	c #42873B",
"*.	c #88C680",
"=.	c #83C37B",
"-.	c #7FC177",
";.	c #4D8F47",
">.	c #3F743B",
",.	c #A1A1A1",
"'.	c #BA844C",
").	c #DBBB8D",
"!.	c #D1A86E",
"~.	c #D1A666",
"{.	c #DFB45F",
"].	c #B18547",
"^.	c #A16925",
"/.	c #3E8237",
"(.	c #3B7E34",
"_.	c #377931",
":.	c #34752E",
"<.	c #509149",
"[.	c #4C8F46",
"}.	c #3D7339",
"|.	c #A2A2A2",
"1.	c #B47E45",
"2.	c #D9B788",
"3.	c #CFA367",
"4.	c #CC9E61",
"5.	c #CC9F63",
"6.	c #B18345",
"7.	c #9C641F",
"8.	c #606060",
"9.	c #A0A0A0",
"0.	c #41763D",
"a.	c #397136",
"b.	c #A3A3A3",
"c.	c #B0793D",
"d.	c #D7B382",
"e.	c #CC9F62",
"f.	c #C99A5A",
"g.	c #CA9B5E",
"h.	c #AF8143",
"i.	c #986019",
"j.	c #5C5C5C",
"k.	c #40733C",
"l.	c #A1A1A0",
"m.	c #A4A4A4",
"n.	c #AA7436",
"o.	c #D4AF7D",
"p.	c #C99A5B",
"q.	c #C79554",
"r.	c #C89658",
"s.	c #AE8041",
"t.	c #945C13",
"u.	c #585858",
"v.	c #A5A5A5",
"w.	c #A56F2F",
"x.	c #D2AB78",
"y.	c #D3AB78",
"z.	c #D1A773",
"A.	c #CDA069",
"B.	c #AE7F40",
"C.	c #91590F",
"D.	c #717171",
"E.	c #545454",
"F.	c #515151",
"G.	c #4F4F4F",
"H.	c #4C4C4C",
"I.	c #4A4A4A",
"J.	c #474747",
"K.	c #454545",
"L.	c #9D6725",
"M.	c #A87432",
"N.	c #AF7C3D",
"O.	c #B58447",
"P.	c #BA8A4E",
"Q.	c #AD7E3E",
"R.	c #8F570C",
"S.	c #925A10",
"T.	c #90580D",
"U.	c #925C13",
"                          . + @ ",
"                      # . $ % & ",
"    * = - ; > , ' ) ! ~ { ] ^ / ",
"    ( _ _ : : < < [ } | 1 2 3 4 ",
"    ; _ 5 6 < 7 7 8 9 0 a b c d ",
"    > : e f 7 g g h i a j k l m ",
"n o p q r s t u u v w x y z A B ",
"C D E F G H I J K L M N O P Q R ",
"S T U V W X Y Z `  ...+.@.#.$.%.",
"&.G H *.=.-.;.>.,.'.).!.~.{.].^.",
"/.(._.:.<.[.}.,.|.1.2.3.4.5.6.7.",
"    8.9.0.a.|.|.b.c.d.e.f.g.h.i.",
"    j.,.k.l.b.b.m.n.o.p.q.r.s.t.",
"    u.|.|.b.m.m.v.w.x.y.z.A.B.C.",
"_ D.E.F.G.H.I.J.K.L.M.N.O.P.Q.R.",
"                        S.T.U.R."};

static const char * save_xpm[] = {
"16 16 153 2",
"  	c None",
". 	c #366BBC",
"+ 	c #366BBB",
"@ 	c #366ABB",
"# 	c #396CBC",
"$ 	c #3B6EBD",
"% 	c #3A6DBB",
"& 	c #386BBB",
"* 	c #3E70BB",
"= 	c #D1E0F6",
"- 	c #D1E0F7",
"; 	c #F8FBFE",
"> 	c #F7FBFE",
", 	c #F6F9FD",
"' 	c #F0F5FC",
") 	c #EAF0FA",
"! 	c #EDF2FB",
"~ 	c #F7FAFD",
"{ 	c #EBF1FB",
"] 	c #DFE9F8",
"^ 	c #BDD0EC",
"/ 	c #5E89C9",
"( 	c #D1DFF6",
"_ 	c #80AAE9",
": 	c #F6FAFE",
"< 	c #F6FAFD",
"[ 	c #648CC8",
"} 	c #EEF3FB",
"| 	c #EAF1FB",
"1 	c #F2F6FC",
"2 	c #F1F6FC",
"3 	c #E2ECF9",
"4 	c #DBE7F8",
"5 	c #BAD0EE",
"6 	c #D0DFF6",
"7 	c #7EA8E8",
"8 	c #E9F1FA",
"9 	c #EEF4FB",
"0 	c #E8F0FA",
"a 	c #DDE8F8",
"b 	c #DBE6F7",
"c 	c #7AA3E1",
"d 	c #C3D5EF",
"e 	c #3569B7",
"f 	c #CCDDF5",
"g 	c #7EA8E7",
"h 	c #668DC9",
"i 	c #E9F0FA",
"j 	c #F3F8FD",
"k 	c #F8FAFE",
"l 	c #EFF4FC",
"m 	c #DFE9F9",
"n 	c #DBE7F7",
"o 	c #D9E5F7",
"p 	c #78A2E0",
"q 	c #A9C2E7",
"r 	c #3568B6",
"s 	c #C9DCF4",
"t 	c #7DA7E7",
"u 	c #E1ECF9",
"v 	c #E3EDF9",
"w 	c #EEF4FC",
"x 	c #F3F7FD",
"y 	c #E5EDFA",
"z 	c #D8E5F6",
"A 	c #77A0DE",
"B 	c #A4BEE4",
"C 	c #3467B4",
"D 	c #C7D9F4",
"E 	c #7DA6E6",
"F 	c #658DC9",
"G 	c #678EC9",
"H 	c #6C92CB",
"I 	c #6D92CB",
"J 	c #6990CA",
"K 	c #658CC8",
"L 	c #749CDA",
"M 	c #9FBAE1",
"N 	c #3466B3",
"O 	c #C5D8F2",
"P 	c #7BA4E3",
"Q 	c #7AA3E3",
"R 	c #7AA4E3",
"S 	c #7BA4E2",
"T 	c #7BA3E2",
"U 	c #7BA3E1",
"V 	c #79A2E1",
"W 	c #77A0DF",
"X 	c #769FDE",
"Y 	c #749EDD",
"Z 	c #729CDB",
"` 	c #749DDC",
" .	c #9AB5DD",
"..	c #3465B1",
"+.	c #C2D5F2",
"@.	c #78A1E0",
"#.	c #759EDE",
"$.	c #739BDA",
"%.	c #739BD9",
"&.	c #95B0DA",
"*.	c #3364AF",
"=.	c #BED2F0",
"-.	c #7AA3E2",
";.	c #779FDE",
">.	c #769FDD",
",.	c #729BD9",
"'.	c #7199D8",
").	c #7099D6",
"!.	c #8EABD5",
"~.	c #3363AD",
"{.	c #366ABA",
"].	c #BBD0EF",
"^.	c #7AA2E2",
"/.	c #6D96D3",
"(.	c #8AA7D2",
"_.	c #3262AB",
":.	c #B8CEEF",
"<.	c #F7FAFE",
"[.	c #88C062",
"}.	c #6A93CF",
"|.	c #84A3CE",
"1.	c #3261AA",
"2.	c #386CBB",
"3.	c #B6CCEE",
"4.	c #7AA2E1",
"5.	c #C2DCBF",
"6.	c #6890CD",
"7.	c #819ECC",
"8.	c #3261A8",
"9.	c #376BBA",
"0.	c #B3CAED",
"a.	c #7AA2E0",
"b.	c #658DCA",
"c.	c #7C9BC9",
"d.	c #3160A7",
"e.	c #356ABA",
"f.	c #ADC6EB",
"g.	c #ADC5EA",
"h.	c #7C9AC8",
"i.	c #7998C7",
"j.	c #3569B9",
"k.	c #3569B8",
"l.	c #3568B7",
"m.	c #3568B5",
"n.	c #3466B2",
"o.	c #3365B0",
"p.	c #3364AE",
"q.	c #3263AC",
"r.	c #3262AA",
"s.	c #3261A9",
"t.	c #3160A8",
"u.	c #3160A6",
"v.	c #3161A8",
"  . . . . + + @ @ # $ % & *     ",
". = - ; > , ' ) ! , ~ { ] ^ /   ",
". ( _ : < [ } | 1 ; 2 3 4 5 ^ * ",
". 6 7 2 2 [ 8 9 ~ , 0 a b c d e ",
". f g 0 0 h i j k l m n o p q r ",
"+ s t u u v w ~ x y n o z A B C ",
"+ D E [ F G H I J K [ [ [ L M N ",
"@ O P Q R S T U V W X Y Z `  ...",
"@ +.Q Q T T S V @.A #.` $.%.&.*.",
"@ =.-.-.c T U @.;.>.` ,.'.).!.~.",
"{.].^.; ; ; ; ; ; ; ; ; ; /.(._.",
"& :.V <.[.[.[.[.[.[.[.[., }.|.1.",
"2.3.4.<.5.5.5.5.5.5.5.5., 6.7.8.",
"9.0.a.<.[.[.[.[.[.[.[.[., b.c.d.",
"e.f.g.; ; ; ; ; ; ; ; ; ; h.i.d.",
"{.j.k.l.m.C n.o.p.q.r.s.t.d.u.v."};

const char * refresh_xpm[] = {
"16 16 88 1",
" 	c None",
".	c #4F9947",
"+	c #499141",
"@	c #65B45B",
"#	c #5FAD56",
"$	c #5AA650",
"%	c #539E4B",
"&	c #4D9645",
"*	c #68A860",
"=	c #62A25B",
"-	c #3A7E34",
";	c #68B95E",
">	c #83C379",
",	c #92CA89",
"'	c #9CD094",
")	c #9ED195",
"!	c #99CF90",
"~	c #94CB8C",
"{	c #8FC987",
"]	c #87C480",
"^	c #54954E",
"/	c #2C6D27",
"(	c #67B65C",
"_	c #8EC985",
":	c #A4D49B",
"<	c #98CE8F",
"[	c #9ACF92",
"}	c #95CC8D",
"|	c #90CA88",
"1	c #8BC683",
"2	c #85C47E",
"3	c #7FC179",
"4	c #4C8D47",
"5	c #256522",
"6	c #7EBF75",
"7	c #A1D298",
"8	c #9CCF94",
"9	c #8DC786",
"0	c #65A75E",
"a	c #408639",
"b	c #33762E",
"c	c #4F9049",
"d	c #4A8B45",
"e	c #246320",
"f	c #5EAB54",
"g	c #89C380",
"h	c #8AC483",
"i	c #448B3D",
"j	c #3E8337",
"k	c #276623",
"l	c #23611F",
"m	c #55A14D",
"n	c #42883B",
"o	c #3C8035",
"p	c #6EC063",
"q	c #6ABB5F",
"r	c #8EC686",
"s	c #8FC988",
"t	c #76B36F",
"u	c #6DBE62",
"v	c #85C77B",
"w	c #81C277",
"x	c #57A34E",
"y	c #519B49",
"z	c #6BAC63",
"A	c #8BC383",
"B	c #89C682",
"C	c #569750",
"D	c #6CBC60",
"E	c #83C479",
"F	c #A7D79E",
"G	c #9FD297",
"H	c #82C27A",
"I	c #63A45D",
"J	c #2A6B26",
"K	c #7CBD73",
"L	c #9FD196",
"M	c #96CD8F",
"N	c #91CA8A",
"O	c #8BC785",
"P	c #81BE7A",
"Q	c #6CAD65",
"R	c #51924B",
"S	c #296824",
"T	c #6EB066",
"U	c #68AA61",
"V	c #377B32",
"W	c #32742C",
"                ",
"         .+     ",
"    @#$%&*=-    ",
"  ;>,')!~{]^/   ",
" (_:<[}|12345   ",
" 67890a-bcde    ",
"fg}hij   kl     ",
"m.+no           ",
"           m.+no",
"     pq   %&rstb",
"    uvwfxyzA{BC ",
"   DEF:G[}|H2IJ ",
"   @KL8MNOPQRS  ",
"    xTUijVW/    ",
"     +n         ",
"                "};

const char * send_xpm[] = {
"16 16 164 2",
"  	c None",
". 	c #7C9AC8",
"+ 	c #84A4D5",
"@ 	c #7097D0",
"# 	c #648FCC",
"$ 	c #628ECC",
"% 	c #608ECB",
"& 	c #5D8CCA",
"* 	c #5B8BC9",
"= 	c #588AC8",
"- 	c #5688C7",
"; 	c #5386C6",
"> 	c #5084C5",
", 	c #4D82C4",
"' 	c #4D83C1",
") 	c #4879B2",
"! 	c #2B518E",
"~ 	c #91ABD7",
"{ 	c #F8FAFD",
"] 	c #F1F5FC",
"^ 	c #F9FCFF",
"/ 	c #FAFCFF",
"( 	c #FBFCFF",
"_ 	c #FBFDFF",
": 	c #FCFDFF",
"< 	c #F3F6FB",
"[ 	c #EAEFF8",
"} 	c #4377AB",
"| 	c #7B9DD3",
"1 	c #F2F6FB",
"2 	c #96B4E3",
"3 	c #DCE8F9",
"4 	c #EEF5FE",
"5 	c #DAE9FD",
"6 	c #DCEAFD",
"7 	c #DEECFD",
"8 	c #E1EDFD",
"9 	c #E4EFFE",
"0 	c #E7F1FE",
"a 	c #F6FAFF",
"b 	c #E0EAF9",
"c 	c #85AAE2",
"d 	c #D9E4F1",
"e 	c #508CC8",
"f 	c #7096D0",
"g 	c #F9FBFD",
"h 	c #B1CDF1",
"i 	c #96B5E3",
"j 	c #DEE9F9",
"k 	c #F1F7FE",
"l 	c #EAF3FE",
"m 	c #F7FAFF",
"n 	c #E3ECF9",
"o 	c #8AAEE2",
"p 	c #95BCF0",
"q 	c #ECF4F8",
"r 	c #668ECC",
"s 	c #D3E5FD",
"t 	c #B2CCF1",
"u 	c #F5F9FF",
"v 	c #EDF4FE",
"w 	c #F9FBFF",
"x 	c #E5EDF9",
"y 	c #8DB0E3",
"z 	c #9EC1F0",
"A 	c #B7D7FC",
"B 	c #EDF3F8",
"C 	c #5B86C9",
"D 	c #D7E8FD",
"E 	c #D4E6FD",
"F 	c #ABC6ED",
"G 	c #89AADC",
"H 	c #E6EEF9",
"I 	c #6DA344",
"J 	c #659F31",
"K 	c #C0DBFC",
"L 	c #507DC5",
"M 	c #D8E9FD",
"N 	c #D0E1F9",
"O 	c #B3CAEB",
"P 	c #A7C5EC",
"Q 	c #98B6E3",
"R 	c #DDE7F7",
"S 	c #DEE8F7",
"T 	c #97B6E3",
"U 	c #68A240",
"V 	c #81B35A",
"W 	c #579828",
"X 	c #C6DFFC",
"Y 	c #508DC8",
"Z 	c #4676C2",
"` 	c #F8FBFD",
" .	c #D2E3F9",
"..	c #B9CFEC",
"+.	c #D0E1F8",
"@.	c #D6E7FD",
"#.	c #6FA53D",
"$.	c #6EA33A",
"%.	c #68A136",
"&.	c #629E32",
"*.	c #7CAF55",
"=.	c #AACB91",
"-.	c #74AB4F",
";.	c #47901B",
">.	c #EBF2F7",
",.	c #508CC9",
"'.	c #3C6FBE",
").	c #F5F9FC",
"!.	c #BCD0EC",
"~.	c #D6E4F9",
"{.	c #DFECFE",
"].	c #DFEBFE",
"^.	c #6BA337",
"/.	c #B0CE96",
"(.	c #ADCD94",
"_.	c #A8CB90",
":.	c #90BC74",
"<.	c #A1C78A",
"[.	c #68A546",
"}.	c #38890B",
"|.	c #508BC6",
"1.	c #315DA3",
"2.	c #EEF3F8",
"3.	c #E4ECF5",
"4.	c #F0F5FB",
"5.	c #F1F7FB",
"6.	c #F3F7FB",
"7.	c #639F31",
"8.	c #8EBA6F",
"9.	c #89B86B",
"0.	c #85B666",
"a.	c #80B361",
"b.	c #82B567",
"c.	c #98C283",
"d.	c #5CA03C",
"e.	c #267F03",
"f.	c #3163B0",
"g.	c #3870BB",
"h.	c #3C77BE",
"i.	c #407BC1",
"j.	c #427EC2",
"k.	c #5B9B29",
"l.	c #A9CA90",
"m.	c #A5C88D",
"n.	c #A1C68A",
"o.	c #9EC588",
"p.	c #85B66A",
"q.	c #97C282",
"r.	c #66A548",
"s.	c #257C18",
"t.	c #2A5387",
"u.	c #519721",
"v.	c #49911B",
"w.	c #438F15",
"x.	c #3B8B0F",
"y.	c #5E9F3A",
"z.	c #96C180",
"A.	c #62A346",
"B.	c #1F7D00",
"C.	c #2B8301",
"D.	c #5FA143",
"E.	c #1F7B00",
"F.	c #217D00",
"G.	c #1E7B03",
"                                ",
"                                ",
". + @ # $ % & * = - ; > , ' ) ! ",
"~ { ] ^ ^ ^ ^ / / / ( _ : < [ } ",
"| 1 2 3 4 5 6 7 8 9 0 a b c d e ",
"f g h i j k 8 9 0 l m n o p q e ",
"r g s t i b u l v w x y z A B e ",
"C g D E F G n w / H I J K K B e ",
"L g M N O P Q R S T U V W X B Y ",
"Z `  ...+.@.#.$.%.&.*.=.-.;.>.,.",
"'.).!.~.{.].^./.(.=._.:.<.[.}.|.",
"1.2.3.4.5.6.7.(.8.9.0.a.b.c.d.e.",
"! f.g.h.i.j.k.l.m.n.o.p.q.r.s.t.",
"            u.v.w.x.y.z.A.B.    ",
"                    C.D.E.      ",
"                    F.G.        "};

static const char * view_small_icons_xpm[] = {
"16 16 61 1",
" 	c None",
".	c #8DB1DD",
"+	c #7BA7DC",
"@	c #7AA6DC",
"#	c #7AA4DA",
"$	c #79A2D8",
"%	c #76A0D5",
"&	c #759ED4",
"*	c #739DD2",
"=	c #729ACF",
"-	c #7099CE",
";	c #6F96CB",
">	c #6C94C9",
",	c #7A9AC4",
"'	c #85ACDD",
")	c #92B9E8",
"!	c #6F90C1",
"~	c #668BC0",
"{	c #7AA4DB",
"]	c #FFFFFF",
"^	c #6387BD",
"/	c #79A3D9",
"(	c #D1D1D1",
"_	c #60B0EB",
":	c #99CF90",
"<	c #FEFEFE",
"[	c #6085BA",
"}	c #5E81B7",
"|	c #FDFDFD",
"1	c #5C7EB5",
"2	c #FFAA73",
"3	c #F0D567",
"4	c #5A7CB2",
"5	c #739CD1",
"6	c #FCFCFC",
"7	c #587AB0",
"8	c #6F97CC",
"9	c #FBFBFB",
"0	c #5475AC",
"a	c #6E94CA",
"b	c #FE6F6B",
"c	c #5373AA",
"d	c #6C92C8",
"e	c #FFC8C7",
"f	c #D8EDD5",
"g	c #E8E8E8",
"h	c #E9E9E9",
"i	c #EAEAEA",
"j	c #EBEBEB",
"k	c #5172A9",
"l	c #5171A9",
"m	c #688EC3",
"n	c #6488BE",
"o	c #6185BB",
"p	c #5F83B9",
"q	c #5C7EB4",
"r	c #587BB1",
"s	c #5779AE",
"t	c #5676AD",
"u	c #5475AB",
"v	c #5373A9",
"                ",
" .+@#$%&*=-;>,  ",
"')))))))))))))! ",
"++++++++++++++~ ",
"{]]]]]]]]]]]]]^ ",
"/]((]__]::<((][ ",
"$]((]__]::<((]} ",
"%]]]]]<<<||||]1 ",
"&]__]((<22|33]4 ",
"5]__<((|22633]7 ",
"8]<|||6666999]0 ",
"a]bb6::6((9((]c ",
"d]ee]ff]gh]ij]k ",
"lm~nopq4rstuvll ",
"                ",
"                "};

static const char * view_large_icons_xpm[] = {
"16 16 60 1",
" 	c None",
".	c #8DB1DD",
"+	c #7BA7DC",
"@	c #7AA6DC",
"#	c #7AA4DA",
"$	c #79A2D8",
"%	c #76A0D5",
"&	c #759ED4",
"*	c #739DD2",
"=	c #729ACF",
"-	c #7099CE",
";	c #6F96CB",
">	c #6C94C9",
",	c #7A9AC4",
"'	c #85ACDD",
")	c #92B9E8",
"!	c #6F90C1",
"~	c #668BC0",
"{	c #7AA4DB",
"]	c #FFFFFF",
"^	c #6387BD",
"/	c #79A3D9",
"(	c #81C3FF",
"_	c #6FB166",
":	c #98CFFF",
"<	c #6085BA",
"[	c #9FD2FF",
"}	c #99CF90",
"|	c #FEFEFE",
"1	c #ADD9FF",
"2	c #5E81B7",
"3	c #FDFDFD",
"4	c #5C7EB5",
"5	c #FCFCFC",
"6	c #5A7CB2",
"7	c #739CD1",
"8	c #FF9754",
"9	c #F0D567",
"0	c #587AB0",
"a	c #6F97CC",
"b	c #9FD297",
"c	c #FFAA73",
"d	c #FFEB9B",
"e	c #5475AC",
"f	c #6E94CA",
"g	c #FBFBFB",
"h	c #5373AA",
"i	c #6C92C8",
"j	c #5172A9",
"k	c #5171A9",
"l	c #688EC3",
"m	c #6488BE",
"n	c #6185BB",
"o	c #5F83B9",
"p	c #5C7EB4",
"q	c #587BB1",
"r	c #5779AE",
"s	c #5676AD",
"t	c #5475AB",
"u	c #5373A9",
"                ",
" .+@#$%&*=-;>,  ",
"')))))))))))))! ",
"++++++++++++++~ ",
"{]]]]]]]]]]]]]^ ",
"/](((]___]:::]< ",
"$]([(]_}_|:1:]2 ",
"%](((]___3:::]4 ",
"&]]]]|||33335]6 ",
"7]___|8883999]0 ",
"a]_b_38c859d9]e ",
"f]___5888g999]h ",
"i]]]]]]]]]]]]]j ",
"kl~mnop6qrstukk ",
"                ",
"                "};

static const char * view_columns_xpm[] = {
"16 16 76 1",
" 	c None",
".	c #8DB1DD",
"+	c #7BA7DC",
"@	c #7AA6DC",
"#	c #7AA4DA",
"$	c #79A2D8",
"%	c #76A0D5",
"&	c #759ED4",
"*	c #739DD2",
"=	c #729ACF",
"-	c #7099CE",
";	c #6F96CB",
">	c #6C94C9",
",	c #7A9AC4",
"'	c #85ACDD",
")	c #92B9E8",
"!	c #6F90C1",
"~	c #668BC0",
"{	c #7AA4DB",
"]	c #FFFFFF",
"^	c #6387BD",
"/	c #79A3D9",
"(	c #CCCCCC",
"_	c #CACACA",
":	c #C6C6C6",
"<	c #F7FAFE",
"[	c #BDBDBD",
"}	c #BBBBBB",
"|	c #B7B7B7",
"1	c #B1B1B1",
"2	c #B0B0B0",
"3	c #ADADAD",
"4	c #6085BA",
"5	c #5E81B7",
"6	c #C8C8C8",
"7	c #C0C0C0",
"8	c #BABABA",
"9	c #B8B8B8",
"0	c #B2B2B2",
"a	c #A9A9A9",
"b	c #A7A7A7",
"c	c #A5A5A5",
"d	c #5C7EB5",
"e	c #5A7CB2",
"f	c #739CD1",
"g	c #C2C2C2",
"h	c #B9B9B9",
"i	c #B5B5B5",
"j	c #B3B3B3",
"k	c #ABABAB",
"l	c #A2A2A2",
"m	c #9E9E9E",
"n	c #9B9B9B",
"o	c #587AB0",
"p	c #6F97CC",
"q	c #5475AC",
"r	c #6E94CA",
"s	c #BEBEBE",
"t	c #AEAEAE",
"u	c #989898",
"v	c #959595",
"w	c #919191",
"x	c #5373AA",
"y	c #6C92C8",
"z	c #5172A9",
"A	c #5171A9",
"B	c #688EC3",
"C	c #6488BE",
"D	c #6185BB",
"E	c #5F83B9",
"F	c #5C7EB4",
"G	c #587BB1",
"H	c #5779AE",
"I	c #5676AD",
"J	c #5475AB",
"K	c #5373A9",
"                ",
" .+@#$%&*=-;>,  ",
"')))))))))))))! ",
"++++++++++++++~ ",
"{]]]]]]]]]]]]]^ ",
"/](_:<[}|<123]4 ",
"$]]]]]]]]]]]]]5 ",
"%]6:7<890<abc]d ",
"&]]]]]]]]]]]]]e ",
"f]g7h<ijk<lmn]o ",
"p]]]]]]]]]]]]]q ",
"r]s80<0tc<uvw]x ",
"y]]]]]]]]]]]]]z ",
"AB~CDEFeGHIJKAA ",
"                ",
"                "};

static const char * view_details_xpm[] = {
"16 16 93 2",
"  	c None",
". 	c #8DB1DD",
"+ 	c #7BA7DC",
"@ 	c #7AA6DC",
"# 	c #7AA4DA",
"$ 	c #79A2D8",
"% 	c #76A0D5",
"& 	c #759ED4",
"* 	c #739DD2",
"= 	c #729ACF",
"- 	c #7099CE",
"; 	c #6F96CB",
"> 	c #6C94C9",
", 	c #7A9AC4",
"' 	c #85ACDD",
") 	c #92B9E8",
"! 	c #6F90C1",
"~ 	c #668BC0",
"{ 	c #7AA4DB",
"] 	c #FFFFFF",
"^ 	c #6387BD",
"/ 	c #79A3D9",
"( 	c #65B9F6",
"_ 	c #BDBDBD",
": 	c #BBBBBB",
"< 	c #B7B7B7",
"[ 	c #F7FAFE",
"} 	c #B5B5B5",
"| 	c #EDF3FC",
"1 	c #B1B1B1",
"2 	c #B0B0B0",
"3 	c #ADADAD",
"4 	c #6085BA",
"5 	c #F8FAFE",
"6 	c #F6FAFE",
"7 	c #F6F8FD",
"8 	c #F2F7FC",
"9 	c #F0F6FC",
"0 	c #EFF5FC",
"a 	c #ECF3FB",
"b 	c #EAF1FA",
"c 	c #E8F0FA",
"d 	c #5E81B7",
"e 	c #63B6F3",
"f 	c #BABABA",
"g 	c #B8B8B8",
"h 	c #B2B2B2",
"i 	c #AFAFAF",
"j 	c #A9A9A9",
"k 	c #A7A7A7",
"l 	c #A5A5A5",
"m 	c #5C7EB5",
"n 	c #FAFCFE",
"o 	c #F9FBFE",
"p 	c #F4F7FC",
"q 	c #EEF4FC",
"r 	c #5A7CB2",
"s 	c #739CD1",
"t 	c #62B4EF",
"u 	c #B3B3B3",
"v 	c #ABABAB",
"w 	c #A8A8A8",
"x 	c #F5F8FD",
"y 	c #A2A2A2",
"z 	c #9E9E9E",
"A 	c #9B9B9B",
"B 	c #587AB0",
"C 	c #6F97CC",
"D 	c #FBFDFE",
"E 	c #FBFCFE",
"F 	c #F4F8FD",
"G 	c #F3F6FC",
"H 	c #5475AC",
"I 	c #6E94CA",
"J 	c #60B0EB",
"K 	c #AEAEAE",
"L 	c #989898",
"M 	c #959595",
"N 	c #919191",
"O 	c #5373AA",
"P 	c #6C92C8",
"Q 	c #5172A9",
"R 	c #5171A9",
"S 	c #688EC3",
"T 	c #6488BE",
"U 	c #6185BB",
"V 	c #5F83B9",
"W 	c #5C7EB4",
"X 	c #587BB1",
"Y 	c #5779AE",
"Z 	c #5676AD",
"` 	c #5475AB",
" .	c #5373A9",
"                                ",
"  . + @ # $ % & * = - ; > ,     ",
"' ) ) ) ) ) ) ) ) ) ) ) ) ) !   ",
"+ + + + + + + + + + + + + + ~   ",
"{ ] ] ] ] ] ] ] ] ] ] ] ] ] ^   ",
"/ ] ( ] _ : < [ } | 1 2 3 ] 4   ",
"$ ] 5 [ 6 7 8 [ 9 0 a b c ] d   ",
"% ] e ] f g h [ i 9 j k l ] m   ",
"& ] n o 5 5 6 [ p 8 9 0 q ] r   ",
"s ] t ] } u v [ w x y z A ] B   ",
"C ] D E o o [ [ [ [ F G G ] H   ",
"I ] J ] h K l [ y [ L M N ] O   ",
"P ] ] ] ] ] ] ] ] ] ] ] ] ] Q   ",
"R S ~ T U V W r X Y Z `  .R R   ",
"                                ",
"                                "};

const char * history_xpm[] = {
"16 16 122 2",
"  	c None",
". 	c #919191",
"+ 	c #9B9B9B",
"@ 	c #DC0000",
"# 	c #C70000",
"$ 	c #CBB5B5",
"% 	c #E6E6E6",
"& 	c #C9B3B3",
"* 	c #CEB8B8",
"= 	c #CDB6B6",
"- 	c #D20707",
"; 	c #D6C4C4",
"> 	c #E3E3E3",
", 	c #D5C4C4",
"' 	c #D00303",
") 	c #ED0202",
"! 	c #CF0101",
"~ 	c #D6C5C5",
"{ 	c #CF0000",
"] 	c #DA0B0B",
"^ 	c #AEA1A1",
"/ 	c #E0E0E0",
"( 	c #AE9F9F",
"_ 	c #CE1414",
": 	c #E11212",
"< 	c #E10E0E",
"[ 	c #CC0909",
"} 	c #AE9E9E",
"| 	c #D70000",
"1 	c #EB0F0F",
"2 	c #BD2828",
"3 	c #981C1C",
"4 	c #BC1F1F",
"5 	c #DD1E1E",
"6 	c #DF1B1B",
"7 	c #DE1616",
"8 	c #D71212",
"9 	c #B50D0D",
"0 	c #920808",
"a 	c #B40606",
"b 	c #E60101",
"c 	c #F31313",
"d 	c #E93B3B",
"e 	c #E83333",
"f 	c #E72D2D",
"g 	c #E32828",
"h 	c #E12323",
"i 	c #DF1E1E",
"j 	c #DD1B1B",
"k 	c #DC1717",
"l 	c #DB1414",
"m 	c #DC1111",
"n 	c #ED0404",
"o 	c #C9C9C9",
"p 	c #FCFCFC",
"q 	c #FBFBFB",
"r 	c #F7F7F7",
"s 	c #FFFFFF",
"t 	c #F5F5F5",
"u 	c #CBCBCB",
"v 	c #EEEEEE",
"w 	c #CACACA",
"x 	c #C7C7C7",
"y 	c #B8B8B8",
"z 	c #FEFEFE",
"A 	c #AFAFAF",
"B 	c #F9F9F9",
"C 	c #E8E8E8",
"D 	c #C2C2C2",
"E 	c #FAFAFA",
"F 	c #F8F8F8",
"G 	c #C8C8C8",
"H 	c #BCD1EC",
"I 	c #467DCE",
"J 	c #4377C9",
"K 	c #AEAEAE",
"L 	c #BCBCBC",
"M 	c #E5E5E5",
"N 	c #F6F6F6",
"O 	c #F3F3F3",
"P 	c #EFEFEF",
"Q 	c #9BAFCA",
"R 	c #457DCB",
"S 	c #5D90D1",
"T 	c #406DC3",
"U 	c #BABABA",
"V 	c #DFDFDF",
"W 	c #DDDDDD",
"X 	c #DBDBDB",
"Y 	c #4578C9",
"Z 	c #5B8DD1",
"` 	c #6191D2",
" .	c #3C63BF",
"..	c #BEBEBE",
"+.	c #FDFDFD",
"@.	c #4E81CB",
"#.	c #5B8BCF",
"$.	c #5F8FD0",
"%.	c #5C8ACE",
"&.	c #3959B8",
"*.	c #EBEBEB",
"=.	c #E2E2E2",
"-.	c #CCCCCC",
";.	c #3E64BF",
">.	c #537DC9",
",.	c #5782CB",
"'.	c #3651B4",
").	c #ECECEC",
"!.	c #D8D8D8",
"~.	c #737FA2",
"{.	c #3853B6",
"].	c #4B72C1",
"^.	c #334CB0",
"/.	c #C3C3C3",
"(.	c #C4C4C4",
"_.	c #C5C5C5",
":.	c #959595",
"<.	c #848484",
"[.	c #6F799D",
"}.	c #334DAF",
"|.	c #314AAD",
"1.	c #8A8A8A",
"        .             +         ",
"  @ # $ % & # @ @ # * % = # @   ",
"  @ - ; > , ' ) ) ! ~ > ; { @   ",
"  @ ] ^ / ( _ : < [ } / } | @   ",
"  @ 1 2 3 4 5 6 7 8 9 0 a b @   ",
"  @ c d e f g h i j k l m n @   ",
"  o p p p p p p p q r r s p o   ",
"  o p p p t u v w x y s z p o   ",
"  o p p p u A q B C D q E F G   ",
"  o H I J p K E F L M N O P G   ",
"  Q R S T q K E C U / V W X x   ",
"  Y Z `  .q K B ../ W p +./ u   ",
"@.#.$.%.&.q q F O *.X +.=.s -.  ",
"  ;.>.,.'.p p B N ).!./ s r x   ",
"  ~.{.].^././././././.(._.D :.  ",
"  <.[.}.|.. . . . . . . . . 1.  "};

const char * single_canvas_xpm[] = {
"16 16 90 1",
" 	c None",
".	c #8DB1DD",
"+	c #7BA7DC",
"@	c #7AA6DC",
"#	c #7AA4DA",
"$	c #79A2D8",
"%	c #76A0D5",
"&	c #759ED4",
"*	c #739DD2",
"=	c #729ACF",
"-	c #7099CE",
";	c #6F96CB",
">	c #6C94C9",
",	c #7A9AC4",
"'	c #85ACDD",
")	c #92B9E8",
"!	c #6F90C1",
"~	c #668BC0",
"{	c #7AA4DB",
"]	c #FFFFFF",
"^	c #6387BD",
"/	c #79A3D9",
"(	c #F9FBFC",
"_	c #F8FBFC",
":	c #F7F9FB",
"<	c #F4F7FB",
"[	c #F2F7FA",
"}	c #F0F5F9",
"|	c #EDF3F7",
"1	c #EAEFF6",
"2	c #E7EBF5",
"3	c #E4EAF3",
"4	c #DEE7F2",
"5	c #6085BA",
"6	c #FAFDFD",
"7	c #FAFCFC",
"8	c #F6FAFB",
"9	c #F5F8FB",
"0	c #F1F6FB",
"a	c #EEF4F8",
"b	c #EBF2F7",
"c	c #EAF0F7",
"d	c #E8ECF6",
"e	c #5E81B7",
"f	c #FCFDFD",
"g	c #FBFDFD",
"h	c #F9FCFC",
"i	c #F7FBFC",
"j	c #F5F9FB",
"k	c #F4F8FB",
"l	c #F3F7FB",
"m	c #F2F5FB",
"n	c #EFF3FA",
"o	c #ECF2F8",
"p	c #5C7EB5",
"q	c #FCFEFE",
"r	c #F9FDFD",
"s	c #F8FCFC",
"t	c #F2F7FB",
"u	c #5A7CB2",
"v	c #739CD1",
"w	c #F8FDFD",
"x	c #F9FBFB",
"y	c #F7FAFB",
"z	c #587AB0",
"A	c #6F97CC",
"B	c #FCFFFF",
"C	c #FDFFFF",
"D	c #FBFEFE",
"E	c #F7FCFC",
"F	c #F6FBFB",
"G	c #5475AC",
"H	c #6E94CA",
"I	c #FEFFFF",
"J	c #FDFEFE",
"K	c #FAFEFE",
"L	c #5373AA",
"M	c #6C92C8",
"N	c #5172A9",
"O	c #5171A9",
"P	c #688EC3",
"Q	c #6488BE",
"R	c #6185BB",
"S	c #5F83B9",
"T	c #5C7EB4",
"U	c #587BB1",
"V	c #5779AE",
"W	c #5676AD",
"X	c #5475AB",
"Y	c #5373A9",
"                ",
" .+@#$%&*=-;>,  ",
"')))))))))))))! ",
"++++++++++++++~ ",
"{]]]]]]]]]]]]]^ ",
"/](_:<[}|1234]5 ",
"$]67(89<0abcd]e ",
"%]fg6hijklmno]p ",
"&]qgfgrs:jktm]u ",
"v]qqqgg6wxy8k]z ",
"A]BCqqD6666EF]G ",
"H]]ICJqqqqKKh]L ",
"M]]]]]]]]]]]]]N ",
"OP~QRSTuUVWXYOO ",
"                ",
"                "};


const char * multi_canvas_xpm[] = {
"16 16 78 1",
" 	c None",
".	c #8DB1DD",
"+	c #7AA6DC",
"@	c #7AA4DA",
"#	c #79A2D8",
"$	c #759ED4",
"%	c #739DD2",
"&	c #729ACF",
"*	c #7099CE",
"=	c #6F96CB",
"-	c #6C94C9",
";	c #7A9AC4",
">	c #85ACDD",
",	c #92B9E8",
"'	c #6F90C1",
")	c #7BA7DC",
"!	c #668BC0",
"~	c #7AA4DB",
"{	c #FFFFFF",
"]	c #6387BD",
"^	c #79A3D9",
"/	c #F8FBFC",
"(	c #A7B7D3",
"_	c #90B3DE",
":	c #FAFCFC",
"<	c #86ADDD",
"[	c #76A0D5",
"}	c #FBFDFD",
"|	c #739CD1",
"1	c #FCFEFE",
"2	c #6F97CC",
"3	c #FDFFFF",
"4	c #F7F9FB",
"5	c #F4F7FB",
"6	c #F0F5F9",
"7	c #EDF3F7",
"8	c #EAEFF6",
"9	c #E7EBF5",
"0	c #E4EAF3",
"a	c #DEE7F2",
"b	c #6085BA",
"c	c #6C92C8",
"d	c #F9FBFC",
"e	c #F6FAFB",
"f	c #F1F6FB",
"g	c #EEF4F8",
"h	c #EBF2F7",
"i	c #EAF0F7",
"j	c #E8ECF6",
"k	c #5E81B7",
"l	c #5171A9",
"m	c #688EC3",
"n	c #6488BE",
"o	c #FAFDFD",
"p	c #F9FCFC",
"q	c #F5F9FB",
"r	c #F4F8FB",
"s	c #F3F7FB",
"t	c #F2F5FB",
"u	c #EFF3FA",
"v	c #ECF2F8",
"w	c #5C7EB5",
"x	c #F8FDFD",
"y	c #F9FBFB",
"z	c #F7FAFB",
"A	c #587AB0",
"B	c #F7FCFC",
"C	c #F6FBFB",
"D	c #5475AC",
"E	c #5172A9",
"F	c #6185BB",
"G	c #5F83B9",
"H	c #5A7CB2",
"I	c #587BB1",
"J	c #5779AE",
"K	c #5676AD",
"L	c #5475AB",
"M	c #5373A9",
" .+@#$%&*=-;    ",
">,,,,,,,,,,,'   ",
"))))))))))))!   ",
"~{{{{{{{{{{{]   ",
"^{/(_+@#$%&*=-; ",
"#{:<,,,,,,,,,,,'",
"[{}))))))))))))!",
"|{1~{{{{{{{{{{{]",
"2{3^{/4567890a{b",
"c{{#{:de5fghij{k",
"lmn[{}opqrstuv{w",
"   |{11}oxyzer{A",
"   2{311ooooBC{D",
"   c{{{{{{{{{{{E",
"   lmnFGHIJKLMll",
"                "};

const char * multi_pad_xpm[] = {
"16 16 85 1",
" 	c None",
".	c #A5C2E4",
"+	c #95BAE3",
"@	c #88AFD8",
"#	c #86ABD6",
"$	c #81A9D4",
"%	c #90ADCF",
"&	c #5F84B8",
"*	c #9FBDE2",
"=	c #8DB4E1",
"-	c #8AB2E1",
";	c #7CA2D1",
">	c #779FCE",
",	c #84A2C9",
"'	c #9FBEE4",
")	c #A9C8ED",
"!	c #A8C7ED",
"~	c #A7C6EC",
"{	c #A5C5EC",
"]	c #A4C4EC",
"^	c #97B8E2",
"/	c #A1C3EB",
"(	c #9FC1EB",
"_	c #9DC0EA",
":	c #9CBFEA",
"<	c #9ABEEA",
"[	c #98BDE9",
"}	c #7394C3",
"|	c #95B9E3",
"1	c #94B9E3",
"2	c #93B8E3",
"3	c #91B7E2",
"4	c #90B6E2",
"5	c #8EB5E2",
"6	c #8CB3E1",
"7	c #8AB2E0",
"8	c #89B1E0",
"9	c #87AFDF",
"0	c #85AEDF",
"a	c #82ACDE",
"b	c #80ABDD",
"c	c #7EA9DD",
"d	c #678CC0",
"e	c #92B6E2",
"f	c #FFFFFF",
"g	c #86ADDF",
"h	c #6184BB",
"i	c #8FB4E0",
"j	c #82AADC",
"k	c #5B7FB6",
"l	c #8CB1DE",
"m	c #7EA6DA",
"n	c #5677B1",
"o	c #86ADDB",
"p	c #78A1D6",
"q	c #5270AD",
"r	c #82A9D9",
"s	c #739DD3",
"t	c #6E98CF",
"u	c #6790C8",
"v	c #6389C5",
"w	c #5E84C1",
"x	c #577CB9",
"y	c #5476B5",
"z	c #4E6BA8",
"A	c #7CA4D5",
"B	c #4A67A4",
"C	c #759DCF",
"D	c #45609D",
"E	c #7197CB",
"F	c #435D99",
"G	c #6B91C8",
"H	c #405A97",
"I	c #4E6DA6",
"J	c #6288C0",
"K	c #5F83BC",
"L	c #4F6CA6",
"M	c #4B69A2",
"N	c #49659F",
"O	c #46629D",
"P	c #45609C",
"Q	c #5172B2",
"R	c #435E9A",
"S	c #425B97",
"T	c #405997",
"                ",
" .+@#$%&*=-;>,  ",
"')!!~{]^/(_:<[} ",
"|1234567890abcd ",
"effffffgffffffh ",
"iffffffjffffffk ",
"lffffffmffffffn ",
"offffffpffffffq ",
"r123jmpstuvwxyz ",
"AfffffftffffffB ",
"CffffffuffffffD ",
"EffffffvffffffF ",
"GffffffwffffffH ",
"IJKLMNOPxyQRSTT ",
"                ",
"                "};

static const char * folder_wrench_xpm[] = {
"16 16 150 2",
"  	c None",
". 	c #9D9D9D",
"+ 	c #9B9B9B",
"@ 	c #999999",
"# 	c #9C9C9C",
"$ 	c #E1E1E1",
"% 	c #D2D2D2",
"& 	c #969696",
"* 	c #B5B5B5",
"= 	c #E6E6E6",
"- 	c #949494",
"; 	c #929292",
"> 	c #8F8F8F",
", 	c #8D8D8D",
"' 	c #B2B2B2",
") 	c #D6D6D6",
"! 	c #919191",
"~ 	c #8E8E8E",
"{ 	c #C0C0C0",
"] 	c #898989",
"^ 	c #CBCBCB",
"/ 	c #C9C9C9",
"( 	c #C6C6C6",
"_ 	c #858585",
": 	c #D9B434",
"< 	c #E1C25E",
"[ 	c #E2C360",
"} 	c #E2C35F",
"| 	c #DBB63C",
"1 	c #96B1D5",
"2 	c #8DABDD",
"3 	c #A3AFC4",
"4 	c #D5D5D5",
"5 	c #BBBBBB",
"6 	c #A6A6A6",
"7 	c #A0A0A0",
"8 	c #848484",
"9 	c #DAB336",
"0 	c #FEFEFD",
"a 	c #FFFFFE",
"b 	c #FFFEFE",
"c 	c #FFFEFD",
"d 	c #C9D6E7",
"e 	c #87A9E0",
"f 	c #B0C7EB",
"g 	c #7CA1DD",
"h 	c #95A5BC",
"i 	c #A59D83",
"j 	c #BEAE7B",
"k 	c #A59563",
"l 	c #DAAF35",
"m 	c #FEFCF7",
"n 	c #F8E48E",
"o 	c #F5DE91",
"p 	c #F5E09F",
"q 	c #C2C7C5",
"r 	c #83A5DF",
"s 	c #B3C8ED",
"t 	c #B8CDED",
"u 	c #A3BEE9",
"v 	c #648ED5",
"w 	c #FEFBEE",
"x 	c #FFFDFA",
"y 	c #DAAF36",
"z 	c #DAAA36",
"A 	c #FDFAF1",
"B 	c #F5DE94",
"C 	c #F4DC93",
"D 	c #BFBFAC",
"E 	c #909FBC",
"F 	c #CFA164",
"G 	c #DA9435",
"H 	c #DAAB35",
"I 	c #FBF6E8",
"J 	c #EAC57E",
"K 	c #DFA34A",
"L 	c #C2975E",
"M 	c #DEA34D",
"N 	c #EDF1F2",
"O 	c #ECEFF3",
"P 	c #DFE5ED",
"Q 	c #E8EBED",
"R 	c #FDF9F1",
"S 	c #FDF9F0",
"T 	c #FFFFFF",
"U 	c #DAA637",
"V 	c #FFFDF8",
"W 	c #FFFDF6",
"X 	c #F2F4F4",
"Y 	c #FEFAE8",
"Z 	c #D8D7B6",
"` 	c #C5C7AA",
" .	c #E4D892",
"..	c #F7E07D",
"+.	c #F6DD72",
"@.	c #F5DB68",
"#.	c #FDF9E9",
"$.	c #DAA136",
"%.	c #FEFCF6",
"&.	c #FCF2C8",
"*.	c #FBEFB9",
"=.	c #EFDF94",
"-.	c #F8E48C",
";.	c #D3CE99",
">.	c #D8D091",
",.	c #F7E182",
"'.	c #F6DD6D",
").	c #F5DA61",
"!.	c #F4D757",
"~.	c #FDF8E7",
"{.	c #DA9A36",
"].	c #FDFAF2",
"^.	c #FAEDB3",
"/.	c #F9E9A4",
"(.	c #F8E695",
"_.	c #F7E285",
":.	c #F7E181",
"<.	c #F7E07A",
"[.	c #F7E07C",
"}.	c #F5DA62",
"|.	c #F3D654",
"1.	c #F2D347",
"2.	c #FDF9E8",
"3.	c #FEFAEF",
"4.	c #F9E9A1",
"5.	c #F8E591",
"6.	c #F6DE72",
"7.	c #F5DA63",
"8.	c #F4D754",
"9.	c #F3D347",
"0.	c #F2D039",
"a.	c #F1CD2E",
"b.	c #F0CB26",
"c.	c #FBF2CA",
"d.	c #D98E33",
"e.	c #FAF0DC",
"f.	c #F4DDA7",
"g.	c #F4DB9E",
"h.	c #F3DA96",
"i.	c #F3D88E",
"j.	c #F3D786",
"k.	c #F2D47F",
"l.	c #F2D379",
"m.	c #F1D272",
"n.	c #F1D06C",
"o.	c #F1CF69",
"p.	c #F8EAC2",
"q.	c #D8882D",
"r.	c #D8872D",
"s.	c #D8862C",
"                      . + @     ",
"                    # $ % &     ",
"                    * = - ; > , ",
"                    ' ) ! ~ { ] ",
"                  - ^ % / % ( _ ",
": < [ [ [ } | 1 2 3 4 5 6 7 8   ",
"9 0 a b c a d e f g h i j k     ",
"l m n o p q r s t u v w x y     ",
"z A B C D E F G G G G G G G     ",
"H I J K L M N O P Q R S T G     ",
"U a V W X Y Z `  ...+.@.#.G     ",
"$.%.&.*.=.-.;.>.,.'.).!.~.G     ",
"{.].^./.(._.:.<.[.}.|.1.2.G     ",
"G 3.4.5.:.6.7.8.9.0.a.b.c.G     ",
"d.e.f.g.h.i.j.k.l.m.n.o.p.d.    ",
"  q.r.q.q.q.q.q.q.q.q.r.q.s.    "};

static const char * folder_xpm[] = {
"16 16 121 2",
"  	c None",
". 	c #D9B434",
"+ 	c #E1C25E",
"@ 	c #E2C360",
"# 	c #E2C35F",
"$ 	c #DBB63C",
"% 	c #DAB336",
"& 	c #FEFEFD",
"* 	c #FFFFFE",
"= 	c #FFFEFE",
"- 	c #FFFEFD",
"; 	c #FBF7EA",
"> 	c #E4C76B",
", 	c #E3C76B",
"' 	c #E6CD79",
") 	c #E5CA74",
"! 	c #DAAF35",
"~ 	c #FEFCF7",
"{ 	c #F8E48E",
"] 	c #F5DE91",
"^ 	c #F5E09F",
"/ 	c #F6E1AC",
"( 	c #FEFBEF",
"_ 	c #FEFDF4",
": 	c #FEFCF3",
"< 	c #FEFCF1",
"[ 	c #FEFBEE",
"} 	c #FFFDFA",
"| 	c #DAAF36",
"1 	c #DAAA36",
"2 	c #FDFAF1",
"3 	c #F5DE94",
"4 	c #F4DC93",
"5 	c #F2D581",
"6 	c #EDCA6A",
"7 	c #EACB6C",
"8 	c #EFD385",
"9 	c #EFD280",
"0 	c #EFD07A",
"a 	c #EECF76",
"b 	c #EECF72",
"c 	c #FBF7E9",
"d 	c #DAAE34",
"e 	c #DAAB35",
"f 	c #FBF6E8",
"g 	c #EFD494",
"h 	c #EECE88",
"i 	c #E9C173",
"j 	c #F6E9C9",
"k 	c #FEFCF2",
"l 	c #FEFCF0",
"m 	c #DAAB36",
"n 	c #DAA637",
"o 	c #FFFDF8",
"p 	c #FFFDF6",
"q 	c #FFFCF5",
"r 	c #FCF6D8",
"s 	c #F8E694",
"t 	c #F7E385",
"u 	c #F6DF76",
"v 	c #F5DB68",
"w 	c #F4D85C",
"x 	c #FCF4D7",
"y 	c #DAA435",
"z 	c #DAA136",
"A 	c #FEFCF6",
"B 	c #FCF2C8",
"C 	c #FBEFB9",
"D 	c #FAECAC",
"E 	c #F9E89C",
"F 	c #F7E38B",
"G 	c #F6E07C",
"H 	c #F6DC6C",
"I 	c #F5D95D",
"J 	c #F4D64F",
"K 	c #F3D344",
"L 	c #FCF3D0",
"M 	c #DA9F35",
"N 	c #DA9A36",
"O 	c #FDFAF2",
"P 	c #FAEDB3",
"Q 	c #F9E9A4",
"R 	c #F8E695",
"S 	c #F7E285",
"T 	c #F6DE76",
"U 	c #F5DB65",
"V 	c #F4D757",
"W 	c #F3D449",
"X 	c #F2D13B",
"Y 	c #F1CE30",
"Z 	c #FBF2CC",
"` 	c #DA9835",
" .	c #DA9435",
"..	c #FEFAEF",
"+.	c #F9E9A1",
"@.	c #F8E591",
"#.	c #F7E181",
"$.	c #F6DE72",
"%.	c #F5DA63",
"&.	c #F4D754",
"*.	c #F3D347",
"=.	c #F2D039",
"-.	c #F1CD2E",
";.	c #F0CB26",
">.	c #FBF2CA",
",.	c #D98E33",
"'.	c #FAF0DC",
").	c #F4DDA7",
"!.	c #F4DB9E",
"~.	c #F3DA96",
"{.	c #F3D88E",
"].	c #F3D786",
"^.	c #F2D47F",
"/.	c #F2D379",
"(.	c #F1D272",
"_.	c #F1D06C",
":.	c #F1CF69",
"<.	c #F8EAC2",
"[.	c #D8882D",
"}.	c #D8872D",
"|.	c #D8862C",
"                                ",
"                                ",
"                                ",
"                                ",
"                                ",
". + @ @ @ # $                   ",
"% & * = - * ; > , , , ' )       ",
"! ~ { ] ^ / ( _ : < ( [ } |     ",
"1 2 3 4 5 6 7 8 9 0 a b c d     ",
"e f g h i j k : k l ( [ * m     ",
"n * o p q : r s t u v w x y     ",
"z A B C D E F G H I J K L M     ",
"N O P Q R S T U V W X Y Z `     ",
" ...+.@.#.$.%.&.*.=.-.;.>. .    ",
",.'.).!.~.{.].^./.(._.:.<.,.    ",
"  [.}.[.[.[.[.[.[.[.[.}.[.|.    "};

static const char * folder_large_xpm[] = {
"32 32 467 2",
"  	c None",
". 	c #E0C25E",
"+ 	c #E1C361",
"@ 	c #E1C360",
"# 	c #E2C461",
"$ 	c #E1C35F",
"% 	c #DEBC4E",
"& 	c #DAB53C",
"* 	c #DAB335",
"= 	c #E4C96E",
"- 	c #EEDFAA",
"; 	c #F0E2B4",
"> 	c #F0E1B2",
", 	c #F0E1B1",
"' 	c #F0E1B0",
") 	c #F0E2B1",
"! 	c #F0E1AF",
"~ 	c #EEDDA4",
"{ 	c #EBD694",
"] 	c #E6CD7B",
"^ 	c #DFBE54",
"/ 	c #DCBB4D",
"( 	c #DDBE56",
"_ 	c #DDBE55",
": 	c #DFC25E",
"< 	c #E1C565",
"[ 	c #E1C363",
"} 	c #EBD795",
"| 	c #FEFEFD",
"1 	c #FFFFFF",
"2 	c #FFFFFE",
"3 	c #FFFEFE",
"4 	c #FFFEFD",
"5 	c #FEFEFC",
"6 	c #FBF7EA",
"7 	c #EFDFAA",
"8 	c #E3C76B",
"9 	c #E2C66B",
"0 	c #E2C66A",
"a 	c #E4CA72",
"b 	c #E5CC79",
"c 	c #E6CC79",
"d 	c #E5CA74",
"e 	c #E1C15E",
"f 	c #DAB135",
"g 	c #ECD89B",
"h 	c #FFFFF6",
"i 	c #FEF6CF",
"j 	c #FDF3CC",
"k 	c #FCF2D1",
"l 	c #FCF2D5",
"m 	c #FCF3DA",
"n 	c #FCF4DD",
"o 	c #FDF5E3",
"p 	c #FFFCF6",
"q 	c #F8F2DA",
"r 	c #F1E3B3",
"s 	c #F0E3B3",
"t 	c #F0E2B2",
"u 	c #F1E2B2",
"v 	c #F1E4B5",
"w 	c #F2E6B9",
"x 	c #F3E7BD",
"y 	c #F2E4B8",
"z 	c #E8CE82",
"A 	c #D9AF33",
"B 	c #DAAE34",
"C 	c #ECD599",
"D 	c #FEFCF7",
"E 	c #FDF5CE",
"F 	c #F8E48E",
"G 	c #F6DF88",
"H 	c #F5DE91",
"I 	c #F5DF97",
"J 	c #F5E09F",
"K 	c #F5DFA2",
"L 	c #F6E1AC",
"M 	c #FAEECE",
"N 	c #FEFBEF",
"O 	c #FEFEF6",
"P 	c #FEFDF4",
"Q 	c #FEFCF3",
"R 	c #FEFCF2",
"S 	c #FEFCF1",
"T 	c #FEFCF0",
"U 	c #FEFBEE",
"V 	c #FFFDFA",
"W 	c #EDD79A",
"X 	c #DAAE35",
"Y 	c #D9AC35",
"Z 	c #EBD498",
"` 	c #FEFBF4",
" .	c #FCF2CA",
"..	c #F6E08A",
"+.	c #F5DC84",
"@.	c #F4DC8C",
"#.	c #F4DB8C",
"$.	c #F3DA8B",
"%.	c #F2D583",
"&.	c #F0D280",
"*.	c #F1D890",
"=.	c #F3E0A5",
"-.	c #F5E5B4",
";.	c #F7E9BE",
">.	c #F7E8BB",
",.	c #F7E7B9",
"'.	c #F7E7B6",
").	c #F7E6B5",
"!.	c #F7E5B3",
"~.	c #F6E4AD",
"{.	c #F7E5AF",
"].	c #FCF5DF",
"^.	c #FEFCF8",
"/.	c #ECD698",
"(.	c #D9AE34",
"_.	c #D9AA36",
":.	c #EBD296",
"<.	c #FDFAF1",
"[.	c #FBF1CE",
"}.	c #F5DE94",
"|.	c #F4DC8F",
"1.	c #F4DC93",
"2.	c #F3D98B",
"3.	c #F2D581",
"4.	c #F0CF74",
"5.	c #EDCA6A",
"6.	c #EBC968",
"7.	c #EACB6C",
"8.	c #ECCF79",
"9.	c #EFD385",
"0.	c #EFD384",
"a.	c #EFD280",
"b.	c #EFD17D",
"c.	c #EFD07A",
"d.	c #EECF78",
"e.	c #EECF76",
"f.	c #EDCC6C",
"g.	c #EECF72",
"h.	c #F7E7B8",
"i.	c #FBF7E9",
"j.	c #EAD392",
"k.	c #D9AD33",
"l.	c #D9AA35",
"m.	c #EAD192",
"n.	c #FCF7EB",
"o.	c #F8ECC8",
"p.	c #F1D68E",
"q.	c #F0D386",
"r.	c #F0D287",
"s.	c #EECB79",
"t.	c #ECC770",
"u.	c #EECD7F",
"v.	c #F0D793",
"w.	c #F2DD9F",
"x.	c #F3E1A8",
"y.	c #F5E4B3",
"z.	c #F6E6BB",
"A.	c #F6E6B9",
"B.	c #F6E6B7",
"C.	c #F6E5B5",
"D.	c #F6E5B4",
"E.	c #F6E4B3",
"F.	c #F5E3AE",
"G.	c #F6E4B1",
"H.	c #FBF5DF",
"I.	c #FDFBF5",
"J.	c #EBD395",
"K.	c #DAAC35",
"L.	c #D9AA34",
"M.	c #EAD08F",
"N.	c #FBF6E8",
"O.	c #F7EACA",
"P.	c #EFD494",
"Q.	c #EED08A",
"R.	c #EECE88",
"S.	c #EBC577",
"T.	c #E9C173",
"U.	c #EFD39A",
"V.	c #F6E9C9",
"W.	c #FBF5E3",
"X.	c #FEFDF5",
"Y.	c #FEFCEF",
"Z.	c #FEFBED",
"`.	c #ECD396",
" +	c #DAAA36",
".+	c #D9A835",
"++	c #EBD092",
"@+	c #FDFAF3",
"#+	c #FCF7EA",
"$+	c #F7E9C9",
"%+	c #F6E6C4",
"&+	c #F6E6C2",
"*+	c #F5E0B9",
"=+	c #F4DEB8",
"-+	c #F7E9CF",
";+	c #FBF6E9",
">+	c #FDFCF3",
",+	c #FFFDF2",
"'+	c #FEF9E0",
")+	c #FCF4CC",
"!+	c #FCF3C6",
"~+	c #FCF3C4",
"{+	c #FBF2C0",
"]+	c #FBF1BC",
"^+	c #FBEFB8",
"/+	c #FBEEB5",
"(+	c #FAECAD",
"_+	c #FAEDAE",
":+	c #FEF8D8",
"<+	c #FEFAEC",
"[+	c #EBCF91",
"}+	c #DAA735",
"|+	c #D9A536",
"1+	c #EBD095",
"2+	c #FFFDF8",
"3+	c #FFFDF7",
"4+	c #FFFDF6",
"5+	c #FFFCF5",
"6+	c #FDFAEA",
"7+	c #FCF6D8",
"8+	c #FAEEB5",
"9+	c #F8E694",
"0+	c #F7E489",
"a+	c #F7E385",
"b+	c #F6E17D",
"c+	c #F6DF76",
"d+	c #F6DD6F",
"e+	c #F5DB68",
"f+	c #F4D859",
"g+	c #F4D85C",
"h+	c #FAEBA3",
"i+	c #FCF4D7",
"j+	c #EBCB8A",
"k+	c #DAA335",
"l+	c #D9A336",
"m+	c #EBCF95",
"n+	c #FFFEFC",
"o+	c #FFFAE8",
"p+	c #FEFAE3",
"q+	c #FEF9DD",
"r+	c #FEF8DA",
"s+	c #FDF6D4",
"t+	c #FBF0C0",
"u+	c #F9ECB1",
"v+	c #F8E79A",
"w+	c #F7E284",
"x+	c #F6E079",
"y+	c #F6DE73",
"z+	c #F6DC6B",
"A+	c #F5DA63",
"B+	c #F5D95B",
"C+	c #F4D754",
"D+	c #F3D345",
"E+	c #F3D448",
"F+	c #F9E896",
"G+	c #FCF3D1",
"H+	c #EBCA88",
"I+	c #DAA135",
"J+	c #D9A135",
"K+	c #EBCD94",
"L+	c #FEFCF6",
"M+	c #FFFDEC",
"N+	c #FCF2C8",
"O+	c #FBF0BE",
"P+	c #FBEFB9",
"Q+	c #FAEEB3",
"R+	c #FAECAC",
"S+	c #FAEAA4",
"T+	c #F9E89C",
"U+	c #F8E593",
"V+	c #F7E38B",
"W+	c #F6E183",
"X+	c #F6E07C",
"Y+	c #F6DE74",
"Z+	c #F6DC6C",
"`+	c #F6DA64",
" @	c #F5D95D",
".@	c #F4D856",
"+@	c #F4D64F",
"@@	c #F3D240",
"#@	c #F3D344",
"$@	c #FAE893",
"%@	c #FCF3D0",
"&@	c #EBC987",
"*@	c #DA9F35",
"=@	c #DA9D35",
"-@	c #EBCA93",
";@	c #FDFBF4",
">@	c #FEFBE4",
",@	c #FBEFBC",
"'@	c #FAEDB1",
")@	c #FAEBAC",
"!@	c #F9EAA5",
"~@	c #F9E89D",
"{@	c #F8E695",
"]@	c #F8E48C",
"^@	c #F6E07D",
"/@	c #F6DE76",
"(@	c #F5DD70",
"_@	c #F5DB69",
":@	c #F5D961",
"<@	c #F5D85A",
"[@	c #F4D652",
"}@	c #F4D54B",
"|@	c #F2D035",
"1@	c #F2D039",
"2@	c #F9E78C",
"3@	c #FCF2CE",
"4@	c #EBC787",
"5@	c #DA9B35",
"6@	c #DA9935",
"7@	c #EBC893",
"8@	c #FDFAF2",
"9@	c #FEFADF",
"0@	c #FAEDB3",
"a@	c #F9EAA8",
"b@	c #F9E9A4",
"c@	c #F8E89D",
"d@	c #F8E48D",
"e@	c #F7E285",
"f@	c #F6E07E",
"g@	c #F6DC6D",
"h@	c #F5DB65",
"i@	c #F4D95E",
"j@	c #F4D757",
"k@	c #F4D550",
"l@	c #F3D449",
"m@	c #F2D242",
"n@	c #F2D13B",
"o@	c #F1CD2B",
"p@	c #F1CE30",
"q@	c #F8E587",
"r@	c #FBF2CC",
"s@	c #EAC586",
"t@	c #DA9835",
"u@	c #DA9635",
"v@	c #EBC793",
"w@	c #FEFBF1",
"x@	c #FEF9D9",
"y@	c #FAEBA8",
"z@	c #F9E99D",
"A@	c #F9E798",
"B@	c #F8E590",
"C@	c #F8E488",
"D@	c #F7E280",
"E@	c #F7E078",
"F@	c #F6DE71",
"G@	c #F6DC69",
"H@	c #F5DA61",
"I@	c #F5D958",
"J@	c #F4D751",
"K@	c #F3D54B",
"L@	c #F3D343",
"M@	c #F2D23C",
"N@	c #F1CE2F",
"O@	c #F0CB1F",
"P@	c #F0CC26",
"Q@	c #F8E581",
"R@	c #FBF2CB",
"S@	c #EAC487",
"T@	c #DA9435",
"U@	c #EBC692",
"V@	c #FEFAEF",
"W@	c #FEF8D4",
"X@	c #F9E9A1",
"Y@	c #F8E591",
"Z@	c #F8E389",
"`@	c #F7E181",
" #	c #F6DE72",
".#	c #F6DC6A",
"+#	c #F4D85B",
"@#	c #F4D54D",
"##	c #F3D347",
"$#	c #F2D140",
"%#	c #F2CE33",
"&#	c #F1CD2E",
"*#	c #F0C91F",
"=#	c #F0CB26",
"-#	c #F7E481",
";#	c #FBF2CA",
">#	c #EAC386",
",#	c #D99134",
"'#	c #EBC390",
")#	c #FDF9ED",
"!#	c #FDF7D7",
"~#	c #F8E8AA",
"{#	c #F8E5A0",
"]#	c #F8E59D",
"^#	c #F7E397",
"/#	c #F7E291",
"(#	c #F6E18B",
"_#	c #F6E085",
":#	c #F6DE7F",
"<#	c #F6DD79",
"[#	c #F5DB73",
"}#	c #F5DA6D",
"|#	c #F4D969",
"1#	c #F4D764",
"2#	c #F3D65E",
"3#	c #F3D559",
"4#	c #F3D454",
"5#	c #F2D350",
"6#	c #F2D045",
"7#	c #F2D14B",
"8#	c #FBF4CF",
"9#	c #EAC286",
"0#	c #D99034",
"a#	c #D88E33",
"b#	c #E9BE87",
"c#	c #FAEFDC",
"d#	c #F9EBCB",
"e#	c #F4DDA6",
"f#	c #F4DB9F",
"g#	c #F4DB9E",
"h#	c #F4DB9A",
"i#	c #F3DA96",
"j#	c #F3D992",
"k#	c #F3D88E",
"l#	c #F3D88A",
"m#	c #F3D786",
"n#	c #F2D682",
"o#	c #F2D47F",
"p#	c #F2D37C",
"q#	c #F2D379",
"r#	c #F2D376",
"s#	c #F1D272",
"t#	c #F1D16F",
"u#	c #F1D06C",
"v#	c #F1CE65",
"w#	c #F1CF69",
"x#	c #F6E29E",
"y#	c #F8EAC2",
"z#	c #E8BC7E",
"A#	c #D98D33",
"B#	c #D78A30",
"C#	c #E1A763",
"D#	c #EAC18D",
"E#	c #E8BA7E",
"F#	c #E5B069",
"G#	c #E5AE64",
"H#	c #E5AF64",
"I#	c #E5AF62",
"J#	c #E5AE60",
"K#	c #E5AE5E",
"L#	c #E5AE5D",
"M#	c #E5AD5B",
"N#	c #E5AD59",
"O#	c #E4AD58",
"P#	c #E4AC56",
"Q#	c #E4AC55",
"R#	c #E4AB54",
"S#	c #E4AB53",
"T#	c #E4AB51",
"U#	c #E4AB50",
"V#	c #E4AA4F",
"W#	c #E4A94B",
"X#	c #E4A94D",
"Y#	c #E6B264",
"Z#	c #E7B774",
"`#	c #E0A357",
" $	c #D88A30",
".$	c #D7862C",
"+$	c #D7872D",
"@$	c #D8872D",
"#$	c #D8862D",
"$$	c #D8872C",
"%$	c #D8862C",
"                                                                ",
"                                                                ",
"                                                                ",
"                                                                ",
"                                                                ",
"                                                                ",
"                                                                ",
"                                                                ",
"      . + @ @ @ @ @ # $ % &                                     ",
"  * = - ; > > > , ' ) ! ~ { ] ^ / ( ( ( _ ( : < [               ",
"  * } | 1 2 2 3 4 4 1 2 5 6 7 8 [ 9 9 9 0 9 a b c d e           ",
"  f g 1 h i j k l m n o p 2 q r ! r s r t u v w x y z A         ",
"  B C D E F G H I J K L M N O P P Q R S T N U U 2 V W X         ",
"  Y Z `  ...+.@.#.$.%.&.*.=.-.;.;.>.,.'.).!.~.{.].^./.(.        ",
"  _.:.<.[.}.|.1.2.3.4.5.6.7.8.9.0.a.b.c.d.e.f.g.h.i.j.k.        ",
"  l.m.n.o.p.q.r.s.t.u.v.w.x.y.z.z.A.B.C.D.E.F.G.H.I.J.K.        ",
"  L.M.N.O.P.Q.R.S.T.U.V.W.R X.Q Q R S T Y.N Z.U 1 2 `. +        ",
"  .+++@+#+$+%+&+*+=+-+;+>+,+'+)+!+~+{+]+^+/+(+_+:+<+[+}+        ",
"  |+1+2 1 2+3+4+p 5+p Q 6+7+8+9+0+a+b+c+d+e+f+g+h+i+j+k+        ",
"  l+m+n+2 o+p+'+q+r+s+)+t+u+v+w+x+y+z+A+B+C+D+E+F+G+H+I+        ",
"  J+K+L+M+N+O+P+Q+R+S+T+U+V+W+X+Y+Z+`+ @.@+@@@#@$@%@&@*@        ",
"  =@-@;@>@,@'@)@!@~@{@]@w+^@/@(@_@:@<@[@}@#@|@1@2@3@4@5@        ",
"  6@7@8@9@0@a@b@c@{@d@e@f@/@g@h@i@j@k@l@m@n@o@p@q@r@s@t@        ",
"  u@v@w@x@y@z@A@B@C@D@E@F@G@H@I@J@K@L@M@|@N@O@P@Q@R@S@u@        ",
"  T@U@V@W@X@{@Y@Z@`@x+ #.#A++#C+@###$#1@%#&#*#=#-#;#>#T@        ",
"  ,#'#)#!#~#{#]#^#/#(#_#:#<#[#}#|#1#2#3#4#5#6#7#F+8#9#0#        ",
"  a#b#c#d#e#f#g#h#i#j#k#l#m#n#o#p#q#r#s#t#u#v#w#x#y#z#A#        ",
"  B#C#D#E#F#G#H#I#J#K#L#M#N#O#P#Q#R#S#T#U#V#W#X#Y#Z#`# $        ",
"    .$+$@$#$@$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$%$$$$$$$          ",
"                                                                ",
"                                                                ",
"                                                                "};

static const char * partition_xpm[] = {
"16 16 142 2",
"  	c None",
". 	c #E36361",
"+ 	c #E25751",
"@ 	c #E3625F",
"# 	c #CE7873",
"$ 	c #EC6F6E",
"% 	c #EB6866",
"& 	c #E9625F",
"* 	c #F07878",
"= 	c #F07474",
"- 	c #EB6B69",
"; 	c #EC716F",
"> 	c #CC7772",
", 	c #DB5A54",
"' 	c #F27C7C",
") 	c #F79397",
"! 	c #E96864",
"~ 	c #E35852",
"{ 	c #D9564D",
"] 	c #77A86E",
"^ 	c #E0524C",
"/ 	c #F4A2A2",
"( 	c #EC6C6A",
"_ 	c #EA6361",
": 	c #EA6665",
"< 	c #E7615C",
"[ 	c #E2574F",
"} 	c #7A9E75",
"| 	c #85B47C",
"1 	c #7EAF76",
"2 	c #78AB6F",
"3 	c #E1544E",
"4 	c #F9B1B4",
"5 	c #F59695",
"6 	c #EB6A66",
"7 	c #EC726E",
"8 	c #E55C5A",
"9 	c #E25851",
"0 	c #6BA064",
"a 	c #8FBA86",
"b 	c #A2C699",
"c 	c #7CAD74",
"d 	c #F49697",
"e 	c #F49393",
"f 	c #F08D8C",
"g 	c #E8605C",
"h 	c #E8615D",
"i 	c #659F5D",
"j 	c #BED6B9",
"k 	c #8FBA87",
"l 	c #78AC71",
"m 	c #DC5953",
"n 	c #F49698",
"o 	c #F39191",
"p 	c #F08A89",
"q 	c #E75F5B",
"r 	c #E45851",
"s 	c #D85449",
"t 	c #68A060",
"u 	c #C9DEC5",
"v 	c #B9D4B4",
"w 	c #AAC9A4",
"x 	c #9AAB81",
"y 	c #C36D61",
"z 	c #E05850",
"A 	c #E45B58",
"B 	c #DC5249",
"C 	c #BE6360",
"D 	c #7F89A6",
"E 	c #719AC1",
"F 	c #6B85A5",
"G 	c #69A162",
"H 	c #C5DAC0",
"I 	c #B3D0AD",
"J 	c #B1CEAB",
"K 	c #A6C89E",
"L 	c #76AA6D",
"M 	c #7E7B95",
"N 	c #C8615A",
"O 	c #E35850",
"P 	c #E0564F",
"Q 	c #C85F58",
"R 	c #847890",
"S 	c #6690BB",
"T 	c #8FB3D1",
"U 	c #7BA2C6",
"V 	c #4F78A9",
"W 	c #6B9F63",
"X 	c #AFCDA9",
"Y 	c #ACCCA6",
"Z 	c #A9C9A2",
"` 	c #9FC599",
" .	c #74A96B",
"..	c #4F7CAE",
"+.	c #B0C8DC",
"@.	c #819FBF",
"#.	c #658DB8",
"$.	c #6891BC",
"%.	c #608AB7",
"&.	c #527EB1",
"*.	c #6C9668",
"=.	c #6CA366",
"-.	c #99C093",
";.	c #A4C79E",
">.	c #517EAF",
",.	c #BCD0E3",
"'.	c #ABC3DA",
").	c #9EB8D3",
"!.	c #7DA3C7",
"~.	c #6F98C1",
"{.	c #5C89B6",
"].	c #628EBA",
"^.	c #5480B1",
"/.	c #659561",
"(.	c #6AA263",
"_.	c #69A161",
":.	c #B8CDE1",
"<.	c #A5C0D8",
"[.	c #A7C0D8",
"}.	c #9DBAD4",
"|.	c #608CB8",
"1.	c #618DB8",
"2.	c #567FAD",
"3.	c #9FBBD5",
"4.	c #9EBBD6",
"5.	c #9CB8D3",
"6.	c #94B3D1",
"7.	c #5D89B7",
"8.	c #5681B2",
"9.	c #4D75A8",
"0.	c #5B7BA0",
"a.	c #5881B2",
"b.	c #89ABCB",
"c.	c #95B4D1",
"d.	c #638EBB",
"e.	c #5A87B5",
"f.	c #4D77AB",
"g.	c #56759B",
"h.	c #5778A1",
"i.	c #5680B2",
"j.	c #527EAF",
"k.	c #5375A1",
"                                ",
"              . + + @           ",
"        # $ % & * = & - ; >     ",
"        , ' ) ! ~ ~ ! ) ' {     ",
"      ] ^ / ( _ ) ) ! : < [     ",
"} | 1 2 3 4 5 6 ; 7 8 < & 9     ",
"0 a b c [ 4 d e f g < h & [     ",
"i j k l m 6 n o p q & h r s     ",
"t u v w x y z % e _ A B C D E F ",
"G H I J K L M N O P Q R S T U V ",
"W X Y Z `  ...+.@.#.T T S $.%.&.",
"  *.=.-.;.l >.,.'.).!.~.{.%.].^.",
"      /.(._.&.:.<.[.}.|.%.1.].&.",
"            2.3.4.5.6.7.].1.8.9.",
"              0.a.b.c.d.e.f.g.  ",
"                  h.i.j.k.      "};

static const char * partition_large_xpm[] = {
"32 32 572 2",
"  	c None",
". 	c #E36361",
"+ 	c #E25D59",
"@ 	c #E25751",
"# 	c #E25C58",
"$ 	c #E3625F",
"% 	c #D96764",
"& 	c #D86763",
"* 	c #DB7471",
"= 	c #E4716F",
"- 	c #E16E6B",
"; 	c #DF6B68",
"> 	c #E36663",
", 	c #E66260",
"' 	c #E86562",
") 	c #E96864",
"! 	c #E96664",
"~ 	c #E96662",
"{ 	c #E86461",
"] 	c #E6625F",
"^ 	c #E36763",
"/ 	c #DE6D6A",
"( 	c #E1706D",
"_ 	c #E47370",
": 	c #DA7571",
"< 	c #CE7873",
"[ 	c #DF7370",
"} 	c #EC6F6E",
"| 	c #EC6C6A",
"1 	c #EB6866",
"2 	c #EA6562",
"3 	c #E9625F",
"4 	c #EC6D6C",
"5 	c #F07878",
"6 	c #F07676",
"7 	c #F07474",
"8 	c #EC6B6A",
"9 	c #EA6664",
"0 	c #EB6B69",
"a 	c #EC6E6C",
"b 	c #EC716F",
"c 	c #DE7470",
"d 	c #CC7772",
"e 	c #D56762",
"f 	c #E36F6C",
"g 	c #EF7675",
"h 	c #F07A7A",
"i 	c #F17E7E",
"j 	c #ED7170",
"k 	c #E96562",
"l 	c #E96663",
"m 	c #EA6865",
"n 	c #EA6764",
"o 	c #EA6663",
"p 	c #ED7271",
"q 	c #F17F80",
"r 	c #F07B7B",
"s 	c #EF7676",
"t 	c #E26E6A",
"u 	c #D3655D",
"v 	c #DB5A54",
"w 	c #E76B68",
"x 	c #F27C7C",
"y 	c #F4888A",
"z 	c #F79397",
"A 	c #F07E7E",
"B 	c #E6605B",
"C 	c #E35852",
"D 	c #E66965",
"E 	c #D9564D",
"F 	c #D55A51",
"G 	c #77A86E",
"H 	c #BB715A",
"I 	c #DE5650",
"J 	c #E87370",
"K 	c #F38F8F",
"L 	c #F28788",
"M 	c #F28080",
"N 	c #EE7272",
"O 	c #EA6662",
"P 	c #EB6E6C",
"Q 	c #ED7674",
"R 	c #EB6F6C",
"S 	c #F07C7E",
"T 	c #EE7675",
"U 	c #E5635D",
"V 	c #DE574E",
"W 	c #D95B52",
"X 	c #75A16D",
"Y 	c #AC7D5D",
"Z 	c #E0524C",
"` 	c #EA7A77",
" .	c #F4A2A2",
"..	c #F08786",
"+.	c #EA6361",
"@.	c #F07B7C",
"#.	c #EA6665",
"$.	c #E86460",
"%.	c #E7615C",
"&.	c #E45C56",
"*.	c #E2574F",
"=.	c #DC5C54",
"-.	c #7FA878",
";.	c #82AE7A",
">.	c #7EAA77",
",.	c #7AA773",
"'.	c #79A870",
").	c #78AA6E",
"!.	c #AC7E5E",
"~.	c #E0534D",
"{.	c #EC7E7C",
"].	c #F6AAAB",
"^.	c #F49595",
"/.	c #F08180",
"(.	c #EE7472",
"_.	c #EE7473",
":.	c #F28283",
"<.	c #F28282",
"[.	c #EC7271",
"}.	c #E7625F",
"|.	c #E86360",
"1.	c #E8625F",
"2.	c #E8625E",
"3.	c #E55C57",
"4.	c #E25850",
"5.	c #DC5C55",
"6.	c #7A9E75",
"7.	c #80AA79",
"8.	c #85B47C",
"9.	c #82B279",
"0.	c #7EAF76",
"a.	c #7BAD72",
"b.	c #78AB6F",
"c.	c #AC805E",
"d.	c #E1544E",
"e.	c #ED8281",
"f.	c #F9B1B4",
"g.	c #F7A4A4",
"h.	c #F59695",
"i.	c #F0807E",
"j.	c #EB6A66",
"k.	c #EC6E6A",
"l.	c #EC726E",
"m.	c #E86764",
"n.	c #E55C5A",
"o.	c #E65E5B",
"p.	c #E65D58",
"q.	c #E25851",
"r.	c #DC5D55",
"s.	c #729F6B",
"t.	c #7FAC77",
"u.	c #8AB781",
"v.	c #8DB984",
"w.	c #90BA88",
"x.	c #85B37C",
"y.	c #7AAC72",
"z.	c #AE8160",
"A.	c #E2564E",
"B.	c #ED8381",
"C.	c #F7A4A5",
"D.	c #F49696",
"E.	c #F28A89",
"F.	c #F07E7C",
"G.	c #EF7F7D",
"H.	c #EE7F7E",
"I.	c #EC7471",
"J.	c #EA6965",
"K.	c #E7605C",
"L.	c #E8615C",
"M.	c #6BA064",
"N.	c #7DAD75",
"O.	c #8FBA86",
"P.	c #98C090",
"Q.	c #A2C699",
"R.	c #7CAD74",
"S.	c #AF8262",
"T.	c #EE8482",
"U.	c #F6A4A6",
"V.	c #F49697",
"W.	c #F49495",
"X.	c #F49393",
"Y.	c #F29090",
"Z.	c #F08D8C",
"`.	c #EC7674",
" +	c #E8605C",
".+	c #E8615D",
"++	c #E65C57",
"@+	c #689F60",
"#+	c #87B480",
"$+	c #A6C8A0",
"%+	c #A0C498",
"&+	c #89B681",
"*+	c #AC8262",
"=+	c #DF5851",
"-+	c #E8736F",
";+	c #F28E8D",
">+	c #F39292",
",+	c #F49698",
"'+	c #F49292",
")+	c #F28F8E",
"!+	c #F08C8A",
"~+	c #EC7673",
"{+	c #E75F5A",
"]+	c #E25952",
"^+	c #DD564C",
"/+	c #CF5C56",
"(+	c #659F5D",
"_+	c #92BA8B",
":+	c #BED6B9",
"<+	c #8FBA87",
"[+	c #84B37C",
"}+	c #78AC71",
"|+	c #AA8262",
"1+	c #DC5953",
"2+	c #E4625C",
"3+	c #F0807F",
"4+	c #F49494",
"5+	c #F39191",
"6+	c #F08A89",
"7+	c #EC7472",
"8+	c #E75F5B",
"9+	c #E8605D",
"0+	c #E45851",
"a+	c #DE564D",
"b+	c #D85449",
"c+	c #C45D59",
"d+	c #66A05E",
"e+	c #95BD8F",
"f+	c #C4DABF",
"g+	c #B4D0AE",
"h+	c #A4C79E",
"i+	c #9AC194",
"j+	c #91BA8A",
"k+	c #A69E7A",
"l+	c #BB826A",
"m+	c #C97767",
"n+	c #D76C64",
"o+	c #E0716C",
"p+	c #EA7774",
"q+	c #EC7A78",
"r+	c #EF7C7C",
"s+	c #F08685",
"t+	c #F28E8E",
"u+	c #ED7876",
"v+	c #E8615E",
"w+	c #E65E5C",
"x+	c #E45C57",
"y+	c #E25A53",
"z+	c #DA5C56",
"A+	c #D15E58",
"B+	c #BE6668",
"C+	c #AB6F78",
"D+	c #957D91",
"E+	c #7294B8",
"F+	c #6F8EB1",
"G+	c #68A060",
"H+	c #98BF92",
"I+	c #C9DEC5",
"J+	c #C1D9BC",
"K+	c #B9D4B4",
"L+	c #B2CEAC",
"M+	c #AAC9A4",
"N+	c #A2BA92",
"O+	c #9AAB81",
"P+	c #AE8C71",
"Q+	c #C36D61",
"R+	c #D26258",
"S+	c #E05850",
"T+	c #EF7B7A",
"U+	c #E75F5C",
"V+	c #E45B58",
"W+	c #E05650",
"X+	c #DC5249",
"Y+	c #CD5A54",
"Z+	c #BE6360",
"`+	c #9E7683",
" @	c #7F89A6",
".@	c #7892B4",
"+@	c #719AC1",
"@@	c #6E91B5",
"#@	c #6B85A5",
"$@	c #68A061",
"%@	c #98BE92",
"&@	c #C7DCC2",
"*@	c #BED7BA",
"=@	c #B6D2B0",
"-@	c #B2CFAC",
";@	c #AECCA8",
">@	c #A7C29C",
",@	c #A0BA90",
"'@	c #9EA27B",
")@	c #9C8C67",
"!@	c #A67A6D",
"~@	c #AF6A72",
"{@	c #C46769",
"]@	c #DA6460",
"^@	c #E26D69",
"/@	c #EC7672",
"(@	c #E86965",
"_@	c #E55C58",
":@	c #DE5D58",
"<@	c #D65D58",
"[@	c #C36162",
"}@	c #B0656C",
"|@	c #A16F7D",
"1@	c #927A8E",
"2@	c #8C8CA4",
"3@	c #879EBC",
"4@	c #7E9EC0",
"5@	c #769EC4",
"6@	c #698FB6",
"7@	c #5B7EA7",
"8@	c #69A162",
"9@	c #97BE91",
"0@	c #C5DAC0",
"a@	c #BCD5B6",
"b@	c #B3D0AD",
"c@	c #B1CEAB",
"d@	c #ACCBA4",
"e@	c #A6C89E",
"f@	c #8EB986",
"g@	c #76AA6D",
"h@	c #7A9281",
"i@	c #7E7B95",
"j@	c #A36E78",
"k@	c #C8615A",
"l@	c #D65C55",
"m@	c #E35850",
"n@	c #E25750",
"o@	c #E0564F",
"p@	c #D45A54",
"q@	c #C85F58",
"r@	c #A66C74",
"s@	c #847890",
"t@	c #7584A6",
"u@	c #6690BB",
"v@	c #7AA2C6",
"w@	c #8FB3D1",
"x@	c #85AACC",
"y@	c #7BA2C6",
"z@	c #658DB8",
"A@	c #4F78A9",
"B@	c #6AA062",
"C@	c #92BA8C",
"D@	c #BAD4B4",
"E@	c #B5D1AF",
"F@	c #B0CEAA",
"G@	c #AECDA8",
"H@	c #ADCCA6",
"I@	c #A8C9A1",
"J@	c #A2C69C",
"K@	c #8CB884",
"L@	c #75AA6C",
"M@	c #6E9287",
"N@	c #667CA2",
"O@	c #91889E",
"P@	c #BC949B",
"Q@	c #B78891",
"R@	c #B27C88",
"S@	c #AA7686",
"T@	c #A27284",
"U@	c #A77D8C",
"V@	c #AC8994",
"W@	c #9A8FA2",
"X@	c #8A96B0",
"Y@	c #7893B6",
"Z@	c #7199C1",
"`@	c #7CA2C6",
" #	c #749CC2",
".#	c #6E96BE",
"+#	c #5F89B6",
"@#	c #517BAD",
"##	c #6B9F63",
"$#	c #8DB686",
"%#	c #AFCDA9",
"&#	c #ACCCA6",
"*#	c #AACAA4",
"=#	c #A9C9A2",
"-#	c #9FC599",
";#	c #8AB782",
">#	c #74A96B",
",#	c #62928C",
"'#	c #4F7CAE",
")#	c #80A2C5",
"!#	c #B0C8DC",
"~#	c #98B4CE",
"{#	c #819FBF",
"]#	c #7396BC",
"^#	c #7AA0C4",
"/#	c #6790BC",
"(#	c #6891BC",
"_#	c #648EBA",
":#	c #608AB7",
"<#	c #5984B4",
"[#	c #527EB1",
"}#	c #6C9C65",
"|#	c #81AA7C",
"1#	c #8FB38A",
"2#	c #8EB588",
"3#	c #8CB886",
"4#	c #96BE90",
"5#	c #A1C49A",
"6#	c #A1C59B",
"7#	c #8CB885",
"8#	c #76AA6E",
"9#	c #63948E",
"0#	c #507DAE",
"a#	c #83A4C7",
"b#	c #B6CCE0",
"c#	c #A6BED6",
"d#	c #96B1CC",
"e#	c #8CAAC9",
"f#	c #82A2C6",
"g#	c #84A7C9",
"h#	c #86ABCC",
"i#	c #82A8CA",
"j#	c #7FA6C9",
"k#	c #7099C1",
"l#	c #618CB8",
"m#	c #628DB9",
"n#	c #5A86B5",
"o#	c #537FB1",
"p#	c #6D9569",
"q#	c #6C9668",
"r#	c #6C9D67",
"s#	c #6CA366",
"t#	c #82B27C",
"u#	c #99C093",
"v#	c #9EC498",
"w#	c #8EBA88",
"x#	c #649590",
"y#	c #517EAF",
"z#	c #86A7C9",
"A#	c #BCD0E3",
"B#	c #B4CADE",
"C#	c #ABC3DA",
"D#	c #A4BED6",
"E#	c #9EB8D3",
"F#	c #8EAECD",
"G#	c #7DA3C7",
"H#	c #6F98C1",
"I#	c #6690BC",
"J#	c #5C89B6",
"K#	c #5E8AB6",
"L#	c #628EBA",
"M#	c #5B87B6",
"N#	c #5480B1",
"O#	c #6D9B68",
"P#	c #6D9E68",
"Q#	c #78A573",
"R#	c #80AB7B",
"S#	c #83B07E",
"T#	c #7CAE75",
"U#	c #70A669",
"V#	c #61928C",
"W#	c #527EB0",
"X#	c #86A6C9",
"Y#	c #BACEE2",
"Z#	c #B1C8DE",
"`#	c #A8C2D9",
" $	c #A5BFD7",
".$	c #A2BCD6",
"+$	c #98B5D2",
"@$	c #8DAECE",
"#$	c #7AA0C5",
"$$	c #6892BC",
"%$	c #638EBA",
"&$	c #5F8AB7",
"*$	c #608CB8",
"=$	c #618DB9",
"-$	c #5A86B6",
";$	c #689464",
">$	c #659561",
",$	c #689C62",
"'$	c #6AA263",
")$	c #6AA262",
"!$	c #69A161",
"~$	c #5E9089",
"{$	c #85A6C9",
"]$	c #B8CDE1",
"^$	c #AEC6DC",
"/$	c #A5C0D8",
"($	c #A6C0D8",
"_$	c #A7C0D8",
":$	c #A2BDD6",
"<$	c #9DBAD4",
"[$	c #7EA3C6",
"}$	c #608BB8",
"|$	c #618DB8",
"1$	c #628EB9",
"2$	c #689B62",
"3$	c #6AA164",
"4$	c #6AA063",
"5$	c #69A061",
"6$	c #5B8A95",
"7$	c #547EAF",
"8$	c #80A1C5",
"9$	c #ACC4DB",
"0$	c #A6C1D9",
"a$	c #A2BED7",
"b$	c #9DB9D4",
"c$	c #98B6D2",
"d$	c #7CA0C5",
"e$	c #5E8AB8",
"f$	c #5E8AB7",
"g$	c #5C88B6",
"h$	c #5681B1",
"i$	c #507AAD",
"j$	c #577FAB",
"k$	c #567FAD",
"l$	c #7B9DC1",
"m$	c #9FBBD5",
"n$	c #9EBBD6",
"o$	c #9CB8D3",
"p$	c #94B3D1",
"q$	c #789EC4",
"r$	c #5D89B7",
"s$	c #5C87B5",
"t$	c #5681B2",
"u$	c #527BAD",
"v$	c #4D75A8",
"w$	c #597EA9",
"x$	c #7091B4",
"y$	c #7F9DBC",
"z$	c #7D9DC0",
"A$	c #7B9EC4",
"B$	c #87A8CA",
"C$	c #92B2CF",
"D$	c #94B2D0",
"E$	c #94B4D1",
"F$	c #608CB9",
"G$	c #5F8BB8",
"H$	c #5A86B4",
"I$	c #5782B2",
"J$	c #577FAC",
"K$	c #567BA7",
"L$	c #5479A6",
"M$	c #5175A3",
"N$	c #5D7B9E",
"O$	c #5B7BA0",
"P$	c #5881B2",
"Q$	c #7096BE",
"R$	c #89ABCB",
"S$	c #8FB0CE",
"T$	c #95B4D1",
"U$	c #7CA1C6",
"V$	c #638EBB",
"W$	c #5A87B5",
"X$	c #547FB0",
"Y$	c #4D77AB",
"Z$	c #5176A3",
"`$	c #56759B",
" %	c #597599",
".%	c #5C7EA7",
"+%	c #5D80AB",
"@%	c #688BB2",
"#%	c #7192B6",
"$%	c #769AC2",
"%%	c #6890BB",
"&%	c #5982B0",
"*%	c #577EAB",
"=%	c #557BA8",
"-%	c #5377A4",
";%	c #5476A1",
">%	c #5C799F",
",%	c #5778A1",
"'%	c #567CAA",
")%	c #5680B2",
"!%	c #527EAF",
"~%	c #527AA8",
"{%	c #5375A1",
"]%	c #57769D",
"                                                                ",
"                                                                ",
"                              . + @ @ @ # $                     ",
"                            % . + @ @ @ # $ &                   ",
"                    * = - ; > , ' ) ! ~ { ] ^ / ( _ :           ",
"                  < [ } | 1 2 3 4 5 6 7 8 3 9 0 a b c d         ",
"                  e f g h i j k l m n o ~ k p q r s t u         ",
"                v v w x y z A ) B C C C B ) A z y x D E F       ",
"              G H I J K L M N O P Q Q Q R ) p S T a U V W       ",
"            X G Y Z `  ...| 1 +.@.z z z A ) n #.$.%.&.*.=.      ",
"    -.;.>.,.'.).!.~.{.].^./.(.9 _.:.:.<.[.}.|.$.1.2.3.4.5.      ",
"6.6.7.8.9.0.a.b.c.d.e.f.g.h.i.j.k.b l.l.m.n.o.%.2.3 p.q.r.      ",
"s.s.t.u.v.w.x.y.z.A.B.f.C.D.E.F.G.H.I.J.$.o.K.L.2.3 p.4.5.      ",
"M.M.N.O.P.Q.O.R.S.*.T.f.U.V.W.X.Y.Z.`. + +%.L..+2.3 ++*.=.      ",
"@+@+#+$+%+P.&+y.*+=+-+;+>+,+W.'+)+!+~+ + +2..+.+{+p.]+^+/+      ",
"(+(+_+:+$+<+[+}+|+1+2+j.3+,+4+5+;+6+7+8+9+3 2..+++0+a+b+c+      ",
"d+d+e+f+g+h+i+j+k+l+m+n+o+p+q+r+s+t+u+v+9+w+x+y+z+A+B+C+D+E+F+  ",
"G+G+H+I+J+K+L+M+N+O+P+Q+R+S+B 1 F.X.T++.U+V+W+X+Y+Z+`+ @.@+@@@#@",
"$@$@%@&@*@=@-@;@>@,@'@)@!@~@{@]@^@/@(@_@:@<@[@}@|@1@2@3@4@5@6@7@",
"8@8@9@0@a@b@-@c@d@e@f@g@h@i@j@k@l@m@n@o@p@q@r@s@t@u@v@w@x@y@z@A@",
"B@B@C@D@E@F@G@H@I@J@K@L@M@N@O@P@Q@R@S@T@U@V@W@X@Y@u@Z@`@ #.#+#@#",
"####$#%#;@&#*#=#h+-#;#>#,#'#)#!#~#{#]#z@^#w@w@w@v@u@/#(#_#:#<#[#",
"}#}#|#1#2#3#4#5#6#J@7#8#9#0#a#b#c#d#e#f#g#h#i#j#k#l#m#_#m#l#n#o#",
"    p#q#r#s#t#u#v#h+w#}+x#y#z#A#B#C#D#E#F#G#5@H#I#J#K#:#l#L#M#N#",
"        O#P#Q#R#S##+T#U#V#W#X#Y#Z#`# $.$+$@$#$$$%$K#&$*$=$L#-$o#",
"            ;$>$,$'$)$!$~$[#{$]$^$/$($_$:$<$[$*$}$:#*$|$1$L#-$[#",
"                2$3$4$5$6$7$8$9$0$a$:$.$b$c$d$e$}$l#l#|$f$g$h$i$",
"                        j$k$l$m$n$n$<$o$c$p$q$r$*$L#1$|$s$t$u$v$",
"                          w$x$y$z$A$B$C$D$E$#$F$G$e$H$I$J$K$L$M$",
"                            N$O$w$P$Q$R$S$T$U$V$e$W$X$Y$Z$`$ %  ",
"                                .%+%@%#%]#$%%%n#&%*%=%-%;%      ",
"                                    >%,%'%)%X$!%~%{%]%          "};



/* XPM */
static const char * provider_xpm[] = {
"16 16 183 2",
"  	c None",
". 	c #FF8100",
"+ 	c #FF7F00",
"@ 	c #FF8900",
"# 	c #FF8D00",
"$ 	c #FF8F05",
"% 	c #FF9103",
"& 	c #FFBF7E",
"* 	c #FFDFC0",
"= 	c #FFD5A9",
"- 	c #FFC882",
"; 	c #FFC476",
"> 	c #FFC87C",
", 	c #FFCA7F",
"' 	c #FFC370",
") 	c #FF8300",
"! 	c #FFCD98",
"~ 	c #FFEBDA",
"{ 	c #FFFAF4",
"] 	c #FFF3E8",
"^ 	c #FFD0A1",
"/ 	c #FFB15C",
"( 	c #FFB15B",
"_ 	c #FFC47B",
": 	c #FF7D00",
"< 	c #FF8500",
"[ 	c #FFC787",
"} 	c #FFC390",
"| 	c #FFBD7D",
"1 	c #FFD9B2",
"2 	c #FFFEFC",
"3 	c #FFDAB2",
"4 	c #FFA955",
"5 	c #FFBA71",
"6 	c #FF7100",
"7 	c #D9B434",
"8 	c #E1C25E",
"9 	c #E2C360",
"0 	c #E2C35F",
"a 	c #FD8804",
"b 	c #FFD5A7",
"c 	c #FFECDB",
"d 	c #FFC386",
"e 	c #FFCC95",
"f 	c #FFFFFF",
"g 	c #FFC493",
"h 	c #FFAE68",
"i 	c #FF6300",
"j 	c #DAB336",
"k 	c #FEFEFD",
"l 	c #FFFFFE",
"m 	c #FFFEFE",
"n 	c #FFFEFD",
"o 	c #FF9210",
"p 	c #FFC77C",
"q 	c #FFBE79",
"r 	c #FFE3C4",
"s 	c #FFFDF9",
"t 	c #FFBA7A",
"u 	c #FFD5B0",
"v 	c #FFF2E8",
"w 	c #FFAE70",
"x 	c #FF5300",
"y 	c #DAAF35",
"z 	c #FEFCF7",
"A 	c #F8E48E",
"B 	c #F5DE91",
"C 	c #F5E09F",
"D 	c #F6E1AC",
"E 	c #FFCE8D",
"F 	c #FFDCB8",
"G 	c #FFC486",
"H 	c #FFE1C2",
"I 	c #FFE5D4",
"J 	c #FFA667",
"K 	c #FFFDFA",
"L 	c #FFBA89",
"M 	c #FF4500",
"N 	c #DAAA36",
"O 	c #FDFAF1",
"P 	c #F5DE94",
"Q 	c #F4DC93",
"R 	c #EECD74",
"S 	c #E4B450",
"T 	c #DF972E",
"U 	c #DD9E3E",
"V 	c #DCA042",
"W 	c #DB9B39",
"X 	c #DB9A37",
"Y 	c #DEA649",
"Z 	c #DD9E3A",
"` 	c #E1B052",
" .	c #FFC8A4",
"..	c #FF3B00",
"+.	c #DAAB35",
"@.	c #FBF6E8",
"#.	c #EFD494",
"$.	c #EECE88",
"%.	c #E9C173",
"&.	c #F9F0DA",
"*.	c #FFEBD3",
"=.	c #FFF9F1",
"-.	c #FFF7EE",
";.	c #FFF4E8",
">.	c #FFF1E5",
",.	c #FFF7F1",
"'.	c #FFF7F2",
").	c #DF9E3E",
"!.	c #FF945F",
"~.	c #FF3F00",
"{.	c #DAA637",
"].	c #FFFDF8",
"^.	c #FFFDF6",
"/.	c #FFFCF5",
"(.	c #FEFCF3",
"_.	c #F5CE54",
":.	c #F6C338",
"<.	c #F5C53B",
"[.	c #F5C43B",
"}.	c #F5C23A",
"|.	c #F5C03A",
"1.	c #FFE1D4",
"2.	c #DF8F2F",
"3.	c #FF3D00",
"4.	c #DAA136",
"5.	c #FEFCF6",
"6.	c #FCF2C8",
"7.	c #FBEFB9",
"8.	c #FAECAC",
"9.	c #F9E89C",
"0.	c #F7E38B",
"a.	c #F6E07C",
"b.	c #F6DC6C",
"c.	c #F5D95D",
"d.	c #F4D64F",
"e.	c #F3D344",
"f.	c #FEFBF1",
"g.	c #DA9B35",
"h.	c #DA9A36",
"i.	c #FDFAF2",
"j.	c #FAEDB3",
"k.	c #F9E9A4",
"l.	c #F8E695",
"m.	c #F7E285",
"n.	c #F6DE76",
"o.	c #F5DB65",
"p.	c #F4D757",
"q.	c #F3D449",
"r.	c #F2D13B",
"s.	c #F1CE30",
"t.	c #FDF9E9",
"u.	c #DA9C35",
"v.	c #DA9435",
"w.	c #FEFAEF",
"x.	c #F9E9A1",
"y.	c #F8E591",
"z.	c #F7E181",
"A.	c #F6DE72",
"B.	c #F5DA63",
"C.	c #F4D754",
"D.	c #F3D347",
"E.	c #F2D039",
"F.	c #F1CD2E",
"G.	c #F0CB26",
"H.	c #FDF8E1",
"I.	c #DA9835",
"J.	c #D98E33",
"K.	c #FAF0DC",
"L.	c #F4DDA7",
"M.	c #F4DB9E",
"N.	c #F3DA96",
"O.	c #F3D88E",
"P.	c #F3D786",
"Q.	c #F2D47F",
"R.	c #F2D379",
"S.	c #F1D272",
"T.	c #F1D06C",
"U.	c #F1CF69",
"V.	c #FAF1D5",
"W.	c #D99233",
"X.	c #D8882D",
"Y.	c #D8872D",
"Z.	c #D8862C",
"                                ",
"              . + . @ # $ % #   ",
"            . & * = - ; > , ' ) ",
"            + ! ~ { ] ^ / ( _ : ",
"            < [ } | 1 2 3 4 5 6 ",
"7 8 9 9 9 0 a b { c d e f g h i ",
"j k l m n l o p q r s t u v w x ",
"y z A B C D o E F G H I J K L M ",
"N O P Q R S T U V W X Y Z `  ...",
"+.@.#.$.%.&.*.=.-.;.>.,.'.).!.~.",
"{.l ].^./.(._.:.<.[.}.|.1.2.3.  ",
"4.5.6.7.8.9.0.a.b.c.d.e.f.g.    ",
"h.i.j.k.l.m.n.o.p.q.r.s.t.u.    ",
"v.w.x.y.z.A.B.C.D.E.F.G.H.I.    ",
"J.K.L.M.N.O.P.Q.R.S.T.U.V.W.    ",
"  X.Y.X.X.X.X.X.X.X.X.Y.X.Z.    "};



static const char * provider_large_xpm[] = {
"32 32 695 2",
"  	c None",
". 	c #FE7E00",
"+ 	c #FF8000",
"@ 	c #FF7F00",
"# 	c #FF7E00",
"$ 	c #FF8100",
"% 	c #FF8400",
"& 	c #FF8800",
"* 	c #FF8B00",
"= 	c #FF8C00",
"- 	c #FF8E02",
"; 	c #FF8E04",
"> 	c #FF9004",
", 	c #FF9102",
"' 	c #FF9001",
") 	c #FE8000",
"! 	c #FE7F00",
"~ 	c #FF9021",
"{ 	c #FF9F3D",
"] 	c #FFA750",
"^ 	c #FFAD5C",
"/ 	c #FFAB58",
"( 	c #FFA84E",
"_ 	c #FFA643",
": 	c #FFA539",
"< 	c #FFA536",
"[ 	c #FFA737",
"} 	c #FFA93C",
"| 	c #FFAC41",
"1 	c #FFAE42",
"2 	c #FFAE41",
"3 	c #FFAD3E",
"4 	c #FFA837",
"5 	c #FF9520",
"6 	c #FE7A00",
"7 	c #FF9D3A",
"8 	c #FFBF7E",
"9 	c #FFD3A7",
"0 	c #FFDFC0",
"a 	c #FFDDBB",
"b 	c #FFD5A9",
"c 	c #FFCE95",
"d 	c #FFC882",
"e 	c #FFC579",
"f 	c #FFC476",
"g 	c #FFC678",
"h 	c #FFC87C",
"i 	c #FFCA7F",
"j 	c #FFCA7E",
"k 	c #FFC370",
"l 	c #FFA43A",
"m 	c #FF8300",
"n 	c #FFA142",
"o 	c #FFCA93",
"p 	c #FFE0C0",
"q 	c #FFEDDD",
"r 	c #FFF2E5",
"s 	c #FFF0E0",
"t 	c #FFEBD3",
"u 	c #FFE3C0",
"v 	c #FFD7A6",
"w 	c #FFCA8D",
"x 	c #FFC27A",
"y 	c #FFBD6E",
"z 	c #FFBE6F",
"A 	c #FFC175",
"B 	c #FFC980",
"C 	c #FFC77C",
"D 	c #FFA540",
"E 	c #FFA346",
"F 	c #FFCD98",
"G 	c #FFEBDA",
"H 	c #FFF5EC",
"I 	c #FFFAF4",
"J 	c #FFF3E8",
"K 	c #FFE3C8",
"L 	c #FFD0A1",
"M 	c #FFBE7A",
"N 	c #FFB15C",
"O 	c #FFAE55",
"P 	c #FFB15B",
"Q 	c #FFBF72",
"R 	c #FFC47B",
"S 	c #FFA241",
"T 	c #FF7C00",
"U 	c #FFA444",
"V 	c #FFCA8F",
"W 	c #FFD3A8",
"X 	c #FFD4B0",
"Y 	c #FFD7B4",
"Z 	c #FFDBB7",
"` 	c #FFE3C7",
" .	c #FFEAD6",
"..	c #FFEEDE",
"+.	c #FFEBD8",
"@.	c #FFD8AF",
"#.	c #FFC280",
"$.	c #FFB261",
"%.	c #FFAA52",
"&.	c #FFB869",
"*.	c #FFC077",
"=.	c #FF9E40",
"-.	c #FF7700",
";.	c #FF8500",
">.	c #FFA541",
",.	c #FFC787",
"'.	c #FFC995",
").	c #FFC390",
"!.	c #FFBE84",
"~.	c #FFBD7D",
"{.	c #FFC892",
"].	c #FFD9B2",
"^.	c #FFF0DF",
"/.	c #FFFEFC",
"(.	c #FFF1E1",
"_.	c #FFDAB2",
":.	c #FFBE7D",
"<.	c #FFA955",
"[.	c #FFB364",
"}.	c #FFBA71",
"|.	c #FF983C",
"1.	c #FF7000",
"2.	c #DDBA4A",
"3.	c #DEBB4D",
"4.	c #DEBC4C",
"5.	c #DFBD4E",
"6.	c #E0BC4C",
"7.	c #F3910C",
"8.	c #FE8601",
"9.	c #FFA747",
"0.	c #FFCE99",
"a.	c #FFDCBA",
"b.	c #FFE0C5",
"c.	c #FFDABA",
"d.	c #FFD1A6",
"e.	c #FFCA96",
"f.	c #FFC991",
"g.	c #FFD8AE",
"h.	c #FFE9D0",
"i.	c #FFF3E5",
"j.	c #FFF2E3",
"k.	c #FFD3AA",
"l.	c #FFB36E",
"m.	c #FFB46C",
"n.	c #FFB36B",
"o.	c #FF9037",
"p.	c #FF6A00",
"q.	c #D9B333",
"r.	c #DDBB4A",
"s.	c #E0C25E",
"t.	c #E1C361",
"u.	c #E1C360",
"v.	c #E0C765",
"w.	c #E1C35F",
"x.	c #EFA026",
"y.	c #FD8703",
"z.	c #FFA84B",
"A.	c #FFD5A7",
"B.	c #FFEDD9",
"C.	c #FFF8F2",
"D.	c #FFECDB",
"E.	c #FFD6AE",
"F.	c #FFC386",
"G.	c #FFC282",
"H.	c #FFCC95",
"I.	c #FFEAD2",
"J.	c #FFFFFF",
"K.	c #FFE6D2",
"L.	c #FFC493",
"M.	c #FFBA7D",
"N.	c #FFAE68",
"O.	c #FF8833",
"P.	c #FF6300",
"Q.	c #DAB335",
"R.	c #E4CA72",
"S.	c #EEDFAA",
"T.	c #F0E2B4",
"U.	c #F0E1B2",
"V.	c #F0E1B1",
"W.	c #F0E1B0",
"X.	c #EFE6BA",
"Y.	c #F0E1AF",
"Z.	c #F7B456",
"`.	c #FE8D0A",
" +	c #FFA741",
".+	c #FFCE92",
"++	c #FFD9AC",
"@+	c #FFDEB9",
"#+	c #FFE7CD",
"$+	c #FFECD9",
"%+	c #FFEAD3",
"&+	c #FFCB96",
"*+	c #FFBD7B",
"=+	c #FFD5AC",
"-+	c #FFEFE1",
";+	c #FFECDC",
">+	c #FFDCC0",
",+	c #FFC899",
"'+	c #FFAC6A",
")+	c #FF8231",
"!+	c #FF5B00",
"~+	c #ECD99B",
"{+	c #FEFEFD",
"]+	c #FFFFFE",
"^+	c #FFFEFE",
"/+	c #FFFEFD",
"(+	c #FFC580",
"_+	c #FF9210",
":+	c #FFA637",
"<+	c #FFC47D",
"[+	c #FFBE79",
"}+	c #FFCE9B",
"|+	c #FFE3C4",
"1+	c #FFF6EB",
"2+	c #FFFDF9",
"3+	c #FFDBB9",
"4+	c #FFBA7A",
"5+	c #FFC28A",
"6+	c #FFD5B0",
"7+	c #FFE9D7",
"8+	c #FFF2E8",
"9+	c #FFD7B6",
"0+	c #FFAE70",
"a+	c #FF7D32",
"b+	c #FF5200",
"c+	c #DAB135",
"d+	c #EDDAA2",
"e+	c #FFFFF6",
"f+	c #FEF6CF",
"g+	c #FDF3CC",
"h+	c #FCF2D1",
"i+	c #FCF2D5",
"j+	c #FCF4DA",
"k+	c #FDFCED",
"l+	c #FDF7E5",
"m+	c #FFC173",
"n+	c #FF920F",
"o+	c #FFCD87",
"p+	c #FFD096",
"q+	c #FFCF9D",
"r+	c #FFD6A8",
"s+	c #FFF7ED",
"t+	c #FFE8D4",
"u+	c #FFD2AE",
"v+	c #FFC090",
"w+	c #FFBB89",
"x+	c #FFE1CB",
"y+	c #FFE3CC",
"z+	c #FFB37B",
"A+	c #FF7C37",
"B+	c #FF4B00",
"C+	c #DAAE34",
"D+	c #EDD89F",
"E+	c #FEFCF7",
"F+	c #FDF5CE",
"G+	c #F8E48E",
"H+	c #F6DF88",
"I+	c #F5DE91",
"J+	c #F5DF97",
"K+	c #F5E09F",
"L+	c #F5E6B0",
"M+	c #F6E1AC",
"N+	c #FBB657",
"O+	c #FFAA42",
"P+	c #FFCE8D",
"Q+	c #FFDAAD",
"R+	c #FFDCB8",
"S+	c #FFCF9E",
"T+	c #FFC486",
"U+	c #FFD1A0",
"V+	c #FFE1C2",
"W+	c #FFE9D6",
"X+	c #FFE5D4",
"Y+	c #FFC095",
"Z+	c #FFA667",
"`+	c #FFD2B1",
" @	c #FFFDFA",
".@	c #FFE8D2",
"+@	c #FFBA89",
"@@	c #FF7D40",
"#@	c #FF4500",
"$@	c #D9AC35",
"%@	c #EDD69E",
"&@	c #FEFBF4",
"*@	c #FCF2CA",
"=@	c #F6E08A",
"-@	c #F5DD85",
";@	c #F4DC8C",
">@	c #F3D989",
",@	c #F1D584",
"'@	c #EED07F",
")@	c #EBC570",
"!@	c #ECA73D",
"~@	c #ED8F15",
"{@	c #ED9C31",
"]@	c #ECB15B",
"^@	c #ECB970",
"/@	c #EBBA76",
"(@	c #EBB163",
"_@	c #EBA851",
":@	c #EBAD5B",
"<@	c #EBB66E",
"[@	c #ECC082",
"}@	c #ECC38A",
"|@	c #ECAB60",
"1@	c #EC9A40",
"2@	c #EDB871",
"3@	c #F0D8A8",
"4@	c #F8DAB2",
"5@	c #FFC59C",
"6@	c #FF8250",
"7@	c #FF3E00",
"8@	c #D9AA36",
"9@	c #ECD59C",
"0@	c #FDFAF1",
"a@	c #FBF1CE",
"b@	c #F5DE94",
"c@	c #F4DC90",
"d@	c #F4DC93",
"e@	c #F2D686",
"f@	c #EECD74",
"g@	c #E9C162",
"h@	c #E4B450",
"i@	c #E1A43C",
"j@	c #DF972E",
"k@	c #DE9934",
"l@	c #DD9E3E",
"m@	c #DCA042",
"n@	c #DB9E3E",
"o@	c #DB9B39",
"p@	c #DB9936",
"q@	c #DB9A37",
"r@	c #DDA041",
"s@	c #DEA649",
"t@	c #DDA241",
"u@	c #DD9E3A",
"v@	c #F0C686",
"w@	c #FFC8A4",
"x@	c #FF8459",
"y@	c #FF3A00",
"z@	c #D9AA35",
"A@	c #EBD397",
"B@	c #FCF7EB",
"C@	c #F8ECC8",
"D@	c #F1D68E",
"E@	c #F0D387",
"F@	c #F0D287",
"G@	c #EDC975",
"H@	c #EAC269",
"I@	c #EBC87A",
"J@	c #EDCE8E",
"K@	c #EEC98D",
"L@	c #EEC38A",
"M@	c #EDC794",
"N@	c #ECCC9E",
"O@	c #ECCC9F",
"P@	c #ECCB9C",
"Q@	c #ECCA99",
"R@	c #EBC896",
"S@	c #EBC592",
"T@	c #EBC490",
"U@	c #ECC998",
"V@	c #EDCEA0",
"W@	c #EDD0A1",
"X@	c #ECCB95",
"Y@	c #E3B664",
"Z@	c #DEA33E",
"`@	c #EEB066",
" #	c #FFB488",
".#	c #FF7A4A",
"+#	c #FF3C00",
"@#	c #D9AA34",
"##	c #EBD394",
"$#	c #FBF6E8",
"%#	c #F7EACA",
"&#	c #EFD494",
"*#	c #EED08A",
"=#	c #EECE88",
"-#	c #EAC476",
";#	c #E9C173",
">#	c #F0D8A6",
",#	c #F9F0DA",
"'#	c #FDF0DB",
")#	c #FFF2E2",
"!#	c #FFF9F1",
"~#	c #FFF9F2",
"{#	c #FFF7EE",
"]#	c #FFF4E8",
"^#	c #FFF1E5",
"/#	c #FFF4EB",
"(#	c #FFF7F1",
"_#	c #FFFDFE",
":#	c #FFF7F2",
"<#	c #EDCB96",
"[#	c #DF9E3E",
"}#	c #ED9849",
"|#	c #FF945F",
"1#	c #FF6B34",
"2#	c #FF3F00",
"3#	c #D9A835",
"4#	c #ECD397",
"5#	c #FDFAF3",
"6#	c #FCF7EA",
"7#	c #F7E9C9",
"8#	c #F6E6C4",
"9#	c #F6E6C2",
"0#	c #F5E0B9",
"a#	c #F4DFB8",
"b#	c #F8EEDC",
"c#	c #FDFBF5",
"d#	c #FDEFCB",
"e#	c #FCE09A",
"f#	c #FCDF95",
"g#	c #FDE29B",
"h#	c #FCE29C",
"i#	c #FCE19B",
"j#	c #FCDF99",
"k#	c #FCDE99",
"l#	c #FCDD97",
"m#	c #FCDF9F",
"n#	c #FFEDD2",
"o#	c #FFF0ED",
"p#	c #EFC696",
"q#	c #DF9535",
"r#	c #ED7826",
"s#	c #FF652B",
"t#	c #FF5219",
"u#	c #FE3F00",
"v#	c #D9A536",
"w#	c #ECD39B",
"x#	c #FFFDF8",
"y#	c #FFFDF7",
"z#	c #FFFDF6",
"A#	c #FFFCF6",
"B#	c #FFFCF5",
"C#	c #FEFCF3",
"D#	c #F9E6A5",
"E#	c #F5CE54",
"F#	c #F5C63C",
"G#	c #F6C338",
"H#	c #F5C53B",
"I#	c #F5C43B",
"J#	c #F5C33A",
"K#	c #F5C23A",
"L#	c #F4BF30",
"M#	c #F5C03A",
"N#	c #FCD691",
"O#	c #FFE1D4",
"P#	c #EEBE8D",
"Q#	c #DF8F2F",
"R#	c #ED610D",
"S#	c #FF3D00",
"T#	c #FF3500",
"U#	c #D9A336",
"V#	c #ECD19B",
"W#	c #FFFAE8",
"X#	c #FEFAE3",
"Y#	c #FEF9E0",
"Z#	c #FEF9DD",
"`#	c #FEF8DA",
" $	c #FDF7D8",
".$	c #FCF3CA",
"+$	c #F9E59A",
"@$	c #F5D769",
"#$	c #F5D157",
"$$	c #F6CE50",
"%$	c #F5CE4C",
"&$	c #F5CE4A",
"*$	c #F5CD46",
"=$	c #F4CC42",
"-$	c #F4CB3F",
";$	c #F4C93B",
">$	c #F3C52D",
",$	c #F4C635",
"'$	c #FBDF96",
")$	c #FFEDE1",
"!$	c #EDC492",
"~$	c #DC9431",
"{$	c #E56C0E",
"]$	c #D9A135",
"^$	c #ECD09A",
"/$	c #FEFCF6",
"($	c #FFFDEC",
"_$	c #FCF2C8",
":$	c #FBF0BE",
"<$	c #FBEFB9",
"[$	c #FAEEB3",
"}$	c #FAECAC",
"|$	c #FAEAA4",
"1$	c #F9E89C",
"2$	c #F8E593",
"3$	c #F7E38B",
"4$	c #F6E183",
"5$	c #F6E07C",
"6$	c #F6DE74",
"7$	c #F6DC6C",
"8$	c #F6DA64",
"9$	c #F5D95D",
"0$	c #F4D856",
"a$	c #F4D64F",
"b$	c #F3D23E",
"c$	c #F3D344",
"d$	c #FBEDA6",
"e$	c #FEFBF1",
"f$	c #ECCA97",
"g$	c #DA9B34",
"h$	c #DA9D35",
"i$	c #ECCD99",
"j$	c #FDFBF4",
"k$	c #FEFBE4",
"l$	c #FBEFBC",
"m$	c #FAEDB1",
"n$	c #FAEBAC",
"o$	c #F9EAA5",
"p$	c #F9E89D",
"q$	c #F8E694",
"r$	c #F8E48C",
"s$	c #F7E389",
"t$	c #F7E285",
"u$	c #F6E17E",
"v$	c #F6E076",
"w$	c #F5DD6E",
"x$	c #F5DB66",
"y$	c #F5DA5E",
"z$	c #F4D74E",
"A$	c #F3D547",
"B$	c #F2D135",
"C$	c #F2D23B",
"D$	c #FAEDA0",
"E$	c #FDFCEF",
"F$	c #EBCB97",
"G$	c #D99C34",
"H$	c #DA9935",
"I$	c #ECCB99",
"J$	c #FDFAF2",
"K$	c #FEFADF",
"L$	c #FAEDB3",
"M$	c #F9EAA8",
"N$	c #F9E9A4",
"O$	c #F8E89D",
"P$	c #F8E695",
"Q$	c #F8E48D",
"R$	c #F6E07E",
"S$	c #F6DE76",
"T$	c #F6DC6D",
"U$	c #F5DB65",
"V$	c #F4D95E",
"W$	c #F4D757",
"X$	c #F4D550",
"Y$	c #F3D449",
"Z$	c #F2D242",
"`$	c #F2D13B",
" %	c #F1CD29",
".%	c #F1CE30",
"+%	c #F9E997",
"@%	c #FDF9E9",
"#%	c #EBCA95",
"$%	c #D99B34",
"%%	c #DA9635",
"&%	c #FEF9D9",
"*%	c #FAEBA8",
"=%	c #F9E99D",
"-%	c #F9E798",
";%	c #F8E590",
">%	c #F8E488",
",%	c #F7E280",
"'%	c #F7E078",
")%	c #F6DE71",
"!%	c #F6DC69",
"~%	c #F5DA61",
"{%	c #F5D958",
"]%	c #F4D751",
"^%	c #F3D54B",
"/%	c #F3D343",
"(%	c #F2D23C",
"_%	c #F2D035",
":%	c #F1CE2F",
"<%	c #F0CA1E",
"[%	c #F0CC26",
"}%	c #F9E890",
"|%	c #FDF9E5",
"1%	c #EBCA94",
"2%	c #D99A34",
"3%	c #DA9435",
"4%	c #EDC998",
"5%	c #FEFAEF",
"6%	c #FEF8D4",
"7%	c #F9E9A1",
"8%	c #F8E591",
"9%	c #F8E389",
"0%	c #F7E181",
"a%	c #F6E079",
"b%	c #F6DE72",
"c%	c #F6DC6A",
"d%	c #F5DA63",
"e%	c #F4D85B",
"f%	c #F4D754",
"g%	c #F4D54D",
"h%	c #F3D347",
"i%	c #F2D140",
"j%	c #F2D039",
"k%	c #F2CE33",
"l%	c #F1CD2E",
"m%	c #F0C91E",
"n%	c #F0CB26",
"o%	c #F9E78E",
"p%	c #FDF8E1",
"q%	c #EBC892",
"r%	c #D99834",
"s%	c #D99134",
"t%	c #ECC796",
"u%	c #FDF9ED",
"v%	c #FDF7D7",
"w%	c #F8E8AA",
"x%	c #F8E5A0",
"y%	c #F8E59D",
"z%	c #F7E397",
"A%	c #F7E291",
"B%	c #F6E18B",
"C%	c #F6E085",
"D%	c #F6DE7F",
"E%	c #F6DD79",
"F%	c #F5DB73",
"G%	c #F5DA6D",
"H%	c #F4D969",
"I%	c #F4D764",
"J%	c #F3D65E",
"K%	c #F3D559",
"L%	c #F3D454",
"M%	c #F2D350",
"N%	c #F1CF43",
"O%	c #F2D14B",
"P%	c #FAECA2",
"Q%	c #EBC891",
"R%	c #D99534",
"S%	c #D88E33",
"T%	c #EAC18D",
"U%	c #FAEFDC",
"V%	c #F9EBCB",
"W%	c #F4DDA6",
"X%	c #F4DB9F",
"Y%	c #F4DB9E",
"Z%	c #F4DB9A",
"`%	c #F3DA96",
" &	c #F3D992",
".&	c #F3D88E",
"+&	c #F3D88A",
"@&	c #F3D786",
"#&	c #F2D682",
"$&	c #F2D47F",
"%&	c #F2D37C",
"&&	c #F2D379",
"*&	c #F2D376",
"=&	c #F1D272",
"-&	c #F1D16F",
";&	c #F1D06C",
">&	c #F0CD63",
",&	c #F1CF69",
"'&	c #F8E6A8",
")&	c #FAF1D5",
"!&	c #E9C287",
"~&	c #D89133",
"{&	c #D78A30",
"]&	c #E2AA68",
"^&	c #EBC492",
"/&	c #E9BD83",
"(&	c #E6B26C",
"_&	c #E6B168",
":&	c #E6B167",
"<&	c #E6B165",
"[&	c #E5B163",
"}&	c #E5B062",
"|&	c #E5B060",
"1&	c #E5B05E",
"2&	c #E5B05C",
"3&	c #E5AF5B",
"4&	c #E5AE59",
"5&	c #E5AE58",
"6&	c #E5AE56",
"7&	c #E5AE55",
"8&	c #E5AD53",
"9&	c #E5AD52",
"0&	c #E5AC51",
"a&	c #E4AB4D",
"b&	c #E5AB4F",
"c&	c #E8B76D",
"d&	c #E9BD82",
"e&	c #E1A75F",
"f&	c #D88C30",
"g&	c #D7862C",
"h&	c #D7872D",
"i&	c #D8872D",
"j&	c #D8862D",
"k&	c #D8872C",
"l&	c #D8862C",
"                            . + @ # @ $ % & * = - ; > , ' = )   ",
"                          ! ~ { ] ^ / ( _ : < [ } | 1 2 3 4 5 6 ",
"                          $ 7 8 9 0 a b c d e f g h i i j k l m ",
"                          @ n o p q r s t u v w x y z A B C D $ ",
"                          # E F p G H I I J K L M N O P Q R S T ",
"                          $ U V W X Y Z `  ...+.@.#.$.%.&.*.=.-.",
"                          ;.>.,.'.).!.~.{.].^./.(._.:.<.[.}.|.1.",
"      2.3.4.4.4.4.4.5.6.7.8.9.0.a.b.c.d.e.f.g.h.i.j.k.l.m.n.o.p.",
"  q.r.s.t.u.u.u.u.u.v.w.x.y.z.A.B.I C.D.E.F.G.H.I.J.K.L.M.N.O.P.",
"  Q.R.S.T.U.U.U.V.W.X.Y.Z.`. +.+++@+#+$+%+p &+*+=+-+;+>+,+'+)+!+",
"  Q.~+{+J.]+]+^+/+/+J.]+(+_+:+C <+[+}+|+1+2+3+4+5+6+7+8+9+0+a+b+",
"  c+d+J.e+f+g+h+i+j+k+l+m+n+} o+p+F q+r+h.s+t+u+v+w+x+J.y+z+A+B+",
"  C+D+E+F+G+H+I+J+K+L+M+N+_+O+P+Q+R+S+T+U+V+W+X+Y+Z+`+ @.@+@@@#@",
"  $@%@&@*@=@-@;@>@,@'@)@!@~@{@]@^@/@(@_@:@<@[@}@|@1@2@3@4@5@6@7@",
"  8@9@0@a@b@c@d@e@f@g@h@i@j@k@l@m@m@n@o@p@q@r@s@t@u@2@3@v@w@x@y@",
"  z@A@B@C@D@E@F@G@H@I@J@K@L@M@N@O@P@Q@R@S@T@U@V@W@X@Y@Z@`@ #.#+#",
"  @###$#%#&#*#=#-#;#>#,#'#t )#!#~#{#1+]#r ^#/#(#_#:#<#[#}#|#1#2#",
"  3#4#5#6#7#8#9#0#a#b#c#d#e#f#g#h#h#i#e#j#k#l#m#n#o#p#q#r#s#t#u#",
"  v#w#]+J.x#y#z#A#B#]+C#D#E#F#G#G#H#H#I#J#K#L#M#N#O#P#Q#R#S#T#  ",
"  U#V#/.]+W#X#Y#Z#`# $.$+$@$#$$$%$&$*$=$-$;$>$,$'$)$!$~${$      ",
"  ]$^$/$($_$:$<$[$}$|$1$2$3$4$5$6$7$8$9$0$a$b$c$d$e$f$g$        ",
"  h$i$j$k$l$m$n$o$p$q$r$s$t$u$v$w$x$y$0$z$A$B$C$D$E$F$G$        ",
"  H$I$J$K$L$M$N$O$P$Q$t$R$S$T$U$V$W$X$Y$Z$`$ %.%+%@%#%$%        ",
"  %%Q@e$&%*%=%-%;%>%,%'%)%!%~%{%]%^%/%(%_%:%<%[%}%|%1%2%        ",
"  3%4%5%6%7%P$8%9%0%a%b%c%d%e%f%g%h%i%j%k%l%m%n%o%p%q%r%        ",
"  s%t%u%v%w%x%y%z%A%B%C%D%E%F%G%H%I%J%K%L%M%N%O%P%k$Q%R%        ",
"  S%T%U%V%W%X%Y%Z%`% &.&+&@&#&$&%&&&*&=&-&;&>&,&'&)&!&~&        ",
"  {&]&^&/&(&_&:&<&[&}&|&1&2&3&4&5&6&7&8&9&0&a&b&c&d&e&f&        ",
"    g&h&i&j&i&k&k&k&k&k&k&k&k&k&k&k&k&k&k&k&k&l&k&k&k&          ",
"                                                                ",
"                                                                ",
"                                                                "};


static const char * histogram_xpm[] = {
"16 16 72 1",
" 	c None",
".	c #77A6EA",
"+	c #74A4E8",
"@	c #6EA0E8",
"#	c #6599E4",
"$	c #5E95E2",
"%	c #70A0E8",
"&	c #ACC8F2",
"*	c #A8C6F0",
"=	c #A2C2EF",
"-	c #538EE1",
";	c #679BE6",
">	c #A6C5F0",
",	c #91B6EC",
"'	c #9BBCEE",
")	c #4785DF",
"!	c #5C92E2",
"~	c #A0C1EE",
"{	c #89B1EA",
"]	c #94B7ED",
"^	c #3A7CDB",
"/	c #528DE1",
"(	c #99BBED",
"_	c #81ACE9",
":	c #8DB3EA",
"<	c #2C74D8",
"[	c #4584DF",
"}	c #92B7EC",
"|	c #78A5E6",
"1	c #85ADE9",
"2	c #1E6BD6",
"3	c #397BD9",
"4	c #8AB2EA",
"5	c #6E9FE4",
"6	c #7DA8E7",
"7	c #1A62D1",
"8	c #2A74D8",
"9	c #83ADE8",
"0	c #6598E2",
"a	c #76A3E5",
"b	c #1857CF",
"c	c #6B9DE6",
"d	c #1E69D6",
"e	c #7BA7E7",
"f	c #5C92E0",
"g	c #6E9EE4",
"h	c #164ECD",
"i	c #1A60D1",
"j	c #74A2E5",
"k	c #538CDE",
"l	c #6699E2",
"m	c #1545C9",
"n	c #8CB3EB",
"o	c #1855CF",
"p	c #6C9CE3",
"q	c #4A86DC",
"r	c #5E94E0",
"s	c #133CC6",
"t	c #85AEE9",
"u	c #164CCD",
"v	c #6397E1",
"w	c #4180DA",
"x	c #588FDF",
"y	c #1235C6",
"z	c #7CA8E7",
"A	c #1543C9",
"B	c #5D93E0",
"C	c #598FDF",
"D	c #518ADE",
"E	c #112EC0",
"F	c #73A2E6",
"G	c #102AC0",
"                ",
"      .+@#$     ",
"      %&*=-     ",
"      ;>,')     ",
"      !~{]^     ",
"  .+@#/(_:<     ",
"  %&*=[}|12     ",
"  ;>,'34567     ",
"  !~{]890ab+c#$ ",
"  /(_:defgh&>=- ",
"  [}|1ijklm>n') ",
"  3456opqrs~t]^ ",
"  890auvwxy(z:< ",
"  defgABCDE}F12 ",
"  GGGGGGGGGGGGG ",
"                "};

static const char * histogram_large_xpm[] = {
"32 32 275 2",
"  	c None",
". 	c #77A6EA",
"+ 	c #76A5E9",
"@ 	c #74A4E8",
"# 	c #71A2E8",
"$ 	c #6EA0E8",
"% 	c #6A9CE6",
"& 	c #6599E4",
"* 	c #6297E3",
"= 	c #5E95E2",
"- 	c #74A3E9",
"; 	c #82ACEB",
"> 	c #90B6ED",
", 	c #8EB4EC",
"' 	c #8BB3EC",
") 	c #87B0EB",
"! 	c #84AEEA",
"~ 	c #6EA0E6",
"{ 	c #5892E2",
"] 	c #70A0E8",
"^ 	c #8EB4ED",
"/ 	c #ACC8F2",
"( 	c #AAC7F1",
"_ 	c #A8C6F0",
": 	c #A5C4F0",
"< 	c #A2C2EF",
"[ 	c #7AA8E8",
"} 	c #538EE1",
"| 	c #6C9EE7",
"1 	c #8AB2EC",
"2 	c #A9C6F1",
"3 	c #A3C2F0",
"4 	c #9CBEEE",
"5 	c #9EBEEE",
"6 	c #9EBFEE",
"7 	c #76A4E7",
"8 	c #4D8AE0",
"9 	c #679BE6",
"0 	c #86B0EB",
"a 	c #A6C5F0",
"b 	c #91B6EC",
"c 	c #96B9ED",
"d 	c #9BBCEE",
"e 	c #71A0E6",
"f 	c #4785DF",
"g 	c #6296E4",
"h 	c #82ADEA",
"i 	c #A3C3EF",
"j 	c #98BBED",
"k 	c #8DB4EB",
"l 	c #92B6EC",
"m 	c #98BAEE",
"n 	c #6C9DE5",
"o 	c #4080DD",
"p 	c #5C92E2",
"q 	c #7EAAE8",
"r 	c #A0C1EE",
"s 	c #94B9EC",
"t 	c #89B1EA",
"u 	c #94B7ED",
"v 	c #679AE4",
"w 	c #3A7CDB",
"x 	c #5C93E2",
"y 	c #5790E2",
"z 	c #7AA7E8",
"A 	c #85AEEA",
"B 	c #8BB2EA",
"C 	c #90B5EC",
"D 	c #6296E2",
"E 	c #3378DA",
"F 	c #528DE1",
"G 	c #99BBED",
"H 	c #81ACE9",
"I 	c #87B0EA",
"J 	c #8DB3EA",
"K 	c #5C94E1",
"L 	c #2C74D8",
"M 	c #689BE5",
"N 	c #4C88E0",
"O 	c #70A1E6",
"P 	c #96B9EC",
"Q 	c #7CA8E8",
"R 	c #83ACE8",
"S 	c #89B0EA",
"T 	c #5790E0",
"U 	c #2570D7",
"V 	c #74A3E7",
"W 	c #4584DF",
"X 	c #6C9EE6",
"Y 	c #92B7EC",
"Z 	c #85AEE9",
"` 	c #78A5E6",
" .	c #7EA9E8",
"..	c #85ADE9",
"+.	c #528CE0",
"@.	c #1E6BD6",
"#.	c #6F9FE5",
"$.	c #3F80DC",
"%.	c #669AE4",
"&.	c #8EB4EB",
"*.	c #80ABE8",
"=.	c #73A2E5",
"-.	c #7AA6E6",
";.	c #81AAE8",
">.	c #4E88DE",
",.	c #1C66D4",
"'.	c #6A9CE4",
").	c #397BD9",
"!.	c #8AB2EA",
"~.	c #7CA8E7",
"{.	c #6E9FE4",
"].	c #76A4E6",
"^.	c #7DA8E7",
"/.	c #4C85DC",
"(.	c #1A62D1",
"_.	c #6498E3",
":.	c #3278D8",
"<.	c #86B0E9",
"[.	c #78A6E6",
"}.	c #6A9CE3",
"|.	c #72A0E4",
"1.	c #4981DB",
"2.	c #195CD0",
"3.	c #3774D8",
"4.	c #70A0E7",
"5.	c #6B9DE6",
"6.	c #5F96E2",
"7.	c #2A74D8",
"8.	c #5690E0",
"9.	c #83ADE8",
"0.	c #74A2E5",
"a.	c #6598E2",
"b.	c #6E9EE4",
"c.	c #76A3E5",
"d.	c #477DDA",
"e.	c #1857CF",
"f.	c #467EDC",
"g.	c #5A92E1",
"h.	c #246ED7",
"i.	c #528CDF",
"j.	c #7FAAE8",
"k.	c #70A0E4",
"l.	c #6095E1",
"m.	c #699BE3",
"n.	c #447AD9",
"o.	c #1752CE",
"p.	c #5484DE",
"q.	c #8CB4EC",
"r.	c #88B1EB",
"s.	c #86AFEA",
"t.	c #568EE0",
"u.	c #1E69D6",
"v.	c #4C88DE",
"w.	c #7BA7E7",
"x.	c #6C9CE4",
"y.	c #5C92E0",
"z.	c #4276D8",
"A.	c #164ECD",
"B.	c #618BE0",
"C.	c #A4C4F0",
"D.	c #528ADE",
"E.	c #1C64D4",
"F.	c #4A84DD",
"G.	c #78A4E6",
"H.	c #689AE2",
"I.	c #588FDF",
"J.	c #6195E1",
"K.	c #4072D7",
"L.	c #164ACB",
"M.	c #5F88DE",
"N.	c #A1C1EF",
"O.	c #99BCEE",
"P.	c #5086DD",
"Q.	c #1A60D1",
"R.	c #4781DB",
"S.	c #6497E2",
"T.	c #538CDE",
"U.	c #6699E2",
"V.	c #3E6FD6",
"W.	c #1545C9",
"X.	c #5E85DC",
"Y.	c #8CB3EB",
"Z.	c #94B8EC",
"`.	c #4D82DC",
" +	c #195AD0",
".+	c #447DDA",
"++	c #709FE4",
"@+	c #5F94E0",
"#+	c #4E89DD",
"$+	c #5890DF",
"%+	c #6296E1",
"&+	c #3B6CD4",
"*+	c #1440C8",
"=+	c #5C82DB",
"-+	c #96BAEC",
";+	c #88B0EA",
">+	c #4A7EDB",
",+	c #1855CF",
"'+	c #4278D9",
")+	c #6C9CE3",
"!+	c #5B91E0",
"~+	c #4A86DC",
"{+	c #548DDE",
"]+	c #5E94E0",
"^+	c #3868D3",
"/+	c #133CC6",
"(+	c #5A7EDA",
"_+	c #92B8EC",
":+	c #8CB2EB",
"<+	c #487BDA",
"[+	c #1750CE",
"}+	c #3F75D8",
"|+	c #568EDE",
"1+	c #4683DB",
"2+	c #508ADD",
"3+	c #5B92E0",
"4+	c #3765D3",
"5+	c #1238C6",
"6+	c #587BDA",
"7+	c #4678D9",
"8+	c #164CCD",
"9+	c #3C72D7",
"0+	c #6397E1",
"a+	c #528CDE",
"b+	c #4180DA",
"c+	c #4C88DC",
"d+	c #3562D2",
"e+	c #1235C6",
"f+	c #5678DA",
"g+	c #84AEE8",
"h+	c #4474D8",
"i+	c #1648CB",
"j+	c #3B6ED6",
"k+	c #6095E0",
"l+	c #4D88DC",
"m+	c #518ADE",
"n+	c #548CDE",
"o+	c #335FD1",
"p+	c #1232C3",
"q+	c #5475D8",
"r+	c #80AAE8",
"s+	c #4270D6",
"t+	c #1543C9",
"u+	c #396BD4",
"v+	c #5D93E0",
"w+	c #598FDF",
"x+	c #558CDE",
"y+	c #315CCF",
"z+	c #112EC0",
"A+	c #5272D6",
"B+	c #82ACE9",
"C+	c #73A2E6",
"D+	c #174ACB",
"E+	c #2E59CF",
"F+	c #4668D4",
"G+	c #3E63D2",
"H+	c #365ED0",
"I+	c #3A61D1",
"J+	c #3F64D2",
"K+	c #294DCB",
"L+	c #1236C4",
"M+	c #244ACA",
"N+	c #345CD0",
"O+	c #325BCF",
"P+	c #305ACF",
"Q+	c #2043C8",
"R+	c #102CC0",
"S+	c #314ECB",
"T+	c #5170D6",
"U+	c #496BD4",
"V+	c #4266D3",
"W+	c #4669D4",
"X+	c #4A6CD4",
"Y+	c #315BD0",
"Z+	c #102AC0",
"                                                                ",
"                                                                ",
"                          . + @ # $ % & * =                     ",
"                        . . + @ # $ % & * = =                   ",
"                        - - ; > , ' ) ! ~ { {                   ",
"                        ] ] ^ / ( _ : < [ } }                   ",
"                        | | 1 2 3 4 5 6 7 8 8                   ",
"                        9 9 0 a 4 b c d e f f                   ",
"                        g g h i j k l m n o o                   ",
"                        p p q r s t , u v w w                   ",
"          . + @ # $ % & x y z 4 b A B C D E E                   ",
"        . . + @ # $ % & x F 7 G k H I J K L L                   ",
"        - - ; > , ' ) ! M N O P t Q R S T U U                   ",
"        ] ] ^ / ( _ : < V W X Y Z `  ...+.@.@.                  ",
"        | | 1 2 3 4 5 6 #.$.%.&.*.=.-.;.>.,.,.                  ",
"        9 9 0 a 4 b c d '.).D !.~.{.].^./.(.(.                  ",
"        g g h i j k l m _.:.K <.[.}.|.-.1.2.3.@ 4.5.M & * =     ",
"        p p q r s t , u 6.7.8.9.0.a.b.c.d.e.f.@ 4.5.M & * = =   ",
"        y y z 4 b A B C g.h.i.j.k.l.m.|.n.o.p.> q.r.s.! ~ { {   ",
"        F F 7 G k H I J t.u.v.w.x.y.a.b.z.A.B./ 2 a C.< [ } }   ",
"        N N O P t Q R S D.E.F.G.H.I.J.}.K.L.M.2 N.O.4 6 7 8 8   ",
"        W W X Y Z `  ...P.Q.R.0.S.T.y.U.V.W.X.a O.Y.Z.d e f f   ",
"        $.$.%.&.*.=.-.;.`. +.+++@+#+$+%+&+*+=+i -+;+C m n o o   ",
"        ).).D !.~.{.].^.>+,+'+)+!+~+{+]+^+/+(+r _+Z :+u v w w   ",
"        :.:.K <.[.}.|.-.<+[+}+H.|+1+2+3+4+5+6+4 &.*.;+C D E E   ",
"        7.7.8.9.0.a.b.c.7+8+9+0+a+b+c+I.d+e+f+G !.~.g+J K L L   ",
"        h.h.i.j.k.l.m.|.h+i+j+k+|+l+m+n+o+p+q+P s.` r+S T U U   ",
"        u.u.v.w.x.y.a.b.s+t+u+v+!+w+x+m+y+z+A+Y B+C+Q ..+.@.@.  ",
"        D+D+E+F+G+H+I+J+K+L+M+H+H+N+O+P+Q+R+S+T+U+V+W+X+Y+D+D+  ",
"        Z+Z+Z+Z+Z+Z+Z+Z+Z+Z+Z+Z+Z+Z+Z+Z+Z+Z+Z+Z+Z+Z+Z+Z+Z+Z+Z+  ",
"          Z+Z+Z+Z+Z+Z+Z+Z+Z+Z+Z+Z+Z+Z+Z+Z+Z+Z+Z+Z+Z+Z+Z+Z+Z+    ",
"                                                                "};

static const char * graph_xpm[] = {
"16 16 89 1",
" 	c None",
".	c #3476C6",
"+	c #4F92DD",
"@	c #EF585A",
"#	c #EF5759",
"$	c #3475C5",
"%	c #3F89DE",
"&	c #F14D50",
"*	c #F24F52",
"=	c #F05153",
"-	c #3474C4",
";	c #2C7FE0",
">	c #3081E0",
",	c #F53E41",
"'	c #F44043",
")	c #F1484B",
"!	c #EE4A50",
"~	c #4B93E0",
"{	c #3373C3",
"]	c #1B76E1",
"^	c #6760AF",
"/	c #F53238",
"(	c #F63639",
"_	c #337FE0",
":	c #3781DF",
"<	c #3982DF",
"[	c #3C86DF",
"}	c #3E88DF",
"|	c #3273C2",
"1	c #EB2A39",
"2	c #E13145",
"3	c #206FE0",
"4	c #2472DE",
"5	c #2773DE",
"6	c #F63336",
"7	c #A65B88",
"8	c #3272C0",
"9	c #FB161A",
"0	c #F9191C",
"a	c #3D4EBA",
"b	c #0A61E0",
"c	c #1062DF",
"d	c #1161DE",
"e	c #F92A2D",
"f	c #F72B2E",
"g	c #3071BE",
"h	c #FD0D11",
"i	c #FC0E12",
"j	c #0058E0",
"k	c #0057E0",
"l	c #0257E0",
"m	c #0357E0",
"n	c #F92124",
"o	c #306FBD",
"p	c #FF0206",
"q	c #4AA240",
"r	c #4BA43C",
"s	c #49A43A",
"t	c #FB171B",
"u	c #2F6EBB",
"v	c #489939",
"w	c #489A37",
"x	c #469B38",
"y	c #459D36",
"z	c #449F35",
"A	c #2E6DB9",
"B	c #418832",
"C	c #418932",
"D	c #408A31",
"E	c #408F31",
"F	c #3E922F",
"G	c #2D6BB7",
"H	c #38752B",
"I	c #37752D",
"J	c #38822C",
"K	c #36842B",
"L	c #2D6AB6",
"M	c #2B69B4",
"N	c #2B68B3",
"O	c #2A68B2",
"P	c #2A68B1",
"Q	c #2A66B0",
"R	c #2A66AF",
"S	c #2966AF",
"T	c #2965AE",
"U	c #2865AE",
"V	c #2864AD",
"W	c #2864AC",
"X	c #2863AB",
"                ",
" .              ",
" . +   @@#      ",
" $ %  &**===    ",
" - ;>,'    )!~  ",
" { ]^/(   _:<[} ",
" |  12   345 67 ",
" 8 90ab cd   ef ",
" g hijklm     n ",
" o p    qrs   t ",
" u     vwxyz    ",
" A   BCD   EF   ",
" G HIH      JK  ",
" L              ",
" MNOPQRSTUVVWXX ",
"                "};

static const char * graph_large_xpm[] = {
"32 32 356 2",
"  	c None",
". 	c #3476C6",
"+ 	c #3375C5",
"@ 	c #3D7ECB",
"# 	c #3375C6",
"$ 	c #3A7AC8",
"% 	c #3677C5",
"& 	c #4A8CD5",
"* 	c #4E91DC",
"= 	c #EE5759",
"- 	c #EE575A",
"; 	c #EE585A",
"> 	c #EE5658",
", 	c #3475C5",
"' 	c #3476C5",
") 	c #458BDA",
"! 	c #468DDD",
"~ 	c #F05053",
"{ 	c #F15254",
"] 	c #F05355",
"^ 	c #EF5356",
"/ 	c #EF5355",
"( 	c #EF5354",
"_ 	c #EF5254",
": 	c #EF5253",
"< 	c #3475C4",
"[ 	c #3376C7",
"} 	c #3E8AE0",
"| 	c #3E88DE",
"1 	c #3E87DD",
"2 	c #F14C50",
"3 	c #F14D51",
"4 	c #F24F52",
"5 	c #F24E51",
"6 	c #F14E51",
"7 	c #F05051",
"8 	c #F05152",
"9 	c #F05052",
"0 	c #EF5052",
"a 	c #EF4F52",
"b 	c #3474C4",
"c 	c #3586E2",
"d 	c #3584DF",
"e 	c #2D85E3",
"f 	c #FA4141",
"g 	c #F24549",
"h 	c #F2484B",
"i 	c #F24B4E",
"j 	c #F24C4F",
"k 	c #FB4C48",
"l 	c #FC4A46",
"m 	c #FC4945",
"n 	c #FF4540",
"o 	c #FF4440",
"p 	c #3472C0",
"q 	c #2B7FDF",
"r 	c #2682E5",
"s 	c #3081DF",
"t 	c #80659E",
"u 	c #F43C40",
"v 	c #FF3B39",
"w 	c #F43F42",
"x 	c #F43F43",
"y 	c #F04749",
"z 	c #F0484A",
"A 	c #F44749",
"B 	c #ED4A50",
"C 	c #B16485",
"D 	c #4A91DF",
"E 	c #3473C4",
"F 	c #336FBC",
"G 	c #237AE0",
"H 	c #2A7ADE",
"I 	c #4473CC",
"J 	c #985687",
"K 	c #F6363A",
"L 	c #FF3432",
"M 	c #F43B3E",
"N 	c #7E6AA5",
"O 	c #906597",
"P 	c #966494",
"Q 	c #916699",
"R 	c #6878BD",
"S 	c #3190EC",
"T 	c #2A92F2",
"U 	c #368BE5",
"V 	c #3374C4",
"W 	c #3373C3",
"X 	c #326EBA",
"Y 	c #1A74E0",
"Z 	c #3E6CCB",
"` 	c #6660AE",
" .	c #AF4872",
"..	c #F53238",
"+.	c #FF2F2F",
"@.	c #F53538",
"#.	c #337FDE",
"$.	c #357FDF",
"%.	c #3680DF",
"&.	c #3880DF",
"*.	c #3981DE",
"=.	c #3A83DE",
"-.	c #3B85DE",
";.	c #3D87DF",
">.	c #3D88DF",
",.	c #3273C3",
"'.	c #3370BD",
").	c #7F5295",
"!.	c #A94473",
"~.	c #D13954",
"{.	c #F52F37",
"].	c #FF2C2B",
"^.	c #2775DF",
"/.	c #2878DF",
"(.	c #247BE5",
"_.	c #237EE8",
":.	c #2580E9",
"<.	c #407BD5",
"[.	c #985C8B",
"}.	c #5A7CC8",
"|.	c #3273C2",
"1.	c #EC2837",
"2.	c #EB2938",
"3.	c #E62D3E",
"4.	c #E03045",
"5.	c #206FDF",
"6.	c #2271DE",
"7.	c #2472DD",
"8.	c #2373DF",
"9.	c #2672DD",
"0.	c #FF2C24",
"a.	c #F63336",
"b.	c #D84155",
"c.	c #A55A87",
"d.	c #3272C1",
"e.	c #3273C1",
"f.	c #2A77C9",
"g.	c #FF1713",
"h.	c #FA1E23",
"i.	c #C62E50",
"j.	c #8D3F80",
"k.	c #604BA3",
"l.	c #1565DE",
"m.	c #1767DE",
"n.	c #1A69DE",
"o.	c #1E6BDD",
"p.	c #1E6EDF",
"q.	c #FF2926",
"r.	c #F43036",
"s.	c #E13948",
"t.	c #3272C0",
"u.	c #2279CD",
"v.	c #FA1619",
"w.	c #FF130F",
"x.	c #F9181B",
"y.	c #9D3269",
"z.	c #3D4DBA",
"A.	c #1A59D5",
"B.	c #0960E0",
"C.	c #0F61DE",
"D.	c #1061DD",
"E.	c #1261DD",
"F.	c #F8292C",
"G.	c #F72A2D",
"H.	c #F62A2E",
"I.	c #3172C0",
"J.	c #3172BF",
"K.	c #2076C7",
"L.	c #FC1114",
"M.	c #FF0E0A",
"N.	c #FB1315",
"O.	c #8D3271",
"P.	c #1953D1",
"Q.	c #005BE4",
"R.	c #035AE0",
"S.	c #015AE0",
"T.	c #0157DF",
"U.	c #0358E3",
"V.	c #0558E5",
"W.	c #0658E7",
"X.	c #0857EA",
"Y.	c #FA2527",
"Z.	c #FB2426",
"`.	c #2F72C0",
" +	c #3071BE",
".+	c #276FBC",
"++	c #FB0708",
"@+	c #FD0C10",
"#+	c #FF0907",
"$+	c #FB0D11",
"%+	c #0057DE",
"&+	c #005AE8",
"*+	c #0057E0",
"=+	c #0157E0",
"-+	c #0257E0",
";+	c #0256E0",
">+	c #0356E0",
",+	c #F92124",
"'+	c #2B73C2",
")+	c #3070BE",
"!+	c #3E65AC",
"~+	c #FF0000",
"{+	c #FE060B",
"]+	c #FF0506",
"^+	c #0054E6",
"/+	c #004FEE",
"(+	c #004FEB",
"_+	c #0A5ECC",
":+	c #1A70A8",
"<+	c #287F89",
"[+	c #399064",
"}+	c #FA1B1F",
"|+	c #2973C4",
"1+	c #306FBD",
"2+	c #545B9C",
"3+	c #FF0106",
"4+	c #25798A",
"5+	c #49A03E",
"6+	c #4DA637",
"7+	c #4BA43C",
"8+	c #4AA43B",
"9+	c #48A339",
"0+	c #46A238",
"a+	c #FB161A",
"b+	c #2773C3",
"c+	c #306EBC",
"d+	c #5F5693",
"e+	c #338368",
"f+	c #40924B",
"g+	c #4EA22C",
"h+	c #4EA42D",
"i+	c #4AA235",
"j+	c #48A037",
"k+	c #469F38",
"l+	c #45A036",
"m+	c #44A035",
"n+	c #2772C2",
"o+	c #2F6EBB",
"p+	c #60538E",
"q+	c #489838",
"r+	c #479938",
"s+	c #489937",
"t+	c #489A37",
"u+	c #479A37",
"v+	c #459B37",
"w+	c #459B36",
"x+	c #449C36",
"y+	c #449E35",
"z+	c #449F34",
"A+	c #439F34",
"B+	c #2971C0",
"C+	c #2E6EBA",
"D+	c #545693",
"E+	c #438D33",
"F+	c #459131",
"G+	c #46952F",
"H+	c #479631",
"I+	c #439A34",
"J+	c #429933",
"K+	c #419832",
"L+	c #3F9630",
"M+	c #2B70BD",
"N+	c #2E6DB9",
"O+	c #445B9C",
"P+	c #418831",
"Q+	c #418832",
"R+	c #408931",
"S+	c #3F8931",
"T+	c #408E31",
"U+	c #3F9030",
"V+	c #3E912F",
"W+	c #2C6DBA",
"X+	c #2D6CB8",
"Y+	c #3863A9",
"Z+	c #3A792C",
"`+	c #3B7C2D",
" @	c #3C7F2E",
".@	c #3D822F",
"+@	c #3E852F",
"@@	c #3B892E",
"#@	c #3B892D",
"$@	c #3A892C",
"%@	c #2D6BB9",
"&@	c #2D6BB7",
"*@	c #2D6BB3",
"=@	c #37752A",
"-@	c #36742B",
";@	c #36742C",
">@	c #37742B",
",@	c #38742A",
"'@	c #37822C",
")@	c #37832B",
"!@	c #36842A",
"~@	c #2D6ABA",
"{@	c #2D6AB6",
"]@	c #2C6BA2",
"^@	c #346E1C",
"/@	c #336C21",
"(@	c #356F1D",
"_@	c #347A1A",
":@	c #2D6ABB",
"<@	c #2E6997",
"[@	c #2C6AB8",
"}@	c #2C69B5",
"|@	c #2C69A8",
"1@	c #2C6893",
"2@	c #2C6892",
"3@	c #2A6799",
"4@	c #29649C",
"5@	c #2861A0",
"6@	c #2862AC",
"7@	c #2864B9",
"8@	c #2965BB",
"9@	c #2965B5",
"0@	c #2862AB",
"a@	c #275FA4",
"b@	c #2862A8",
"c@	c #2965AE",
"d@	c #2966B0",
"e@	c #2865AE",
"f@	c #2761A7",
"g@	c #265DA2",
"h@	c #2760A7",
"i@	c #2864AD",
"j@	c #2864AF",
"k@	c #2762AA",
"l@	c #275F96",
"m@	c #275E8A",
"n@	c #286094",
"o@	c #2863A4",
"p@	c #2B69B4",
"q@	c #2B68B3",
"r@	c #2A68B2",
"s@	c #2A68B1",
"t@	c #2A67B0",
"u@	c #2A66B0",
"v@	c #2A66AF",
"w@	c #2966AF",
"x@	c #2966AE",
"y@	c #2864AE",
"z@	c #2864AC",
"A@	c #2864AB",
"B@	c #2863AB",
"C@	c #2B68B6",
"D@	c #2B68B8",
"E@	c #2A68B8",
"F@	c #2A68B6",
"G@	c #2A69B6",
"H@	c #2A69B5",
"I@	c #2A67B3",
"J@	c #2A66B1",
"K@	c #2967B0",
"L@	c #2864B0",
"M@	c #2864B1",
"N@	c #2863AE",
"O@	c #2863AC",
"                                                                ",
"                                                                ",
"      .                                                         ",
"    + . @                                                       ",
"    # . $                                                       ",
"    . . %   & *               = - ; = > >                       ",
"    , . '   ) !             ~ { ] ^ / / ( _ :                   ",
"    < , [   } | 1         2 3 4 5 6 7 8 8 9 0 0 a               ",
"    b b <   c d e       f g h i j         k l m n o             ",
"    b b p     q r s t u v w x               y z A B C D         ",
"    b E F     G H I J K L M                 N O P Q R S T U     ",
"    V W X     Y Z `  ...+.@.              #.$.%.&.*.=.-.;.>.>.  ",
"    W ,.'.      ).!.~.{.].              ^./.(._.:.<.t [.N }.    ",
"    |.|.|.      1.2.3.4.              5.6.7.8.9.    0.a.b.c.    ",
"    d.e.f.      g.h.i.j.k.          l.m.n.o.p.        q.r.s.    ",
"    t.t.u.    v.w.x.y.z.A.B.      C.D.D.E.            F.G.H.    ",
"    I.J.K.    L.M.N.O.P.Q.R.S.T.U.V.W.X.                Y.Z.Z.  ",
"    `. +.+  ++@+#+$+  %+&+*+*+=+-+;+>+                  ,+,+,+  ",
"    '+)+!+  ~+{+]+        ^+/+(+_+:+<+[+                  }+    ",
"    |+1+2+  ~+3+                4+5+6+7+8+9+0+            a+    ",
"    b+c+d+                    e+f+g+h+i+j+k+l+m+                ",
"    n+o+p+                  q+r+s+t+u+v+w+x+y+z+A+              ",
"    B+C+D+                E+F+G+H+          I+J+K+L+            ",
"    M+N+O+            P+Q+Q+R+S+              T+U+V+            ",
"    W+X+Y+          Z+`+ @.@+@                  @@#@$@          ",
"    %@&@*@    =@-@;@>@,@=@                        '@)@!@        ",
"    ~@{@]@      ^@/@(@                              _@          ",
"    :@{@<@                                                      ",
"    [@}@|@1@2@3@4@5@6@7@8@9@0@a@b@c@d@e@f@g@h@i@j@k@l@m@n@o@    ",
"    p@p@p@q@r@r@r@s@t@u@v@v@v@w@x@c@e@e@y@i@i@i@i@z@A@B@B@B@B@  ",
"      p@C@D@E@F@G@H@I@J@v@v@t@K@w@c@e@e@e@e@y@i@i@y@L@M@N@O@    ",
"                                                                "};

static const char * graph_2d_xpm[] = {
"16 16 83 1",
" 	c None",
".	c #2865AE",
"+	c #EAEA8A",
"@	c #EAE98B",
"#	c #EBEA8A",
"$	c #E8E873",
"%	c #C1C146",
"&	c #A5BBBB",
"*	c #83A4D0",
"=	c #8EB0DE",
"-	c #7A9ED1",
";	c #7AA2D6",
">	c #F9F99F",
",	c #DFDD81",
"'	c #EAE981",
")	c #DEDE75",
"!	c #D7DA60",
"~	c #CAD598",
"{	c #9CB7E0",
"]	c #A9C7ED",
"^	c #94B3E0",
"/	c #98B8E6",
"(	c #EAEA90",
"_	c #DEDD78",
":	c #FAF899",
"<	c #D7D75E",
"[	c #C9CB5B",
"}	c #97B0D4",
"|	c #9FBAE2",
"1	c #8FACD6",
"2	c #91B0DB",
"3	c #F9F9A6",
"4	c #EADC77",
"5	c #DEDF70",
"6	c #B5C5C1",
"7	c #BAD1F1",
"8	c #A9C1E5",
"9	c #AEC7EA",
"0	c #F1F19F",
"a	c #DDDC68",
"b	c #B7BF77",
"c	c #B2C8E5",
"d	c #A3BADA",
"e	c #A6BCDE",
"f	c #FAFAAF",
"g	c #EBEB94",
"h	c #FAF9A2",
"i	c #F3ED95",
"j	c #E6D987",
"k	c #D1D25C",
"l	c #C9DBDC",
"m	c #CDD4AC",
"n	c #D4DA97",
"o	c #EDEBA4",
"p	c #DFDF8D",
"q	c #EBEB97",
"r	c #B7CF72",
"s	c #99CA74",
"t	c #BBE193",
"u	c #97C977",
"v	c #B6C351",
"w	c #CDD590",
"x	c #C6C650",
"y	c #DDD07E",
"z	c #FBFBBC",
"A	c #DFE79D",
"B	c #ADAE6B",
"C	c #DDE182",
"D	c #C4DE9B",
"E	c #93C373",
"F	c #9FCF80",
"G	c #8FC16F",
"H	c #9DBE73",
"I	c #AFDB96",
"J	c #9AC97F",
"K	c #AAD88F",
"L	c #97C87A",
"M	c #A0D087",
"N	c #BCDBA4",
"O	c #A6CA8C",
"P	c #B1D598",
"Q	c #A1C986",
"R	c #A6D08C",
"                ",
" .              ",
" . +@#$$%&*=-;  ",
" . >,'))!~{]^/  ",
" . (_:'#<[}|12  ",
" . 3@:@:456789  ",
" . 0,#,#!abcde  ",
" . fgh#i<jklmn  ",
" . opqrstuvwxy  ",
" . zAtuttuBCxy  ",
" . DEFGFFGFGFH  ",
" . IJKLKKLKLKM  ",
" . NOPQPPQPQPR  ",
" .              ",
" .............. ",
"                "};

static const char * graph_2d_large_xpm[] = {
"32 32 315 2",
"  	c None",
". 	c #2865AE",
"+ 	c #EAEA8A",
"@ 	c #EAE98B",
"# 	c #EBEA8A",
"$ 	c #EAE97E",
"% 	c #E8E873",
"& 	c #D4D45C",
"* 	c #C1C146",
"= 	c #B3BE80",
"- 	c #A5BBBB",
"; 	c #94B0C6",
"> 	c #83A4D0",
", 	c #88AAD7",
"' 	c #8EB0DE",
") 	c #84A7D8",
"! 	c #7A9ED1",
"~ 	c #7AA0D4",
"{ 	c #7AA2D6",
"] 	c #F2F294",
"^ 	c #EBEA8D",
"/ 	c #E4E386",
"( 	c #E8E686",
"_ 	c #EAEA86",
": 	c #E7E67D",
"< 	c #E3E374",
"[ 	c #D8D864",
"} 	c #CCCE53",
"| 	c #C2CB7E",
"1 	c #B8C8AA",
"2 	c #A4BBC1",
"3 	c #90AED8",
"4 	c #96B4DF",
"5 	c #9CBCE6",
"6 	c #91B2DF",
"7 	c #87A8D8",
"8 	c #88ABDB",
"9 	c #89ADDE",
"0 	c #F9F99F",
"a 	c #ECEB90",
"b 	c #DFDD81",
"c 	c #E4E381",
"d 	c #EAE981",
"e 	c #E4E47B",
"f 	c #DEDE75",
"g 	c #DADC6A",
"h 	c #D7DA60",
"i 	c #D0D87C",
"j 	c #CAD598",
"k 	c #B3C6BC",
"l 	c #9CB7E0",
"m 	c #A2BFE6",
"n 	c #A9C7ED",
"o 	c #9EBDE6",
"p 	c #94B3E0",
"q 	c #96B6E3",
"r 	c #98B8E6",
"s 	c #F2F298",
"t 	c #E8E78A",
"u 	c #DEDD7C",
"v 	c #E8E785",
"w 	c #F2F08D",
"x 	c #EBEA84",
"y 	c #E4E47D",
"z 	c #E4E480",
"A 	c #DEDE6F",
"B 	c #D7D85F",
"C 	c #D0D46C",
"D 	c #CAD07A",
"E 	c #B2C2AA",
"F 	c #9AB4DA",
"G 	c #9FBAE1",
"H 	c #A4C0E8",
"I 	c #9BB8E1",
"J 	c #92B0DB",
"K 	c #93B2DE",
"L 	c #94B4E0",
"M 	c #EAEA90",
"N 	c #E4E484",
"O 	c #DEDD78",
"P 	c #ECEA88",
"Q 	c #FAF899",
"R 	c #E1E074",
"S 	c #D7D75E",
"T 	c #D0D15C",
"U 	c #C9CB5B",
"V 	c #B0BE98",
"W 	c #97B0D4",
"X 	c #9BB5DB",
"Y 	c #9FBAE2",
"Z 	c #97B3DC",
"` 	c #8FACD6",
" .	c #91B0DB",
"..	c #F2F29B",
"+.	c #EBEA8E",
"@.	c #E4E382",
"#.	c #EFEE8D",
"$.	c #F2F090",
"%.	c #EAE986",
"&.	c #EEED8C",
"*.	c #F2F192",
"=.	c #EAE57E",
"-.	c #E0DA6A",
";.	c #DAD768",
">.	c #D4D566",
",.	c #BDC898",
"'.	c #A6BACA",
").	c #A9C0DA",
"!.	c #ACC6EA",
"~.	c #A4BEE4",
"{.	c #9CB6DE",
"].	c #9EB9E0",
"^.	c #A0BCE2",
"/.	c #F9F9A6",
"(.	c #F2F198",
"_.	c #F2F092",
":.	c #F2EA88",
"<.	c #EADC77",
"[.	c #E4DE74",
"}.	c #DEDF70",
"|.	c #CAD298",
"1.	c #B5C5C1",
"2.	c #B8CBD9",
"3.	c #BAD1F1",
"4.	c #B2C9EB",
"5.	c #A9C1E5",
"6.	c #ACC4E8",
"7.	c #AEC7EA",
"8.	c #F5F5A2",
"9.	c #EDEC94",
"0.	c #ECEA8C",
"a.	c #EAE67E",
"b.	c #E0DB6C",
"c.	c #DFDC6C",
"d.	c #DEDE6C",
"e.	c #CAD084",
"f.	c #B6C29C",
"g.	c #B6C7C4",
"h.	c #B6CCEB",
"i.	c #AEC5E5",
"j.	c #A6BEE0",
"k.	c #A8C0E2",
"l.	c #AAC2E4",
"m.	c #F1F19F",
"n.	c #E8E790",
"o.	c #E5E486",
"p.	c #E1E275",
"q.	c #DADB64",
"r.	c #DDDC68",
"s.	c #CACE70",
"t.	c #B7BF77",
"u.	c #B4C4AE",
"v.	c #B2C8E5",
"w.	c #AAC1E0",
"x.	c #A3BADA",
"y.	c #A4BBDC",
"z.	c #A6BCDE",
"A.	c #F6F6A7",
"B.	c #EDED99",
"C.	c #E5E48A",
"D.	c #F2F296",
"E.	c #ECEA8E",
"F.	c #EAE88A",
"G.	c #EFEC90",
"H.	c #E3E277",
"I.	c #DCDA6B",
"J.	c #E2DA78",
"K.	c #D3D270",
"L.	c #C4C86A",
"M.	c #C1CDA5",
"N.	c #BED2E0",
"O.	c #BBCCD2",
"P.	c #B8C7C3",
"Q.	c #BAC9BF",
"R.	c #BDCBBA",
"S.	c #FAFAAF",
"T.	c #F2F2A2",
"U.	c #EBEB94",
"V.	c #FAF9A2",
"W.	c #F3ED95",
"X.	c #E5E27A",
"Y.	c #DED872",
"Z.	c #E6D987",
"`.	c #DCD672",
" +	c #D1D25C",
".+	c #CDD69C",
"++	c #C9DBDC",
"@+	c #CBD8C4",
"#+	c #CDD4AC",
"$+	c #D0D7A2",
"%+	c #D4DA97",
"&+	c #F4F2AA",
"*+	c #ECEC9D",
"=+	c #E5E590",
"-+	c #ECEC96",
";+	c #F2F29C",
">+	c #E2E78D",
",+	c #D1DC7E",
"'+	c #CCDC81",
")+	c #C6DC84",
"!+	c #C8DC7E",
"~+	c #C9DC78",
"{+	c #C4D67C",
"]+	c #BED17F",
"^+	c #C1CE6B",
"/+	c #C4CA56",
"(+	c #C7D186",
"_+	c #CBD8B6",
":+	c #CAD29A",
"<+	c #CACD7E",
"[+	c #D1D184",
"}+	c #D8D58A",
"|+	c #EDEBA4",
"1+	c #E6E598",
"2+	c #DFDF8D",
"3+	c #E5E592",
"4+	c #EBEB97",
"5+	c #D1DD84",
"6+	c #B7CF72",
"7+	c #A8CC73",
"8+	c #99CA74",
"9+	c #AAD684",
"0+	c #BBE193",
"a+	c #A9D585",
"b+	c #97C977",
"c+	c #A6C664",
"d+	c #B6C351",
"e+	c #C2CC70",
"f+	c #CDD590",
"g+	c #C6C650",
"h+	c #D2CB67",
"i+	c #DDD07E",
"j+	c #F4F3B0",
"k+	c #EAEBA2",
"l+	c #DFE395",
"m+	c #D9E495",
"n+	c #D3E695",
"o+	c #BDD985",
"p+	c #A7CC74",
"q+	c #A8D17C",
"r+	c #B2DB8B",
"s+	c #A4C16A",
"t+	c #B2B85E",
"u+	c #C3CA74",
"v+	c #D5DB89",
"w+	c #CED06C",
"x+	c #FBFBBC",
"y+	c #EDF1AC",
"z+	c #DFE79D",
"A+	c #CDE498",
"B+	c #A2BC71",
"C+	c #ADAE6B",
"D+	c #C5C876",
"E+	c #DDE182",
"F+	c #D2D469",
"G+	c #E0ECAC",
"H+	c #CCE19A",
"I+	c #B9D588",
"J+	c #B3D689",
"K+	c #ADD88A",
"L+	c #A0CE7E",
"M+	c #93C573",
"N+	c #9CC274",
"O+	c #A6BE76",
"P+	c #AEC877",
"Q+	c #B6D178",
"R+	c #B4CE70",
"S+	c #B2CA68",
"T+	c #B8C970",
"U+	c #BDC778",
"V+	c #C4DE9B",
"W+	c #ACD087",
"X+	c #93C373",
"Y+	c #99C97A",
"Z+	c #9FCF80",
"`+	c #97C878",
" @	c #8FC16F",
".@	c #9EC67A",
"+@	c #9DBE73",
"@@	c #BADC98",
"#@	c #A8D189",
"$@	c #96C679",
"%@	c #9ECD80",
"&@	c #A4D488",
"*@	c #9CCC7E",
"=@	c #93C474",
"-@	c #A2CD82",
";@	c #9EC77D",
">@	c #AFDB96",
",@	c #A4D28A",
"'@	c #9AC97F",
")@	c #A2D087",
"!@	c #AAD88F",
"~@	c #A0D084",
"{@	c #97C87A",
"]@	c #A5D48B",
"^@	c #A0D087",
"/@	c #B6DB9D",
"(@	c #ABD291",
"_@	c #A0CA86",
":@	c #A7D08C",
"<@	c #AED694",
"[@	c #A5D08A",
"}@	c #9CC880",
"|@	c #A8D38E",
"1@	c #A3D08A",
"2@	c #BCDBA4",
"3@	c #B1D298",
"4@	c #A6CA8C",
"5@	c #ACD092",
"6@	c #B1D598",
"7@	c #A9CF8F",
"8@	c #A1C986",
"9@	c #ACD292",
"0@	c #A6D08C",
"                                                                ",
"                                                                ",
"      .                                                         ",
"    . . .                                                       ",
"    . . .     + + @ + # $ % % % & * = - ; > , ' ) ! ~ {         ",
"    . . .   + + + @ + # $ % % % & * = - ; > , ' ) ! ~ { {       ",
"    . . .   ] ] ^ / ( _ : < < < [ } | 1 2 3 4 5 6 7 8 9 9       ",
"    . . .   0 0 a b c d e f f f g h i j k l m n o p q r r       ",
"    . . .   s s t u v w x e y z A B C D E F G H I J K L L       ",
"    . . .   M M N O P Q w d _ # R S T U V W X Y Z ` 3  . .      ",
"    . . .   ....+.@.#.Q $.%.&.*.=.-.;.>.,.'.).!.~.{.].^.^.      ",
"    . . .   /./.(.@ _.Q _.@ _.Q :.<.[.}.|.1.2.3.4.5.6.7.7.      ",
"    . . .   8.8.9./ 0.*.0./ 0.*.a.b.c.d.e.f.g.h.i.j.k.l.l.      ",
"    . . .   m.m.n.b o.# o.b o.# p.h q.r.s.t.u.v.w.x.y.z.z.      ",
"    . . .   A.A.B.C.a D.E.o.F.G.H.B I.J.K.L.M.N.O.P.Q.R.R.      ",
"    . . .   S.S.T.U...V.D.# G.W.X.S Y.Z.`. +.+++@+#+$+%+%+      ",
"    . . .   &+&+*+=+-+;+>+,+'+)+!+~+{+]+^+/+(+_+:+<+[+}+}+      ",
"    . . .   |+|+1+2+3+4+5+6+7+8+9+0+a+b+c+d+e+f+s.g+h+i+i+      ",
"    . . .   j+j+k+l+m+n+o+p+q+9+r+0+a+b+s+t+u+v+w+g+h+i+i+      ",
"    . . .   x+x+y+z+A+0+a+b+a+0+0+0+a+b+B+C+D+E+F+g+h+i+i+      ",
"    . . .   G+G+H+I+J+K+L+M+L+K+K+K+L+M+N+O+P+Q+R+S+T+U+U+      ",
"    . . .   V+V+W+X+Y+Z+`+ @`+Z+Z+Z+`+ @`+Z+`+ @`+Z+.@+@+@      ",
"    . . .   @@@@#@$@%@&@*@=@*@&@&@&@*@=@*@&@*@=@*@&@-@;@;@      ",
"    . . .   >@>@,@'@)@!@~@{@~@!@!@!@~@{@~@!@~@{@~@!@]@^@^@      ",
"    . . .   /@/@(@_@:@<@[@}@[@<@<@<@[@}@[@<@[@}@[@<@|@1@1@      ",
"    . . .   2@2@3@4@5@6@7@8@7@6@6@6@7@8@7@6@7@8@7@6@9@0@0@      ",
"    . . .     2@3@4@5@6@7@8@7@6@6@6@7@8@7@6@7@8@7@6@9@0@        ",
"    . . .                                                       ",
"    . . . . . . . . . . . . . . . . . . . . . . . . . . . .     ",
"    . . . . . . . . . . . . . . . . . . . . . . . . . . . . .   ",
"      . . . . . . . . . . . . . . . . . . . . . . . . . . .     ",
"                                                                "};

static const char * system_xpm[] = {
"16 16 82 1",
" 	g None",
".	g #BABABA",
"+	g #B8B8B8",
"@	g #B7B7B7",
"#	g #B6B6B6",
"$	g #B4B4B4",
"%	g #B3B3B3",
"&	g #BBBBBB",
"*	g #D0D0D0",
"=	g #E8E8E8",
"-	g #F3F3F3",
";	g #FDFDFD",
">	g #FCFCFC",
",	g #EDEDED",
"'	g #E0E0E0",
")	g #C2C2C2",
"!	g #ADADAD",
"~	g #E1E1E1",
"{	g #FEFEFE",
"]	g #FFFFFF",
"^	g #FBFBFB",
"/	g #CFCFCF",
"(	g #A9A9A9",
"_	g #B9B9B9",
":	g #F8F8F8",
"<	g #EAEAEA",
"[	g #A7A7A7",
"}	g #F7F7F7",
"|	g #E7E7E7",
"1	g #EFEFEF",
"2	g #F6F6F6",
"3	g #FAFAFA",
"4	g #F0F0F0",
"5	g #DEDEDE",
"6	g #C3C3C3",
"7	g #E6E6E6",
"8	g #A5A5A5",
"9	g #B5B5B5",
"0	g #EBEBEB",
"a	g #D6D6D6",
"b	g #D5D5D5",
"c	g #D1D1D1",
"d	g #BCBCBC",
"e	g #C0C0C0",
"f	g #E5E5E5",
"g	g #A3A3A3",
"h	g #F5F5F5",
"i	g #EEEEEE",
"j	g #E2E2E2",
"k	g #CDCDCD",
"l	g #E3E3E3",
"m	g #A0A0A0",
"n	g #B2B2B2",
"o	g #F4F4F4",
"p	g #DDDDDD",
"q	g #C9C9C9",
"r	g #BDBDBD",
"s	g #BFBFBF",
"t	g #9E9E9E",
"u	g #B0B0B0",
"v	g #D9D9D9",
"w	g #DBDBDB",
"x	g #C4C4C4",
"y	g #9B9B9B",
"z	g #AEAEAE",
"A	g #F2F2F2",
"B	g #D8D8D8",
"C	g #DCDCDC",
"D	g #969696",
"E	g #ACACAC",
"F	g #D4D4D4",
"G	g #D2D2D2",
"H	g #909090",
"I	g #8B8B8B",
"J	g #CECECE",
"K	g #8A8A8A",
"L	g #A1A1A1",
"M	g #9F9F9F",
"N	g #ABABAB",
"O	g #959595",
"P	g #8D8D8D",
"Q	g #898989",
"                ",
"     .+@#$%     ",
"   &*=-;>,')!   ",
"  .~{]]]]]]^/(  ",
"  _:{]]]]]]^<[  ",
"  @}|12^345678  ",
"  9205abc6defg  ",
"  $hi7j7~k))lm  ",
"  no<~pl5qrsjt  ",
"  u-|pv'wx+&~y  ",
"  zAjBbCBe%@'D  ",
"  E45FGwasu%5H  ",
"  (5-wGwaeq7xI  ",
"   8J,oho1j.K   ",
"    LMLN[OPQ    ",
"                "};

static const char * system_large_xpm[] = {
"32 32 112 2",
"  	g None",
". 	g #BABABA",
"+ 	g #B9B9B9",
"@ 	g #B8B8B8",
"# 	g #B7B7B7",
"$ 	g #B6B6B6",
"% 	g #B5B5B5",
"& 	g #B4B4B4",
"* 	g #B3B3B3",
"= 	g #C5C5C5",
"- 	g #CBCBCB",
"; 	g #D1D1D1",
"> 	g #D5D5D5",
", 	g #D7D7D7",
"' 	g #D8D8D8",
") 	g #D9D9D9",
"! 	g #DADADA",
"~ 	g #D4D4D4",
"{ 	g #CECECE",
"] 	g #C7C7C7",
"^ 	g #BEBEBE",
"/ 	g #BBBBBB",
"( 	g #D0D0D0",
"_ 	g #DCDCDC",
": 	g #E8E8E8",
"< 	g #EEEEEE",
"[ 	g #F3F3F3",
"} 	g #F8F8F8",
"| 	g #FDFDFD",
"1 	g #FCFCFC",
"2 	g #F4F4F4",
"3 	g #EDEDED",
"4 	g #E6E6E6",
"5 	g #E0E0E0",
"6 	g #C2C2C2",
"7 	g #ADADAD",
"8 	g #C9C9C9",
"9 	g #E7E7E7",
"0 	g #F6F6F6",
"a 	g #F9F9F9",
"b 	g #FEFEFE",
"c 	g #FAFAFA",
"d 	g #F0F0F0",
"e 	g #DEDEDE",
"f 	g #C0C0C0",
"g 	g #E1E1E1",
"h 	g #FFFFFF",
"i 	g #FBFBFB",
"j 	g #E5E5E5",
"k 	g #CFCFCF",
"l 	g #A9A9A9",
"m 	g #ECECEC",
"n 	g #F5F5F5",
"o 	g #C6C6C6",
"p 	g #A8A8A8",
"q 	g #F2F2F2",
"r 	g #EAEAEA",
"s 	g #CACACA",
"t 	g #A7A7A7",
"u 	g #F7F7F7",
"v 	g #DFDFDF",
"w 	g #E4E4E4",
"x 	g #C8C8C8",
"y 	g #A6A6A6",
"z 	g #EFEFEF",
"A 	g #EBEBEB",
"B 	g #C3C3C3",
"C 	g #A5A5A5",
"D 	g #E9E9E9",
"E 	g #D3D3D3",
"F 	g #CDCDCD",
"G 	g #A4A4A4",
"H 	g #D6D6D6",
"I 	g #BCBCBC",
"J 	g #D2D2D2",
"K 	g #A3A3A3",
"L 	g #F1F1F1",
"M 	g #E2E2E2",
"N 	g #DDDDDD",
"O 	g #DBDBDB",
"P 	g #C4C4C4",
"Q 	g #BFBFBF",
"R 	g #C1C1C1",
"S 	g #A1A1A1",
"T 	g #E3E3E3",
"U 	g #A0A0A0",
"V 	g #9F9F9F",
"W 	g #B2B2B2",
"X 	g #BDBDBD",
"Y 	g #9E9E9E",
"Z 	g #B1B1B1",
"` 	g #9C9C9C",
" .	g #B0B0B0",
"..	g #9B9B9B",
"+.	g #AFAFAF",
"@.	g #989898",
"#.	g #AEAEAE",
"$.	g #CCCCCC",
"%.	g #969696",
"&.	g #939393",
"*.	g #ACACAC",
"=.	g #909090",
"-.	g #AAAAAA",
";.	g #8D8D8D",
">.	g #8B8B8B",
",.	g #9D9D9D",
"'.	g #8A8A8A",
").	g #898989",
"!.	g #ABABAB",
"~.	g #959595",
"{.	g #919191",
"].	g #8C8C8C",
"                                                                ",
"                                                                ",
"                                                                ",
"                    . . + @ # # # $ % & & *                     ",
"                = - ; > , ' ) ! ! ) , ~ ; { ] ^ @               ",
"              / ] ( _ : < [ } | 1 1 2 3 4 5 ; 6 + 7             ",
"            8 ( _ 9 3 2 0 a 1 b b b c 0 [ d 9 e ( f .           ",
"          . ( g d b b h h h h h h h h h h h | i j k f l         ",
"          + > m n b b h h h h h h h h h h h | i m _ o p         ",
"          + ! } i b b h h h h h h h h h h h | i q r s t         ",
"          @ ) } n q n u a c 1 | | 1 c } [ < 9 v w : x y         ",
"          # ' u z 9 A z q 0 } i c c n d 9 e ( B ~ 4 ] C         ",
"          $ ' 0 d D : 4 4 4 9 : 9 4 5 ! E F ] 6 ~ 4 o G         ",
"          % , 0 d A w e ! H H > E ; s B f I ^ f J j = K         ",
"          & H 0 L m 9 M v _ N e O ) ( x P Q f R J w P S         ",
"          & H n q < r 4 w M w 4 w g , F x 6 6 6 J T B U         ",
"          * > 2 d m : w M 5 M w M 5 > - = f f f J M 6 V         ",
"          W ~ 2 z r 4 g v N 5 T 5 e ~ 8 B X ^ Q ( M R Y         ",
"          Z ~ 2 < : w v N O e M v _ J o f . I X k M f `         ",
"           .E [ 3 9 M N O ) _ 5 e O ( P ^ @ . / { g f ..        ",
"          +.J q m w 5 ! ) , ! e _ ! { 6 I $ # + F 5 ^ @.        ",
"          #.; q r M N ' H > ' _ ! ' $.f . * % # $.5 X %.        ",
"          7 ( L : 5 O H > ~ ' _ ) , - f @ W * % s v / &.        ",
"          *.k d 9 e ) ~ E J H O ' H s Q @  .W * x e + =.        ",
"          -.s 9 : : 5 ' > J H O ' H - f ^ I P $.k ; Z ;.        ",
"          l = e : [ 9 O H J H O ' H - f P 8 ' 4 > P l >.        ",
"          l @ 6 ; 5 M w w T 4 : 4 j e ' H H E ( X p ,.'.        ",
"            C C . { e 3 d 2 2 n 2 2 q z : M { . K '.).          ",
"              C * X 6 ] 8 s F ( k { x 6 ^ . W l ,.              ",
"                  S U V U S y !.l t Y ~.{.;.].).                ",
"                        U S G t y G ,.~.                        ",
"                                                                "};

OHPictures::OHPictures( const TGClient * client )
{
    TImage * img;
    TGPicturePool * pp = client->GetPicturePool();
    
    // will add this image to the Root image pool with the name "send__16x16"
    img = TImage::Open((char**)exit_xpm);
    pp->GetPicture( "exit", img->GetPixmap(), img->GetMask() );
    delete img;
    
    img = TImage::Open((char**)save_xpm);
    pp->GetPicture( "save", img->GetPixmap(), img->GetMask() );
    delete img;
    
    img = TImage::Open((char**)refresh_xpm);
    pp->GetPicture( "refresh", img->GetPixmap(), img->GetMask() );
    delete img;
    
    img = TImage::Open((char**)send_xpm);
    pp->GetPicture( "send", img->GetPixmap(), img->GetMask() );
    delete img;
    
    img = TImage::Open((char**)history_xpm);
    pp->GetPicture( "history", img->GetPixmap(), img->GetMask() );
    delete img;
    
    img = TImage::Open((char**)view_small_icons_xpm);
    pp->GetPicture( "view_small_icons", img->GetPixmap(), img->GetMask() );
    delete img;
    
    img = TImage::Open((char**)view_large_icons_xpm);
    pp->GetPicture( "view_large_icons", img->GetPixmap(), img->GetMask() );
    delete img;
    
    img = TImage::Open((char**)view_columns_xpm);
    pp->GetPicture( "view_columns", img->GetPixmap(), img->GetMask() );
    delete img;

    img = TImage::Open((char**)view_details_xpm);
    pp->GetPicture( "view_details", img->GetPixmap(), img->GetMask() );
    delete img;
    
   img = TImage::Open((char**)single_canvas_xpm);
    pp->GetPicture( "single_canvas", img->GetPixmap(), img->GetMask() );
    delete img;
    
    img = TImage::Open((char**)multi_canvas_xpm);
    pp->GetPicture( "multi_canvas", img->GetPixmap(), img->GetMask() );
    delete img;
    
    img = TImage::Open((char**)multi_pad_xpm);
    pp->GetPicture( "multi_pad", img->GetPixmap(), img->GetMask() );
    delete img;
    
    img = TImage::Open((char**)folder_wrench_xpm);
    pp->GetPicture( "folder_wrench", img->GetPixmap(), img->GetMask() );
    delete img;
    
    img = TImage::Open((char**)folder_xpm);
    pp->GetPicture( "folder", img->GetPixmap(), img->GetMask() );
    delete img;
    
    img = TImage::Open((char**)folder_large_xpm);
    pp->GetPicture( "folder", img->GetPixmap(), img->GetMask() );
    delete img;
    
    img = TImage::Open((char**)partition_xpm);
    pp->GetPicture( "partition", img->GetPixmap(), img->GetMask() );
    delete img;
    
    img = TImage::Open((char**)partition_large_xpm);
    pp->GetPicture( "partition", img->GetPixmap(), img->GetMask() );
    delete img;
    
    img = TImage::Open((char**)provider_xpm);
    pp->GetPicture( "provider", img->GetPixmap(), img->GetMask() );
    delete img;
    
    img = TImage::Open((char**)provider_large_xpm);
    pp->GetPicture( "provider", img->GetPixmap(), img->GetMask() );
    delete img;
    
    img = TImage::Open((char**)histogram_xpm);
    pp->GetPicture( "histogram", img->GetPixmap(), img->GetMask() );
    delete img;
    
    img = TImage::Open((char**)histogram_large_xpm);
    pp->GetPicture( "histogram", img->GetPixmap(), img->GetMask() );
    delete img;
    
    img = TImage::Open((char**)graph_xpm);
    pp->GetPicture( "graph", img->GetPixmap(), img->GetMask() );
    delete img;
    
    img = TImage::Open((char**)graph_large_xpm);
    pp->GetPicture( "graph", img->GetPixmap(), img->GetMask() );
    delete img;
    
    img = TImage::Open((char**)graph_2d_xpm);
    pp->GetPicture( "graph_2d", img->GetPixmap(), img->GetMask() );
    delete img;
    
    img = TImage::Open((char**)graph_2d_large_xpm);
    pp->GetPicture( "graph_2d", img->GetPixmap(), img->GetMask() );
    delete img;
    
    img = TImage::Open((char**)system_xpm);
    pp->GetPicture( "system", img->GetPixmap(), img->GetMask() );
    delete img;
    
    img = TImage::Open((char**)system_large_xpm);
    pp->GetPicture( "system", img->GetPixmap(), img->GetMask() );
    delete img;
}
